/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { IAxisVisualDataManager_$type } from "./IAxisVisualDataManager";
import { TextBlock } from "./TextBlock";
import { VisualExportHelper } from "./VisualExportHelper";
import { ChartTitleVisualData } from "./ChartTitleVisualData";
import { HorizontalAlignment_$type } from "./HorizontalAlignment";
import { VerticalAlignment_$type } from "./VerticalAlignment";
import { AxisTitlePosition_$type } from "./AxisTitlePosition";
import { RectData } from "./RectData";
import { AppearanceHelper } from "./AppearanceHelper";
import { AxisVisualData } from "./AxisVisualData";
import { PathVisualData } from "./PathVisualData";
import { List$1 } from "./List$1";
import { Base, EnumUtil, fromEnum, markType, getInstanceType } from "./type";
import { AxisLabelVisualData } from "./AxisLabelVisualData";
import { PointData } from "./PointData";
import { Size } from "./Size";
import { SizeData } from "./SizeData";
import { FontUtil } from "./FontUtil";
export class AxisVisualDataManager extends Base {
    c(a) {
        return a;
    }
    d(a, b) {
        let c = VisualExportHelper.a(b);
        return c;
    }
    a(a, b, c, d) {
        let e = new ChartTitleVisualData();
        let f = a.ay;
        let g = f.a1();
        e.viewport = RectData.b(g);
        let h = this.d(a, d);
        e.textPlotArea = RectData.b(h);
        let i = d._visibility == 0 && d.x != null;
        let j = a.ap.ae.d();
        let k = f.a7(d);
        let l = this.b(a, d, j);
        let m = AppearanceHelper.c(d, l);
        m.marginLeft = k.c;
        m.marginRight = k.d;
        m.marginTop = k.e;
        m.marginBottom = k.b;
        m.fontStretch = "Normal";
        m.textWrapping = "Wrap";
        m.visibility = i;
        if (a.a6 != null) {
            m.horizontalAlignment = EnumUtil.getName(HorizontalAlignment_$type, a.a6.horizontalAlignment);
            m.verticalAlignment = EnumUtil.getName(VerticalAlignment_$type, a.a6.verticalAlignment);
            m.textPosition = EnumUtil.getName(AxisTitlePosition_$type, a.a6.position);
        }
        else {
            m.horizontalAlignment = EnumUtil.getName(HorizontalAlignment_$type, (0));
            m.verticalAlignment = EnumUtil.getName(VerticalAlignment_$type, (1));
            m.textPosition = EnumUtil.getName(AxisTitlePosition_$type, (0));
        }
        e.appearance = m;
        return e;
    }
    exportVisualData(a) {
        let b = new AxisVisualData();
        b.viewport = RectData.b(a.ib);
        b.labelsViewport = RectData.b(a.ay.a1());
        b.type = this.c(getInstanceType(a).typeName);
        b.name = a.name;
        let c = new PathVisualData(1, "axisLine", a.ay.a2);
        b.axisLine = c;
        b.tickMarks = new PathVisualData(1, "tickMarks", a.ap.ae.at);
        if (!a.ap.ab.contains(a.ap.ae.at)) {
            b.tickMarks.data.clear();
        }
        b.minorLines = new PathVisualData(1, "minorLines", a.ay.a4);
        b.majorLines = new PathVisualData(1, "majorLines", a.ay.a3);
        b.strips = new PathVisualData(1, "strips", a.ay.a5);
        if (a.fp != null) {
            let d = this.a(a, a.a9, b.type, a.gx);
            b.title = d;
        }
        else {
            b.title = null;
        }
        let e = a.a9.getFontInfo();
        if (a.as != null && a.as.textStyle != null) {
            e = a.as.f(a.a9.bk.i.af);
        }
        let f, g, h, i;
        let j = a.ap.ae.at.aj.c;
        for (let k = 1; k < j.count; k++) {
            let l = j._inner[k];
            let m = j._inner[k - 1];
            f = l.c.x - l.b.x;
            g = l.c.y - l.b.y;
            h = m.c.x - m.b.x;
            i = m.c.y - m.b.y;
            if (1 == k) {
                b.tickMarksLength = Math.sqrt(Math.pow(f, 2) + Math.pow(g, 2));
            }
        }
        let n = a.ap.a2;
        let o = a.ap.ae.g();
        for (let p = 0; p < n.count; p++) {
            let q = a.ap.a2._inner[p];
            let r = a.ap.a1._inner[p];
            let s = ((() => {
                let $ret = new AxisLabelVisualData();
                $ret.labelPosition = q.a;
                $ret.labelValue = r;
                $ret.panelPosition = PointData.b(a.ay.ay());
                return $ret;
            })());
            let t = new List$1(TextBlock.$, 0);
            for (let u of fromEnum(o)) {
                t.add(u);
            }
            if (p < t.count) {
                let v = this.b(a, t._inner[p], e);
                s.appearance = AppearanceHelper.c(t._inner[p], v);
                let w = a.bg.a._inner[p];
                s.position = PointData.b(a.ay.ax(w));
                s.size = SizeData.b(new Size(1, w.m, w.l));
            }
            b.labels.add(s);
        }
        return b;
    }
    b(a, b, c) {
        return FontUtil.getFontInfo(a.a9.bk.i.af, b, c);
    }
}
AxisVisualDataManager.$t = markType(AxisVisualDataManager, 'AxisVisualDataManager', Base.$, [IAxisVisualDataManager_$type]);
//# sourceMappingURL=AxisVisualDataManager.js.map