/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialOverlay } from "./FinancialOverlay";
import { DependencyProperty } from "./DependencyProperty";
import { List$1 } from "./List$1";
import { Type, Number_$type, typeCast, runOn, markType, getEnumerator, Point_$type, fromEnum } from "./type";
import { CategoryFrame } from "./CategoryFrame";
import { SafeEnumerable } from "./SafeEnumerable";
import { TrendCalculators } from "./TrendCalculators";
import { AxisRange } from "./AxisRange";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "./Polyline";
import { Polygon } from "./Polygon";
import { PropertyMetadata } from "./PropertyMetadata";
import { isNaN_ } from "./number";
import { Flattener } from "./Flattener";
export class BollingerBandsOverlay extends FinancialOverlay {
    constructor() {
        super();
        this.o3 = 0;
        this.o4 = 0;
        this.o1 = new List$1(Number_$type, 0);
        this.o2 = new List$1(Number_$type, 0);
        this.ab = BollingerBandsOverlay.$;
        this.lq = new CategoryFrame(4);
        this.ls = new CategoryFrame(4);
        this.lp = new CategoryFrame(4);
    }
    ie(a, b, c, d) {
        if (this.m4().contains(b)) {
            this.ov = false;
        }
        super.ie(a, b, c, d);
        switch (b) {
            case BollingerBandsOverlay.$$p[1]:
                this.ov = false;
                this.it(false);
                break;
            case BollingerBandsOverlay.$$p[0]:
                this.it(false);
                break;
        }
    }
    ow() {
        this.o1.clear();
        this.o2.clear();
        let a = getEnumerator(TrendCalculators.e(new SafeEnumerable(this.m3), this.o6));
        let b = getEnumerator(TrendCalculators.f(new SafeEnumerable(this.m3), this.o6));
        this.o4 = 1.7976931348623157E+308;
        this.o3 = -1.7976931348623157E+308;
        let c = true;
        let d = true;
        let e = this.o5;
        while (c || d) {
            if (a.moveNext()) {
                this.o1.add(a.current);
            }
            else {
                c = false;
            }
            if (b.moveNext()) {
                this.o2.add(b.current);
            }
            else {
                d = false;
            }
            if (c && d) {
                this.o4 = Math.min(this.o4, a.current - b.current * e);
                this.o3 = Math.max(this.o3, a.current + b.current * e);
            }
        }
        return true;
    }
    am(a) {
        if (this.o1 == null || this.o2 == null || a == null || this.by == null || a != this.l7) {
            return null;
        }
        let b = new AxisRange(this.o4, this.o3);
        return b;
    }
    ob(a, b) {
        super.ob(a, b);
        let c = b.bq;
        let d = b.bp;
        let e = this.getEffectiveViewport1(b);
        let f = this.ln;
        let g = this.l7;
        let h = new ScalerParams(0, c, d, f.bz, e);
        let i = new ScalerParams(0, c, d, g.bz, e);
        a.f.clear();
        a.m.clear();
        a.p.clear();
        let j = typeCast(ISortingAxis_$type, this.ln);
        if (j != null && j.i$b.count != this.by.count) {
            return;
        }
        let k = 0;
        k = this.nc(c, d, e);
        if (!this.ov) {
            this.ov = this.ow();
            if (this.l7 != null) {
                this.l7.cc(true);
            }
        }
        i.b = this.d8();
        let l = this.ln.dm(2, h) - this.ln.dm(1, h);
        for (let m = b.bs.c; m <= b.bs.d; ++m) {
            let n;
            if (j == null) {
                n = b.bs.getBucket(m);
            }
            else {
                let o = j.i$b._inner[m];
                let p = j.i$d(o);
                let q = this.o1._inner[m];
                let r = this.o2._inner[m];
                let s = q;
                let t = r;
                let u = p;
                let v = 1;
                while (m < b.bs.d) {
                    o = j.i$b._inner[m + 1];
                    u = j.i$d(o);
                    if (u - p > l) {
                        break;
                    }
                    m++;
                    s += this.o1._inner[m];
                    t += this.o2._inner[m];
                    v++;
                }
                s /= v;
                t /= v;
                let w = s - t * this.o5;
                let x = s;
                let y = s + t * this.o5;
                let z = NaN;
                if (!isNaN_(p)) {
                    z = this.ln.dj(p, h);
                }
                n = [z, w, x, y];
            }
            let aa = Math.max(1, l);
            if (!isNaN_(n[0]) && m * aa >= this.ox) {
                if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
                    n[0] = n[0] + k;
                }
                else {
                    n[0] = f.dj(n[0], h) + k;
                }
                n[1] = g.dj(n[1], i);
                n[2] = g.dj(n[2], i);
                n[3] = g.dj(n[3], i);
                a.f.add(n);
            }
        }
    }
    he(a, b) {
        super.he(a, b);
        let c = b;
        if (c != null) {
            c.bz();
        }
    }
    ed(a, b, c) {
        if (this.o1 == null) {
            return super.ed(a, b, c);
        }
        let d = this.getEffectiveViewport1(this.bh);
        let e = this.nc(this.bh.bq, this.bh.bp, d);
        let f = new ScalerParams(0, this.bh.bq, this.bh.bp, this.ln.bz, d);
        f.c = this.br.mx;
        return this.ef(this.o1, a, this.ln, f, e, runOn(this, this.nb), b, c);
    }
    e3(a, b) {
        if (this.o1 == null) {
            return super.e3(a, b);
        }
        return this.e4(a, b, this.ln, runOn(this, this.nb), this.o1);
    }
    e1(a, b) {
        if (this.o1 == null) {
            return super.e1(a, b);
        }
        return this.e2(a, b, this.ln, runOn(this, this.nb), this.o1);
    }
    ds(a, b, c) {
        let d = super.ds(a, b, c);
        if (!this.mu(this.m4())) {
            d = false;
        }
        return d;
    }
    od(a, b) {
        super.od(a, b);
        let c = typeCast(BollingerBandsOverlayView.$, b);
        let d = this.getEffectiveViewport1(b);
        if (b.bv(a)) {
            c.bz();
            let e = a.f.count;
            let f = (g) => a.f._inner[g][0];
            let g = (h) => a.f._inner[e - 1 - h][0];
            let h = (i) => a.f._inner[i][1];
            let i = (j) => a.f._inner[j][2];
            let j = (k) => a.f._inner[e - 1 - k][3];
            c.b0(e, f, g, h, i, j);
            b.bx(a);
        }
        this.lv.x(this, this.mt(), this.ln, runOn(this, this.lf), this.ni(b), this.nj(b));
        let k = false;
        let l = this.lv.c;
        let m = a.f;
        let n = this.by.count;
        if (l != null) {
            k = true;
        }
        if (k) {
            let o = new ScalerParams(0, b.bq, b.bp, this.ln.bz, d);
            this.oa(m, -1, n, this.ln, o, b.n);
        }
        let p = c.b7;
        let q = c.b8;
        let r = c.b9;
        let s = c.b2;
        this.lv.ae(q, true, false, true, true);
        this.lv.ao = null;
        this.lv.an = null;
        this.lv.ae(p, true, false, false, true);
        this.lv.ae(r, true, false, false, true);
        this.lv.ae(s, false, true, false, false);
        s._opacity = this.lv.i * this.dy;
    }
    be() {
        return new BollingerBandsOverlayView(this);
    }
    h9(a) {
        super.h9(a);
        this.o0 = typeCast(BollingerBandsOverlayView.$, a);
    }
    nk() {
        return 3;
    }
    d8() {
        return this.o1 == null || this.o1.count == 0 ? NaN : this.o1._inner[0];
    }
}
BollingerBandsOverlay.$t = markType(BollingerBandsOverlay, 'BollingerBandsOverlay', FinancialOverlay.$);
Type.dep(DependencyProperty, PropertyMetadata, BollingerBandsOverlay, 'raisePropertyChanged', ['Multiplier:o5:o9', [1, 2], 'Period:o6:pa', [1, 14]]);
export class BollingerBandsBucketCalculator extends FinancialBucketCalculator {
    constructor(a) {
        super(a);
        this.f = null;
        this.f = a;
    }
    getBucket(a) {
        let b = a * this.b;
        let c = Math.min(b + this.b - 1, this.a.bu.by.count - 1);
        if (b <= c) {
            let d = this.f.by.o5;
            let e = 0;
            let f = 0;
            let g = 0;
            for (let h = b; h <= c; ++h) {
                if (!isNaN_(this.f.by.o1._inner[h]) && !isNaN_(this.f.by.o2._inner[h])) {
                    e += this.f.by.o1._inner[h];
                    f += this.f.by.o2._inner[h];
                    ++g;
                }
            }
            if (g > 0) {
                e = e / g;
                f = f / g;
                return [0.5 * (b + c), e - f * d, e, e + f * d];
            }
        }
        return [NaN, NaN, NaN, NaN];
    }
}
BollingerBandsBucketCalculator.$t = markType(BollingerBandsBucketCalculator, 'BollingerBandsBucketCalculator', FinancialBucketCalculator.$);
export class BollingerBandsOverlayView extends FinancialSeriesView {
    constructor(a) {
        super(a);
        this.by = null;
        this.b3 = new Polygon();
        this.ca = new Polyline();
        this.cb = new Polyline();
        this.cc = new Polyline();
        this.b1 = new Polygon();
        this.b4 = new Polyline();
        this.b5 = new Polyline();
        this.b6 = new Polyline();
        this.by = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bi = 1;
        }
    }
    bt() {
        return new BollingerBandsBucketCalculator(this);
    }
    b0(a, b, c, d, e, f) {
        for (let g of fromEnum(Flattener.d(a, b, d, this.e.ej))) {
            this.b3.aj.add({ $type: Point_$type, x: b(g), y: d(g) });
            this.ca.aj.add({ $type: Point_$type, x: b(g), y: d(g) });
        }
        for (let h of fromEnum(Flattener.d(a, b, e, this.e.ej))) {
            this.cb.aj.add({ $type: Point_$type, x: b(h), y: e(h) });
        }
        for (let i of fromEnum(Flattener.d(a, c, f, this.e.ej))) {
            this.b3.aj.add({ $type: Point_$type, x: c(i), y: f(i) });
            this.cc.aj.add({ $type: Point_$type, x: c(i), y: f(i) });
        }
        this.an();
    }
    bz() {
        this.b3.aj.clear();
        this.ca.aj.clear();
        this.cb.aj.clear();
        this.cc.aj.clear();
        this.an();
    }
    get b2() {
        return this.b3;
    }
    get b7() {
        return this.ca;
    }
    get b8() {
        return this.cb;
    }
    get b9() {
        return this.cc;
    }
    a9() {
        super.a9();
        this.b1.aj = this.b3.aj;
        this.b4.aj = this.ca.aj;
        this.b5.aj = this.cb.aj;
        this.b6.aj = this.cc.aj;
        let a = this.bk();
        this.b1._fill = a;
        this.b1._opacity = 1;
        this.b4._stroke = a;
        this.b4.ac = this.e.en + 3;
        this.b5._stroke = a;
        this.b5.ac = this.e.en + 3;
        this.b6._stroke = a;
        this.b6.ac = this.e.en + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (b) {
                a.t(this.b1);
                a.u(this.b4);
                a.u(this.b5);
                a.u(this.b6);
            }
            else {
                a.t(this.b3);
                a.u(this.ca);
                a.u(this.cb);
                a.u(this.cc);
            }
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a1.exportPolygonData(a, this.b3, "FillShape", ["Fill"]);
        this.e.a1.exportPolylineData(a, this.ca, "BottomLine", ["Lower", "Main"]);
        this.e.a1.exportPolylineData(a, this.cb, "CentralLine", ["Central"]);
        this.e.a1.exportPolylineData(a, this.cc, "TopLine", ["Upper"]);
    }
}
BollingerBandsOverlayView.$t = markType(BollingerBandsOverlayView, 'BollingerBandsOverlayView', FinancialSeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.BollingerBandsOverlay" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.BollingerBandsOverlay" />*/
//# sourceMappingURL=BollingerBandsOverlay_combined.js.map