import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "./IFastItemColumn$1";
import { Rect } from "./Rect";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { Base, Type, Point } from "./type";
import { CategoryMode } from "./CategoryMode";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { List$1 } from "./List$1";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { PreparationParams } from "./PreparationParams";
import { Frame } from "./Frame";
import { ICategoryScaler } from "./ICategoryScaler";
import { ValuesHolder } from "./ValuesHolder";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager } from "./ICategorySeriesInteractionManager";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { AssigningCategoryMarkerStyleEventArgs } from "./AssigningCategoryMarkerStyleEventArgs";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { Marker } from "./Marker";
import { Pool$1 } from "./Pool$1";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { RenderSurface } from "./RenderSurface";
import { Clipper } from "./Clipper";
import { MarkerSeriesView } from "./MarkerSeriesView";
export declare class CategoryBucketCalculator extends Base implements IBucketizer {
    protected c: CategorySeriesView;
    constructor(a: CategorySeriesView);
    e: number;
    f: number;
    d: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    g(a: number): void;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    cacheValues(): void;
    unCacheValues(): void;
    static $t: Type;
}
export declare abstract class CategoryFramePreparerBase extends FramePreparer {
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    g: IBucketizer;
    h: IIsCategoryBased;
    protected abstract l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    m: boolean;
    private i(a);
    r(a: ICategoryScaler, b: Rect, c: Rect, d: Rect): number;
    private s(a);
    d(a: Frame, b: SeriesView): void;
    protected v(a: CategoryFrame, b: SeriesView): void;
    private o;
    protected readonly q: List$1<number[]>;
    private p;
    private n;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected k(): boolean;
    protected abstract z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected abstract u(a: ValuesHolder, b: number, c: boolean): void;
    protected abstract e(a: number, b: ValuesHolder): number[];
    protected f(a: PreparationParams, b: number, c: ValuesHolder, d: number, e: boolean, f: number[], g: number): {
        ret: number[];
        p1?: number;
        p4: boolean;
        p5: number[];
    };
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected abstract x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected abstract j(a: PreparationParams): ValuesHolder;
    static $t: Type;
}
export declare class CategoryFramePreparer extends CategoryFramePreparerBase {
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    protected aa: IHasCategoryTrendline;
    protected ab: IHasSingleValueCategory;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    protected j(a: PreparationParams): ValuesHolder;
    protected x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected u(a: ValuesHolder, b: number, c: boolean): void;
    protected e(a: number, b: ValuesHolder): number[];
    static $t: Type;
}
export declare abstract class CategorySeries extends MarkerSeries implements IHasCategoryModePreference, ISupportsErrorBars {
    mq: CategoryFramePreparer;
    protected be(): SeriesView;
    mu: CategorySeriesView;
    private m3;
    readonly m4: ICategorySeriesInteractionManager;
    h9(a: SeriesView): void;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    readonly categoryAxis: CategoryAxisBase;
    ml(): CategoryAxisBase;
    m5(): NumericAxisBase;
    protected get_cj(): boolean;
    readonly cj: boolean;
    constructor();
    ac(): void;
    nc: boolean;
    nb: boolean;
    protected m7: boolean;
    protected m6: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    assigningCategoryMarkerStyle: (sender: any, args: AssigningCategoryMarkerStyleEventArgs) => void;
    protected ne(): boolean;
    protected nf(): boolean;
    protected n1(a: AssigningCategoryStyleEventArgs): void;
    protected n0(a: AssigningCategoryMarkerStyleEventArgs): void;
    mf(a: number, b: number): any[];
    he(a: boolean, b: SeriesView): void;
    a7(): SeriesComponentsForView;
    ht(): void;
    nh: boolean;
    protected i8(a: Rect, b: Rect): void;
    mw: CategoryTransitionInMode;
    nd: boolean;
    protected i7(a: Rect, b: Rect): void;
    protected ie(a: any, b: string, c: any, d: any): void;
    protected m9(): boolean;
    protected m8(): boolean;
    nk(a: Point): number;
    protected get_cz(): boolean;
    readonly cz: boolean;
    ao(): CategoryAxisBase;
    ez(a: Point): number;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    fe(a: Point): any;
    ex(a: Point): number;
    d2(a: Point): number;
    private m1;
    private m2;
    protected get_na(): boolean;
    protected readonly na: boolean;
    at(a: any, b: Point): HighlightingInfo;
    protected get_ct(): boolean;
    protected readonly ct: boolean;
    as(a: any, b: Point): HighlightingInfo;
    protected nj(): List$1<Marker>;
    protected m0(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected mz(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected my(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    mn: CategoryFrame;
    mp: CategoryFrame;
    mm: CategoryFrame;
    mo: CategoryFrame;
    protected mt: CategorySeriesRenderManager;
    protected nx(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    protected ny(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    ds(a: Rect, b: Rect, c: SeriesView): boolean;
    private ni(a);
    protected c8(): boolean;
    protected mv(): CategoryTransitionInMode;
    mx: CategoryTransitionSourceFramePreparer;
    protected hf(): void;
    iu(a: boolean): void;
    protected bn(): TransitionInSpeedType;
    protected nl(): number;
    no(): number;
    readonly GetErrorBarsXAxis: Axis;
    readonly GetErrorBarsYAxis: Axis;
    nw(a: CategorySeriesView, b: CategoryFrame): void;
    n2(a: CategoryFrame, b: CategorySeriesView): void;
    private n9;
    protected readonly oa: Rect;
    nz(a: CategoryFrame, b: CategorySeriesView): void;
    nm(a: SeriesView): number;
    nn(a: SeriesView): number;
    nv(a: SeriesView): void;
    iv(a: Rect, b: RenderSurface): void;
    n3(): void;
    abstract fetchXAxis(): Axis;
    abstract fetchYAxis(): Axis;
    abstract ng(): boolean;
    mr(a: CategorySeriesView): CategoryFramePreparer;
    al(a: Axis): Axis;
    static mg(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    static $$p: string[];
    static $t: Type;
}
export declare class CategorySeriesView extends MarkerSeriesView implements ISupportsMarkers {
    cn: CategorySeries;
    cq: number;
    cp(a: CategoryFrame): boolean;
    cs(a: CategoryFrame): void;
    constructor(a: CategorySeries);
    updateMarkerTemplate(a: number, b: number, c: number): void;
    cl: CategoryBucketCalculator;
    cm(): CategoryBucketCalculator;
    co: Pool$1<Marker>;
    readonly shouldDisplayMarkers: boolean;
    updateMarkerCount(a: number): void;
    ca(a: (arg1: Marker) => void): void;
    cr(): void;
    static $t: Type;
}
