/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "./ArgumentNullException";
import { Rect } from "./Rect";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { ScalerParams } from "./ScalerParams";
import { Series } from "./Series";
import { Base, typeCast, Type, markType, Array_$type, Number_$type, Point_$type, enumGetBox, runOn, fromEnum } from "./type";
import { truncate, intDivide, isNaN_, isInfinity } from "./number";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { List$1 } from "./List$1";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { IProvidesViewport_$type } from "./IProvidesViewport";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { PreparationParams } from "./PreparationParams";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { DefaultCategoryTrendlineHost } from "./DefaultCategoryTrendlineHost";
import { DefaultSingleValueProvider } from "./DefaultSingleValueProvider";
import { SingleValuesHolder } from "./SingleValuesHolder";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager_$type } from "./ICategorySeriesInteractionManager";
import { DVContainer } from "./DVContainer";
import { DependencyProperty } from "./DependencyProperty";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { Marker } from "./Marker";
import { Pool$1 } from "./Pool$1";
import { Clipper } from "./Clipper";
import { PropertyMetadata } from "./PropertyMetadata";
import { MarkerSeriesView } from "./MarkerSeriesView";
export class CategoryBucketCalculator extends Base {
    constructor(a) {
        super();
        this.c = null;
        this.e = 0;
        this.f = 0;
        this.d = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        this.c = a;
        this.e = -1;
        this.d = 0;
    }
    getBucket(a) {
        return null;
    }
    getBucketWithoutUnknowns(a) {
        return this.getBucket(a);
    }
    getErrorBucket(a, b) {
        return NaN;
    }
    g(a) {
        let b = this.c.bq;
        let c = this.c.bp;
        let d = this.c.cn;
        let e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
        let f = d.by;
        if (b.isEmpty || c.isEmpty || e == null || f == null || f.count == 0) {
            this.d = 0;
            return;
        }
        let g = d.getEffectiveViewport1(this.c);
        let h = d.k5(this.c);
        let i = typeCast(ISortingAxis_$type, e);
        if (i == null || i.i$b == null) {
            let j = new ScalerParams(0, b, c, e.bz, g);
            let k = Math.floor(e.dn(h.left, j, 0));
            let l = Math.ceil(e.dn(h.right, j, 0));
            if (e.bz) {
                l = Math.ceil(e.dn(h.left, j, 0));
                k = Math.floor(e.dn(h.right, j, 0));
            }
            let m = Math.floor((l - k + 1) * a / h.width);
            this.d = truncate(Math.max(1, m));
            this.e = truncate(Math.max(0, Math.floor(k / this.d) - 1));
            this.f = truncate(Math.ceil(l / this.d));
        }
        else {
            this.e = i.i$e(b, c, g, h);
            this.f = i.i$g(b, c, g, h);
            this.d = 1;
        }
    }
    getBucketInfo(a, b, c, d) {
        a = this.e;
        b = this.f;
        c = this.d;
        d = this.c.cn.ej;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    }
    cacheValues() {
    }
    unCacheValues() {
    }
}
CategoryBucketCalculator.$t = markType(CategoryBucketCalculator, 'CategoryBucketCalculator', Base.$, [IBucketizer_$type]);
export class CategoryFramePreparerBase extends FramePreparer {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        let f = d[0];
                        let g = d[1];
                        let h = d[2];
                        let i = d[3];
                        let j = d[4];
                        super(1, g, h, i);
                        this.g = null;
                        this.h = null;
                        this.m = false;
                        this.o = new List$1(Array_$type, 0);
                        this.p = new List$1(Number_$type, 0);
                        this.n = new List$1(Number_$type, 0);
                        this.h = f;
                        this.g = j;
                    }
                    this.g = null;
                    this.h = null;
                    this.m = false;
                    this.o = new List$1(Array_$type, 0);
                    this.p = new List$1(Number_$type, 0);
                    this.n = new List$1(Number_$type, 0);
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    super(1, d, e, f);
                    this.g = null;
                    this.h = null;
                    this.m = false;
                    this.o = new List$1(Array_$type, 0);
                    this.p = new List$1(Number_$type, 0);
                    this.n = new List$1(Number_$type, 0);
                    this.h = c;
                    this.g = g;
                }
                break;
        }
    }
    i(a) {
        let b = new PreparationParams();
        b.f = this.h.useHighMarkerFidelity;
        b.b = this.h.scaler;
        b.c = this.h.yScaler;
        b.d = typeCast(ISortingAxis_$type, b.b);
        b.a = typeCast(CategoryFrame.$, a);
        if (b.a == null || b.b == null || b.c == null) {
            return null;
        }
        let c;
        let d;
        let e;
        let f;
        let g = this.g.getBucketInfo(c, d, e, f);
        c = g.p0;
        d = g.p1;
        e = g.p2;
        f = g.p3;
        b.i = c;
        b.j = d;
        b.h = e;
        b.g = f;
        if (b.j < b.i) {
            return null;
        }
        let h;
        let i;
        let j;
        let k = this.a.getViewInfo(i, h);
        i = k.p0;
        h = k.p1;
        j = this.a.getEffectiveViewport();
        b.m = h;
        b.l = i;
        b.k = j;
        if (Rect.l_op_Equality(b.m, Rect.empty) || Rect.l_op_Equality(b.l, Rect.empty)) {
            return null;
        }
        if (this.h != null && (typeCast(Series.$, this.h) !== null && this.h.cq) && this.g != null) {
            b.e = true;
        }
        return b;
    }
    r(a, b, c, d) {
        return a.getOffset(b, c, d, this.h.currentMode2Index, this.h.currentCategoryMode);
    }
    s(a) {
        return this.r(a.b, a.m, a.l, a.k);
    }
    d(a, b) {
        let c = this.i(a);
        if (c == null || this.g == null) {
            return;
        }
        c.a.f.clear();
        c.a.k.clear();
        c.a.m.clear();
        c.a.p.clear();
        c.a.i.clear();
        c.a.h.clear();
        c.a.g.clear();
        let d = this.c.shouldDisplayMarkers;
        let e = false;
        let f = this.s(c);
        let g = this.j(c);
        if (c.d != null && c.d.i$b != null && c.d.i$b.count != g.e) {
            return;
        }
        if (c.d != null && c.d.i$a) {
            c.d.i$h();
        }
        this.g.cacheValues();
        if (this.m && c.d != null && c.d.i$b.count > 0) {
            let h = c.d.i$b._inner[c.i];
            this.z(g, h, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.i > 0) {
                c.i = c.i - 1;
                h = c.d.i$b._inner[c.i];
                this.z(g, h, true, c.e);
            }
            let i = c.d.i$b._inner[c.j];
            this.z(g, i, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.j < g.e - 1) {
                c.j = c.j + 1;
                i = c.d.i$b._inner[c.j];
                this.z(g, i, true, c.e);
            }
        }
        if (this.m && c.d == null) {
            let j = c.i;
            let k = this.g.getBucket(j);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.i > 0) {
                c.i = c.i - 1;
                j = c.i;
                k = this.g.getBucket(j);
            }
            let l = c.j;
            k = this.g.getBucket(l);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.j < (intDivide(g.e, c.h))) {
                c.j = c.j + 1;
                l = c.j;
                k = this.g.getBucket(l);
            }
        }
        this.w(c, g, f);
        let m = this.t(c, g, f, d, e);
        this.c.updateMarkerCount(m);
        this.v(typeCast(CategoryFrame.$, a), b);
        this.g.unCacheValues();
        return;
    }
    v(a, b) {
    }
    get q() {
        return this.o;
    }
    t(a, b, c, d, e) {
        let f = 0;
        let g = false;
        let h = null;
        let i = false;
        let j = a.d != null;
        let k = a.m;
        let l = a.l;
        let m = typeCast(NumericAxisBase.$, a.c) !== null && a.c.i6;
        let n = a.f;
        let o = this.h.mayContainUnknowns;
        let p = this.o;
        let q = this.n;
        let r = this.p;
        p.clear();
        q.clear();
        r.clear();
        let s = this.g;
        let t = this.h.provideCollisionDetector();
        let u = 0;
        let v = a.k;
        let w = new ScalerParams(0, k, l, a.b.j$a, v);
        let x = ((() => {
            let $ret = new ScalerParams(0, k, l, a.c.j$a, v);
            $ret.b = typeCast(Series.$, this.h) !== null ? this.h.d8() : NaN;
            return $ret;
        })());
        if (j) {
            u = a.b.j$c(2, w) - a.b.j$c(1, w);
            i = this.k();
        }
        let y = a.i;
        let z = a.j;
        let aa = a.a.f;
        let ab = typeCast(IDateTimeAxis_$type, a.b);
        if (ab != null) {
            ab.StartTimeCursor();
        }
        for (let ac = y; ac <= z; ++ac) {
            let ad;
            if (!j) {
                if (!o) {
                    ad = s.getBucketWithoutUnknowns(ac);
                }
                else {
                    ad = s.getBucket(ac);
                }
            }
            else {
                ad = ((() => { let ae = this.f(a, ac, b, u, g, h, c); ac = ae.p1; g = ae.p4; h = ae.p5; return ae.ret; })());
            }
            let ae = !m || (m && ad[1] > 0);
            let af = ad[0];
            if (!j || !isNaN_(ad[0])) {
                aa.add(ad);
                if (g && i) {
                    if (h != null) {
                        aa.add(h);
                    }
                }
                if (d && ae) {
                    let ag = ac * a.h;
                    let ah = ag;
                    if (j && a.d.i$b != null && ag >= 0 && ag < a.d.i$b.count) {
                        ag = a.d.i$b._inner[ag];
                    }
                    let ai = new Array(ad.length);
                    ai[0] = ad[0];
                    ai[1] = ad[1];
                    ai[2] = ad[2];
                    if (n && ag < b.e) {
                        ai = new Array(ad.length);
                        ai[0] = af;
                        this.z(b, ag, true, a.e);
                        ai[1] = b.c;
                        ai[2] = b.d;
                    }
                    p.add(ai);
                    q.add(a.a.f.count - 1);
                    r.add(ag);
                }
            }
        }
        if (ab != null) {
            ab.ResetTimeCursor();
        }
        this.y(a, c, j, w, x, e, d);
        if (d) {
            let aj = p.count;
            let ak;
            for (let al = 0; al < aj; al++) {
                ak = p._inner[al];
                if (this.l(a.a, ak, t, Math.min(r._inner[al], b.e - 1), f, q._inner[al])) {
                    ++f;
                }
            }
        }
        return f;
    }
    k() {
        if (typeCast(Series.$, this.h) !== null) {
            return this.h.ci;
        }
        return false;
    }
    f(a, b, c, d, e, f, g) {
        let h;
        f = null;
        e = false;
        let i = typeCast(CategorySeries.$, this.h);
        let j = a.l;
        let k = a.m;
        let l = a.k;
        let m = new ScalerParams(0, k, j, a.b.j$a, l);
        let n = new ScalerParams(0, k, j, a.c.j$a, l);
        let o = a.e;
        if (a.d == null || a.d.i$b == null || a.d.i$b.count == 0) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        if (i != null && i.by != null && i.by.count < a.d.i$b.count) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        let p = a.d.i$b._inner[b];
        let q = a.d.i$d(p);
        let r = q;
        this.z(c, p, false, o);
        while (b < a.j) {
            p = a.d.i$b._inner[b + 1];
            r = a.d.i$d(p);
            this.z(c, p, true, o);
            if (r - q >= d || isNaN_(c.c) || isNaN_(c.d)) {
                if (e) {
                    let s = a.d.i$b._inner[b];
                    this.z(c, s, true, o);
                    f = [a.b.j$b(q, m), c.c, c.d];
                }
                break;
            }
            if (!e && this.k()) {
                let t = a.d.i$b._inner[b];
                this.z(c, t, true, o);
                let u = [a.b.j$b(q, m), c.c, c.d];
                if (!isNaN_(u[0])) {
                    if (!isNaN_(u[1]) && !isNaN_(u[2])) {
                        if (a.d != null) {
                            u[0] = u[0] + g;
                        }
                        a.a.f.add(u);
                        e = true;
                    }
                    else {
                        break;
                    }
                }
            }
            b++;
            this.u(c, p, o);
        }
        let v = NaN;
        if (!isNaN_(q)) {
            v = a.b.j$b(q, m);
        }
        h = this.e(v, c);
        return {
            ret: h,
            p1: b,
            p4: e,
            p5: f
        };
    }
    y(a, b, c, d, e, f, g) {
        let h = a.h;
        let i = a.a.f.count;
        let j = a.a.f;
        let k = this.o;
        let l = k.count;
        if (f) {
            let m = a.c.j$b(a.c.jq, e);
            a.c.j$e(a.a.k, 0, a.a.k.count, e);
            let n = a.a.k;
            let o = n.count;
            for (let p = 0; p < n.count; p++) {
                n._inner[p] = Math.abs(n._inner[p] - m);
            }
        }
    }
    w(a, b, c) {
    }
}
CategoryFramePreparerBase.$t = markType(CategoryFramePreparerBase, 'CategoryFramePreparerBase', FramePreparer.$);
export class CategoryFramePreparer extends CategoryFramePreparerBase {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        let f = d[0];
                        let g = d[1];
                        let h = d[2];
                        let i = d[3];
                        let j = d[4];
                        super(1, f, g, h, i, j);
                        this.aa = null;
                        this.ab = null;
                        this.aa = new DefaultCategoryTrendlineHost();
                        if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                            this.aa = typeCast(IHasCategoryTrendline_$type, f);
                        }
                        this.ab = new DefaultSingleValueProvider();
                        if (typeCast(IHasSingleValueCategory_$type, f) !== null) {
                            this.ab = typeCast(IHasSingleValueCategory_$type, f);
                        }
                    }
                    this.aa = null;
                    this.ab = null;
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    super(1, c, d, e, f, g);
                    this.aa = null;
                    this.ab = null;
                    this.aa = new DefaultCategoryTrendlineHost();
                    if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                        this.aa = typeCast(IHasCategoryTrendline_$type, c);
                    }
                    this.ab = new DefaultSingleValueProvider();
                    if (typeCast(IHasSingleValueCategory_$type, c) !== null) {
                        this.ab = typeCast(IHasSingleValueCategory_$type, c);
                    }
                }
                break;
        }
    }
    l(a, b, c, d, e, f) {
        let g = b[0];
        let h = b[1];
        let i = new Rect(0, g - 5, h - 5, 11, 11);
        if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
            a.m.add({ $type: Point_$type, x: g, y: h });
            this.c.updateMarkerTemplate(e, d, f);
            return true;
        }
        return false;
    }
    j(a) {
        let b = new SingleValuesHolder();
        let c = this.ab.valueColumn;
        b.f = c;
        return b;
    }
    x(a, b, c, d, e, f) {
        if (d) {
            b[0] = b[0] + c;
        }
        else {
            b[0] = a.b.j$b(b[0], e) + c;
        }
        b[1] = a.c.j$b(b[1], f);
        if (a.h > 1 || d) {
            b[2] = a.c.j$b(b[2], f);
        }
        else {
            b[2] = b[1];
        }
    }
    y(a, b, c, d, e, f, g) {
        super.y(a, b, c, d, e, f, g);
        let h = a.h;
        let i = a.a.f.count;
        let j = a.a.f;
        let k = this.q;
        let l = k.count;
        let m = new List$1(Number_$type, 0);
        if (!c) {
            m.add(0);
        }
        let n = new List$1(Number_$type, 0);
        n.add(1);
        if (c || h > 1) {
            n.add(2);
        }
        a.b.j$d(j, m, 0, i, d);
        a.c.j$d(j, n, 0, i, e);
        for (let o = 0; o < i; o++) {
            j._inner[o][0] = j._inner[o][0] + b;
        }
        if (h == 1 && !c) {
            for (let p = 0; p < i; p++) {
                j._inner[p][2] = j._inner[p][1];
            }
        }
        if (g) {
            a.b.j$d(k, m, 0, l, d);
            a.c.j$d(k, n, 0, l, e);
            for (let q = 0; q < l; q++) {
                k._inner[q][0] = k._inner[q][0] + b;
            }
            if (h == 1 && !c) {
                for (let r = 0; r < l; r++) {
                    k._inner[r][2] = k._inner[r][1];
                }
            }
        }
    }
    w(a, b, c) {
        if (this.aa.trendLineType == 0 || this.aa.trendlinePreparer == null || this.aa.trendLinePeriod < 1) {
            return;
        }
        this.aa.trendlinePreparer.prepareLine(this.aa, a, b, c);
    }
    z(a, b, c, d) {
        let e = a;
        let f = e.f;
        let g = f.item(b);
        let h = g;
        if (d) {
            let i = this.g.getBucket(b);
            g = i[1];
            h = i[1];
        }
        if (c) {
            e.c = g;
            e.d = h;
        }
        else {
            e.a = g;
            e.b = h;
        }
    }
    u(a, b, c) {
        let d = a;
        let e = d.f;
        if (b < e.count) {
            let f;
            if (c) {
                let g = this.g.getBucket(b);
                f = g[1];
            }
            else {
                f = e.item(b);
            }
            d.a = Math.min(d.a, f);
            d.b = Math.max(d.b, f);
        }
    }
    e(a, b) {
        let c = b;
        return [a, c.a, c.b];
    }
}
CategoryFramePreparer.$t = markType(CategoryFramePreparer, 'CategoryFramePreparer', CategoryFramePreparerBase.$);
export class CategorySeries extends MarkerSeries {
    constructor() {
        super();
        this.mq = null;
        this.m3 = null;
        this.m7 = false;
        this.m6 = false;
        this.assigningCategoryStyle = null;
        this.assigningCategoryMarkerStyle = null;
        this.m1 = null;
        this.m2 = null;
        this.mn = new CategoryFrame(3);
        this.mp = new CategoryFrame(3);
        this.mm = new CategoryFrame(3);
        this.mo = new CategoryFrame(3);
        this.mt = null;
        this.mx = null;
        this.n9 = null;
        this.mt = new CategorySeriesRenderManager();
        this.mx = new CategoryTransitionSourceFramePreparer();
        this.n9 = new Rect(0, 0, 0, 1, 1);
        this.m7 = false;
        this.m6 = false;
        this.ab = CategorySeries.$;
    }
    be() {
        let a = new CategorySeriesView(this);
        return a;
    }
    get m4() {
        if (this.m3 == null) {
            this.m3 = DVContainer.instance.createInstance(ICategorySeriesInteractionManager_$type, () => this.b1.n);
        }
        return this.m3;
    }
    h9(a) {
        super.h9(a);
        this.mu = a;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    get categoryAxis() {
        return this.ml();
    }
    ml() {
        return this.fetchXAxis();
    }
    m5() {
        return this.fetchYAxis();
    }
    get_cj() {
        return true;
    }
    get cj() {
        return this.get_cj();
    }
    ac() {
        super.ac();
        this.mu.cl.g(this.ej);
    }
    ne() {
        return (this.assigningCategoryStyle != null && this.m7) || this.cs;
    }
    nf() {
        return (this.assigningCategoryMarkerStyle != null && this.m6) || this.cs;
    }
    n1(a) {
        if (this.assigningCategoryStyle != null && this.m7) {
            this.assigningCategoryStyle(this, a);
        }
    }
    n0(a) {
        if (this.assigningCategoryMarkerStyle != null && this.m6) {
            this.assigningCategoryMarkerStyle(this, a);
        }
    }
    mf(a, b) {
        return null;
    }
    he(a, b) {
        super.he(a, b);
        if (a) {
            this.nv(b);
        }
    }
    a7() {
        let a = super.a7();
        return a;
    }
    ht() {
        super.ht();
        let a = this.fetchXAxis();
        if (a != null) {
            a.gj(false);
        }
        let b = this.fetchYAxis();
        if (b != null) {
            b.gj(false);
        }
    }
    i8(a, b) {
        super.i8(a, b);
        this.mu.cl.g(this.ej);
        this.it(false);
    }
    i7(a, b) {
        if (this.di && this.eo < 0.05 && (this.br == null || !this.br.c2())) {
            this.dj = true;
        }
        super.i7(a, b);
        this.mu.cl.g(this.ej);
        this.it(false);
    }
    ie(a, b, c, d) {
        super.ie(a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                let e = this.fetchYAxis();
                let f = this.fetchXAxis();
                if (c != null && d == null) {
                    this.hi(f);
                    this.hi(e);
                }
                if (c == null && d != null) {
                    this.ik(f);
                    this.ik(e);
                }
                this.mu.cl.g(this.ej);
                this.it(false);
                break;
            case "SyncLink":
                if (this.bm != null && this.br != null) {
                    this.mu.cl.g(this.ej);
                }
                this.it(false);
                break;
            case "TransitionProgress":
                this.mp.c(this.eo, this.mn, this.mm);
                if (this.cb(this.bh)) {
                    return;
                }
                if (this.eo == 1) {
                    this.mm.v();
                    this.n2(this.mm, this.mu);
                    if (this.di) {
                        this.di = false;
                        this.hf();
                        this.bs.r = truncate(this.eg());
                        this.bs.b = this.bt;
                    }
                }
                else {
                    this.n2(this.mp, this.mu);
                }
                break;
            case "ErrorBarSettings":
                this.h1();
                break;
            case CategorySeries.$$p[4]:
                this.it(false);
                break;
            case CategorySeries.$$p[1]:
                this.m7 = this.m9();
                this.it(false);
                break;
            case CategorySeries.$$p[0]:
                this.m6 = this.m8();
                this.it(false);
                break;
        }
    }
    m9() {
        return this.nc;
    }
    m8() {
        return this.nb;
    }
    nk(a) {
        return this.d4(a, this.fetchXAxis());
    }
    get_cz() {
        return typeCast(ISortingAxis_$type, this.ml()) !== null;
    }
    get cz() {
        return this.get_cz();
    }
    ao() {
        return this.ml();
    }
    ez(a) {
        return this.m4.b$d(this, a);
    }
    fe(a) {
        return this.m4.b$f(this, a);
    }
    ex(a) {
        let b = truncate(Math.round(this.d2(a)));
        return b;
    }
    d2(a) {
        return this.m4.b$c(this, a);
    }
    get_na() {
        return false;
    }
    get na() {
        return this.get_na();
    }
    at(a, b) {
        let c = this.m0(a, b, this.m2);
        this.m2 = c;
        return c;
    }
    get_ct() {
        return true;
    }
    get ct() {
        return this.get_ct();
    }
    as(a, b) {
        if (this.na) {
            let c = this.mz(a, b, this.m1);
            this.m1 = c;
            return c;
        }
        else {
            let d = this.my(a, b, this.m1);
            this.m1 = d;
            return d;
        }
    }
    nj() {
        return this.mu.co.a;
    }
    m0(a, b, c) {
        if (!this.li()) {
            return null;
        }
        let d = this.mm;
        if (this.b9()) {
            d = this.mp;
        }
        let e = this.nj();
        return this.m4.b$b(this, e, d.f, a, b, c);
    }
    mz(a, b, c) {
        let d = this.mu.cl.e;
        let e = this.mu.cl.f;
        let f = this.mu.cl.d;
        let g = this.mm;
        if (this.b9()) {
            g = this.mp;
        }
        return this.m4.b$a(this, g.f, d, e, f, a, b, c);
    }
    my(a, b, c) {
        let d = new HighlightingInfo();
        d.b = this;
        d.f = 0;
        d.e = this.by.count - 1;
        if (c != null && c.f == d.f && c.e == d.e) {
            return c;
        }
        return d;
    }
    nx(a, b, c, d, e, f) {
        let g = this.b8;
        this.mt.ab(a, b, c, d, e, f, g);
        let h = this.mt.b;
        let i = null;
        let j = this.by;
        if (g && this.br != null) {
            i = this.br.az.getHighlightingInfo(this, j, d, h.m, h.l, true);
            h.b = i;
        }
        h.f = f;
        this.n0(h);
        this.mt.z(i, f, g);
    }
    ny(a, b, c, d, e, f) {
        let g = this.b8;
        this.mt.ac(a, b, c, d, e, f, g);
        let h = this.mt.c;
        let i = null;
        let j = this.by;
        if (g && this.br != null) {
            i = this.br.az.getHighlightingInfo(this, j, d, h.m, h.l, false);
            h.b = i;
        }
        h.f = f;
        this.n1(h);
        this.mt.aa(i, f, g);
    }
    ds(a, b, c) {
        let d = super.ds(a, b, c);
        d = d && this.ni(this.fetchXAxis());
        d = d && this.ni(this.fetchYAxis());
        let e = c;
        if (!c.l() || b.isEmpty || a.isEmpty || this.by == null) {
            d = false;
        }
        if (!d) {
            e.cl.d = 0;
        }
        return d;
    }
    ni(a) {
        if (a == null || a.a9 == null) {
            return false;
        }
        let b = typeCast(CategoryAxisBase.$, a);
        if (b != null) {
            if (b.itemsSource == null) {
                return false;
            }
            if (b.ja < 1) {
                return false;
            }
        }
        else {
            let c = typeCast(NumericAxisBase.$, a);
            if (c != null) {
                return c.jg != c.jf;
            }
        }
        return true;
    }
    c8() {
        return this.nd;
    }
    mv() {
        return 12;
    }
    hf() {
        super.hf();
        this.mn.v();
        this.mm.v();
        this.mp.v();
    }
    iu(a) {
        super.iu(a);
        this.mu.cl.g(this.ej);
        if (this.cb(this.bh)) {
            this.mm.y();
            this.mp.y();
            this.mn.y();
            return;
        }
        if (this.da) {
            if (this.b9()) {
                if (this.bs.g) {
                    this.bs.t();
                }
                this.n2(this.mp, this.mu);
            }
            else {
                this.n2(this.mm, this.mu);
            }
            return;
        }
        if (this.c6(a)) {
            let b = this.mn;
            if (this.b9()) {
                if (this.bs.g) {
                    this.bs.t();
                }
                this.mn = this.mp;
                this.mp = b;
            }
            else {
                this.mn = this.mm;
                this.mm = b;
            }
            this.nz(this.mm, this.mu);
            if (this.dk) {
                this.bs.w();
                this.bs.r = truncate(this.eh());
                this.bs.b = this.bu != null ? this.bu : this.bt;
                this.mx.p(this.mn, this.mm, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.mw, this.mv(), this.bo, this.bn(), runOn(this, this.nl), this.mu.bp);
            }
            this.hb();
            this.i1();
            if (this.dk) {
                this.dj = false;
                this.di = true;
            }
        }
        else {
            this.nz(this.mm, this.mu);
            this.n2(this.mm, this.mu);
        }
    }
    bn() {
        return 3;
    }
    nl() {
        if (this.isVertical) {
            return this.ld.left;
        }
        return this.ld.bottom;
    }
    no() {
        let a = 0;
        let b = this.fetchXAxis();
        for (let c of fromEnum(this.br.series)) {
            if (c == this) {
                return a;
            }
            let d = typeCast(CategorySeries.$, c);
            if (d != null) {
                let e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
                if (e == b && d.preferredCategoryMode(e) == 2) {
                    a++;
                }
            }
        }
        return -1;
    }
    get GetErrorBarsXAxis() {
        return this.fetchXAxis();
    }
    get GetErrorBarsYAxis() {
        return this.fetchYAxis();
    }
    nw(a, b) {
        this.mt.w(this, this.nf(), runOn(this, this.mf), this.nm(a), this.nn(a));
        let c = this.mt.b;
        let d = c != null;
        let e = this.ml();
        if (e == null) {
            return;
        }
        let f = this.getEffectiveViewport1(a);
        let g = new ScalerParams(0, a.bq, a.bp, e.bz, f);
        let h = this.by == null ? 0 : this.by.count;
        let i = a;
        let j = b.f;
        let k = i.cl.e;
        let l = i.cl.f;
        let m = i.cl.d;
        let n = k * m;
        for (let o = 0; o < a.co.count; o++) {
            let p = a.co.item(o);
            let q = p.content;
            if (d) {
                let r = p.al;
                this.nx(j, r, h, e, g, a.n);
            }
            this.mt.ad(p, q);
        }
    }
    n2(a, b) {
        this.k4 = a.aa;
        b.ar();
    }
    get oa() {
        return this.n9;
    }
    nz(a, b) {
        a.u();
    }
    nm(a) {
        return a.cl.d;
    }
    nn(a) {
        return a.cl.e;
    }
    nv(a) {
        let b = a;
        b.co.count = 0;
    }
    iv(a, b) {
        super.iv(a, b);
        if (!this.dh) {
            this.bh.az(b);
            return;
        }
        let c = typeCast(CategorySeriesView.$, this.bg);
        c.cl.g(this.ej);
        this.bh.az(b);
        if (this.cb(this.bg)) {
            return;
        }
        this.n3();
        this.dh = false;
    }
    n3() {
        let a = typeCast(CategorySeriesView.$, this.bg);
        if (!this.db) {
            this.nz(this.mo, a);
        }
        this.db = false;
        this.n2(this.mo, a);
    }
    mr(a) {
        let b = typeCast(CategorySeriesView.$, a);
        if (b != null && b.n) {
            if (b.m) {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), b, this, b.cl);
            }
            else {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), this.br.bk.m, this, b.cl);
            }
        }
        else {
            return this.mq;
        }
    }
    al(a) {
        if (this.fetchXAxis() == a) {
            return this.fetchYAxis();
        }
        if (this.fetchYAxis() == a) {
            return this.fetchXAxis();
        }
        return null;
    }
    static mg(a, b, c, d, e) {
        let f = null;
        if (b > -1 && !d.isEmpty && !c.isEmpty) {
            let g = a._inner[0][0] < c.left - 2000 ? c.left - 10 : NaN;
            let h = c.bottom + 10;
            let i = a._inner[b][0] > c.right + 2000 ? c.right + 10 : NaN;
            let j = c.top - 10;
            f = new Clipper(1, g, h, i, j, e);
        }
        return f;
    }
}
CategorySeries.$t = markType(CategorySeries, 'CategorySeries', MarkerSeries.$, [IHasCategoryModePreference_$type, ISupportsErrorBars_$type]);
Type.dep(DependencyProperty, PropertyMetadata, CategorySeries, 'raisePropertyChanged', ['IsCustomCategoryMarkerStyleAllowed:nb:n4', [0, false], 'IsCustomCategoryStyleAllowed:nc:n5', [0, false], 'IsTransitionInEnabled:nd:n6', [0, false], 'TransitionInMode:mw:n7', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'UseHighMarkerFidelity:nh:n8', [0, false]]);
export class CategorySeriesView extends MarkerSeriesView {
    constructor(a) {
        super(a);
        this.cn = null;
        this.cq = 0;
        this.cl = null;
        this.co = null;
        this.cq = -1;
        this.cn = a;
        this.cl = this.cm();
        this.co = ((() => {
            let $ret = new Pool$1(Marker.$);
            $ret.create = runOn(this, this.bv);
            $ret.activate = runOn(this, this.ce);
            $ret.disactivate = runOn(this, this.cg);
            $ret.destroy = runOn(this, this.cf);
            return $ret;
        })());
    }
    cp(a) {
        if (this.cq != a.t) {
            return true;
        }
        return false;
    }
    cs(a) {
        this.cq = a.t;
    }
    updateMarkerTemplate(a, b, c) {
        if (!this.bw.lk) {
            let d = this.co.item(a);
            let e = d.content;
            e.item = this.e.by.item(b);
            d.ak = b;
            d.al = c;
        }
    }
    cm() {
        return new CategoryBucketCalculator(this);
    }
    get shouldDisplayMarkers() {
        return this.cn.li();
    }
    updateMarkerCount(a) {
        this.co.count = a;
    }
    ca(a) {
        this.co.c(a);
    }
    cr() {
    }
}
CategorySeriesView.$t = markType(CategorySeriesView, 'CategorySeriesView', MarkerSeriesView.$, [ISupportsMarkers_$type]);
/*<BeginStatics Name="Infragistics.Controls.Charts.CategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.CategorySeries" />*/
//# sourceMappingURL=CategoryBucketCalculator_combined.js.map