/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { TimeAxisBase } from "./TimeAxisBase";
import { TimeAxisDisplayType_$type } from "./TimeAxisDisplayType";
import { DependencyProperty } from "./DependencyProperty";
import { Type, Base, enumGetBox, Number_$type, typeGetValue, typeCast, markType } from "./type";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { NumericYAxis } from "./NumericYAxis";
import { LinearNumericSnapper } from "./LinearNumericSnapper";
import { LabelPosition } from "./LabelPosition";
import { PropertyMetadata } from "./PropertyMetadata";
import { truncate, intDivide, isNaN_, isInfinity } from "./number";
import { dateMinValue } from "./date";
import { timeSpanFromMilliseconds } from "./timespan";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
export class CategoryDateTimeXAxis extends TimeAxisBase {
    constructor() {
        super();
        this.li = 0;
        this.lj = 0;
        this.ab = CategoryDateTimeXAxis.$;
        this.actualMinimumValue = (new Date());
        this.actualMaximumValue = (new Date());
    }
    get_bv() {
        return this.ld == 0;
    }
    get bv() {
        return this.get_bv();
    }
    ax() {
        return new CategoryDateTimeXAxisView(this);
    }
    f5(a) {
        super.f5(a);
        this.lc = a;
    }
    get lk() {
        return this.li;
    }
    set lk(a) {
        if (this.lk != a) {
            let b = this.li;
            this.li = a;
            this.gd("ActualInterval", b, this.lk);
        }
    }
    get lo() {
        return typeGetValue(this.c(CategoryDateTimeXAxis.lz));
    }
    set lo(a) {
        this.h(CategoryDateTimeXAxis.lz, a);
    }
    get ll() {
        return this.lj;
    }
    set ll(a) {
        if (this.ll != a) {
            let b = this.lj;
            this.lj = a;
            this.gd("ActualMinorInterval", b, this.ll);
        }
    }
    ch(a, b, c) {
        let d = super.ch(a, b, c);
        if (!d) {
            return false;
        }
        return +(this.actualMinimumValue) != +(this.actualMaximumValue);
    }
    c7() {
        return this.lk;
    }
    gk(a) {
        super.gk(a);
        let b = this.a9 != null ? this.a9.mk : Rect.empty;
        let c = !b.isEmpty ? this.ib : Rect.empty;
        let d = this.h6();
        let e = this.h5();
        let f = new ScalerParams(0, b, c, this.bz, d);
        if (this.ka == null && !this.kg() && !this.kh()) {
            return;
        }
        if (!b.isEmpty && !c.isEmpty && (this.ld != 1 || this.ka != null)) {
            let g = c.bottom;
            let h = g - c.top;
            if (this.ag != null) {
                let i = typeCast(NumericYAxis.$, this.ag);
                if (i != null) {
                    let j = this.gn(g, h, b, c, d, c.top, c.bottom);
                    g = j.p0;
                    h = j.p1;
                }
            }
            if (isNaN_(g)) {
                g = 0;
            }
            this.f3(this.ay.at(), g, c, this.ay.e(), true);
            this.ap.a6 = h;
            let k = this.ay.aw();
            let l = this.ay.f();
            let m = this.ay.au();
            let n = this.ay.av();
            let o = this.ay.g();
            if (this.ld == 1) {
                let p = this.i$e(b, c, d, e);
                let q = this.i$g(b, c, d, e);
                if (p < 0 || q < 0) {
                    return;
                }
                let r = NaN;
                for (let s = p; s <= q; s++) {
                    let t = this.kj == null ? s : this.kj._inner[s];
                    let u = this.dj(this.ka.item(t).getTime(), f);
                    if (u == r) {
                        continue;
                    }
                    r = u;
                    if (this.categoryMode == 2) {
                        u += this.bz ? -this.getGroupCenter(s, b, c, d) : this.getGroupCenter(s, b, c, d);
                    }
                    if (u < e.left || u > e.right) {
                        continue;
                    }
                    this.gs(m, u, c, l, false);
                    this.iy.add(u);
                    if (this.ir != null && s < this.ir.count) {
                        let v = this.ir.item(t);
                        let w = super.eq(v);
                        if (!isNaN_(u) && !isInfinity(u) && w != null) {
                            if ((typeof w === 'string') && Base.equalsStatic(w, "")) {
                            }
                            else {
                                this.cj.add1(w);
                                this.ck.add(new LabelPosition(u));
                            }
                        }
                    }
                }
            }
            else {
                let x = this.dm(e.left, f);
                let y = this.dm(e.right, f);
                let z = Math.min(x, y);
                let aa = Math.max(x, y);
                let ab = new LinearNumericSnapper(0, z, aa, e.width, this.dw());
                let ac = this.ke ? this.lh() : ab.g;
                this.lv(truncate(ac));
                let ad = truncate(Math.floor((z - this.actualMinimumValue.getTime()) / ac));
                let ae = truncate(Math.ceil((aa - this.actualMinimumValue.getTime()) / ac));
                let af = 0;
                if (this.categoryMode == 2) {
                    af = this.getGroupCenter(0, b, c, d);
                    af = this.bz ? -af : af;
                }
                let ag = truncate(Math.ceil(e.right));
                let ah = truncate(Math.floor(e.left));
                let ai = this.dj(this.actualMinimumValue.getTime() + ad * ac, f) + af;
                for (let aj = ad; aj <= ae; aj++) {
                    let ak = this.dj(this.actualMinimumValue.getTime() + (aj + 1) * ac, f) + af;
                    if (!isNaN_(ai) && !isInfinity(ai)) {
                        let al = truncate(Math.round(ai));
                        if (al <= ag) {
                            if (aj % 2 == 0) {
                                this.gt(k, ai, ak, c);
                            }
                            this.gs(m, ai, c, l, false);
                            this.iy.add(ai);
                            if (this.b9) {
                                let am = this.lm();
                                if (am > 0 && am < ac) {
                                    if (ac / am < 20) {
                                        let an = ai;
                                        let ao = Math.abs(this.dj(this.actualMinimumValue.getTime() + am, f) - this.dj(this.actualMinimumValue.getTime(), f));
                                        while (an + ao < ak) {
                                            if (Math.abs(an + ao - ak) < 0.0001) {
                                                break;
                                            }
                                            an += ao;
                                            if (an > 0) {
                                                this.gs(n, an, c, o, false);
                                            }
                                        }
                                        this.lw(am);
                                    }
                                }
                                else {
                                    for (let ap = 1; ap < ab.i; ++ap) {
                                        let aq = this.dj(this.actualMinimumValue.getTime() + aj * ac + (ap * ac) / ab.i, f) + af;
                                        this.gs(n, aq, c, o, false);
                                    }
                                    if (ab.i > 0) {
                                        this.lw(truncate((ac / ab.i)));
                                    }
                                }
                            }
                        }
                        if (al >= ah && al <= ag) {
                            let ar = this.actualMinimumValue.getTime() + aj * ac;
                            let ticks_ = truncate(Math.floor(ar));
                            let as = (new Date(ticks_));
                            let at = this.eq(as);
                            if (at != null) {
                                this.cj.add1(at);
                                this.ck.add(new LabelPosition(ai));
                            }
                        }
                    }
                    ai = ak;
                }
            }
            if ((this.as == null || this.as.visibility == 0) && this.ag != null) {
                if (this.as != null && (this.as.location == 4 || this.as.location == 5)) {
                    this.a9.hp();
                }
            }
            this.ap.a1 = this.cj;
            this.ap.a2 = this.ck;
            this.jy();
        }
    }
    lh() {
        return this.lk;
    }
    lm() {
        return this.lo;
    }
    lv(a) {
        this.lk = a;
    }
    lw(a) {
        this.ll = a;
    }
    lf() {
        return this.ln != 0;
    }
    le() {
        return this.lk == 0;
    }
    lg(a) {
        return this.ka == null ? dateMinValue() : this.ka.item(a);
    }
    lu(a, b) {
        if (a > b || this.ir == null || this.ir.count == 0) {
            return;
        }
        let c = (a.getTime() - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        let d = (b.getTime() - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        this.a9.my = new Rect(0, c, this.a9.my.y, d - c, this.a9.my.height);
    }
    f7(a, b, c, d) {
        super.f7(a, b, c, d);
        switch (b) {
            case CategoryDateTimeXAxis.$$p[0]:
                this.b6 = true;
                this.ap.ak = this.ld == 1;
                this.gj(false);
                break;
            case CategoryDateTimeXAxis.$$p[1]:
                this.b6 = true;
                this.gj(false);
                break;
        }
    }
    k2() {
        super.k2();
        if (this.lf()) {
            this.lk = this.ln;
            let a = this.a9 != null ? this.a9.mk : Rect.empty;
            let b = !a.isEmpty ? this.ib : Rect.empty;
            let c = Math.abs(this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            this.ke = this.le() || (this.ld == 1) || (1 * c / this.lh() > (b.width / a.width)) ? false : true;
        }
        else {
            this.ke = false;
        }
    }
    k0(a, b) {
        let c = b.getTime() - a.getTime();
        let timeOffset_ = truncate(Math.round(intDivide(c, this.ja) / 2));
        return timeOffset_ == 0 ? timeSpanFromMilliseconds(1) : timeSpanFromMilliseconds(timeOffset_);
    }
    get_bu() {
        return true;
    }
    get bu() {
        return this.get_bu();
    }
    get isVertical() {
        return this.b5;
    }
    j$c(a, b) {
        return this.dm.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dj.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.fz.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.f0.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.f1.apply(this, arguments);
    }
    get j$a() {
        return this.bz;
    }
    get i$a() {
        return this.bw;
    }
}
CategoryDateTimeXAxis.lz = DependencyProperty.i("MinorInterval", Number_$type, CategoryDateTimeXAxis.$, new PropertyMetadata(2, 0, (a, b) => {
    (typeCast(CategoryDateTimeXAxis.$, a)).gd("MinorInterval", b.oldValue, b.newValue);
    (typeCast(CategoryDateTimeXAxis.$, a)).gj(false);
}));
CategoryDateTimeXAxis.$t = markType(CategoryDateTimeXAxis, 'CategoryDateTimeXAxis', TimeAxisBase.$);
Type.dep(DependencyProperty, PropertyMetadata, CategoryDateTimeXAxis, 'gd', ['DisplayType:ld:lx', [TimeAxisDisplayType_$type, enumGetBox(TimeAxisDisplayType_$type, 0)], 'Interval:ln:ly', [1, 0]]);
export class CategoryDateTimeXAxisView extends CategoryAxisBaseView {
    constructor(a) {
        super(a);
        this.ba = null;
        this.ba = a;
    }
}
CategoryDateTimeXAxisView.$t = markType(CategoryDateTimeXAxisView, 'CategoryDateTimeXAxisView', CategoryAxisBaseView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.CategoryDateTimeXAxis" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.CategoryDateTimeXAxis" />*/
//# sourceMappingURL=CategoryDateTimeXAxis_combined.js.map