/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Brush } from "./Brush";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { BaseError, EventArgs, Base, runOn, delegateRemove, delegateCombine, typeCast, fromEnum, EnumUtil, Number_$type, String_$type, enumGetBox, Type, markType, TypeRegistrar, typeCastObjTo$t, fromEn } from "./type";
import { ZoomSliderWidget } from "./ZoomSliderWidget";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { List$1 } from "./List$1";
import { DataSeriesType_$type } from "./DataSeriesType";
import { IDataSeriesAdapterRule_$type } from "./IDataSeriesAdapterRule";
import { SimpleFinancialPriceSeriesRule } from "./SimpleFinancialPriceSeriesRule";
import { SubCollectionsRule } from "./SubCollectionsRule";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { FinancialIndicatorTypeCollection } from "./FinancialIndicatorTypeCollection";
import { FinancialOverlayTypeCollection } from "./FinancialOverlayTypeCollection";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "./BrushCollection";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Rect } from "./Rect";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { Series } from "./Series";
import { MarkerSeries } from "./MarkerSeries";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { ArrayExtension } from "./ArrayExtension";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ObservableCollection$1 } from "./ObservableCollection$1";
import { ScalerParams } from "./ScalerParams";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { stringReplace, stringJoin, stringIsNullOrEmpty, stringToString$1 } from "./string";
import { timeSpanFromDays } from "./timespan";
import { dateMaxValue, dateMinValue } from "./date";
import { isNaN_, isInfinity } from "./number";
import { FinancialChartEnumCollectionPickerToolViewModel } from "./FinancialChartEnumCollectionPickerToolViewModel";
import { FinancialChartEnumCollectionPickerToolView } from "./FinancialChartEnumCollectionPickerToolView";
import { SRProvider } from "./SRProvider";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartTrendLinePicker } from "./FinancialChartTrendLinePicker";
import { FinancialChartVolumeTypePicker } from "./FinancialChartVolumeTypePicker";
import { TrendLineType_$type } from "./TrendLineType";
import { FinancialChartChartTypePickerContext } from "./FinancialChartChartTypePickerContext";
import { FinancialChartIndicatorPickerContext } from "./FinancialChartIndicatorPickerContext";
import { FinancialChartOverlayPickerContext } from "./FinancialChartOverlayPickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartTrendLinePickerContext } from "./FinancialChartTrendLinePickerContext";
import { FinancialChartVolumeTypePickerContext } from "./FinancialChartVolumeTypePickerContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
export class FinancialChart extends XYChart {
    constructor() {
        super();
        this.om = null;
        this.qu = null;
        this.qs = null;
        this.qq = null;
        this.qr = null;
        this.qt = null;
        this.nu = null;
        this.rc = null;
        this.rd = null;
        this.q9 = null;
        this.re = null;
        this.rf = null;
        this.ra = null;
        this.rb = null;
        this.pb = null;
        this.p8 = 40;
        this.og = null;
        this.oe = null;
        this.oi = null;
        this.on = null;
        this.rn = null;
        this.o7 = null;
        this.pu = false;
        this.pt = false;
        this.pg = false;
        this.q0 = 10;
        this.qa = NaN;
        this.qc = NaN;
        this.qb = NaN;
        this.qd = 0;
        this.n0 = 0;
        this.n3 = 0;
        this.n5 = 0;
        this.pd = true;
        this.nw = 0;
        this.pe = false;
        this.oa = null;
        this.oc = null;
        this.p0 = null;
        this.pf = true;
        this.o8 = null;
        this.n7 = 1;
        this.my = null;
        this.mz = null;
        this.m0 = null;
        this.m1 = null;
        this.m3 = null;
        this.m2 = null;
        this.mx = null;
        this.mw = null;
        this.p9 = 1;
        this.p7 = 1;
        this.p6 = 1;
        this.ok = null;
        this.qw = -2147483648;
        this.p5 = 2;
        this.qz = 3;
        this.qx = 10;
        this.qv = 30;
        this.qy = 9;
        this.nr = null;
        this.ns = null;
        this.nn = null;
        this.applyCustomIndicators = null;
        this.eo();
        this.t6();
    }
    fk(a, b, c) {
        super.fk(a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.nv = new FinancialChartToolbar(this, this.rk);
                break;
            case "Toolbar":
                let d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.tu));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.tx));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.ty));
                    d.l(null);
                }
                if (this.nv != null) {
                    this.nv.af = this.n2;
                    this.nv.an = this.ai;
                    this.nv.ab = this.nx;
                    this.nv.aq = this.pr;
                    if (this.qr != null) {
                        this.nv.l(this.qr);
                    }
                    let e = this.nv;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.tu));
                    ;
                    let f = this.nv;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.tx));
                    let g = this.nv;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.ty));
                }
                break;
            case "ChartType":
                if (this.nv != null) {
                    this.nv.ab = this.nx;
                }
                break;
            case "VolumeType":
                if (this.nv != null) {
                    this.nv.af = this.n2;
                }
                break;
            case "TrendLineType":
                if (this.nv != null) {
                    this.nv.an = this.ai;
                }
                break;
            case "IsToolbarVisible":
                if (this.nv == null) {
                    break;
                }
                this.nv.aq = this.pr;
                this.setGridRows();
                break;
        }
    }
    ty(a, b) {
        this.n2 = this.nv.af;
    }
    tx(a, b) {
        this.ai = this.nv.an;
    }
    tu(a, b) {
        this.nx = this.nv.ab;
    }
    t6() {
        this.om = new IndicatorPane();
    }
    provideGrid(a) {
        this.qu = a;
        this.up();
        this.setGridRows();
        if (this.nv != null) {
            this.nv.bp(a);
        }
    }
    onDocumentClick(a) {
        if (this.nv != null) {
            this.nv.bx(a);
        }
    }
    pm() {
        return (navigator.userAgent.indexOf("Trident/7") >= 0);
    }
    getContext() {
        let a = this.nv.w();
        let b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.cm;
        b.toolbarContainer = this.qr;
        b.indicatorsContainer = this.qq;
        b.volumeContainer = this.qs;
        b.zoomContainer = this.qt;
        return b;
    }
    provideContainer(a) {
        let b = a;
        if (b != null) {
            let c = "financialChartMainGrid";
            let d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.nv == null) {
                this.nv = new FinancialChartToolbar(this, this.rk);
            }
            this.nv.x.isIndicatorPickerVisible = this.pi;
            this.nv.x.isOverlayPickerVisible = this.pj;
            this.qr = b.getSubRenderer(d);
            this.nv.l(this.qr);
            let e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            let f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.qq = b.getSubRenderer(f);
            let g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.qs = b.getSubRenderer(g);
            let h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.qt = b.getSubRenderer(h);
            a = b.getSubRenderer(e);
        }
        else {
            this.qr = null;
            if (this.nv != null) {
                this.nv.l(null);
            }
        }
        super.provideContainer(a);
        if (this.volumeChart != null) {
            this.volumeChart.provideContainer(this.qs);
        }
        if (this.om != null) {
            this.om.h(this.qq);
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.provideContainer(this.qt);
            if (a != null) {
                this.th();
            }
            else {
                this.pc = null;
            }
        }
        this.setGridRows();
    }
    ug(a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    }
    ut(a, b) {
        this.ug(a, b, this.qt);
        if (b == null) {
            return;
        }
        this.th();
    }
    th() {
        if (this.qt == null) {
            return;
        }
        this.pc = ZoomSliderWidget.a(this.externalObject, this.qt.rootWrapper);
        let a = this.pc;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, (a, b) => {
            if (this.dataChart != null) {
                this.dataChart.my = new Rect(0, this.pc.r.left, this.dataChart.mk.top, this.pc.r.width, this.dataChart.mk.height);
            }
        });
    }
    ur(a, b) {
        this.ug(a, b, this.qs);
    }
    setGridRows() {
        if (this.qu == null) {
            return;
        }
        let a = new Array(5);
        a[0] = (this.pr ? this.qi : 0) + "px";
        a[1] = "auto";
        a[2] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[3] = this.volumeChart == null ? "0px" : "100px";
        a[4] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.pc != null) {
            let b = this.pc;
            if (a[4] == "0px") {
                b.hide();
            }
            else {
                b.show();
            }
        }
        this.qu.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin(" ", ...a), "auto", "1fr"));
        this.qu.setStyleProperty("grid-template-rows", stringJoin(" ", ...a));
        if (this.cm == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.om != null) {
            this.om.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.pc != null) {
            this.pc.m();
        }
    }
    e1() {
        super.e1();
        this.gq = 3;
        this.lt = 0;
        this.by = NaN;
        this.bw = 30;
        this.ay = true;
        this.a3 = false;
        if (this.dataChart != null) {
            let a = this.dataChart.bk.i.e();
            this.m6 = a.d;
            this.m7 = a.e;
            this.m5 = a.d;
        }
        let b = new BrushCollection();
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(116, 70, 185, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(159, 179, 40, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(46, 156, 166, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(63, 81, 181, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(154, 154, 154, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(67, 156, 71, .3)";
            return $ret;
        })()));
        this.m8 = b;
        let c = new BrushCollection();
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#7446B9";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#9FB328";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#2E9CA6";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#3F51B5";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#9A9A9A";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#439C47";
            return $ret;
        })()));
        this.m9 = c;
    }
    uc() {
        if (this.om != null) {
            this.om.b = null;
            this.om.b = this.indicatorCharts;
        }
        this.setGridRows();
    }
    ud() {
        this.setGridRows();
    }
    ul() {
        this.uc();
    }
    t4() {
        if (this.pc == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        let a = this.cm.rootWrapper.width();
        let b = this.dataChart.mx.left + this.dataChart.mx.width;
        let c = this.dataChart.mx.left;
        let d = a - b;
        this.pc.d = c - this.pc.f;
        this.pc.c = d - this.pc.e;
        if (this.pc.c < 0) {
            let e = this.pc.c;
            this.pc.c = 0;
            this.dataChart.ei += (e * -1);
        }
        if (this.pc.d < 0) {
            let f = this.pc.d;
            this.pc.d = 0;
            this.dataChart.eg += (f * -1);
        }
        this.zoomSliderChart.eg = c;
        this.zoomSliderChart.ei = d;
        this.zoomSliderChart.ec = this.pc.b;
    }
    ey(a) {
        super.ey(a);
        if (a != null) {
            a.eb = 0;
        }
    }
    uu(a) {
        return a.md();
    }
    uv(a) {
        if (a == null || a.d == null || a.d.rootWrapper == null) {
            return null;
        }
        let b = a.d.rootWrapper.getOffset();
        return new Rect(0, b.left, b.top, a.d.rootWrapper.width(), a.d.rootWrapper.height());
    }
    qe() {
        if (this.qu == null) {
            return NaN;
        }
        let a = this.qu.getOffset();
        return this.qu.width() + (a == null ? 0 : a.left);
    }
    e9(source_, a, b) {
        super.e9(source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hu(source_, a, b);
        }
    }
    fa(source_, a, b) {
        super.fa(source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hv(source_, a, b);
        }
    }
    e8(source_) {
        super.e8(source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hr(source_);
        }
    }
    fc(source_, a, b, c) {
        super.fc(source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hw(source_, a, b, c);
        }
    }
    get nv() {
        return this.nu;
    }
    set nv(a) {
        let b = this.nv;
        if (a != b) {
            this.nu = a;
            this.fi("Toolbar", b, this.nv);
        }
    }
    get rj() {
        return this.rc;
    }
    set rj(a) {
        let b = this.rj;
        if (a != b) {
            this.rc = a;
            this.fi("RangeSelectorTemplate", b, this.rj);
        }
    }
    get rk() {
        return this.rd;
    }
    set rk(a) {
        let b = this.rk;
        if (a != b) {
            this.rd = a;
            this.fi("ToolbarTemplate", b, this.rk);
        }
    }
    get rg() {
        return this.q9;
    }
    set rg(a) {
        let b = this.rg;
        if (a != b) {
            this.q9 = a;
            this.fi("ChartTypePickerTemplate", b, this.rg);
        }
    }
    get rl() {
        return this.re;
    }
    set rl(a) {
        let b = this.rl;
        if (a != b) {
            this.re = a;
            this.fi("TrendLineTypePickerTemplate", b, this.rl);
        }
    }
    get rm() {
        return this.rf;
    }
    set rm(a) {
        let b = this.rm;
        if (a != b) {
            this.rf = a;
            this.fi("VolumeTypePickerTemplate", b, this.rm);
        }
    }
    get rh() {
        return this.ra;
    }
    set rh(a) {
        let b = this.rh;
        if (a != b) {
            this.ra = a;
            this.fi("IndicatorPickerTemplate", b, this.rh);
        }
    }
    get ri() {
        return this.rb;
    }
    set ri(a) {
        let b = this.ri;
        if (a != b) {
            this.rb = a;
            this.fi("OverlayPickerTemplate", b, this.ri);
        }
    }
    get pc() {
        return this.pb;
    }
    set pc(a) {
        let b = this.pc;
        if (a != b) {
            this.pb = a;
            this.fi("ZoomSlider", b, this.pc);
        }
    }
    get_bw() {
        return super.get_bw();
    }
    set_bw(a) {
        super.set_bw(a);
    }
    get bw() {
        return this.get_bw();
    }
    set bw(a) {
        this.set_bw(a);
    }
    get_ay() {
        return super.get_ay();
    }
    set_ay(a) {
        super.set_ay(a);
    }
    get ay() {
        return this.get_ay();
    }
    set ay(a) {
        this.set_ay(a);
    }
    get qi() {
        return this.p8;
    }
    set qi(a) {
        let b = this.qi;
        if (a != b) {
            this.p8 = a;
            this.fi("ToolbarHeight", b, this.qi);
        }
    }
    get xAxis() {
        return this.ne;
    }
    set xAxis(a) {
        let b = this.xAxis;
        if (a != b) {
            this.ne = a;
            this.fi("XAxis", b, this.xAxis);
        }
    }
    get yAxis() {
        return this.or;
    }
    set yAxis(a) {
        let b = this.yAxis;
        if (a != b) {
            this.or = a;
            this.fi("YAxis", b, this.yAxis);
        }
    }
    get volumeAxis() {
        return this.oq;
    }
    set volumeAxis(a) {
        let b = this.volumeAxis;
        if (a != b) {
            this.oq = a;
            this.fi("VolumeAxis", b, this.volumeAxis);
        }
    }
    get volumeXAxis() {
        return this.nd;
    }
    set volumeXAxis(a) {
        let b = this.volumeXAxis;
        if (a != b) {
            this.nd = a;
            this.fi("VolumeXAxis", b, this.volumeXAxis);
        }
    }
    get indicatorAxis() {
        return this.op;
    }
    set indicatorAxis(a) {
        let b = this.indicatorAxis;
        if (a != b) {
            this.op = a;
            this.fi("IndicatorAxis", b, this.indicatorAxis);
        }
    }
    get indicatorXAxis() {
        return this.nc;
    }
    set indicatorXAxis(a) {
        let b = this.indicatorXAxis;
        if (a != b) {
            this.nc = a;
            this.fi("IndicatorXAxis", b, this.indicatorXAxis);
        }
    }
    get p2() {
        return this.pz;
    }
    set p2(a) {
        let b = this.p2;
        if (a != b) {
            this.pz = a;
            this.fi("IndicatorAxes", b, this.p2);
        }
    }
    get p4() {
        return this.p1;
    }
    set p4(a) {
        let b = this.p4;
        if (a != b) {
            this.p1 = a;
            this.fi("IndicatorXAxes", b, this.p4);
        }
    }
    gj() {
        return this.xAxis;
    }
    gk() {
        return this.yAxis;
    }
    r(a) {
        return 20;
    }
    get_ba() {
        return ((() => {
            let $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    }
    get ba() {
        return this.get_ba();
    }
    get_a9() {
        return ((() => {
            let $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    }
    get a9() {
        return this.get_a9();
    }
    nh(a) {
        return this.ni(a);
    }
    ot(a) {
        return this.ou(a);
    }
    ng(a) {
        let b = this.nh(0);
        b.name = a;
        return b;
    }
    em() {
        this.xAxis = this.ng("xAxis");
        this.yAxis = this.ot(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.ot(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.ng("volumeXAxis");
        this.indicatorAxis = this.ot(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.ng("indicatorXAxis");
        this.p2 = new List$1(NumericYAxis.$, 0);
        this.p4 = new List$1(CategoryAxisBase.$, 0);
        this.p2.add(this.indicatorAxis);
        this.p4.add(this.indicatorXAxis);
        if (this.xAxis.as == null) {
            this.xAxis.as = new AxisLabelSettings();
        }
        if (this.yAxis.as == null) {
            this.yAxis.as = new AxisLabelSettings();
        }
        if (this.volumeAxis.as == null) {
            this.volumeAxis.as = new AxisLabelSettings();
        }
        if (this.volumeXAxis.as == null) {
            this.volumeAxis.as = new AxisLabelSettings();
        }
        if (this.indicatorAxis.as == null) {
            this.indicatorAxis.as = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.as == null) {
            this.indicatorXAxis.as = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.ot(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.ng("zoomSliderXAxis");
        if (this.zoomSliderAxis.as == null) {
            this.zoomSliderAxis.as = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.as == null) {
            this.zoomSliderXAxis.as = new AxisLabelSettings();
        }
        this.lb(this.zoomSliderAxis, (a) => a.visibility = 1);
        this.lb(this.zoomSliderXAxis, (a) => a.visibility = 1);
    }
    f1(a) {
        super.f1(a);
        a.hc();
    }
    ek(a, b) {
        let c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.lg = this.ad(a, b);
        }
    }
    fw(a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.i5 = true;
            this.yAxis.js = 10;
        }
    }
    fz() {
        this.yAxis.i5 = this.pw;
        this.yAxis.js = this.q8;
    }
    nz() {
        let a;
        if (this.nx == 0) {
            if (this.s == null || this.s.dataSeries == null || this.s.dataSeries.count == 0 || stringIsNullOrEmpty(this.s.dataSeries._inner[0].getMemberPathFor(12))) {
                a = 4;
            }
            else {
                a = 1;
            }
        }
        else {
            a = this.nx;
        }
        a = this.ny(a);
        return a;
    }
    ny(a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    }
    n8(a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    }
    n1(a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    }
    rt(a) {
        let b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    }
    o5(seriesType_) {
        return (this.externalObject.createSeries(seriesType_).i);
    }
    ni(axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            let a;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    }
    ou(axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            let a;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    }
    o0() {
        return this.o5(1);
    }
    o1() {
        return this.o5(0);
    }
    oz() {
        return this.o5(2);
    }
    o2() {
        return this.o5(20);
    }
    get ph() {
        return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
    }
    get oh() {
        if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
            return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
        }
        else {
            throw new BaseError(1, "horizontal series module is not loaded, but is required.");
        }
    }
    get pk() {
        return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
    }
    get of() {
        if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
            return TypeRegistrar.create("FinancialPriceSeriesProxy");
        }
        else {
            throw new BaseError(1, "financial series module is not loaded, but is required.");
        }
    }
    get pi() {
        return (TypeRegistrar.isRegistered("IndicatorProxy"));
    }
    get oj() {
        if (TypeRegistrar.isRegistered("IndicatorProxy")) {
            return TypeRegistrar.create("IndicatorProxy");
        }
        else {
            throw new BaseError(1, "financial series module is not loaded, but is required.");
        }
    }
    get pj() {
        return (TypeRegistrar.isRegistered("OverlayProxy"));
    }
    get oo() {
        if (TypeRegistrar.isRegistered("OverlayProxy")) {
            return TypeRegistrar.create("OverlayProxy");
        }
        else {
            throw new BaseError(1, "overlay series module is not loaded, but is required.");
        }
    }
    ag(a, b) {
        let c = this.rt(a);
        switch (this.nz()) {
            case 3:
                let d = this.o0();
                this.oh.setValueMemberPath(d, c);
                this.oh.setXAxis(d, this.xAxis);
                this.oh.setYAxis(d, this.yAxis);
                this.oh.setCategoryMode(d, 1);
                return d;
            case 4:
                let e = this.o1();
                this.oh.setValueMemberPath(e, c);
                this.oh.setXAxis(e, this.xAxis);
                this.oh.setYAxis(e, this.yAxis);
                this.oh.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                let f = this.o2();
                this.of.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.of.setHighMemberPath(f, a.getMemberPathFor(12));
                this.of.setLowMemberPath(f, a.getMemberPathFor(13));
                this.of.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.of.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.of.setXAxis(f, this.xAxis);
                this.of.setYAxis(f, this.yAxis);
                this.of.setDisplayType(f, this.nx == 2 ? 0 : 1);
                this.of.setCategoryMode(f, 1);
                return f;
        }
    }
    fy() {
        super.fy();
        this.t2(this.xAxis);
        this.un(false);
        if (this.n2 != 0 && this.volumeChart != null) {
            this.t8();
        }
        this.t2(this.volumeXAxis);
        this.t2(this.indicatorXAxis);
        this.uk();
        this.um();
        if (this.n9 != 0) {
            this.t9();
            this.t2(this.zoomSliderXAxis);
        }
    }
    lh(a) {
        super.lh(a);
        a(this.volumeXAxis);
        if (this.p4 != null) {
            for (let b of fromEnum(this.p4)) {
                a(b);
            }
        }
        a(this.zoomSliderXAxis);
    }
    ll(a, b) {
        super.ll(a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.p2 != null) {
                for (let c of fromEnum(this.p2)) {
                    a(c);
                }
            }
            a(this.zoomSliderAxis);
        }
    }
    lj(a) {
        super.lj(a);
        this.lc(this.volumeXAxis, a);
        this.lc(this.indicatorXAxis, a);
        this.lc(this.zoomSliderXAxis, a);
    }
    ln(a) {
        super.ln(a);
        this.lc(this.volumeAxis, a);
        this.lc(this.indicatorAxis, a);
        this.lc(this.zoomSliderAxis, a);
    }
    lm(a) {
        super.lm(a);
        this.lb(this.volumeAxis, a);
        this.lb(this.indicatorAxis, a);
        this.lb(this.zoomSliderAxis, a);
    }
    li(a) {
        super.li(a);
        this.lb(this.volumeXAxis, a);
        this.lb(this.indicatorXAxis, a);
        this.lb(this.zoomSliderXAxis, a);
    }
    ex(a) {
        super.ex(a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.nl = a.nn = false;
            a.ay = null;
        }
        else {
            SyncManager.d(a, ((() => {
                let $ret = new SyncSettings();
                $ret.ae = this.sm();
                $ret.ac = true;
                $ret.ad = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.bc = 2;
    }
    sm() {
        if (this.rn == null) {
            FinancialChart.q7++;
            this.rn = FinancialChart.q7.toString();
        }
        return this.rn;
    }
    to(a, b) {
        this.tf();
        this.t4();
    }
    tf() {
        if (this.yAxis.br()) {
            return;
        }
        let a = this.yAxis.ap.a5;
        if (this.n2 != 0) {
            a = Math.max(a, this.volumeAxis.ap.a5);
        }
        for (let b of fromEnum(this.p2)) {
            a = Math.max(a, b.ap.a5);
        }
        this.yAxis.ds = this.volumeAxis.ds = a;
        for (let c of fromEnum(this.p2)) {
            c.ds = a;
        }
        this.zoomSliderAxis.ds = this.yAxis.ds;
    }
    ti(a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (let b = 0; b < this.indicatorCharts.count; b++) {
            let c = this.indicatorCharts._inner[b];
            for (let d = 0; d < c.series.count; d++) {
                a(c.series._inner[d], b);
            }
        }
    }
    tk(a) {
        if (this.volumeChart == null) {
            return;
        }
        for (let b = 0; b < this.volumeChart.series.count; b++) {
            a(this.volumeChart.series._inner[b], b);
        }
    }
    tj(a) {
        if (this.dataChart == null) {
            return;
        }
        let b = this.s == null || this.s.dataSeries == null ? 0 : this.s.dataSeries.count;
        let c = this.od == null ? 0 : this.od.count;
        for (let d = 0; d < this.dataChart.series.count; d++) {
            if (this.po(this.dataChart.series._inner[d])) {
                continue;
            }
            let e = d - (b * c);
            a(this.dataChart.series._inner[d], e);
        }
    }
    q1(a, b) {
        if (a.bp != this.dataChart) {
            return b;
        }
        let c = this.s == null || this.s.dataSeries == null ? 0 : this.s.dataSeries.count;
        let d = this.od == null ? 0 : this.od.count;
        return b - (c * d);
    }
    er(a) {
        super.er(a);
        this.tk(a);
        this.ti(a);
    }
    get volumeChart() {
        return this.o7;
    }
    set volumeChart(a) {
        let b = this.volumeChart;
        if (a != b) {
            this.o7 = a;
            this.fi("VolumeChart", b, this.volumeChart);
        }
    }
    t8() {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        let a = new List$1(Series.$, 0);
        let b = -1;
        for (let c = 0; c < this.dataChart.series.count; c++) {
            let d = this.dataChart.series._inner[c];
            if (this.po(d)) {
                continue;
            }
            b++;
            let e;
            let f = this.n2;
            f = this.n1(f);
            switch (f) {
                case 2:
                    e = this.o1();
                    break;
                case 3:
                    e = this.oz();
                    break;
                default:
                case 1:
                    e = this.o0();
                    break;
            }
            this.oh.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.oh.setXAxis(e, this.volumeXAxis);
            this.oh.setYAxis(e, this.volumeAxis);
            this.oh.setValueMemberPath(e, this.s != null && this.s.dataSeries != null && this.s.dataSeries.count > b ? this.s.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.fj = d.fj + " Volume";
            e.kk = ArrayExtension.getModulus$1(Brush.$, this.na, b);
            e.kn = ArrayExtension.getModulus$1(Brush.$, this.nb, b);
            e.en = this.qj;
            a.add(e);
        }
        for (let g = 0; g < a.count; g++) {
            let h = a._inner[g];
            this.volumeChart.series.add(h);
            this.e2(h, g);
        }
    }
    pl(a) {
        if (!this.ph) {
            return false;
        }
        return this.oh.matchesType(a);
    }
    pp(a) {
        if (!this.pk) {
            return false;
        }
        return this.of.matchesType(a);
    }
    pn(a) {
        if (!this.pi) {
            return false;
        }
        return this.oj.matchesType(a);
    }
    po(a) {
        if (!this.pj) {
            return false;
        }
        return this.oo.matchesType(a);
    }
    t7() {
        if (this.dataChart == null) {
            return;
        }
        let a = 0;
        let b = this.ob == null ? 0 : this.ob.count;
        let c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        let d = b + c;
        for (let e = 0; e < d; e++) {
            let f = new List$1(Series.$, 0);
            let g = this.indicatorCharts._inner[e];
            let h = e >= b;
            let i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.ob._inner[e]);
            let j = -1;
            for (let k = 0; k < this.dataChart.series.count; k++) {
                let l = this.dataChart.series._inner[k];
                if (this.po(l)) {
                    continue;
                }
                j++;
                let m;
                if (h) {
                    let n = this.o3("Custom");
                    this.oj.handleCustomIndicatorEvent(n, runOn(this, this.tm));
                    m = n;
                }
                else {
                    m = this.o6(this.ob._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.oj.setXAxis(m, this.p4._inner[e]);
                this.oj.setYAxis(m, this.p2._inner[e]);
                m.itemsSource = l.itemsSource;
                this.oj.setOpenMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(11));
                this.oj.setHighMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(12));
                this.oj.setLowMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(13));
                this.oj.setCloseMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(14));
                this.oj.setVolumeMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(15));
                m.fj = l.fj + " " + i;
                m.kk = ArrayExtension.getModulus$1(Brush.$, this.m4, e);
                m.en = this.qg;
                if (this.pn(m)) {
                    this.oj.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.m5, e));
                    this.oj.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.ol, e));
                }
                if (this.q3 != -2147483648 && this.pn(m)) {
                    this.oj.setPeriodOverride(m, this.q3);
                }
                if (this.pn(m)) {
                    this.oj.setSmoothingPeriod(m, this.q6);
                }
                if (this.pn(m)) {
                    this.oj.setSignalPeriod(m, this.q5);
                }
                if (this.pn(m)) {
                    this.oj.setShortPeriod(m, this.q4);
                    this.oj.setLongPeriod(m, this.q2);
                }
                this.e2(m, e);
                f.add(m);
            }
            for (let o of fromEnum(f)) {
                g.series.add(o);
            }
        }
    }
    o3(indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    }
    o6(a) {
        return this.o3(EnumUtil.getName(FinancialIndicatorType_$type, a));
    }
    un(a) {
        if (this.nv == null) {
            return;
        }
        let b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.nv.ax = b.actualMinimumValue;
        this.nv.aw = b.actualMaximumValue;
        if (a) {
            this.nv.az = b.visibleMinimum;
            this.nv.ay = b.visibleMaximum;
        }
        this.nv.bz();
    }
    cn() {
        let a = ((() => {
            let $ret = new FinancialChartVisualData();
            $ret.mainChart = super.cn();
            $ret.volumeChart = this.volumeChart == null ? null : this.volumeChart.n8();
            $ret.toolbar = this.nv == null ? null : this.nv.ao();
            $ret.zoomChart = this.zoomSliderChart == null ? null : this.zoomSliderChart.n8();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            for (let b of fromEnum(this.indicatorCharts)) {
                a.indicatorCharts.add1(b.n8());
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.uu(this.dataChart).x;
            a.mainChartTop = this.uu(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.uu(this.volumeChart).x;
            a.volumeChartTop = this.uu(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.uu(this.zoomSliderChart).x;
            a.zoomChartTop = this.uu(this.zoomSliderChart).y;
        }
        if (this.nv != null) {
            let c = this.uv(this.nv);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            for (let d of fromEnum(this.indicatorCharts)) {
                a.indicatorChartLefts.add(this.uu(d).x);
                a.indicatorChartTops.add(this.uu(d).y);
            }
        }
        return a;
    }
    rs() {
        let a = this.cn();
        a.scaleByViewport();
        return a.serialize();
    }
    o4(overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    }
    um() {
        if (this.dataChart == null) {
            return;
        }
        let a = new List$1(Series.$, 0);
        for (let b of fromEnum(this.dataChart.series)) {
            if (this.po(b)) {
                a.add(b);
            }
        }
        for (let c of fromEnum(a)) {
            this.dataChart.series.remove(c);
        }
        if (this.od == null) {
            return;
        }
        let d = new List$1(Series.$, 0);
        for (let e = 0; e < this.dataChart.series.count; e++) {
            let f = this.dataChart.series._inner[e];
            for (let g = 0; g < this.od.count; g++) {
                let h = this.od._inner[g];
                let i;
                switch (h) {
                    case 1:
                        i = this.o4(EnumUtil.getName(FinancialOverlayType_$type, h));
                        break;
                    default:
                    case 0:
                        i = this.o4(EnumUtil.getName(FinancialOverlayType_$type, h));
                        break;
                }
                i.name = f.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, h);
                this.oo.setXAxis(i, this.xAxis);
                this.oo.setYAxis(i, this.yAxis);
                i.itemsSource = f.itemsSource;
                let j = e * this.od.count + g;
                i.kk = ArrayExtension.getModulus$1(Brush.$, this.m8, j);
                i.kn = ArrayExtension.getModulus$1(Brush.$, this.m9, j);
                i.en = this.qh;
                i.fj = f.fj + " " + EnumUtil.getName(FinancialOverlayType_$type, h);
                let k = f;
                if (k == null) {
                    continue;
                }
                this.oo.setOpenMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(11));
                this.oo.setHighMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(12));
                this.oo.setLowMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(13));
                this.oo.setCloseMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(14));
                this.oo.setVolumeMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(15));
                d.add(i);
            }
        }
        let l = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(l, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (let m = 0; m < l.length; m++) {
            l[m].e6 = -1;
        }
        d.o(l);
        for (let n of fromEnum(d)) {
            this.dataChart.series.add(n);
        }
    }
    uk() {
        if (this.pu) {
            return;
        }
        this.pu = true;
        if (this.indicatorCharts != null) {
            let a = this.indicatorCharts;
            this.indicatorCharts = null;
            for (let b of fromEnum(a)) {
                this.t3(b);
            }
        }
        if ((this.ob == null || this.ob.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            this.uc();
            this.ul();
            this.pu = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.p2.clear();
        this.p4.clear();
        let c = this.ob == null ? 0 : this.ob.count;
        let d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        let e = c + d;
        for (let f = 0; f < e; f++) {
            let g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.t1(g);
            let h = f >= c;
            g.gm = h ? this.customIndicatorNames._inner[f - c] : EnumUtil.getName(FinancialIndicatorType_$type, this.ob._inner[f]);
            if (this.indicatorAxis != null) {
                let i;
                let j;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.bw) {
                        j = this.nh(0);
                    }
                    else {
                        j = this.nh(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.p2.add(i);
                this.p4.add(j);
                if (this.aw) {
                    this.lf(i);
                }
                if (this.aw) {
                    this.ld(j);
                }
            }
        }
        this.t7();
        this.uc();
        if (this.nv != null) {
            this.nv.aj = this.ob;
        }
        this.tg();
        this.ul();
        this.pu = false;
    }
    eu() {
        super.eu();
        this.ld(this.xAxis);
        this.ld(this.volumeXAxis);
        if (this.p4 != null) {
            for (let a of fromEnum(this.p4)) {
                this.ld(a);
            }
        }
        this.lf(this.yAxis);
        this.lf(this.volumeAxis);
        if (this.p2 != null) {
            for (let b of fromEnum(this.p2)) {
                this.lf(b);
            }
        }
    }
    get_a2() {
        return !this.ps;
    }
    get a2() {
        return this.get_a2();
    }
    get py() {
        return (this.externalObject._dynamicContent);
    }
    us(a, b) {
        this.uf(a, b);
        this.tg();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.t9();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.ud();
        this.ut(a, b);
    }
    t9() {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        let a = new List$1(Series.$, 0);
        for (let b = 0; b < this.dataChart.series.count; b++) {
            let c = this.dataChart.series._inner[b];
            let d;
            let e = this.n9;
            e = this.n8(e);
            switch (e) {
                case 1:
                    d = this.o2();
                    this.of.setDisplayType(d, 1);
                    break;
                case 2:
                    d = this.o2();
                    this.of.setDisplayType(d, 0);
                    break;
                case 4:
                    d = this.o1();
                    break;
                case 5:
                    d = this.oz();
                    break;
                default:
                case 3:
                    d = this.o0();
                    break;
            }
            if (d.cj && !d.cp) {
                this.oh.setCategoryMode(d, 1);
                this.oh.setXAxis(d, this.zoomSliderXAxis);
                this.oh.setYAxis(d, this.zoomSliderAxis);
                this.oh.setValueMemberPath(d, this.s != null && this.s.dataSeries != null && this.s.dataSeries.count > b ? this.rt(this.s.dataSeries._inner[b]) : null);
            }
            else if (d.cp) {
                this.of.setCategoryMode(d, 1);
                this.of.setXAxis(d, this.zoomSliderXAxis);
                this.of.setYAxis(d, this.zoomSliderAxis);
                if (this.s != null && this.s.dataSeries != null && this.s.dataSeries.count > b) {
                    this.of.setOpenMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(11));
                    this.of.setHighMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(12));
                    this.of.setLowMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(13));
                    this.of.setCloseMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(14));
                    this.of.setVolumeMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + b;
            d.itemsSource = c.itemsSource;
            d.fj = c.fj;
            a.add(d);
        }
        for (let f of fromEnum(a)) {
            this.zoomSliderChart.series.add(f);
        }
    }
    ff(a, b) {
        super.ff(a, b);
        if (a == null || !b) {
            return;
        }
        if (this.indicatorCharts != null) {
            for (let c of fromEnum(this.indicatorCharts)) {
                a(c);
            }
        }
        if (this.volumeChart != null) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
    }
    tm(a, b) {
        let c = b;
        let d = a;
        let e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.bp);
        }
        e -= this.ob == null ? 0 : this.ob.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    }
    ld(a) {
        super.ld(a);
        let b = a;
        this.t2(b);
        if (a.a7 != null) {
            for (let c of fromEnum(a.a7.series)) {
                if (this.pl(c)) {
                    this.oh.setXAxis(c, b);
                }
                else if (this.pp(c)) {
                    this.of.setXAxis(c, b);
                }
                else if (this.pn(c)) {
                    this.oj.setXAxis(c, b);
                }
                else if (this.po(c)) {
                    this.oo.setXAxis(c, b);
                }
            }
        }
    }
    lf(a) {
        super.lf(a);
        if (a.a7 != null) {
            for (let b of fromEnum(a.a7.series)) {
                if (this.pl(b)) {
                    this.oh.setYAxis(b, this.yAxis);
                }
                else if (this.pp(b)) {
                    this.of.setYAxis(b, this.yAxis);
                }
                else if (this.pn(b)) {
                    this.oj.setYAxis(b, this.yAxis);
                }
                else if (this.po(b)) {
                    this.oo.setYAxis(b, this.yAxis);
                }
            }
        }
        a.i0 = this.pv;
        a.jo = this.qo;
        a.jn = this.qn;
        a.jk = this.qm;
    }
    t2(a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.er = XYChart.i7(a, this.s.dataSeries);
        if (this.s.dataSeries.count > 0) {
            let b = this.s.dataSeries._inner[0].getMemberPathFor(17);
            a.f9(b);
        }
    }
    e2(a, b) {
        super.e2(a, b);
        if (a == null) {
            return;
        }
        let c = this.dataChart != null && this.dataChart.series.contains(a);
        if (c && a.cx) {
            a.iy(this.m6 != null ? ArrayExtension.getModulus$1(Brush.$, this.m6, b) : null, this.m7 != null ? ArrayExtension.getModulus$1(Brush.$, this.m7, b) : null);
        }
        if (this.po(a)) {
            a.kk = this.m8 != null ? ArrayExtension.getModulus$1(Brush.$, this.m8, b) : null;
            a.kn = this.m9 != null ? ArrayExtension.getModulus$1(Brush.$, this.m9, b) : null;
            a.en = this.qh;
        }
        else if (this.pn(a)) {
            a.kk = this.m4 != null ? ArrayExtension.getModulus$1(Brush.$, this.m4, b) : null;
            a.en = this.qg;
        }
        else if (c) {
            a.kk = this.j != null ? ArrayExtension.getModulus$1(Brush.$, this.j, b) : null;
            a.kn = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, b) : null;
        }
        let d = this.volumeChart != null && this.volumeChart.series.count > b && this.volumeChart.series._inner[b] == a;
        if (d) {
            a.en = this.qj;
        }
    }
    fi(a, b, c) {
        super.fi(a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.i5 = this.pw;
                break;
            case "YAxisLogarithmBase":
                this.yAxis.js = this.q8;
                break;
            case "VolumeType":
                let d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.n2 == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((() => {
                        let $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.t8();
                }
                break;
            case "VolumeChart":
                this.uq(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    let e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.to));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.tl));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.tt));
                }
                if (this.dataChart != null) {
                    let f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.to));
                    let g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.tl));
                    let h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.tt));
                }
                this.up();
                break;
            case "XAxisMode":
                this.xAxis = this.nh(this.n4);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.nh(this.n4);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.nh(this.n4);
                this.indicatorXAxis.name = "indicatorXAxis";
                this.zoomSliderXAxis = this.nh(this.n4);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.lb(this.zoomSliderXAxis, (i) => i.visibility = 1);
                this.tg();
                break;
            case "YAxisMode":
                this.yAxis = this.ot(this.n6);
                this.yAxis.name = "yAxis";
                break;
            case "Toolbar":
                let i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.ts));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.tv));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.tw));
                }
                if (this.nv != null) {
                    this.nv.aj = this.ob;
                    this.nv.al = this.od;
                    this.nv.v = this.ns;
                    this.un(true);
                    let j = this.nv;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.ts));
                    let k = this.nv;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.tv));
                    let l = this.nv;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.tw));
                }
                break;
            case "XAxis":
                let m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                let n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.actualRangeChanged = delegateRemove(n.actualRangeChanged, runOn(this, this.tz));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.aw) {
                    this.ld(this.xAxis);
                    this.ep();
                }
                this.un(false);
                this.uo();
                if (typeCast(ITimeRangeSelectorAxis_$type, this.xAxis) !== null) {
                    let o = this.xAxis;
                    o.actualRangeChanged = delegateCombine(o.actualRangeChanged, runOn(this, this.tz));
                }
                break;
            case "ChartType":
                this.fy();
                break;
            case "VolumeXAxis":
                this.uh(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.uh(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.uk();
                break;
            case "YAxis":
                let p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.aw) {
                    this.lf(this.yAxis);
                    this.lf(this.yAxis);
                }
                let q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.t0));
                break;
            case "VolumeAxis":
                let r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.aw) {
                    this.lf(this.volumeAxis);
                }
                let s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.t0));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (let t = 0; t < this.indicatorCharts.count; t++) {
                        let u = this.indicatorCharts._inner[t];
                        let v = new List$1(Axis.$, 0);
                        for (let w of fromEnum(u.axes)) {
                            if (typeCast(NumericYAxis.$, w) !== null) {
                                v.add(w);
                            }
                        }
                        for (let x of fromEnum(v)) {
                            u.axes.remove(x);
                        }
                        let y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.n6 == 1) {
                            y = this.ot(this.n6);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.aw) {
                            this.lf(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.nn = this.a3 && this.a2;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.nn = this.a3 && this.a2;
                }
                if (this.ps) {
                    this.ui(this.dataChart);
                }
                break;
            case "IndicatorTypes":
                let z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.tp));
                }
                let aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.tp));
                }
                this.uk();
                break;
            case "OverlayTypes":
                let ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.tq));
                }
                let ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.tq));
                }
                this.um();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.lk((ad) => ad.i0 = this.pv);
                break;
            case "YAxisMinimumValue":
                this.ll((ad) => ad.jo = this.qo, false);
                break;
            case "YAxisMaximumValue":
                this.ll((ad) => ad.jn = this.qn, false);
                break;
            case "YAxisInterval":
                this.ll((ad) => ad.jk = this.qm, false);
                break;
            case "ZoomSliderType":
                this.up();
                break;
            case "ZoomSliderChart":
                if (!this.px) {
                    return;
                }
                this.us(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.tj((ad, ae) => {
                    if (ad.cx) {
                        ad.iy(this.m6 != null ? ArrayExtension.getModulus$1(Brush.$, this.m6, ae) : null, this.m7 != null ? ArrayExtension.getModulus$1(Brush.$, this.m7, ae) : null);
                    }
                });
                break;
            case "OverlayBrushes":
                this.er((ad, ae) => {
                    if (!(this.po(ad))) {
                        return;
                    }
                    ad.kk = this.m8 != null ? ArrayExtension.getModulus$1(Brush.$, this.m8, ae) : null;
                });
                break;
            case "OverlayOutlines":
                this.er((ad, ae) => {
                    if (!(this.po(ad))) {
                        return;
                    }
                    ad.kn = this.m9 != null ? ArrayExtension.getModulus$1(Brush.$, this.m9, ae) : null;
                });
                break;
            case "OverlayThickness":
                this.er((ad, ae) => {
                    if (!(this.po(ad))) {
                        return;
                    }
                    ad.en = this.qh;
                });
                break;
            case "VolumeBrushes":
                this.tk((ad, ae) => ad.kk = ArrayExtension.getModulus$1(Brush.$, this.na, ae));
                break;
            case "VolumeOutlines":
                this.tk((ad, ae) => ad.kn = ArrayExtension.getModulus$1(Brush.$, this.nb, ae));
                break;
            case "VolumeThickness":
                this.tk((ad, ae) => ad.en = this.qj);
                break;
            case "IndicatorNegativeBrushes":
                this.ti((ad, ae) => this.oj.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, this.m5, ae)));
                break;
            case "IndicatorBrushes":
                this.ti((ad, ae) => ad.kk = ArrayExtension.getModulus$1(Brush.$, this.m4, ae));
                break;
            case "IndicatorThickness":
                this.ti((ad, ae) => ad.en = this.qg);
                break;
            case "IndicatorDisplayTypes":
                this.ti((ad, ae) => this.oj.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.ol, ae)));
                break;
            case "IndicatorPeriod":
                this.ti((ad, ae) => {
                    if (this.q3 == -2147483648 || !(this.pn(ad))) {
                        return;
                    }
                    this.oj.setPeriodOverride(ad, this.q3);
                });
                break;
            case "IndicatorMultiplier":
                this.ti((ad, ae) => {
                    if (!(this.po(ad))) {
                        return;
                    }
                    this.oo.setMultiplier(ad, this.qf);
                });
                break;
            case "IndicatorSmoothingPeriod":
                this.ti((ad, ae) => {
                    if (!(this.pn(ad))) {
                        return;
                    }
                    this.oj.setSmoothingPeriod(ad, this.q6);
                });
                break;
            case "IndicatorShortPeriod":
                this.ti((ad, ae) => {
                    if (!(this.pn(ad))) {
                        return;
                    }
                    this.oj.setShortPeriod(ad, this.q4);
                });
                break;
            case "IndicatorLongPeriod":
                this.ti((ad, ae) => {
                    if (!(this.pn(ad))) {
                        return;
                    }
                    this.oj.setLongPeriod(ad, this.q2);
                });
                break;
            case "IndicatorSignalPeriod":
                this.ti((ad, ae) => {
                    if (!(this.pn(ad))) {
                        return;
                    }
                    this.oj.setSignalPeriod(ad, this.q5);
                });
                break;
            case "RangeSelectorOptions":
                let ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.tr));
                }
                if (this.nt != null) {
                    let ae = this.nt;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.tr));
                }
                this.ub();
                break;
            case "CustomIndicatorNames":
                let af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.tn));
                }
                if (this.customIndicatorNames != null) {
                    let ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.tn));
                }
                this.uk();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.ay = null;
                }
                break;
            case "Brushes":
                this.tj((ah, ai) => {
                    if (this.po(ah)) {
                        return;
                    }
                    ah.kk = this.j != null ? ArrayExtension.getModulus$1(Brush.$, this.j, ai) : null;
                });
                break;
            case "Outlines":
                this.tj((ah, ai) => {
                    if (this.po(ah)) {
                        return;
                    }
                    ah.kn = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, ai) : null;
                });
                break;
            case "XAxisLabelVisibility":
                if (this.mu != 0 || this.zoomSliderXAxis == null) {
                    break;
                }
                this.lb(this.zoomSliderXAxis, (ah) => ah.visibility = 1);
                break;
            case "YAxisLabelVisibility":
                if (this.mv != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.lb(this.zoomSliderAxis, (ah) => ah.visibility = 1);
                break;
        }
    }
    uh(a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.aw) {
            this.ld(c);
        }
    }
    get px() {
        return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
    }
    tn(a, b) {
        this.uk();
    }
    pq(a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    }
    ub() {
        let a = this.nt != null ? this.nt : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        let b = new FinancialChartRangeSelectorOptionCollection(0);
        let c = this.xAxis;
        let d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        for (let e of fromEnum(a)) {
            if (this.pq(e, d)) {
                b.add(e);
            }
        }
        this.ns = b;
        if (this.nv != null) {
            this.nv.v = this.ns;
        }
    }
    tr(a, b) {
        this.ub();
    }
    tw(a, b) {
        this.od = this.nv.al;
    }
    tv(a, b) {
        this.ob = this.nv.aj;
    }
    tp(a, b) {
        this.uk();
    }
    tq(a, b) {
        this.um();
    }
    t0(a, b) {
        let c = a;
        if (c.a7 == null) {
            return;
        }
        if (this.ps) {
            this.ui(c.a7);
        }
    }
    t3(a) {
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.to));
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.ds = this.volumeAxis.ds = this.indicatorAxis.ds = 0;
            this.xAxis.as.visibility = this.mu;
        }
    }
    t1(a) {
        let b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.my = new Rect(0, this.dataChart.mk.x, a.my.y, this.dataChart.mk.width, a.my.height);
            }
            let c = ((() => {
                let $ret = new SyncSettings();
                $ret.ae = "one";
                $ret.ac = true;
                $ret.ad = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.to));
        this.ew(a);
    }
    tg() {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.lb(this.xAxis, (a) => a.visibility = 1);
        }
        for (let a = 0; a < this.p4.count; a++) {
            let b = this.p4._inner[a];
            let c = a < this.p4.count - 1 || this.volumeChart != null;
            this.lb(b, (d) => d.visibility = c ? 1 : 0);
        }
    }
    uf(a, b) {
        if (a != null) {
            this.t3(a);
        }
        if (b != null) {
            this.t1(b);
        }
    }
    uq(a, b) {
        this.uf(a, b);
        this.tg();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.t8();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.ur(a, b);
    }
    ts(a, b) {
        this.uo();
    }
    uo() {
        if (this.nv == null || +(this.nv.az) == +(dateMaxValue()) || +(this.nv.ay) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        let a = this.xAxis;
        let b = a.getWindowRectForSelection(this.nv.az, this.nv.ay);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.pt = true;
        this.dataChart.my = new Rect(0, b.left, this.dataChart.my.top, b.width, this.dataChart.my.height);
        if (this.pc != null) {
            this.pc.r = this.dataChart.mk;
        }
        if (this.ps) {
            this.ui(this.dataChart);
        }
        this.pt = false;
    }
    tz(a, b) {
        this.ub();
        this.un(true);
    }
    tl(a, b) {
        if (!this.pt) {
            if (this.ps) {
                this.ui(a);
            }
            let c = false;
            let d = this.fm(() => this.un(true), c);
            c = d.p1;
            if (this.pc != null) {
                this.pc.r = this.dataChart.mk;
            }
        }
    }
    uj(a, b, c, d) {
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.pt = true;
            a.my = new Rect(0, d, a.mk.top, c, a.mk.height);
            this.pt = false;
        }
        let e = 1.7976931348623157E+308;
        let f = -1.7976931348623157E+308;
        let g = new Rect(0, 0, 0, 1, 1);
        let h = new ScalerParams(0, g, g, this.yAxis.bz, a.mo);
        for (let i of fromEnum(a.series)) {
            h.b = i.d8();
            let j = i.an();
            let k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
            if (k) {
                continue;
            }
            let l = b.dj(j.c, h);
            let m = b.dj(j.b, h);
            f = Math.max(f, l);
            e = Math.min(e, m);
        }
        let n = a.mk.width;
        if (c != -1) {
            n = c;
        }
        let o = a.mk.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.pt = true;
        let p = new Rect(0, o, e, n, f - e);
        a.my = p;
        this.pt = false;
    }
    ui(a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.uj(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.uj(this.volumeChart, this.volumeAxis, this.dataChart.mk.width, this.dataChart.mk.left);
            }
        }
        else if (a == this.volumeChart) {
            this.uj(this.volumeChart, this.volumeAxis, -1, -1);
            this.uj(this.dataChart, this.yAxis, this.volumeChart.mk.width, this.volumeChart.mk.left);
        }
    }
    tt(a, b) {
        if (this.ps) {
            this.ui(a);
        }
    }
    up() {
        if (!this.py) {
            return;
        }
        if (this.n9 == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((() => {
                let $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.t9();
        }
    }
    get pw() {
        return this.pg;
    }
    set pw(a) {
        let b = this.pw;
        if (a != b) {
            this.pg = a;
            this.fi("YAxisIsLogarithmic", b, this.pw);
        }
    }
    get q8() {
        return this.q0;
    }
    set q8(a) {
        let b = this.q8;
        if (a != b) {
            this.q0 = a;
            this.fi("YAxisLogarithmBase", b, this.q8);
        }
    }
    get qm() {
        return this.qa;
    }
    set qm(a) {
        let b = this.qm;
        if (a != b) {
            this.qa = a;
            this.fi("YAxisInterval", b, this.qm);
        }
    }
    get qo() {
        return this.qc;
    }
    set qo(a) {
        let b = this.qo;
        if (a != b) {
            this.qc = a;
            this.fi("YAxisMinimumValue", b, this.qo);
        }
    }
    get qn() {
        return this.qb;
    }
    set qn(a) {
        let b = this.qn;
        if (a != b) {
            this.qb = a;
            this.fi("YAxisMaximumValue", b, this.qn);
        }
    }
    get qp() {
        return this.qd;
    }
    set qp(a) {
        let b = this.qp;
        if (a != b) {
            this.qd = a;
            this.fi("YAxisMinorInterval", b, this.qp);
        }
    }
    get ql() {
        return this.yAxis.jg;
    }
    get qk() {
        return this.yAxis.jf;
    }
    get n2() {
        return this.n0;
    }
    set n2(a) {
        let b = this.n2;
        if (a != b) {
            this.n0 = a;
            this.fi("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.n2));
        }
    }
    get n4() {
        return this.n3;
    }
    set n4(a) {
        let b = this.n4;
        if (a != b) {
            this.n3 = a;
            this.fi("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.n4));
        }
    }
    get n6() {
        return this.n5;
    }
    set n6(a) {
        let b = this.n6;
        if (a != b) {
            this.n5 = a;
            this.fi("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.n6));
        }
    }
    get pr() {
        return this.pd;
    }
    set pr(a) {
        let b = this.pr;
        if (a != b) {
            this.pd = a;
            this.fi("IsToolbarVisible", b, this.pr);
        }
    }
    get nx() {
        return this.nw;
    }
    set nx(a) {
        let b = this.nx;
        if (a != b) {
            this.nw = a;
            this.fi("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.nx));
        }
    }
    get_lt() {
        return super.get_lt();
    }
    set_lt(a) {
        super.set_lt(a);
    }
    get lt() {
        return this.get_lt();
    }
    set lt(a) {
        this.set_lt(a);
    }
    get ps() {
        return this.pe;
    }
    set ps(a) {
        let b = this.ps;
        if (a != b) {
            this.pe = a;
            this.fi("IsWindowSyncedToVisibleRange", b, this.ps);
        }
    }
    get ob() {
        return this.oa;
    }
    set ob(a) {
        let b = this.ob;
        if (a != b) {
            this.oa = a;
            this.fi("IndicatorTypes", b, this.ob);
        }
    }
    get od() {
        return this.oc;
    }
    set od(a) {
        let b = this.od;
        if (a != b) {
            this.oc = a;
            this.fi("OverlayTypes", b, this.od);
        }
    }
    get indicatorCharts() {
        return this.p0;
    }
    set indicatorCharts(a) {
        let b = this.indicatorCharts;
        if (a != b) {
            this.p0 = a;
            this.fi("IndicatorCharts", b, this.indicatorCharts);
        }
    }
    get pv() {
        return this.pf;
    }
    set pv(a) {
        let b = this.pv;
        if (a != b) {
            this.pf = a;
            this.fi("YAxisAbbreviateLargeNumbers", b, this.pv);
        }
    }
    get_by() {
        return super.get_by();
    }
    set_by(a) {
        super.set_by(a);
    }
    get by() {
        return this.get_by();
    }
    set by(a) {
        this.set_by(a);
    }
    get_gq() {
        return super.get_gq();
    }
    set_gq(a) {
        super.set_gq(a);
    }
    get gq() {
        return this.get_gq();
    }
    set gq(a) {
        this.set_gq(a);
    }
    get zoomSliderChart() {
        return this.o8;
    }
    set zoomSliderChart(a) {
        let b = this.zoomSliderChart;
        if (a != b) {
            this.o8 = a;
            this.fi("ZoomSliderChart", b, this.zoomSliderChart);
        }
    }
    get zoomSliderAxis() {
        return this.os;
    }
    set zoomSliderAxis(a) {
        let b = this.zoomSliderAxis;
        if (a != b) {
            this.os = a;
            this.fi("ZoomSliderAxis", b, this.zoomSliderAxis);
        }
    }
    get zoomSliderXAxis() {
        return this.nf;
    }
    set zoomSliderXAxis(a) {
        let b = this.zoomSliderXAxis;
        if (a != b) {
            this.nf = a;
            this.fi("ZoomSliderXAxis", b, this.zoomSliderXAxis);
        }
    }
    get n9() {
        return this.n7;
    }
    set n9(a) {
        let b = this.n9;
        if (a != b) {
            this.n7 = a;
            this.fi("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.n9));
        }
    }
    get m6() {
        return this.my;
    }
    set m6(a) {
        let b = this.m6;
        if (a != b) {
            this.my = a;
            this.fi("NegativeBrushes", b, this.m6);
        }
    }
    get m7() {
        return this.mz;
    }
    set m7(a) {
        let b = this.m7;
        if (a != b) {
            this.mz = a;
            this.fi("NegativeOutlines", b, this.m7);
        }
    }
    get m8() {
        return this.m0;
    }
    set m8(a) {
        let b = this.m8;
        if (a != b) {
            this.m0 = a;
            this.fi("OverlayBrushes", b, this.m8);
        }
    }
    get m9() {
        return this.m1;
    }
    set m9(a) {
        let b = this.m9;
        if (a != b) {
            this.m1 = a;
            this.fi("OverlayOutlines", b, this.m9);
        }
    }
    get nb() {
        return this.m3;
    }
    set nb(a) {
        let b = this.nb;
        if (a != b) {
            this.m3 = a;
            this.fi("VolumeOutlines", b, this.nb);
        }
    }
    get na() {
        return this.m2;
    }
    set na(a) {
        let b = this.na;
        if (a != b) {
            this.m2 = a;
            this.fi("VolumeBrushes", b, this.na);
        }
    }
    get m5() {
        return this.mx;
    }
    set m5(a) {
        let b = this.m5;
        if (a != b) {
            this.mx = a;
            this.fi("IndicatorNegativeBrushes", b, this.m5);
        }
    }
    get m4() {
        return this.mw;
    }
    set m4(a) {
        let b = this.m4;
        if (a != b) {
            this.mw = a;
            this.fi("IndicatorBrushes", b, this.m4);
        }
    }
    get qj() {
        return this.p9;
    }
    set qj(a) {
        let b = this.qj;
        if (a != b) {
            this.p9 = a;
            this.fi("VolumeThickness", b, this.qj);
        }
    }
    get qh() {
        return this.p7;
    }
    set qh(a) {
        let b = this.qh;
        if (a != b) {
            this.p7 = a;
            this.fi("OverlayThickness", b, this.qh);
        }
    }
    get qg() {
        return this.p6;
    }
    set qg(a) {
        let b = this.qg;
        if (a != b) {
            this.p6 = a;
            this.fi("IndicatorThickness", b, this.qg);
        }
    }
    get ol() {
        return this.ok;
    }
    set ol(a) {
        let b = this.ol;
        if (a != b) {
            this.ok = a;
            this.fi("IndicatorDisplayTypes", b, this.ol);
        }
    }
    get q3() {
        return this.qw;
    }
    set q3(a) {
        let b = this.q3;
        if (a != b) {
            this.qw = a;
            this.fi("IndicatorPeriod", b, this.q3);
        }
    }
    get qf() {
        return this.p5;
    }
    set qf(a) {
        let b = this.qf;
        if (a != b) {
            this.p5 = a;
            this.fi("IndicatorMultiplier", b, this.qf);
        }
    }
    get q6() {
        return this.qz;
    }
    set q6(a) {
        let b = this.q6;
        if (a != b) {
            this.qz = a;
            this.fi("IndicatorSmoothingPeriod", b, this.q6);
        }
    }
    get q4() {
        return this.qx;
    }
    set q4(a) {
        let b = this.q4;
        if (a != b) {
            this.qx = a;
            this.fi("IndicatorShortPeriod", b, this.q4);
        }
    }
    get q2() {
        return this.qv;
    }
    set q2(a) {
        let b = this.q2;
        if (a != b) {
            this.qv = a;
            this.fi("IndicatorLongPeriod", b, this.q2);
        }
    }
    get q5() {
        return this.qy;
    }
    set q5(a) {
        let b = this.q5;
        if (a != b) {
            this.qy = a;
            this.fi("IndicatorSignalPeriod", b, this.q5);
        }
    }
    get nt() {
        return this.nr;
    }
    set nt(a) {
        let b = this.nt;
        if (a != b) {
            this.nr = a;
            this.fi("RangeSelectorOptions", b, this.nt);
        }
    }
    get customIndicatorNames() {
        return this.nn;
    }
    set customIndicatorNames(a) {
        let b = this.nn;
        if (a != b) {
            this.nn = a;
            this.fi("CustomIndicatorNames", b, this.customIndicatorNames);
        }
    }
    get_a3() {
        return super.get_a3();
    }
    set_a3(a) {
        super.set_a3(a);
    }
    get a3() {
        return this.get_a3();
    }
    set a3(a) {
        this.set_a3(a);
    }
}
FinancialChart.q7 = 0;
FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
export class FinancialChartEnumCollectionPickerTool$2 extends TemplatedHtmlControl {
    constructor($tColl, $tEnum, a, b, c) {
        super(a, b, c);
        this.$tColl = null;
        this.$tEnum = null;
        this.o = null;
        this.p = null;
        this.changed = null;
        this.$tColl = $tColl;
        this.$tEnum = $tEnum;
        this.$type = this.$type.specialize(this.$tColl, this.$tEnum);
        this.o = new FinancialChartEnumCollectionPickerToolView();
        this.p = new FinancialChartEnumCollectionPickerToolViewModel();
        this.p.onSelectionChanged = runOn(this, this.w);
    }
    l(a) {
        super.l(a);
        this.o.d(this.j, this.d, this.p, this.s());
    }
    u(a) {
    }
    get n() {
        let a = Type.createInstance(this.$tColl);
        let d = this.p.selection;
        for (let c = 0; c < d.length; c++) {
            let b = d[c];
            a.add(typeCastObjTo$t(this.$tEnum, EnumUtil.parse(this.$tEnum, b, true)));
        }
        return a;
    }
    set n(a) {
        let b = this.n;
        if (!FinancialChartToolbar.ar(b, a)) {
            let c = new List$1(String_$type, 0);
            if (a != null) {
                for (let d = 0; d < a.count; d++) {
                    let e = a._inner[d];
                    c.add(stringToString$1(this.$tEnum, e));
                }
            }
            this.p.selection = c.b();
            this.v("Selection", b, a);
        }
    }
    w() {
        if (this.changed != null) {
            this.changed(this, EventArgs.empty);
        }
    }
    v(a, b, c) {
        switch (a) {
            case "Selection":
                this.p.updateUI();
                this.o.g(this.p);
                break;
        }
    }
    q() {
        return this.o.b(this.g);
    }
}
FinancialChartEnumCollectionPickerTool$2.$t = markType(FinancialChartEnumCollectionPickerTool$2, 'FinancialChartEnumCollectionPickerTool$2', TemplatedHtmlControl.$);
export class FinancialChartIndicatorPicker extends FinancialChartEnumCollectionPickerTool$2 {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = [null];
                    {
                        let e = c[0];
                        super(FinancialIndicatorTypeCollection.$, FinancialIndicatorType_$type, "financialChartIndicatorPicker", e, "");
                    }
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    super(FinancialIndicatorTypeCollection.$, FinancialIndicatorType_$type, "financialChartIndicatorPicker", c, "");
                }
                break;
        }
    }
    u(a) {
        super.u(a);
        if (this.p.isOpen) {
            for (let b = 0; b < a.length; b++) {
                if (a[b] == "financialChartIndicatorPickerDropDownButton") {
                    return;
                }
            }
            this.p.isOpen = false;
            this.p.updateUI();
        }
    }
    s() {
        return this.d != null ? new SRProvider(this.d).ac : null;
    }
}
FinancialChartIndicatorPicker.$t = markType(FinancialChartIndicatorPicker, 'FinancialChartIndicatorPicker', FinancialChartEnumCollectionPickerTool$2.$.specialize(FinancialIndicatorTypeCollection.$, FinancialIndicatorType_$type));
export class FinancialChartOverlayPicker extends FinancialChartEnumCollectionPickerTool$2 {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = [null];
                    {
                        let e = c[0];
                        super(FinancialOverlayTypeCollection.$, FinancialOverlayType_$type, "financialChartOverlayPicker", e, "");
                    }
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    super(FinancialOverlayTypeCollection.$, FinancialOverlayType_$type, "financialChartOverlayPicker", c, "");
                }
                break;
        }
    }
    u(a) {
        super.u(a);
        if (this.p.isOpen) {
            for (let b = 0; b < a.length; b++) {
                if (a[b] == "financialChartOverlayPickerDropDownButton") {
                    return;
                }
            }
            this.p.isOpen = false;
            this.p.updateUI();
        }
    }
    s() {
        return this.d != null ? new SRProvider(this.d).ad : null;
    }
}
FinancialChartOverlayPicker.$t = markType(FinancialChartOverlayPicker, 'FinancialChartOverlayPicker', FinancialChartEnumCollectionPickerTool$2.$.specialize(FinancialOverlayTypeCollection.$, FinancialOverlayType_$type));
export class FinancialChartToolbar extends TemplatedHtmlControl {
    constructor(a, b) {
        super("financialChartToolbar", b, "");
        this.n = null;
        this.s = null;
        this.ac = null;
        this.y = null;
        this.ag = null;
        this.o = null;
        this.q = null;
        this.x = null;
        this.av = dateMaxValue();
        this.au = dateMinValue();
        this.at = dateMaxValue();
        this.as = dateMinValue();
        this.rangeChanged = null;
        this.chartTypeChanged = null;
        this.trendLineTypeChanged = null;
        this.volumeTypeChanged = null;
        this.indicatorTypesChanged = null;
        this.overlayTypesChanged = null;
        this.aa = 0;
        this.am = 0;
        this.ae = 0;
        this.ai = null;
        this.ak = null;
        this.u = null;
        this.ap = false;
        this.n = a;
        this.x = new FinancialChartToolbarViewModel();
        this.t = new FinancialChartRangeSelector(a != null ? a.rj : null);
        this.ad = new FinancialChartTypePicker(a != null ? a.rg : null);
        this.z = new FinancialChartTrendLinePicker(1, a != null ? a.rl : null);
        this.ah = new FinancialChartVolumeTypePicker(a != null ? a.rm : null);
        this.p = new FinancialChartIndicatorPicker(1, a != null ? a.rh : null);
        this.r = new FinancialChartOverlayPicker(1, a != null ? a.ri : null);
    }
    bp(a) {
        let b = this.d.querySelector(".financialChartRangeSelector");
        this.t.g = b;
        let c = this.d.querySelector(".financialChartChartTypePicker");
        this.ad.g = c;
        let d = this.d.querySelector(".financialChartIndicatorPicker");
        this.p.g = d;
        let e = this.d.querySelector(".financialChartOverlayPicker");
        this.r.g = e;
        let f = this.d.querySelector(".financialChartTrendLineTypePicker");
        this.z.g = f;
        let g = this.d.querySelector(".financialChartVolumeTypePicker");
        this.ah.g = g;
    }
    bx(a) {
        this.p.u(a);
        this.r.u(a);
    }
    get t() {
        return this.s;
    }
    set t(a) {
        let b = this.t;
        if (a != b) {
            this.s = a;
            this.by("RangeSelector", b, this.t);
        }
    }
    get ad() {
        return this.ac;
    }
    set ad(a) {
        let b = this.ad;
        if (a != b) {
            this.ac = a;
            this.by("ChartTypePicker", b, this.ad);
        }
    }
    get z() {
        return this.y;
    }
    set z(a) {
        let b = this.z;
        if (a != b) {
            this.y = a;
            this.by("TrendLineTypePicker", b, this.z);
        }
    }
    get ah() {
        return this.ag;
    }
    set ah(a) {
        let b = this.ah;
        if (a != b) {
            this.ag = a;
            this.by("VolumeTypePicker", b, this.ah);
        }
    }
    get p() {
        return this.o;
    }
    set p(a) {
        let b = this.p;
        if (a != b) {
            this.o = a;
            this.by("IndicatorPicker", b, this.p);
        }
    }
    get r() {
        return this.q;
    }
    set r(a) {
        let b = this.r;
        if (a != b) {
            this.q = a;
            this.by("OverlayPicker", b, this.r);
        }
    }
    by(a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.t != null) {
                    this.t.s = this.ax;
                }
                break;
            case "RangeEnd":
                if (this.t != null) {
                    this.t.r = this.aw;
                }
                break;
            case "SelectionStart":
                if (this.t != null) {
                    this.t.u = this.az;
                }
                break;
            case "SelectionEnd":
                if (this.t != null) {
                    this.t.t = this.ay;
                }
                break;
            case "RangeSelector":
                let d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bt));
                }
                if (this.t != null) {
                    this.t.s = this.ax;
                    this.t.r = this.aw;
                    this.t.n = this.v;
                    this.t.u = this.az;
                    this.t.t = this.ay;
                    let e = this.t;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bt));
                }
                break;
            case "ChartTypePicker":
                let f = b;
                if (f != null) {
                    f.changed = delegateRemove(f.changed, runOn(this, this.bs));
                }
                if (this.ad != null) {
                    this.ad.n = this.ab;
                    let g = this.ad;
                    g.changed = delegateCombine(g.changed, runOn(this, this.bs));
                }
                break;
            case "ChartType":
                if (this.ad != null) {
                    this.ad.n = this.ab;
                }
                break;
            case "TrendLineTypePicker":
                let h = b;
                if (h != null) {
                    h.changed = delegateRemove(h.changed, runOn(this, this.bu));
                }
                if (this.z != null) {
                    this.z.n = this.an;
                    let i = this.z;
                    i.changed = delegateCombine(i.changed, runOn(this, this.bu));
                }
                break;
            case "VolumeType":
                if (this.ah != null) {
                    this.ah.n = this.af;
                }
                break;
            case "VolumeTypePicker":
                let j = b;
                if (j != null) {
                    j.changed = delegateRemove(j.changed, runOn(this, this.bv));
                }
                if (this.ah != null) {
                    this.ah.n = this.af;
                    let k = this.ah;
                    k.changed = delegateCombine(k.changed, runOn(this, this.bv));
                }
                break;
            case "TrendLineType":
                if (this.z != null) {
                    this.z.n = this.an;
                }
                break;
            case "IndicatorPicker":
                let l = b;
                if (l != null) {
                    l.changed = delegateRemove(l.changed, runOn(this, this.bq));
                }
                if (this.p != null) {
                    this.p.n = this.aj;
                    let m = this.p;
                    m.changed = delegateCombine(m.changed, runOn(this, this.bq));
                }
                break;
            case "IndicatorTypes":
                if (this.p != null) {
                    this.p.n = this.aj;
                }
                break;
            case "OverlayPicker":
                let n = b;
                if (n != null) {
                    n.changed = delegateRemove(n.changed, runOn(this, this.br));
                }
                if (this.r != null) {
                    this.r.n = this.al;
                    let o = this.r;
                    o.changed = delegateCombine(o.changed, runOn(this, this.br));
                }
                break;
            case "OverlayTypes":
                if (this.r != null) {
                    this.r.n = this.al;
                }
                break;
            case "RangeSelectorOptions":
                if (this.t != null) {
                    this.t.n = this.v;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.aq) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
        }
    }
    br(a, b) {
        this.al = this.r.n;
        if (this.overlayTypesChanged != null) {
            this.overlayTypesChanged(this, b);
        }
    }
    bq(a, b) {
        this.aj = this.p.n;
        if (this.indicatorTypesChanged != null) {
            this.indicatorTypesChanged(this, b);
        }
    }
    bs(a, b) {
        this.ab = this.ad.n;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    }
    bu(a, b) {
        this.an = this.z.n;
        if (this.trendLineTypeChanged != null) {
            this.trendLineTypeChanged(this, b);
        }
    }
    bv(a, b) {
        this.af = this.ah.n;
        if (this.volumeTypeChanged != null) {
            this.volumeTypeChanged(this, b);
        }
    }
    bt(a, b) {
        this.az = this.t.u;
        this.ay = this.t.t;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    }
    w() {
        let a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.x;
        a.vm.financialChartChartTypePicker = ((() => {
            let $ret = new FinancialChartChartTypePickerContext();
            $ret.vm = this.ad.p;
            return $ret;
        })());
        a.vm.financialChartIndicatorPicker = ((() => {
            let $ret = new FinancialChartIndicatorPickerContext();
            $ret.vm = this.p.p;
            return $ret;
        })());
        a.vm.financialChartOverlayPicker = ((() => {
            let $ret = new FinancialChartOverlayPickerContext();
            $ret.vm = this.r.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((() => {
            let $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = this.t.p;
            return $ret;
        })());
        a.vm.financialChartTrendLineTypePicker = ((() => {
            let $ret = new FinancialChartTrendLinePickerContext();
            $ret.vm = this.z.p;
            return $ret;
        })());
        a.vm.financialChartVolumeTypePicker = ((() => {
            let $ret = new FinancialChartVolumeTypePickerContext();
            $ret.vm = this.ah.p;
            return $ret;
        })());
        return a;
    }
    l(a) {
        super.l(a);
        if (a == null) {
            return;
        }
        this.bw();
    }
    bw() {
    }
    get az() {
        return this.av;
    }
    set az(a) {
        let b = this.az;
        if (+a != +b) {
            this.av = a;
            this.by("SelectionStart", b, this.az);
        }
    }
    get ay() {
        return this.au;
    }
    set ay(a) {
        let b = this.ay;
        if (+a != +b) {
            this.au = a;
            this.by("SelectionEnd", b, this.ay);
        }
    }
    get ax() {
        return this.at;
    }
    set ax(a) {
        let b = this.ax;
        if (+a != +b) {
            this.at = a;
            this.by("RangeStart", b, this.ax);
        }
    }
    get aw() {
        return this.as;
    }
    set aw(a) {
        let b = this.aw;
        if (+a != +b) {
            this.as = a;
            this.by("RangeEnd", b, this.aw);
        }
    }
    bz() {
        if (this.t != null) {
            this.t.z();
        }
    }
    get ab() {
        return this.aa;
    }
    set ab(a) {
        let b = this.ab;
        if (a != b) {
            this.aa = a;
            this.by("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.ab));
        }
    }
    get an() {
        return this.am;
    }
    set an(a) {
        let b = this.an;
        if (a != b) {
            this.am = a;
            this.by("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.an));
        }
    }
    get af() {
        return this.ae;
    }
    set af(a) {
        let b = this.af;
        if (a != b) {
            this.ae = a;
            this.by("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.af));
        }
    }
    get aj() {
        return this.ai;
    }
    set aj(a) {
        let b = this.aj;
        if (!FinancialChartToolbar.ar(b, a)) {
            this.ai = a;
            this.by("IndicatorTypes", b, this.aj);
        }
    }
    get al() {
        return this.ak;
    }
    set al(a) {
        let b = this.al;
        if (!FinancialChartToolbar.ar(b, a)) {
            this.ak = a;
            this.by("OverlayTypes", b, this.al);
        }
    }
    static ar(a, b) {
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        for (let c of fromEn(a)) {
            if (!b.contains(c)) {
                return false;
            }
        }
        return true;
    }
    ao() {
        return ((() => {
            let $ret = new FinancialChartToolbarVisualData();
            $ret.indicatorPicker = this.p == null ? null : this.p.q();
            $ret.overlayPicker = this.r == null ? null : this.r.q();
            $ret.trendLineTypePicker = this.z == null ? null : this.z.q();
            $ret.chartTypePicker = this.ad == null ? null : this.ad.q();
            $ret.volumeTypePicker = this.ah == null ? null : this.ah.q();
            $ret.rangeSelector = this.t == null ? null : this.t.q();
            return $ret;
        })());
    }
    get v() {
        return this.u;
    }
    set v(a) {
        let b = this.v;
        if (a != b) {
            this.u = a;
            this.by("RangeSelectorOptions", b, this.v);
        }
    }
    get aq() {
        return this.ap;
    }
    set aq(a) {
        let b = this.aq;
        if (a != b) {
            this.ap = a;
            this.by("IsToolbarVisible", b, this.aq);
        }
    }
}
FinancialChartToolbar.a6 = 0;
FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
export class FinancialChartRangeSelector extends TemplatedHtmlControl {
    constructor(a) {
        super("financialChartRangeSelector", a, "");
        this.p = null;
        this.rangeChanged = null;
        this.o = null;
        this.o = new FinancialChartRangeSelectorView();
        this.p = new FinancialChartRangeSelectorViewModel();
        this.p.onRangeChanged = runOn(this, this.y);
    }
    get u() {
        return this.p.selectionStart;
    }
    set u(a) {
        this.p.selectionStart = a;
    }
    get t() {
        return this.p.selectionEnd;
    }
    set t(a) {
        this.p.selectionEnd = a;
    }
    get s() {
        return this.p.rangeStart;
    }
    set s(a) {
        this.p.rangeStart = a;
    }
    get r() {
        return this.p.rangeEnd;
    }
    set r(a) {
        this.p.rangeEnd = a;
    }
    z() {
        if (this.p.onPropertiesChanged()) {
            this.o.e(this.p);
        }
    }
    l(a) {
        super.l(a);
        this.o.d(this.d, this.p);
    }
    y() {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    }
    q() {
        return this.o.c(this.g);
    }
    get n() {
        return this.p.options;
    }
    set n(a) {
        let b = !FinancialChartToolbar.ar(this.p.options, a);
        if (b) {
            this.p.options = a;
            if (this.o != null) {
                this.o.g(this.n);
            }
        }
    }
}
FinancialChartRangeSelector.w = 0;
FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
//# sourceMappingURL=FinancialChart_combined.js.map