/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventArgs, Base, Type, markType, typeCast, Point_$type, String_$type, runOn, Number_$type, enumGetBox, fromEnum, toEnum, Delegate_$type } from "./type";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "./ArgumentNullException";
import { IFastItemColumn$1_$type } from "./IFastItemColumn$1";
import { Series } from "./Series";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { SeriesView } from "./SeriesView";
import { truncate, intDivide, isInfinity, isNaN_ } from "./number";
import { IHasCategoryAxis_$type } from "./IHasCategoryAxis";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Brush } from "./Brush";
import { DependencyProperty } from "./DependencyProperty";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode_$type } from "./CategoryMode";
import { List$1 } from "./List$1";
import { Dictionary$2 } from "./Dictionary$2";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { IFastItemsSource_$type } from "./IFastItemsSource";
import { FinancialValueList } from "./FinancialValueList";
import { CategoryXAxis } from "./CategoryXAxis";
import { SafeSortedReadOnlyDoubleCollection } from "./SafeSortedReadOnlyDoubleCollection";
import { SafeReadOnlyDoubleCollection } from "./SafeReadOnlyDoubleCollection";
import { SafeEnumerable } from "./SafeEnumerable";
import { CalculatedColumn } from "./CalculatedColumn";
import { TrendCalculators } from "./TrendCalculators";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { PropertyMetadata } from "./PropertyMetadata";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
import { Color } from "./Color";
import { stringIsNullOrEmpty } from "./string";
export class FinancialEventArgs extends EventArgs {
    constructor(a, b, c, d, e) {
        super();
        this._position = 0;
        this._count = 0;
        this._dataSource = null;
        this._supportingCalculations = null;
        this._basedOn = null;
        this.position = a;
        this.count = b;
        this.dataSource = c;
        this.supportingCalculations = d;
        if (c != null) {
            c.series = e;
        }
    }
    get position() {
        return this._position;
    }
    set position(a) {
        this._position = a;
    }
    get count() {
        return this._count;
    }
    set count(a) {
        this._count = a;
    }
    get dataSource() {
        return this._dataSource;
    }
    set dataSource(a) {
        this._dataSource = a;
    }
    get supportingCalculations() {
        return this._supportingCalculations;
    }
    set supportingCalculations(a) {
        this._supportingCalculations = a;
    }
    get basedOn() {
        return this._basedOn;
    }
    set basedOn(a) {
        this._basedOn = a;
    }
}
FinancialEventArgs.$t = markType(FinancialEventArgs, 'FinancialEventArgs', EventArgs.$);
export class FinancialBucketCalculator extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.c = 0;
        this.d = 0;
        this.b = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        this.a = a;
        this.c = -1;
        this.d = this.d;
        this.b = 0;
    }
    getBucket(a) {
        return null;
    }
    getBucketWithoutUnknowns(a) {
        return this.getBucket(a);
    }
    getErrorBucket(a, b) {
        return NaN;
    }
    getBucketInfo(a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.bu.ej;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    }
    e(a) {
        let b = this.a.bq;
        let c = this.a.bp;
        let d = this.a.bp;
        if (this.a.bu != null) {
            d = this.a.bu.getEffectiveViewport1(this.a);
        }
        if (b.isEmpty || c.isEmpty || this.a.bu.ln == null) {
            this.b = 0;
            return;
        }
        let e = (this.a.bu.ln != null) ? this.a.bu.ln.bz : false;
        let f = new ScalerParams(0, b, c, e, d);
        let g = this.a.bu.k5(this.a);
        let h = typeCast(ISortingAxis_$type, this.a.bu.ln);
        if (h == null || h.i$b == null) {
            let i = Math.floor(this.a.bu.ln.dm(g.left, f));
            let j = Math.ceil(this.a.bu.ln.dm(g.right, f));
            if (this.a.bu.ln.bz) {
                j = Math.ceil(this.a.bu.ln.dm(g.left, f));
                i = Math.floor(this.a.bu.ln.dm(g.right, f));
            }
            let k = Math.floor((j - i + 1) * a / g.width);
            this.b = truncate(Math.max(1, k));
            this.c = truncate(Math.floor(i / this.b));
            this.d = truncate(Math.ceil(j / this.b));
        }
        else {
            this.c = h.i$e(b, c, d, g);
            this.d = h.i$g(b, c, d, g);
            this.b = 1;
        }
    }
    cacheValues() {
    }
    unCacheValues() {
    }
}
FinancialBucketCalculator.$t = markType(FinancialBucketCalculator, 'FinancialBucketCalculator', Base.$, [IBucketizer_$type]);
export class FinancialSeries extends Series {
    constructor() {
        super();
        this.me = null;
        this.ma = null;
        this.mc = null;
        this.l8 = null;
        this.mh = null;
        this.ml = false;
        this.assigningCategoryStyle = null;
        this.lv = null;
        this.mw = new Dictionary$2(IFastItemColumn$1_$type.specialize(Number_$type), String_$type, 0);
        this.mx = new Dictionary$2(String_$type, String_$type, 0);
        this.mk = false;
        this.l6 = null;
        this.lq = null;
        this.ls = null;
        this.lp = null;
        this.ot = null;
        this.ly = null;
        this.typical = null;
        this.typicalBasedOn = null;
        this.mj = false;
        this.m9 = null;
        this.m7 = null;
        this.m8 = null;
        this.m6 = null;
        this.na = null;
        this.lr = null;
        this.lo = null;
        this.lt = 0;
        this.lv = new CategorySeriesRenderManager();
        this.ml = false;
        this.ly = new CategoryTransitionSourceFramePreparer();
        this.lr = new CategoryFrame(3);
        this.ab = FinancialSeries.$;
        this.lu = 0;
    }
    h9(a) {
        super.h9(a);
        this.l3 = a;
    }
    get_cp() {
        return true;
    }
    get cp() {
        return this.get_cp();
    }
    nk() {
        return 2;
    }
    ag(a) {
        let b = this.ai(this.ln, this.lp.f, this.ni(this.bh), this.nj(this.bh), this.k3(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        let g = this.nk();
        f[0] = { $type: Point_$type, x: c[0], y: c[g] };
        f[1] = { $type: Point_$type, x: d[0], y: d[g] };
        e[0] = f;
        return e;
    }
    ah(a) {
        let b = this.ai(this.ln, this.lp.f, this.ni(this.bh), this.nj(this.bh), this.k3(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    }
    ko() {
        return this.op;
    }
    hc() {
        super.hc();
        this.ln = null;
        this.l7 = null;
    }
    get mf() {
        return this.me;
    }
    set mf(a) {
        if (this.me != a) {
            let b = this.me;
            this.me = a;
            this.raisePropertyChanged("OpenColumn", b, this.me);
        }
    }
    get mb() {
        return this.ma;
    }
    set mb(a) {
        if (this.ma != a) {
            let b = this.ma;
            this.ma = a;
            this.raisePropertyChanged("HighColumn", b, this.ma);
        }
    }
    get md() {
        return this.mc;
    }
    set md(a) {
        if (this.mc != a) {
            let b = this.mc;
            this.mc = a;
            this.raisePropertyChanged("LowColumn", b, this.mc);
        }
    }
    get l9() {
        return this.l8;
    }
    set l9(a) {
        if (this.l8 != a) {
            let b = this.l8;
            this.l8 = a;
            this.raisePropertyChanged("CloseColumn", b, this.l8);
        }
    }
    get mi() {
        return this.mh;
    }
    set mi(a) {
        if (this.mh != a) {
            let b = this.mh;
            this.mh = a;
            this.raisePropertyChanged("VolumeColumn", b, this.mh);
        }
    }
    mt() {
        return (this.assigningCategoryStyle != null && this.ml) || this.cs;
    }
    oc(a) {
        if (this.assigningCategoryStyle != null && this.ml) {
            this.assigningCategoryStyle(this, a);
        }
    }
    oa(a, b, c, d, e, f) {
        let g = this.b8;
        this.lv.ac(a, b, c, d, e, f, g);
        let h = this.lv.c;
        let i = null;
        let j = this.by;
        if (g && this.br != null) {
            i = this.br.az.getHighlightingInfo(this, j, d, h.m, h.l, false);
            h.b = i;
        }
        h.f = f;
        this.oc(h);
        this.lv.aa(i, f, g);
    }
    nb(a) {
        return this.d4(a, this.ln);
    }
    e3(a, b) {
        return this.e4(a, b, this.ln, runOn(this, this.nb), new FinancialValueList(this.mf, this.mb, this.md, this.l9, this.mi));
    }
    e1(a, b) {
        return this.e2(a, b, this.ln, runOn(this, this.nb), new FinancialValueList(this.mf, this.mb, this.md, this.l9, this.mi));
    }
    d0(a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        let f = this.ln.ja;
        return this.d1(a, b, this.ln, d, e, f, runOn(this, this.nb));
    }
    getOffsetValue() {
        return this.nc(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh));
    }
    getCategoryWidth() {
        return this.ln.getCategorySize(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh));
    }
    k0(a, b, c) {
        return this.k2(a, b, c, this.nc(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.l7, this.ln, null, null, null);
    }
    ed(a, b, c) {
        let d = this.getEffectiveViewport1(this.bh);
        let e = this.nc(this.bh.bq, this.bh.bp, d);
        let f = new ScalerParams(0, this.bh.bq, this.bh.bp, this.ln.bz, d);
        return this.ef(new FinancialValueList(this.mf, this.mb, this.md, this.l9, this.mi), a, this.ln, f, e, runOn(this, this.nb), b, c);
    }
    d9(a, b, c) {
        let d = this.getEffectiveViewport1(this.bh);
        let e = this.nc(this.bh.bq, this.bh.bp, d);
        let f = new ScalerParams(0, this.bh.bq, this.bh.bp, this.ln.bz, d);
        return this.ef(this.mb, a, this.ln, f, e, runOn(this, this.nb), b, c);
    }
    eb(a, b, c) {
        let d = this.getEffectiveViewport1(this.bh);
        let e = this.nc(this.bh.bq, this.bh.bp, d);
        let f = new ScalerParams(0, this.bh.bq, this.bh.bp, this.ln.bz, d);
        return this.ef(this.md, a, this.ln, f, e, runOn(this, this.nb), b, c);
    }
    nd(a, b, c) {
        let d = this.getEffectiveViewport1(this.bh);
        let e = this.nc(this.bh.bq, this.bh.bp, d);
        let f = new ScalerParams(0, this.bh.bq, this.bh.bp, this.ln.bz, d);
        return this.ef(this.l9, a, this.ln, f, e, runOn(this, this.nb), b, c);
    }
    ne(a, b, c) {
        let d = this.getEffectiveViewport1(this.bh);
        let e = this.nc(this.bh.bq, this.bh.bp, d);
        let f = new ScalerParams(0, this.bh.bq, this.bh.bp, this.ln.bz, d);
        return this.ef(this.mf, a, this.ln, f, e, runOn(this, this.nb), b, c);
    }
    nf(a, b, c) {
        let d = this.getEffectiveViewport1(this.bh);
        let e = this.nc(this.bh.bq, this.bh.bp, d);
        let f = new ScalerParams(0, this.bh.bq, this.bh.bp, this.ln.bz, d);
        return this.ef(this.mi, a, this.ln, f, e, runOn(this, this.nb), b, c);
    }
    kw(a, b, c) {
        return this.k2(a, b, c, this.nc(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.l7, this.ln, runOn(this, this.d9), (d, e) => this.e4(d, e, this.ln, runOn(this, this.nb), this.mb), (d, e) => this.e2(d, e, this.ln, runOn(this, this.nb), this.mb));
    }
    ky(a, b, c) {
        return this.k2(a, b, c, this.nc(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.l7, this.ln, runOn(this, this.eb), (d, e) => this.e4(d, e, this.ln, runOn(this, this.nb), this.md), (d, e) => this.e2(d, e, this.ln, runOn(this, this.nb), this.md));
    }
    or(a, b, c) {
        return this.k2(a, b, c, this.nc(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.l7, this.ln, runOn(this, this.ne), (d, e) => this.e4(d, e, this.ln, runOn(this, this.nb), this.mf), (d, e) => this.e2(d, e, this.ln, runOn(this, this.nb), this.mf));
    }
    oq(a, b, c) {
        return this.k2(a, b, c, this.nc(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.l7, this.ln, runOn(this, this.nd), (d, e) => this.e4(d, e, this.ln, runOn(this, this.nb), this.l9), (d, e) => this.e2(d, e, this.ln, runOn(this, this.nb), this.l9));
    }
    os(a, b, c) {
        return this.k2(a, b, c, this.nc(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.l7, this.ln, runOn(this, this.nf), (d, e) => this.e4(d, e, this.ln, runOn(this, this.nb), this.mi), (d, e) => this.e2(d, e, this.ln, runOn(this, this.nb), this.mi));
    }
    ht() {
        super.ht();
        if (this.ln != null) {
            this.ln.gj(false);
        }
        if (this.l7 != null) {
            this.l7.gj(false);
        }
    }
    i8(a, b) {
        this.l3.bs.e(this.ej);
        this.it(false);
    }
    i7(a, b) {
        if (this.di && this.eo < 0.05) {
            this.dj = true;
        }
        this.l3.bs.e(this.ej);
        this.it(false);
    }
    mg(a, b, c) {
        let d = this.bv(b);
        this.mw.addItem(d, b);
        this.mx.addItem(b, c);
        return d;
    }
    n9(a, b) {
        if (b == null) {
            return;
        }
        a.deregisterColumn(b);
        let c = this.mw.item(b);
        this.mx.removeItem(c);
        this.mw.removeItem(b);
    }
    ie(a, b, c, d) {
        super.ie(a, b, c, d);
        switch (b) {
            case "SyncLink":
                if (this.bm != null && this.br != null) {
                    this.l3.bs.e(this.ej);
                    this.it(false);
                }
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.ln != null) {
                        this.ln.bn(this);
                    }
                    if (this.l7 != null) {
                        this.l7.bn(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.ln != null) {
                        this.ln.b8(this);
                    }
                    if (this.l7 != null) {
                        this.l7.b8(this);
                    }
                }
                this.l3.bs.e(this.ej);
                this.it(false);
                break;
            case "FastItemsSource":
                this.mk = true;
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    this.n9(typeCast(IFastItemsSource_$type, c), this.mf);
                    this.n9(typeCast(IFastItemsSource_$type, c), this.mb);
                    this.n9(typeCast(IFastItemsSource_$type, c), this.md);
                    this.n9(typeCast(IFastItemsSource_$type, c), this.l9);
                    this.n9(typeCast(IFastItemsSource_$type, c), this.mi);
                    this.mf = null;
                    this.mb = null;
                    this.md = null;
                    this.l9 = null;
                    this.mi = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    if (this.n0 != null) {
                        this.mf = this.mg(typeCast(IFastItemsSource_$type, d), this.n0, "OpenColumn");
                    }
                    if (this.nr != null) {
                        this.mb = this.mg(typeCast(IFastItemsSource_$type, d), this.nr, "HighColumn");
                    }
                    if (this.nw != null) {
                        this.md = this.mg(typeCast(IFastItemsSource_$type, d), this.nw, "LowColumn");
                    }
                    if (this.no != null) {
                        this.l9 = this.mg(typeCast(IFastItemsSource_$type, d), this.no, "CloseColumn");
                    }
                    if (this.n4 != null) {
                        this.mi = this.mg(typeCast(IFastItemsSource_$type, d), this.n4, "VolumeColumn");
                    }
                }
                this.mk = false;
                if (this.l7 != null && !this.l7.cb()) {
                    this.l3.bs.e(this.ej);
                    this.it(false);
                }
                break;
            case FinancialSeries.$$p[6]:
                if (this.by != null) {
                    this.n9(this.by, this.mf);
                    this.mf = this.mg(this.by, this.n0, "OpenColumn");
                }
                break;
            case "OpenColumn":
                if (this.l7 != null && !this.l7.cb() && !this.mk) {
                    this.l3.bs.e(this.ej);
                    this.it(false);
                }
                break;
            case FinancialSeries.$$p[1]:
                if (this.by != null) {
                    this.n9(this.by, this.mb);
                    this.mb = this.mg(this.by, this.nr, "HighColumn");
                }
                break;
            case "HighColumn":
                if (this.l7 != null && !this.l7.cb() && !this.mk) {
                    this.l3.bs.e(this.ej);
                    this.it(false);
                }
                break;
            case FinancialSeries.$$p[4]:
                if (this.by != null) {
                    this.n9(this.by, this.md);
                    this.md = this.mg(this.by, this.nw, "LowColumn");
                }
                break;
            case "LowColumn":
                if (this.l7 != null && !this.l7.cb() && !this.mk) {
                    this.l3.bs.e(this.ej);
                    this.it(false);
                }
                break;
            case FinancialSeries.$$p[0]:
                if (this.by != null) {
                    this.n9(this.by, this.l9);
                    this.l9 = this.mg(this.by, this.no, "CloseColumn");
                }
                break;
            case "CloseColumn":
                if (this.l7 != null && !this.l7.cb() && !this.mk) {
                    this.l3.bs.e(this.ej);
                    this.it(false);
                }
                break;
            case FinancialSeries.$$p[8]:
                if (this.by != null) {
                    this.n9(this.by, this.mi);
                    this.mi = this.mg(this.by, this.n4, "VolumeColumn");
                }
                break;
            case "VolumeColumn":
                if (this.l7 != null && !this.l7.cb() && !this.mk) {
                    this.l3.bs.e(this.ej);
                    this.it(false);
                }
                break;
            case FinancialSeries.$$p[9]:
                if (c != null) {
                    c.bn(this);
                }
                if (d != null) {
                    d.b8(this);
                }
                this.l3.bs.e(this.ej);
                this.it(false);
                this.h1();
                break;
            case FinancialSeries.$$p[10]:
                if (c != null) {
                    c.bn(this);
                }
                if (d != null) {
                    d.b8(this);
                }
                this.l3.bs.e(this.ej);
                if (this.l7 != null) {
                    this.l7.cb();
                }
                {
                    this.it(false);
                }
                this.h1();
                break;
            case "TransitionProgress":
                this.ls.c(this.eo, this.lq, this.lp);
                if (this.cb(this.bh)) {
                    return;
                }
                if (this.eo == 1) {
                    this.lp.v();
                    this.od(this.lp, this.l3);
                    if (this.di) {
                        this.di = false;
                        this.hf();
                        this.bs.r = truncate(this.eg());
                        this.bs.b = this.bt;
                    }
                }
                else {
                    this.od(this.ls, this.l3);
                }
                break;
            case FinancialSeries.$$p[5]:
                this.it(false);
                break;
            case "IsCustomCategoryStyleAllowed":
                this.ml = this.mo();
                this.it(false);
                break;
            case "CategoryMode":
                if (this.ln != null) {
                    this.ln.jz(true);
                }
                break;
        }
    }
    mn(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    mm(a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.bw) {
            return true;
        }
        return false;
    }
    lg(a, b, c) {
        if (b < a || a < 0 || a > this.by.count || b < 0 || b > this.by.count || c == null) {
            return null;
        }
        let d = new Array((b - a) + 1);
        let e = c.b3;
        let f = null;
        if (e) {
            f = c.i$b;
        }
        for (let g = a; g <= b; g++) {
            let h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.by.item(g);
        }
        return d;
    }
    ni(a) {
        return a.bs.b;
    }
    nj(a) {
        return a.bs.c;
    }
    lf(a, b) {
        return this.lg(a, b, this.l7);
    }
    get_mp() {
        return false;
    }
    get mp() {
        return this.get_mp();
    }
    get_ct() {
        return true;
    }
    get ct() {
        return this.get_ct();
    }
    as(a, b) {
        if (this.mp) {
            let c = this.l5(a, b, this.l6);
            this.l6 = c;
            return c;
        }
        else {
            let d = this.l4(a, b, this.l6);
            this.l6 = d;
            return d;
        }
    }
    nl(a) {
        let b = this.lp;
        if (this.b9()) {
            b = this.ls;
        }
        let c = this.bh.bp;
        let d = this.bh.bq;
        let e = this.ln;
        let f = 0;
        if (e.b5) {
            let g = (a.y - d.top) / d.height;
            f = g * c.height + c.top;
        }
        else {
            let h = (a.x - d.left) / d.width;
            f = h * c.width + c.left;
        }
        let i = b.f.count;
        let j = 0;
        for (j = 0; j < i; j++) {
            let k = b.f._inner[j];
            let l = null;
            if (j < i - 1) {
                l = b.f._inner[j + 1];
            }
            if (k[0] <= f && l == null || l[0] >= f) {
                if (l != null) {
                    if (Math.abs(k[0] - f) < Math.abs(l[0] - f)) {
                        return j;
                    }
                    else {
                        return j + 1;
                    }
                }
                else {
                    return j;
                }
            }
        }
        return j;
    }
    l5(a, b, c) {
        let d = this.by.count;
        let e = this.l3.bs.c;
        let f = this.l3.bs.d;
        let g = this.l3.bs.b;
        let h = this.ln;
        let i = -1;
        let j = -1;
        if (h.b3) {
            let k = this.lp;
            if (this.b9()) {
                k = this.ls;
            }
            let l = this.nl(b);
            i = l;
            j = l;
        }
        else {
            let m = this.ex(b);
            i = truncate(Math.floor((intDivide(m, g)))) * g;
            j = i + (g - 1);
        }
        if (c != null && c.f == i && c.e == j) {
            return c;
        }
        let n = new HighlightingInfo();
        n.b = this;
        n.f = i;
        n.e = j;
        return n;
    }
    l4(a, b, c) {
        let d = new HighlightingInfo();
        d.b = this;
        d.f = 0;
        d.e = this.by.count - 1;
        if (c != null && c.f == d.f && c.e == d.e) {
            return c;
        }
        return d;
    }
    mo() {
        return this.mr;
    }
    d2(a) {
        let b = this.bh.bq;
        let c = this.bh.bp;
        let d = -1;
        if (!b.isEmpty && !c.isEmpty && this.ln != null) {
            let e = this.getEffectiveViewport1(this.bh);
            let f = new ScalerParams(0, b, c, this.ln.bz, e);
            let g = this.k5(this.bh);
            let h = this.ln.dm(g.left, f);
            let i = this.ln.dm(g.right, f);
            let j = (a.x - b.left) / b.width;
            let k = h + (j * (i - h));
            if (this.ln.categoryMode != 0) {
                k -= 0.5;
            }
            d = k;
        }
        return d;
    }
    ex(a) {
        return truncate(Math.round(this.d2(a)));
    }
    get_cz() {
        return typeCast(ISortingAxis_$type, this.ln) !== null;
    }
    get cz() {
        return this.get_cz();
    }
    ao() {
        return this.ln;
    }
    ez(a) {
        let b = this.bh.bq;
        let c = this.bh.bp;
        let d = this.getEffectiveViewport1(this.bh);
        if (b.isEmpty || c.isEmpty) {
            return -1;
        }
        let e = new Rect(0, 0, 0, 1, 1);
        let f = new ScalerParams(0, b, c, this.ln.bz, d);
        let g = typeCast(ISortingAxis_$type, this.ln);
        let h = this.k5(this.bh);
        let i = h.left;
        let j = h.right;
        let k = this.kv(a).x;
        let l = this.ln.dm(k, f);
        let m = this.ln.dm(i, f);
        let n = this.ln.dm(j, f);
        l = Math.max(m, Math.min(n, l));
        let o = g.i$f(l);
        return o;
    }
    fe(a) {
        let b = 0;
        if (typeCast(ISortingAxis_$type, this.ln) !== null) {
            b = this.ez(a);
            if (b == -1) {
                return null;
            }
        }
        else {
            b = this.ex(a);
        }
        return b >= 0 && this.by != null && b < this.by.count ? this.by.item(b) : null;
    }
    nc(a, b, c) {
        if (this.ln == null) {
            return 0;
        }
        return this.ln.getOffset(a, b, c, this.e6);
    }
    c8() {
        return this.ms;
    }
    lw() {
        return 11;
    }
    bn() {
        return 3;
    }
    od(a, b) {
        this.k4 = a.aa;
        b.ar();
    }
    get ou() {
        return this.ot;
    }
    ob(a, b) {
        a.u();
    }
    ds(a, b, c) {
        let d = super.ds(a, b, c);
        let e = c;
        if (this.by == null || this.by.count == 0 || !c.l() || b.isEmpty || a.isEmpty || this.ln == null || this.l7 == null || e.bs.b < 1 || this.ln.a9 == null || this.l7.a9 == null || this.l7.jg == this.l7.jf || this.ln.itemsSource == null || this.ln.ja < 1) {
            e.bs.b = 0;
            d = false;
        }
        return d;
    }
    getViewInfo(a, b) {
        b = this.bh.bq;
        a = this.bh.bp;
        return {
            p0: a,
            p1: b
        };
    }
    ng(a) {
        let b = 0;
        let c = a.bq;
        let d = a.bp;
        let e = this.getEffectiveViewport1(this.bh);
        if (!c.isEmpty && !d.isEmpty && this.l7 != null) {
            let f = new ScalerParams(0, c, d, this.l7.bz, e);
            b = this.l7.dj(this.l7.jq, f);
        }
        return b;
    }
    hf() {
        super.hf();
        this.lq.v();
        this.lp.v();
        this.ls.v();
    }
    iu(a) {
        super.iu(a);
        this.l3.bs.e(this.ej);
        if (this.cb(this.bh)) {
            return;
        }
        if (this.da) {
            if (this.b9()) {
                this.od(this.ls, this.l3);
            }
            else {
                this.od(this.lp, this.l3);
            }
            return;
        }
        if (this.c6(a)) {
            let b = this.lq;
            if (this.b9()) {
                if (this.bs.g) {
                    this.bs.t();
                }
                this.lq = this.ls;
                this.ls = b;
            }
            else {
                this.lq = this.lp;
                this.lp = b;
            }
            this.ob(this.lp, this.l3);
            if (this.dk) {
                this.bs.w();
                this.bs.r = truncate(this.eh());
                this.bs.b = this.bu != null ? this.bu : this.bt;
                this.ly.p(this.lq, this.lp, this.isVertical, this.ln, this.l7, this.lx, this.lw(), this.bo, this.bn(), () => this.ng(this.l3), this.l3.bp);
            }
            this.hb();
            this.i1();
            if (this.dk) {
                this.dj = false;
                this.di = true;
            }
        }
        else {
            this.ob(this.lp, this.l3);
            this.od(this.lp, this.l3);
        }
    }
    mu(a) {
        for (let b of fromEnum(a)) {
            switch (b) {
                case "HighColumn":
                    if (this.mb == null) {
                        return false;
                    }
                    break;
                case "LowColumn":
                    if (this.md == null) {
                        return false;
                    }
                    break;
                case "OpenColumn":
                    if (this.mf == null) {
                        return false;
                    }
                    break;
                case "CloseColumn":
                    if (this.l9 == null) {
                        return false;
                    }
                    break;
                case "VolumeColumn":
                    if (this.mi == null) {
                        return false;
                    }
                    break;
            }
        }
        return true;
    }
    get mv() {
        return this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null;
    }
    mq() {
        return this.typical != null;
    }
    n8(a) {
        this.typical(this, a);
    }
    get m3() {
        return this.m0();
    }
    *_m0() {
        let a = false;
        if (this.mq()) {
            let b = this.lz(0, this.by.count);
            this.n8(new FinancialEventArgs(0, this.by.count, b, this.l0(b), this));
            if (b.typicalColumn != null) {
                a = true;
                for (let c of fromEnum(b.typicalColumn)) {
                    yield c;
                }
            }
        }
        if (!a) {
            if (this.mv && this.ln.i$b != null) {
                let d = this.by.count;
                let e = this.ln.i$b;
                for (let f = 0; f < d; ++f) {
                    yield (this.mb.item(e.item(f)) + this.md.item(e.item(f)) + this.l9.item(e.item(f))) / 3;
                }
            }
            else {
                let g = this.by.count;
                for (let h = 0; h < g; ++h) {
                    yield (this.mb.item(h) + this.md.item(h) + this.l9.item(h)) / 3;
                }
            }
        }
    }
    m0() {
        return toEnum(() => this._m0());
    }
    get m2() {
        return this.mz();
    }
    *_mz() {
        if (this.mv && this.ln.i$b != null) {
            let a = this.mb.count;
            let b = this.ln.i$b;
            if (a > 0) {
                yield this.nh(this.mb.item(b.item(0)) - this.md.item(b.item(0)));
            }
            for (let c = 1; c < a; ++c) {
                yield Math.max(this.nh(this.mb.item(b.item(c)) - this.md.item(b.item(c))), Math.max(this.nh(Math.abs(this.mb.item(b.item(c)) - this.l9.item(b.item(c - 1)))), this.nh(Math.abs(this.md.item(b.item(c)) - this.l9.item(b.item(c - 1))))));
            }
        }
        else {
            let d = this.mb.count;
            if (d > 0) {
                yield this.nh(this.mb.item(0) - this.md.item(0));
            }
            for (let e = 1; e < d; ++e) {
                yield Math.max(this.nh(this.mb.item(e) - this.md.item(e)), Math.max(this.nh(Math.abs(this.mb.item(e) - this.l9.item(e - 1))), this.nh(Math.abs(this.md.item(e) - this.l9.item(e - 1)))));
            }
        }
    }
    mz() {
        return toEnum(() => this._mz());
    }
    get m1() {
        return this.my();
    }
    *_my() {
        if (this.mv && this.ln.i$b != null) {
            let a = this.md.count;
            let b = this.ln.i$b;
            if (a > 0) {
                yield this.nh(this.md.item(b.item(0)));
            }
            for (let c = 1; c < a; c++) {
                yield Math.min(this.nh(this.md.item(b.item(c))), this.nh(this.l9.item(b.item(c - 1))));
            }
        }
        else {
            let d = this.md.count;
            if (d > 0) {
                yield this.nh(this.md.item(0));
            }
            for (let e = 1; e < d; e++) {
                yield Math.min(this.nh(this.md.item(e)), this.nh(this.l9.item(e - 1)));
            }
        }
    }
    my() {
        return toEnum(() => this._my());
    }
    m5(a) {
        if (a == null) {
            return null;
        }
        if (this.mv && this.ln.i$b != null) {
            return new SafeSortedReadOnlyDoubleCollection(0, a, this.ln.i$b);
        }
        return new SafeReadOnlyDoubleCollection(0, a);
    }
    m4() {
        let a = new List$1(String_$type, 0);
        a.add("HighColumn");
        a.add("LowColumn");
        a.add("CloseColumn");
        if (this.typicalBasedOn != null && this.by != null && !this.mj) {
            this.mj = true;
            let b = this.lz(0, this.by.count);
            this.mj = false;
            let c = new FinancialEventArgs(0, this.by.count, b, this.l0(b), this);
            this.typicalBasedOn(this, c);
            if (c.basedOn != null && c.basedOn.count > 0) {
                return c.basedOn;
            }
        }
        return a;
    }
    getOpenColumnAsArray() {
        if (this.mf == null) {
            return null;
        }
        if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
            if (this.m9 != null) {
                return this.m9.asArray();
            }
            let a = new List$1(Number_$type, 2, this.mf.count);
            let b = this.ln.i$b;
            let c = this.mf.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.m9 = a;
            return this.m9.asArray();
        }
        else {
            return this.mf.asArray();
        }
    }
    getHighColumnAsArray() {
        if (this.mb == null) {
            return null;
        }
        if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
            if (this.m7 != null) {
                return this.m7.asArray();
            }
            let a = new List$1(Number_$type, 2, this.mb.count);
            let b = this.ln.i$b;
            let c = this.mb.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.m7 = a;
            return this.m7.asArray();
        }
        else {
            return this.mb.asArray();
        }
    }
    getLowColumnAsArray() {
        if (this.md == null) {
            return null;
        }
        if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
            if (this.m8 != null) {
                return this.m8.asArray();
            }
            let a = new List$1(Number_$type, 2, this.md.count);
            let b = this.ln.i$b;
            let c = this.md.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.m8 = a;
            return this.m8.asArray();
        }
        else {
            return this.md.asArray();
        }
    }
    getCloseColumnAsArray() {
        if (this.l9 == null) {
            return null;
        }
        if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
            if (this.m6 != null) {
                return this.m6.asArray();
            }
            let a = new List$1(Number_$type, 2, this.l9.count);
            let b = this.ln.i$b;
            let c = this.l9.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.m6 = a;
            return this.m6.asArray();
        }
        else {
            return this.l9.asArray();
        }
    }
    getVolumeColumnAsArray() {
        if (this.mi == null) {
            return null;
        }
        if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
            if (this.na != null) {
                return this.na.asArray();
            }
            let a = new List$1(Number_$type, 2, this.mi.count);
            let b = this.ln.i$b;
            let c = this.mi.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.na = a;
            return this.na.asArray();
        }
        else {
            return this.mi.asArray();
        }
    }
    hh(a, b, c, d) {
        super.hh(a, b, c, d);
        if (this.ln == null || !(typeCast(ISortingAxis_$type, this.ln) !== null)) {
            return;
        }
        let e = this.ln.i$b;
        switch (a) {
            case 1:
                for (let f = b; f < c; f++) {
                    let g = e._inner[f];
                    if (this.m9 != null) {
                        this.m9.insert(f, this.mf.item(g));
                    }
                    if (this.m7 != null) {
                        this.m7.insert(f, this.mb.item(g));
                    }
                    if (this.m8 != null) {
                        this.m8.insert(f, this.md.item(g));
                    }
                    if (this.m6 != null) {
                        this.m6.insert(f, this.l9.item(g));
                    }
                    if (this.na != null) {
                        this.na.insert(f, this.mi.item(g));
                    }
                }
                break;
            case 0:
                if (this.m9 != null) {
                    this.m9.v(b, c);
                }
                if (this.m7 != null) {
                    this.m7.v(b, c);
                }
                if (this.m8 != null) {
                    this.m8.v(b, c);
                }
                if (this.m6 != null) {
                    this.m6.v(b, c);
                }
                if (this.na != null) {
                    this.na.v(b, c);
                }
                break;
            case 4:
                if (this.m9 != null) {
                    this.m9 = new List$1(Number_$type, 0);
                }
                if (this.m7 != null) {
                    this.m7 = new List$1(Number_$type, 0);
                }
                if (this.m8 != null) {
                    this.m8 = new List$1(Number_$type, 0);
                }
                if (this.m6 != null) {
                    this.m6 = new List$1(Number_$type, 0);
                }
                if (this.na != null) {
                    this.na = new List$1(Number_$type, 0);
                }
                break;
            case 3:
            case 2:
                for (let h = b; h < c; h++) {
                    let i = e._inner[h];
                    if (this.m9 != null) {
                        this.m9._inner[h] = this.mf.item(i);
                    }
                    if (this.m7 != null) {
                        this.m7._inner[h] = this.mb.item(i);
                    }
                    if (this.m8 != null) {
                        this.m8._inner[h] = this.md.item(i);
                    }
                    if (this.m6 != null) {
                        this.m6._inner[h] = this.l9.item(i);
                    }
                    if (this.na != null) {
                        this.na._inner[h] = this.mi.item(i);
                    }
                }
                break;
        }
    }
    lz(a, b) {
        let c = this.m5(this.mf);
        let d = this.m5(this.l9);
        let e = this.m5(this.mb);
        let f = this.m5(this.md);
        let g = this.m5(this.mi);
        let h = ((() => {
            let $ret = new FinancialCalculationDataSource();
            $ret.typicalColumn = new CalculatedColumn(1, new SafeEnumerable(this.m3), this.m4());
            $ret.trueRange = new CalculatedColumn(1, new SafeEnumerable(this.m2), ((() => {
                let $ret = new List$1(String_$type, 0);
                $ret.add("HighColumn");
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.trueLow = new CalculatedColumn(1, new SafeEnumerable(this.m1), ((() => {
                let $ret = new List$1(String_$type, 0);
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.openColumn = c;
            $ret.closeColumn = d;
            $ret.highColumn = e;
            $ret.lowColumn = f;
            $ret.volumeColumn = g;
            $ret.calculateFrom = a;
            $ret.calculateCount = b;
            $ret.minimumValue = NaN;
            $ret.maximumValue = NaN;
            $ret.count = this.by != null ? this.by.count : 0;
            return $ret;
        })());
        return h;
    }
    nh(a) {
        if (isInfinity(a) || isNaN_(a)) {
            return 0;
        }
        return a;
    }
    l0(a) {
        return ((() => {
            let $ret = new FinancialCalculationSupportingCalculations();
            $ret.a = new ColumnSupportingCalculation(1, TrendCalculators.b, new List$1(String_$type, 0));
            $ret.c = new ColumnSupportingCalculation(1, TrendCalculators.e, new List$1(String_$type, 0));
            $ret.d = new ColumnSupportingCalculation(1, TrendCalculators.f, new List$1(String_$type, 0));
            $ret.b = new ColumnSupportingCalculation(1, TrendCalculators.d, new List$1(String_$type, 0));
            $ret.h = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.volumeColumn, b.shortPeriod), ((() => {
                let $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.f = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.volumeColumn, b.longPeriod), ((() => {
                let $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.g = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.typicalColumn, b.shortPeriod), a.typicalColumn.basedOn);
            $ret.e = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.typicalColumn, b.longPeriod), a.typicalColumn.basedOn);
            $ret.k = Series.dv;
            $ret.j = Series.du;
            $ret.i = runOn(this, this.nh);
            return $ret;
        })());
    }
    get categoryAxis() {
        return this.ln;
    }
    iv(a, b) {
        super.iv(a, b);
        if (!this.dh) {
            this.bh.az(b);
            return;
        }
        let c = typeCast(FinancialSeriesView.$, this.bg);
        this.bh.az(b);
        c.bs.e(this.ej);
        if (this.cb(this.bg)) {
            return;
        }
        if (!this.db) {
            this.ob(this.lr, c);
        }
        this.db = false;
        this.od(this.lr, c);
        this.dh = false;
    }
    is(a, b, c, d, e) {
        super.is(a, b, c, d, e);
        let f = this.az.a$h.item(d);
        let g = f;
        g.bs.e(this.ej);
        f.ay(c);
        if (this.cb(g)) {
            return;
        }
        if (this.lo == null) {
            this.lo = new CategoryFrame(3);
        }
        this.lo.u();
        this.ob(this.lo, g);
        this.od(this.lo, g);
    }
    al(a) {
        if (this.ln == a) {
            return this.l7;
        }
        if (this.l7 == a) {
            return this.ln;
        }
        return null;
    }
    preferredCategoryMode(a) {
        let b = typeCast(IDateTimeAxis_$type, this.ln);
        return b != null ? b.preferredCategoryMode(this) : this.lu;
    }
    get lu() {
        return this.lt;
    }
    set lu(a) {
        let b = this.lu;
        if (a != b) {
            this.lt = a;
            this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.lu));
        }
    }
    get_cx() {
        return true;
    }
    get cx() {
        return this.get_cx();
    }
    iy(a, b) {
        super.iy(a, b);
        this.op = a;
    }
}
FinancialSeries.$t = markType(FinancialSeries, 'FinancialSeries', Series.$, [IHasCategoryAxis_$type, IHasCategoryModePreference_$type]);
Type.dep(DependencyProperty, PropertyMetadata, FinancialSeries, 'raisePropertyChanged', ['CloseMemberPath:no:oe', [2, null], 'HighMemberPath:nr:of', [2, null], 'IsCustomCategoryStyleAllowed:mr:og', [0, false], 'IsTransitionInEnabled:ms:oh', [0, false], 'LowMemberPath:nw:oi', [2, null], 'NegativeBrush:op:oj', [Brush.$, null], 'OpenMemberPath:n0:ok', [2, null], 'TransitionInMode:lx:ol', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'VolumeMemberPath:n4:om', [2, null], 'XAxis:ln:on', [CategoryAxisBase.$, null], 'YAxis:l7:oo', [NumericYAxis.$, null]]);
export class FinancialCalculationSupportingCalculations extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.c = null;
        this.d = null;
        this.b = null;
        this.h = null;
        this.f = null;
        this.g = null;
        this.e = null;
        this.k = null;
        this.j = null;
        this.i = null;
    }
}
FinancialCalculationSupportingCalculations.$t = markType(FinancialCalculationSupportingCalculations, 'FinancialCalculationSupportingCalculations');
export class DataSourceSupportingCalculation extends SupportingCalculation$1 {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    super(Delegate_$type, 0, c);
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    super(Delegate_$type, 1, c, d);
                }
                break;
        }
    }
}
DataSourceSupportingCalculation.$t = markType(DataSourceSupportingCalculation, 'DataSourceSupportingCalculation', SupportingCalculation$1.$.specialize(Delegate_$type));
export class FinancialCalculationDataSource extends Base {
    constructor() {
        super(...arguments);
        this._openColumn = null;
        this._closeColumn = null;
        this._highColumn = null;
        this._lowColumn = null;
        this._volumeColumn = null;
        this._indicatorColumn = null;
        this._typicalColumn = null;
        this._trueRange = null;
        this._trueLow = null;
        this._period = 0;
        this._shortPeriod = 0;
        this._longPeriod = 0;
        this._count = 0;
        this._calculateFrom = 0;
        this._calculateCount = 0;
        this._multiplier = 0;
        this._minimumValue = 0;
        this._maximumValue = 0;
        this._specifiesRange = false;
        this._series = null;
    }
    get openColumn() {
        return this._openColumn;
    }
    set openColumn(a) {
        this._openColumn = a;
    }
    get closeColumn() {
        return this._closeColumn;
    }
    set closeColumn(a) {
        this._closeColumn = a;
    }
    get highColumn() {
        return this._highColumn;
    }
    set highColumn(a) {
        this._highColumn = a;
    }
    get lowColumn() {
        return this._lowColumn;
    }
    set lowColumn(a) {
        this._lowColumn = a;
    }
    get volumeColumn() {
        return this._volumeColumn;
    }
    set volumeColumn(a) {
        this._volumeColumn = a;
    }
    get indicatorColumn() {
        return this._indicatorColumn;
    }
    set indicatorColumn(a) {
        this._indicatorColumn = a;
    }
    get typicalColumn() {
        return this._typicalColumn;
    }
    set typicalColumn(a) {
        this._typicalColumn = a;
    }
    get trueRange() {
        return this._trueRange;
    }
    set trueRange(a) {
        this._trueRange = a;
    }
    get trueLow() {
        return this._trueLow;
    }
    set trueLow(a) {
        this._trueLow = a;
    }
    get period() {
        return this._period;
    }
    set period(a) {
        this._period = a;
    }
    get shortPeriod() {
        return this._shortPeriod;
    }
    set shortPeriod(a) {
        this._shortPeriod = a;
    }
    get longPeriod() {
        return this._longPeriod;
    }
    set longPeriod(a) {
        this._longPeriod = a;
    }
    get count() {
        return this._count;
    }
    set count(a) {
        this._count = a;
    }
    get calculateFrom() {
        return this._calculateFrom;
    }
    set calculateFrom(a) {
        this._calculateFrom = a;
    }
    get calculateCount() {
        return this._calculateCount;
    }
    set calculateCount(a) {
        this._calculateCount = a;
    }
    get multiplier() {
        return this._multiplier;
    }
    set multiplier(a) {
        this._multiplier = a;
    }
    get minimumValue() {
        return this._minimumValue;
    }
    set minimumValue(a) {
        this._minimumValue = a;
    }
    get maximumValue() {
        return this._maximumValue;
    }
    set maximumValue(a) {
        this._maximumValue = a;
    }
    get specifiesRange() {
        return this._specifiesRange;
    }
    set specifiesRange(a) {
        this._specifiesRange = a;
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
}
FinancialCalculationDataSource.$t = markType(FinancialCalculationDataSource, 'FinancialCalculationDataSource');
export class FinancialSeriesView extends SeriesView {
    constructor(a) {
        super(a);
        this.bu = null;
        this.bs = null;
        this.bw = 0;
        this.bw = -1;
        this.bu = a;
        this.bs = this.bt();
    }
    bv(a) {
        if (this.bw != a.t) {
            return true;
        }
        return false;
    }
    bx(a) {
        this.bw = a.t;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bi = 6;
        }
    }
    getDefaultTooltipTemplate() {
        let a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.bu.ln.bw) {
            let b = this.bu.ln;
            a += "<span>${item." + b.dateTimeMemberPath + "}</span><br/>";
        }
        else if (this.bu.ln.er != null) {
            a += "<span>${item." + this.bu.ln.er + "}</span><br/>";
        }
        a += "<span class='ui-priority-primary'";
        let c = this.e.az.a$q(this.e);
        if (!stringIsNullOrEmpty(c)) {
            a += " style='color:" + c + "'";
        }
        a += ">" + this.bu.fj + "</span><table><tr><td>" + "Open:</td><td>" + "${item." + this.bu.n0 + "}</td></tr><tr><td>" + "High:</td><td>" + "${item." + this.bu.nr + "}</td></tr><tr><td>" + "Low:</td><td>" + "${item." + this.bu.nw + "}</td></tr><tr><td>" + "Close:</td><td>" + "${item." + this.bu.no + "}</td></tr>";
        if (!stringIsNullOrEmpty(this.bu.n4)) {
            a += "<tr><td>" + "Volume:</td><td>" + "${item." + this.bu.n4 + "}</td></tr>";
        }
        a += "</table></div>";
        return a;
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.kp = a;
        this.e.ek = 5;
        this.e.el = 2;
        this.e.em = 2;
    }
}
FinancialSeriesView.$t = markType(FinancialSeriesView, 'FinancialSeriesView', SeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.FinancialSeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.FinancialSeries" />*/
//# sourceMappingURL=FinancialEventArgs_combined.js.map