/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { DependencyProperty } from "./DependencyProperty";
import { TrendLineType_$type } from "./TrendLineType";
import { Brush } from "./Brush";
import { PenLineCap_$type } from "./PenLineCap";
import { DoubleCollection } from "./DoubleCollection";
import { List$1 } from "./List$1";
import { AxisRange } from "./AxisRange";
import { CategoryFrame } from "./CategoryFrame";
import { Type, Number_$type, typeCast, enumGetBox, EnumUtil, runOn, markType } from "./type";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { CategorySeries } from "./CategorySeries";
import { NotImplementedException } from "./NotImplementedException";
import { Path } from "./Path";
import { PropertyMetadata } from "./PropertyMetadata";
import { isNaN_ } from "./number";
import { PathGeometry } from "./PathGeometry";
import { GeometryGroup } from "./GeometryGroup";
import { Pool$1 } from "./Pool$1";
import { LineGeometry } from "./LineGeometry";
import { Extensions } from "./Extensions";
import { IndicatorRenderer } from "./IndicatorRenderer";
export class FinancialIndicator extends FinancialSeries {
    constructor() {
        super();
        this._indicatorColumn = null;
        this.ov = null;
        this.lq = new CategoryFrame(3);
        this.ls = new CategoryFrame(3);
        this.lp = new CategoryFrame(3);
        this.indicatorColumn = new List$1(Number_$type, 0);
        this.ov = new AxisRange(-100, 100);
    }
    be() {
        return new FinancialIndicatorView(this);
    }
    h9(a) {
        super.h9(a);
        this.ow = a;
    }
    o8(a) {
        if (this.l7 != null && !this.l7.cb()) {
            this.it(true);
        }
    }
    o0(a, b, c) {
        if (isNaN_(b.x) || isNaN_(b.y)) {
            return false;
        }
        let d = this.l7;
        let e = 0;
        if (d != null) {
            e = d.dy(d.jq);
        }
        if ((a.y >= e && a.y <= b.y) || (a.y <= e && a.y >= b.y)) {
            return true;
        }
        return false;
    }
    bc() {
        if (this.bd == 0) {
            return 1;
        }
        else {
            return super.bc();
        }
    }
    k9(a) {
        if (this.ln == null || this.l7 == null) {
            return Rect.empty;
        }
        let b = this.kv(a);
        let c = this.bh.bq;
        let d = this.bh.bp;
        let e = this.getEffectiveViewport1(this.bh);
        let f = new ScalerParams(0, c, d, this.l7.bz, e);
        let g = this.ai(this.ln, this.lp.f, this.ni(this.bh), this.nj(this.bh), a, true);
        if (g == null) {
            return Rect.empty;
        }
        let h = g[0];
        let i = g[1];
        let j = Math.abs(b.x - h[0]);
        let k = Math.abs(b.x - i[0]);
        let l = this.l7.dj(this.l7.jq, f);
        let m = 1;
        if (j < k) {
            let n = h[0] - 0.5 * m;
            let o = h[1];
            let p = l;
            return new Rect(0, n, Math.min(o, p), m, Math.max(o, p) - Math.min(o, p));
        }
        else {
            let q = i[0] - 0.5 * m;
            let r = i[1];
            let s = l;
            return new Rect(0, q, Math.min(r, s), m, Math.max(r, s) - Math.min(r, s));
        }
    }
    dd(a, b) {
        let c = this.k0(this.k3(a), true, false);
        if (this.ox == 1) {
            if (this.o0(a, c, b)) {
                return true;
            }
        }
        if (this.ox == 1 || this.ox == 0) {
            if (this.dc(a, b)) {
                return true;
            }
        }
        if (this.ox == 2) {
            if (this.dg(a, b)) {
                return true;
            }
        }
        return false;
    }
    hh(a, b, c, d) {
        super.hh(a, b, c, d);
        if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
            this.ln.i$i();
        }
        if (this.ow.b2) {
            this.ow.b0.g$e(a, b, c, d);
        }
        if (d != null && this.mx.containsKey(d)) {
            let e = this.mx.tryGetValue(d, d);
            d = e.p1;
        }
        if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
            a = 4;
            b = 0;
            c = this.by.count;
        }
        switch (a) {
            case 3:
                if (this.oz(b, c, d)) {
                    this.pa(b, c, d);
                    this.o8(true);
                }
                break;
            case 2:
                if (this.oz(b, this.by.count - b, d)) {
                    this.pa(b, this.by.count - b, d);
                    this.o8(true);
                }
                break;
            case 1:
                if (this.oz(b, this.by.count - b, d)) {
                    let f = new Array(c);
                    for (let g = 0; g < c; g++) {
                        f[g] = 0;
                    }
                    this.indicatorColumn.s(b, f);
                    this.pa(b, this.by.count - b, d);
                    this.o8(true);
                }
                break;
            case 0:
                if (this.oz(b, this.by.count - b, d)) {
                    this.indicatorColumn.v(b, c);
                    this.pa(b, this.by.count - b, d);
                    this.o8(true);
                }
                break;
            case 4:
                if (this.oz(b, this.by.count - b, d)) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.by.count);
                    let h = new Array(c);
                    for (let i = 0; i < c; i++) {
                        h[i] = 0;
                    }
                    this.indicatorColumn.s(0, h);
                    this.pa(b, this.by.count - b, d);
                    this.o8(true);
                }
                break;
        }
    }
    get pl() {
        return this.c(FinancialIndicator.pb);
    }
    set pl(a) {
        this.h(FinancialIndicator.pb, a);
    }
    o5() {
        return -1;
    }
    get indicatorColumn() {
        return this._indicatorColumn;
    }
    set indicatorColumn(a) {
        this._indicatorColumn = a;
    }
    ie(a, b, c, d) {
        switch (b) {
            case "XAxis":
                this.ow.b8();
                break;
            case "TrendLineType":
                let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.ow.b0 = CategoryTrendLineManagerFactory.a(this.ow.b0, this.ln, this.jc, this, this.b1);
                }
                break;
        }
        super.ie(a, b, c, d);
        if (this.ow.b2 && this.ow.b0.g$b(a, b, c, d)) {
            this.it(false);
            let f = typeCast(FinancialIndicatorView.$, this.bg);
            if (f != null && f.b2) {
                f.b0.g$b(a, b, c, d);
            }
            this.h1();
        }
        switch (b) {
            case "FastItemsSource":
                if (this.by != null) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.by.count);
                    let g = new Array(this.by.count);
                    for (let h = 0; h < this.by.count; h++) {
                        g[h] = 0;
                    }
                    this.indicatorColumn.s(0, g);
                    this.pa(0, this.by.count, null);
                    if (this.l7 != null && !this.l7.cb()) {
                        this.l3.bs.e(this.ej);
                        this.it(false);
                    }
                }
                break;
            case "TrendLineBrush":
                this.i4();
                break;
            case FinancialIndicator.$$p[0]:
                this.he(true, this.bh);
                this.it(false);
                this.h1();
                break;
            case "OpenColumn":
            case "HighColumn":
            case "LowColumn":
            case "CloseColumn":
            case "VolumeColumn":
                if (this.by != null) {
                    if (this.indicatorColumn.count != this.by.count) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.by.count);
                        let i = new Array(this.by.count);
                        for (let j = 0; j < this.by.count; j++) {
                            i[j] = 0;
                        }
                        this.indicatorColumn.s(0, i);
                    }
                    if (this.oz(0, this.by.count - 1, b)) {
                        this.o9();
                    }
                }
                break;
            case "XAxis":
                if (this.ln != null && (typeCast(ISortingAxis_$type, this.ln) !== null || typeCast(ISortingAxis_$type, c) !== null)) {
                    this.o9();
                }
                break;
            case "YAxis":
            case FinancialIndicator.$$p[1]:
                this.o9();
                this.h1();
                break;
            case "TrendLineType":
                this.h1();
                break;
        }
    }
    ed(a, b, c) {
        if (this.indicatorColumn == null) {
            return super.ed(a, b, c);
        }
        let d = this.getEffectiveViewport1(this.bh);
        let e = this.nc(this.bh.bq, this.bh.bp, d);
        let f = new ScalerParams(0, this.bh.bq, this.bh.bp, this.ln.bz, d);
        f.c = this.br.mx;
        return this.ef(this.indicatorColumn, a, this.ln, f, e, runOn(this, this.nb), b, c);
    }
    e3(a, b) {
        if (this.indicatorColumn == null) {
            return super.e3(a, b);
        }
        return this.e4(a, b, this.ln, runOn(this, this.nb), this.indicatorColumn);
    }
    e1(a, b) {
        if (this.indicatorColumn == null) {
            return super.e1(a, b);
        }
        return this.e2(a, b, this.ln, runOn(this, this.nb), this.indicatorColumn);
    }
    get_dr() {
        return true;
    }
    get dr() {
        return this.get_dr();
    }
    oz(a, b, c) {
        if (c == null) {
            return true;
        }
        if (this.o1(a, b).contains(c)) {
            return true;
        }
        return false;
    }
    pa(a, b, c) {
        this.oy(a, b);
    }
    am(a) {
        if (this.by == null) {
            return null;
        }
        if (a != null && a == this.l7) {
            return this.ov;
        }
        return null;
    }
    c5(a) {
        let b = this.by != null ? this.by.indexOf(a) : -1;
        let c = this.bh.bq;
        c = c.copy();
        let d = this.bh.bp;
        let e = new Rect(0, 0, 0, 1, 1);
        let f = this.k7(this.bh);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.ln != null) {
                let g = new ScalerParams(0, e, e, this.ln.bz, f);
                let h = this.ln.dj(b, g);
                if (h < c.left + 0.1 * c.width) {
                    h = h + 0.4 * c.width;
                }
                if (h > c.right - 0.1 * c.width) {
                    h = h - 0.4 * c.width;
                }
                c.x = h - 0.5 * c.width;
            }
            if (this.l7 != null && this.indicatorColumn != null && b < this.indicatorColumn.count) {
                let i = new ScalerParams(0, e, e, this.l7.bz, f);
                let j = this.l7.dj(this.indicatorColumn._inner[b], i);
                if (j < c.top + 0.1 * c.height) {
                    j = j + 0.4 * c.height;
                }
                if (j > c.bottom - 0.1 * c.height) {
                    j = j - 0.4 * c.height;
                }
                c.y = j - 0.5 * c.height;
            }
            this.bm.ap(this.br, c, true);
        }
        return b >= 0;
    }
    ds(a, b, c) {
        let d = super.ds(a, b, c);
        if (this.indicatorColumn == null || this.indicatorColumn.count == 0) {
            d = false;
        }
        return d;
    }
    ob(a, b) {
        super.ob(a, b);
        let c = b.bq;
        let d = b.bp;
        let e = this.getEffectiveViewport1(b);
        let f = this.ln;
        let g = this.l7;
        let h = new ScalerParams(0, c, d, f.bz, e);
        let i = new ScalerParams(0, c, d, g.bz, e);
        a.f.clear();
        a.m.clear();
        a.p.clear();
        let j = 0;
        let k = typeCast(ISortingAxis_$type, this.ln);
        if (k != null && k.i$b.count != this.by.count) {
            return;
        }
        j = this.nc(c, d, e);
        let l = this.o5();
        if (l == -1) {
            l = this.trendLinePeriod;
        }
        let m = typeCast(FinancialIndicatorView.$, b);
        if (m.b2) {
            m.b0.prepareLineCore(a.p, this.trendLineType, this.indicatorColumn, l, (n) => this.ln.dj(n, h), (n) => this.l7.dj(n, i), ((() => {
                let $ret = new TrendResolutionParams();
                $ret.c = b.bs.b;
                $ret.d = b.bs.c;
                $ret.e = b.bs.d;
                $ret.a = j;
                $ret.b = this.ej;
                $ret.f = d;
                $ret.g = c;
                return $ret;
            })()));
        }
        let n = this.ln.dm(2, h) - this.ln.dm(1, h);
        for (let o = b.bs.c; o <= b.bs.d; ++o) {
            let p;
            if (k == null) {
                p = b.bs.getBucket(o);
            }
            else {
                let q = k.i$b._inner[o];
                let r = k.i$d(q);
                let s = this.indicatorColumn._inner[o];
                let t = s;
                let u = r;
                while (o < b.bs.d) {
                    q = k.i$b._inner[o + 1];
                    u = k.i$d(q);
                    if (u - r > n) {
                        break;
                    }
                    o++;
                    let v = this.indicatorColumn._inner[o];
                    s = Math.min(s, v);
                    t = Math.max(t, v);
                }
                let w = NaN;
                if (!isNaN_(r)) {
                    w = this.ln.dj(r, h);
                }
                p = [w, s, t];
            }
            if (!isNaN_(p[0])) {
                if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
                    p[0] = p[0] + j;
                }
                else {
                    p[0] = f.dj(p[0], h) + j;
                }
                p[1] = g.dj(p[1], i);
                if (b.bs.b > 1 || k != null) {
                    p[2] = g.dj(p[2], i);
                }
                else {
                    p[2] = p[1];
                }
                a.f.add(p);
            }
        }
        return;
    }
    he(a, b) {
        super.he(a, b);
        let c = b;
        c.b3(a);
        if (c.b2) {
            c.b0.g$d();
        }
    }
    lw() {
        switch (this.ox) {
            case 1: return 1;
            case 2: return 1;
            case 0: return 12;
        }
        return 1;
    }
    od(a, b) {
        super.od(a, b);
        let c = typeCast(FinancialIndicatorView.$, b);
        let d = (e) => a.f._inner[e][0];
        let e = (f) => a.f._inner[f][1];
        if (c.b2) {
            c.b0.g$d();
            c.b0.g$g(a.p);
        }
        let f = b.bp;
        let g = this.getEffectiveViewport1(b);
        let h = 0;
        let i = this.ki;
        let j = this.op;
        if (b.bv(a)) {
            c.b3(false);
            if (a.f.count > 0) {
                switch (this.ox) {
                    case 0:
                        let k = CategorySeries.mg(a.f, a.f.count - 1, f, b.bq, false);
                        c.b7(a.f.count, d, e, true, k);
                        break;
                    case 1:
                        if (this.l7 != null) {
                            h = this.ng(b);
                        }
                        else {
                            h = 0.5 * (f.top + f.bottom);
                        }
                        let l = CategorySeries.mg(a.f, a.f.count - 1, f, b.bq, false);
                        c.b5(a.f.count, d, e, true, h, l);
                        break;
                    case 2:
                        h = this.ng(b);
                        c.b6(a.f.count, d, e, true, h);
                        break;
                    default: throw new NotImplementedException(0);
                }
            }
            b.bx(a);
        }
        let m = a.f;
        let n = this.by.count;
        this.lv.x(this, this.mt(), this.ln, runOn(this, this.lf), this.ni(b), this.nj(b));
        let o = false;
        let p = this.lv.c;
        if (p != null) {
            o = true;
        }
        this.lv.al = i;
        this.lv.ah = i;
        if (o) {
            let q = new ScalerParams(0, b.bq, b.bp, this.ln.bz, g);
            this.lv.f = false;
            this.oa(m, -1, n, this.ln, q, b.n);
        }
        this.lv.ae(c.cp, true, false, true, false);
        this.lv.ae(c.cr, true, false, true, false);
        this.lv.ae(c.cq, false, true, false, false);
        c.cq._opacity = 0.8 * this.lv.i * this.dy;
        this.lv.ae(c.co, true, false, false, false);
        this.lv.al = j;
        this.lv.ah = j;
        if (o) {
            let r = new ScalerParams(0, b.bq, b.bp, this.ln.bz, g);
            this.lv.f = true;
            this.oa(m, -1, n, this.ln, r, b.n);
        }
        this.lv.ae(c.cl, true, false, true, false);
        this.lv.ae(c.cn, true, false, true, false);
        this.lv.ae(c.cm, false, true, false, false);
        c.cm._opacity = 0.8 * this.lv.i * this.dy;
        this.lv.ae(c.ck, true, false, false, false);
        c.b9();
    }
    i4() {
        super.i4();
        if (this.e6 < 0) {
            return;
        }
        if (this.ow.b2) {
            this.ow.ca();
        }
    }
    o9() {
        if (this.ow.b2) {
            this.ow.b0.g$i();
        }
        this.oy(0, this.indicatorColumn.count);
        if (this.l7 != null && !this.l7.cb()) {
            this.it(false);
        }
    }
    hn(a) {
        super.hn(a);
        this.a1.exportTrendlineData(this, a, this.ow.b0.g$j);
    }
}
FinancialIndicator.pb = DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialIndicator.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
FinancialIndicator.$t = markType(FinancialIndicator, 'FinancialIndicator', FinancialSeries.$, [ITrendLineSeries_$type]);
Type.dep(DependencyProperty, PropertyMetadata, FinancialIndicator, 'raisePropertyChanged', ['DisplayType:ox:pc', [IndicatorDisplayType_$type, enumGetBox(IndicatorDisplayType_$type, 0)], 'IgnoreFirst:o3:pd', [1, 0], 'TrendLineType::pj', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::pi', [1, 1.5], 'TrendLinePeriod::ph', [1, 7], 'TrendLineBrush::pe', [Brush.$, null], 'TrendLineZIndex:o4:pk', [1, 1001], 'TrendLineDashArray:pm:pf', [DoubleCollection.$], 'TrendLineDashCap:pn:pg', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
export class FinancialIndicatorBucketCalculator extends FinancialBucketCalculator {
    constructor(a) {
        super(a);
        this.f = null;
        this.f = a;
    }
    getBucket(a) {
        let b = a * this.b;
        let c = Math.min(b + this.b - 1, this.f.by.indicatorColumn.count - 1);
        let d = NaN;
        let e = NaN;
        for (let f = b; f <= c; ++f) {
            let g = this.f.by.indicatorColumn._inner[f];
            if (!isNaN_(d)) {
                if (!isNaN_(g)) {
                    d = Math.min(d, g);
                    e = Math.max(e, g);
                }
            }
            else {
                d = g;
                e = g;
            }
        }
        if (!isNaN_(d)) {
            return [0.5 * (b + c), d, e];
        }
        return [NaN, NaN, NaN];
    }
}
FinancialIndicatorBucketCalculator.$t = markType(FinancialIndicatorBucketCalculator, 'FinancialIndicatorBucketCalculator', FinancialBucketCalculator.$);
export class FinancialIndicatorView extends FinancialSeriesView {
    constructor(a) {
        super(a);
        this.by = null;
        this.b1 = null;
        this.cp = ((() => {
            let $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        this.cl = ((() => {
            let $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        this.cq = ((() => {
            let $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        this.cm = ((() => {
            let $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        this.cr = ((() => {
            let $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        this.cn = ((() => {
            let $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        this.co = ((() => {
            let $ret = new Path();
            $ret.aj = new GeometryGroup();
            return $ret;
        })());
        this.ck = ((() => {
            let $ret = new Path();
            $ret.aj = new GeometryGroup();
            return $ret;
        })());
        this.bz = null;
        this.ch = new Path();
        this.cj = new Path();
        this.ci = new Path();
        this.cg = new Path();
        this.cd = new Path();
        this.cf = new Path();
        this.ce = new Path();
        this.cc = new Path();
        this.by = a;
        this.b1 = ((() => {
            let $ret = new Pool$1(LineGeometry.$);
            $ret.create = runOn(this, this.cb);
            $ret.destroy = runOn(this, this.b4);
            return $ret;
        })());
    }
    bt() {
        return new FinancialIndicatorBucketCalculator(this);
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.bu.op = ((() => {
                let $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.bu.en = 2;
        }
    }
    cb() {
        return new LineGeometry();
    }
    b4(a) {
    }
    get b0() {
        if (this.bz == null) {
            this.bz = CategoryTrendLineManagerFactory.a(this.bz, this.e.ao(), this.e.jc, this.e, this.e.b1);
        }
        return this.bz;
    }
    set b0(a) {
        this.bz = a;
    }
    get b2() {
        return this.bz != null;
    }
    b3(a) {
        Extensions.e(this.cp.aj);
        Extensions.e(this.cq.aj);
        Extensions.e(this.cr.aj);
        Extensions.e(this.cl.aj);
        Extensions.e(this.cm.aj);
        Extensions.e(this.cn.aj);
        Extensions.d(this.co.aj);
        Extensions.d(this.ck.aj);
        if (a) {
            this.b1.count = 0;
        }
        this.an();
    }
    b9() {
    }
    b7(a, b, c, d, e) {
        IndicatorRenderer.g(a, b, c, d, this.bq, this.bp, this.cp, this.cl, this.bs.b, this.e.ej, e);
        this.an();
    }
    b5(a, b, c, d, e, f) {
        IndicatorRenderer.e(a, b, c, d, this.bq, this.bp, this.cp, this.cq, this.cl, this.cm, e, this.bs.b, this.e.ej, f);
        this.an();
    }
    b6(a, b, c, d, e) {
        IndicatorRenderer.f(a, b, c, d, this.bp, e, this.b1, this.co, this.ck);
        this.an();
    }
    ca() {
        this.by.pl = null;
        if (this.by.trendLineBrush != null) {
            this.by.pl = this.by.trendLineBrush;
        }
        else {
            this.by.pl = this.by.ki;
        }
    }
    a9() {
        super.a9();
        let a = this.bk();
        this.ch.aj = this.cp.aj;
        this.cj.aj = this.cr.aj;
        this.ci.aj = this.cq.aj;
        this.cg.aj = this.co.aj;
        this.cd.aj = this.cl.aj;
        this.cf.aj = this.cn.aj;
        this.ce.aj = this.cm.aj;
        this.cc.aj = this.ck.aj;
        this.ch._stroke = a;
        this.cj._stroke = a;
        this.ch.ac = this.e.en + 3;
        this.cj.ac = this.e.en + 3;
        this.ci._fill = a;
        this.ci._opacity = 1;
        this.cg._stroke = a;
        this.cg.ac = this.e.en + 3;
        this.cd._stroke = a;
        this.cf._stroke = a;
        this.cd.ac = this.e.en + 3;
        this.cf.ac = this.e.en + 3;
        this.ce._fill = a;
        this.ce._opacity = 1;
        this.cc._stroke = a;
        this.cc.ac = this.e.en + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (b) {
                if (this.by.ox == 2) {
                    a.s(this.cg);
                    a.s(this.cc);
                }
                else {
                    a.s(this.ci);
                    a.s(this.ch);
                    a.s(this.cj);
                    a.s(this.ce);
                    a.s(this.cd);
                    a.s(this.cf);
                }
            }
            else {
                if (this.by.ox == 2) {
                    a.s(this.co);
                    a.s(this.ck);
                }
                else {
                    a.s(this.cq);
                    a.s(this.cp);
                    a.s(this.cr);
                    a.s(this.cm);
                    a.s(this.cl);
                    a.s(this.cn);
                }
            }
        }
    }
    a2(a, b) {
        if (a.d) {
            if (this.by.trendLineType != 0 && !b) {
                let c = this.b0.g$j;
                c.ac = this.by.trendLineThickness;
                c._stroke = this.by.pl;
                c.ad = this.by.pn;
                c.ai = this.by.pm;
                a.u(c);
            }
        }
        super.a2(a, b);
    }
    ai(a) {
        super.ai(a);
        this.e.a1.exportPathData(a, this.co, "positiveColumnsShape", ["Positive", "Main"]);
        this.e.a1.exportPathData(a, this.ck, "negativeColumnsShape", ["Negative"]);
        this.e.a1.exportPathData(a, this.cp, "positive0", ["Positive", "Main"]);
        this.e.a1.exportPathData(a, this.cr, "positive1", ["Positive"]);
        this.e.a1.exportPathData(a, this.cq, "positive01", ["PositiveFill"]);
        this.e.a1.exportPathData(a, this.cl, "negative0", ["Negative", "Main"]);
        this.e.a1.exportPathData(a, this.cn, "negative1", ["Negative"]);
        this.e.a1.exportPathData(a, this.cm, "negative01", ["NegativeFill"]);
    }
    b8() {
        if (this.b2) {
            this.bz = CategoryTrendLineManagerFactory.a(this.bz, this.e.ao(), this.e.jc, this.e, this.e.b1);
        }
    }
}
FinancialIndicatorView.$t = markType(FinancialIndicatorView, 'FinancialIndicatorView', FinancialSeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.FinancialIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.FinancialIndicator" />*/
//# sourceMappingURL=FinancialIndicator_combined.js.map