/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { IHorizontalAnchoredCategorySeriesInteractionManager_$type } from "./IHorizontalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "./DVContainer";
import { Type, runOn, Point_$type, typeCast, EnumUtil, enumGetBox, markType } from "./type";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "./DependencyProperty";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryMode_$type } from "./CategoryMode";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { Axis } from "./Axis";
import { TrendLineType_$type } from "./TrendLineType";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "./PropertyMetadata";
export class HorizontalAnchoredCategorySeries extends AnchoredCategorySeries {
    constructor() {
        super(...arguments);
        this.ph = null;
        this.pd = null;
        this.pj = null;
        this.pf = 0;
    }
    get pi() {
        if (this.ph == null) {
            this.ph = DVContainer.instance.createInstance(IHorizontalAnchoredCategorySeriesInteractionManager_$type, () => this.b1.n);
        }
        return this.ph;
    }
    hc() {
        super.hc();
        this.xAxis = null;
        this.yAxis = null;
    }
    bc() {
        if (this.bd == 0) {
            return 1;
        }
        else {
            return super.bc();
        }
    }
    ml() {
        return this.pd;
    }
    m5() {
        return this.pj;
    }
    lb(a) {
        if (this.mm == null || this.mm.m.count == 0 || !this.hasMarkers || !this.li()) {
            return Rect.empty;
        }
        return this.pi.d$d(this, this.mm.m, a, runOn(this, this.pv));
    }
    pv(a) {
        return this.oe.c3(a);
    }
    pn(a, b, c) {
        return this.pi.d$c(this, this.m5(), a, b, c);
    }
    ag(a) {
        return this.pi.d$a(this, this.mm.f, this.nm(this.bh), this.nn(this.bh), a);
    }
    ah(a) {
        return this.pi.d$b(this, this.mm.f, this.nm(this.bh), this.nn(this.bh), a);
    }
    dd(a, b) {
        if (this.dc(a, b)) {
            return true;
        }
        if (this.lj(a, b)) {
            return true;
        }
        return false;
    }
    getOffsetValue() {
        return this.mq.r(this.ml(), this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh));
    }
    getCategoryWidth() {
        let a = this.getEffectiveViewport1(this.bh);
        return this.ml().getCategorySize(this.bh.bq, this.bh.bp, a);
    }
    ed(a, b, c) {
        if (this.br == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bh);
        let e = this.ml();
        let f = new ScalerParams(0, this.br.mk, this.bh.bp, e.bz, d);
        let g = this.mq.r(e, this.br.mk, this.bh.bp, d);
        return this.ef(this.valueColumn, a, e, f, g, runOn(this, this.nk), b, c);
    }
    e3(a, b) {
        return this.e4(a, b, this.ml(), runOn(this, this.nk), this.valueColumn);
    }
    e1(a, b) {
        return this.e2(a, b, this.ml(), runOn(this, this.nk), this.valueColumn);
    }
    d0(a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.d1(a, b, this.ml(), d, e, this.valueColumn.count, runOn(this, this.nk));
    }
    k0(a, b, c) {
        if (this.ml() == null || this.m5() == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        return this.k2(a, b, c, this.mq.r(this.ml(), this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.m5(), this.ml(), null, null, null);
    }
    fetchXAxis() {
        return this.pd;
    }
    fetchYAxis() {
        return this.pj;
    }
    ow(a) {
        this.xAxis = typeCast(CategoryAxisBase.$, a);
    }
    ox(a) {
        this.yAxis = typeCast(NumericYAxis.$, a);
    }
    ng() {
        return this.pj != null && this.pj.cb();
    }
    pr(a) {
        this.pd = a;
    }
    ps(a) {
        this.pj = a;
    }
    mf(a, b) {
        return this.ob(a, b, this.pd);
    }
    ie(a, b, c, d) {
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                this.pr(this.xAxis);
                if (this.oe.cx) {
                    this.oe.cw = CategoryTrendLineManagerFactory.a(this.oe.cw, this.pd, this.jc, this, this.b1);
                }
                break;
            case "TrendLineType":
                let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.oe.cw = CategoryTrendLineManagerFactory.a(this.oe.cw, this.pd, this.jc, this, this.b1);
                }
                break;
        }
        super.ie(a, b, c, d);
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.hi(typeCast(Axis.$, c));
                    this.ik(typeCast(Axis.$, d));
                    this.pr(this.xAxis);
                    this.mu.cl.g(this.ej);
                    this.it(false);
                    this.h1();
                }
                break;
            case HorizontalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.hi(typeCast(Axis.$, c));
                    this.ik(typeCast(Axis.$, d));
                    this.ps(this.yAxis);
                    this.mu.cl.g(this.ej);
                    this.ng();
                    this.it(false);
                    this.h1();
                }
                break;
            case "CategoryMode":
                if (this.xAxis != null) {
                    this.xAxis.jz(true);
                }
                break;
        }
    }
    hh(a, b, c, d) {
        super.hh(a, b, c, d);
        if (this.pd != null && typeCast(ISortingAxis_$type, this.pd) !== null) {
            this.pd.i$i();
        }
        switch (a) {
            case 4:
                if (this.pd != null) {
                    this.pd.cb();
                }
                if (this.pj != null && !this.pj.cb()) {
                    this.it(true);
                }
                break;
            case 1:
                if (this.pd != null) {
                    this.pd.cb();
                }
                if (this.pj != null && !this.pj.cb()) {
                    this.it(true);
                }
                break;
            case 0:
                if (this.pd != null) {
                    this.pd.cb();
                }
                if (this.pj != null && !this.pj.cb()) {
                    this.it(true);
                }
                break;
            case 2:
                if (this.op != null && this.oe.cl.d > 0 && this.pj != null && !this.pj.cb()) {
                    this.it(true);
                }
                break;
            case 3:
                if (d == this.op) {
                    if (this.pd != null) {
                        this.pd.cb();
                    }
                    if (this.pj != null && !this.pj.cb()) {
                        this.it(true);
                    }
                }
                break;
        }
    }
    pl(a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.bw) {
            return true;
        }
        return false;
    }
    pm(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    get pg() {
        return this.pf;
    }
    set pg(a) {
        let b = this.pg;
        if (a != b) {
            this.pf = a;
            this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.pg));
        }
    }
    get useHighMarkerFidelity() {
        return this.nh;
    }
}
HorizontalAnchoredCategorySeries.$t = markType(HorizontalAnchoredCategorySeries, 'HorizontalAnchoredCategorySeries', AnchoredCategorySeries.$);
Type.dep(DependencyProperty, PropertyMetadata, HorizontalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::pt', [CategoryAxisBase.$, null], 'YAxis::pu', [NumericYAxis.$, null]]);
/*<BeginStatics Name="Infragistics.Controls.Charts.HorizontalAnchoredCategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.HorizontalAnchoredCategorySeries" />*/
//# sourceMappingURL=HorizontalAnchoredCategorySeries.js.map