/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler_$type } from "./IScaler";
import { markType, TypeRegistrar } from "./type";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "./Rect";
import { RangeInfo } from "./RangeInfo";
import { HorizontalLogarithmicScaler } from "./HorizontalLogarithmicScaler";
import { FastHorizontalLinearScaler } from "./FastHorizontalLinearScaler";
import { isNaN_ } from "./number";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
export class NumericXAxis extends StraightNumericAxisBase {
    constructor() {
        super();
        this.ab = NumericXAxis.$;
        this.ir = this.ip();
    }
    ax() {
        return new NumericXAxisView(this);
    }
    f5(a) {
        super.f5(a);
        this.k7 = a;
    }
    ao() {
        if (this.cf) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    }
    ip() {
        let a = super.ip();
        a.b.c = (b) => {
            if ((this.as == null || this.as.visibility == 0) && this.ag != null) {
                this.ap.a6 = b;
                if (this.as != null && (this.as.location == 4 || this.as.location == 5)) {
                    this.a9.hp();
                }
            }
        };
        a.k = (b, c, d) => this.gs(c, d, b.z, b.b, false);
        a.l = (b, c, d, e) => this.gt(c, d, e, b.z);
        a.m = (b, c) => {
            let d = b.y;
            let e = new ScalerParams(0, b.aa, b.z, this.b0, d);
            return this.dj(c, e);
        };
        a.q = (b, c) => true;
        a.j = (b) => this.f3(b.t, b.n, b.z, b.a, true);
        a.e = (b) => {
            b.n = b.z.bottom;
            if (this.ag != null && this.ag.a9 != null) {
                let c = b.n;
                let d = b.r;
                let e = this.gn(c, d, b.aa, b.z, b.y, b.z.top, b.z.bottom);
                c = e.p0;
                d = e.p1;
                b.n = c;
                b.r = d;
            }
        };
        a.p = (b, c, d) => {
            let e = Math.round(c);
            return e >= Math.floor(b.z.left) && e <= Math.ceil(b.z.right);
        };
        return a;
    }
    dj(a, b) {
        if (this.kq != null) {
            return this.kq.p(a, b);
        }
        return this.kp.p(a, b);
    }
    dm(a, b) {
        if (this.kq != null) {
            return this.kq.q(a, b);
        }
        return this.kp.q(a, b);
    }
    f0(a, b, c, d) {
        if (this.kq != null) {
            this.kq.v(a, b, c, d);
            return;
        }
        this.kp.v(a, b, c, d);
    }
    fz(a, b, c, d, e) {
        if (this.kq != null) {
            this.kq.u(a, b, c, d, e);
            return;
        }
        this.kp.u(a, b, c, d, e);
    }
    f1(a, b, c, d) {
        if (this.kq != null) {
            this.kq.j(a, b, c, d);
            return;
        }
        this.kp.j(a, b, c, d);
    }
    k8(a, b) {
        if (this.a9 == null || a == NaN || b == NaN) {
            return;
        }
        let c = this.kv(a, this);
        let d = this.kv(b, this);
        if (c == NaN || d == NaN) {
            return;
        }
        this.a9.my = new Rect(0, c, this.a9.my.y, d - c, this.a9.my.height);
    }
    is(a, b, c, d) {
        let e = d;
        let f = super.is(a, b, c, d);
        let g = new ScalerParams(0, b, a, this.bz, c);
        let h = NaN;
        let i = NaN;
        if (!this.bz && b.right == 1) {
            i = this.jf;
        }
        else if (this.bz && b.left == 0) {
            h = this.jf;
        }
        if (isNaN_(h)) {
            h = this.dm(e.left, g);
        }
        if (isNaN_(i)) {
            i = this.dm(e.right, g);
        }
        let j = Math.min(h, i);
        let k = Math.max(h, i);
        this.jj = j;
        this.ji = k;
        f.k.add(((() => {
            let $ret = new RangeInfo();
            $ret.d = j;
            $ret.c = k;
            $ret.b = e.width;
            return $ret;
        })()));
        return f;
    }
    gk(a) {
        super.gk(a);
        let b = this.a9 != null ? this.a9.mk : Rect.empty;
        let c = !b.isEmpty ? this.ib : Rect.empty;
        let d = this.h6();
        let e = this.h5();
        let f = this.ir.c(a, c, b, d, e);
        if (f != null) {
            this.je = f.f.m;
            this.jh = f.f.l;
        }
    }
    gu(a, b) {
        super.gu(a, b);
        if (b.height != a.height) {
            this.cb();
        }
    }
    get_av() {
        return 0;
    }
    get av() {
        return this.get_av();
    }
    iu() {
        if (this.i5) {
            return new HorizontalLogarithmicScaler();
        }
        switch (this.ko) {
            case 0: return new FastHorizontalLinearScaler();
            case 1: return new HorizontalLogarithmicScaler();
        }
        return null;
    }
    j$c(a, b) {
        return this.dm.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dj.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.fz.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.f0.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.f1.apply(this, arguments);
    }
    get j$a() {
        return this.bz;
    }
}
NumericXAxis.$t = markType(NumericXAxis, 'NumericXAxis', StraightNumericAxisBase.$, [IScaler_$type]);
export class NumericXAxisView extends StraightNumericAxisBaseView {
    constructor(a) {
        super(a);
        this.bc = null;
        this.bc = a;
    }
}
NumericXAxisView.$t = markType(NumericXAxisView, 'NumericXAxisView', StraightNumericAxisBaseView.$);
//# sourceMappingURL=NumericXAxis_combined.js.map