/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler_$type } from "./IScaler";
import { markType } from "./type";
import { VerticalAxisLabelPanel } from "./VerticalAxisLabelPanel";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { RangeInfo } from "./RangeInfo";
import { VerticalLogarithmicScaler } from "./VerticalLogarithmicScaler";
import { FastVerticalLinearScaler } from "./FastVerticalLinearScaler";
import { isNaN_ } from "./number";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
export class NumericYAxis extends StraightNumericAxisBase {
    constructor() {
        super();
        this.ab = NumericYAxis.$;
        this.ir = this.ip();
    }
    ax() {
        return new NumericYAxisView(this);
    }
    ao() {
        return new VerticalAxisLabelPanel();
    }
    get_b5() {
        return true;
    }
    get b5() {
        return this.get_b5();
    }
    di() {
        return this.ib.height;
    }
    dj(a, b) {
        if (this.kq != null) {
            return this.kq.p(a, b);
        }
        return this.kp.p(a, b);
    }
    f0(a, b, c, d) {
        if (this.kq != null) {
            this.kq.v(a, b, c, d);
            return;
        }
        this.kp.v(a, b, c, d);
    }
    fz(a, b, c, d, e) {
        if (this.kq != null) {
            this.kq.u(a, b, c, d, e);
            return;
        }
        this.kp.u(a, b, c, d, e);
    }
    dm(a, b) {
        if (this.kq != null) {
            return this.kq.q(a, b);
        }
        return this.kp.q(a, b);
    }
    f1(a, b, c, d) {
        if (this.kq != null) {
            this.kq.j(a, b, c, d);
            return;
        }
        this.kp.j(a, b, c, d);
    }
    k7(a, b) {
        if (this.a9 == null || a == NaN || b == NaN) {
            return;
        }
        let c = this.kv(a, this);
        let d = this.kv(b, this);
        if (c == NaN || d == NaN) {
            return;
        }
        this.a9.my = new Rect(0, this.a9.my.x, d, this.a9.my.width, c - d);
    }
    ip() {
        let a = super.ip();
        a.b.c = (b) => {
            if (this.as == null || this.as.visibility == 0) {
                this.ap.a6 = b;
                if (this.as != null && (this.as.location == 7 || this.as.location == 6)) {
                    this.a9.hp();
                }
            }
        };
        a.k = (b, c, d) => this.f3(c, d, b.z, b.b, false);
        a.l = (b, c, d, e) => this.f4(c, d, e, b.z);
        a.m = (b, c) => {
            let d = b.y;
            let e = new ScalerParams(0, b.aa, b.z, this.b0, d);
            return this.dj(c, e);
        };
        a.q = (b, c) => true;
        a.j = (b) => this.gs(b.t, b.n, b.z, b.a, true);
        a.e = (b) => {
            b.n = b.z.left;
            let c = b.y;
            let d = new ScalerParams(0, b.aa, b.z, this.b0, c);
            if (this.ag != null && this.ag.a9 != null) {
                let e = b.n;
                let f = b.r;
                let g = this.gn(e, f, b.aa, b.z, b.y, b.z.left, b.z.right);
                e = g.p0;
                f = g.p1;
                b.n = e;
                b.r = f;
            }
        };
        a.p = (b, c, d) => {
            let e = Math.round(c);
            return e >= Math.floor(b.z.top) && e <= Math.ceil(b.z.bottom);
        };
        return a;
    }
    is(a, b, c, d) {
        let e = d;
        let f = super.is(a, b, c, d);
        let g = new ScalerParams(0, b, a, this.bz, c);
        let h = NaN;
        let i = NaN;
        if (!this.bz && b.top == 0) {
            i = this.jf;
        }
        else if (this.bz && b.bottom == 1) {
            h = this.jf;
        }
        if (isNaN_(h)) {
            h = this.dm(e.bottom, g);
        }
        if (isNaN_(i)) {
            i = this.dm(e.top, g);
        }
        let j = Math.min(h, i);
        let k = Math.max(h, i);
        this.jj = j;
        this.ji = k;
        let l = ((() => {
            let $ret = new RangeInfo();
            $ret.d = j;
            $ret.c = k;
            $ret.b = e.height;
            return $ret;
        })());
        f.k.add(l);
        return f;
    }
    gk(a) {
        super.gk(a);
        let b = this.a9 != null ? this.a9.mk : Rect.empty;
        let c = this.ib;
        let d = this.h6();
        let e = this.h5();
        let f = this.ir.c(a, c, b, d, e);
        if (f != null) {
            this.je = f.f.m;
            this.jh = f.f.l;
        }
    }
    gu(a, b) {
        super.gu(a, b);
        if (b.height != a.height) {
            this.cb();
        }
    }
    get_av() {
        return 1;
    }
    get av() {
        return this.get_av();
    }
    iu() {
        if (this.i5) {
            return new VerticalLogarithmicScaler();
        }
        switch (this.ko) {
            case 0: return new FastVerticalLinearScaler();
            case 1: return new VerticalLogarithmicScaler();
        }
        return null;
    }
    j$c(a, b) {
        return this.dm.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dj.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.fz.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.f0.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.f1.apply(this, arguments);
    }
    get j$a() {
        return this.bz;
    }
}
NumericYAxis.$t = markType(NumericYAxis, 'NumericYAxis', StraightNumericAxisBase.$, [IScaler_$type]);
export class NumericYAxisView extends StraightNumericAxisBaseView {
    constructor(a) {
        super(a);
        this.bc = null;
        this.bc = a;
    }
}
NumericYAxisView.$t = markType(NumericYAxisView, 'NumericYAxisView', StraightNumericAxisBaseView.$);
//# sourceMappingURL=NumericYAxis_combined.js.map