/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FastItemDateTimeColumn } from "./FastItemDateTimeColumn";
import { CategoryXAxis } from "./CategoryXAxis";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { TimeAxisLabelFormatCollection } from "./TimeAxisLabelFormatCollection";
import { IFastItemsSource_$type } from "./IFastItemsSource";
import { TimeAxisBase } from "./TimeAxisBase";
import { runOn, delegateCombine, typeCast, Date_$type, markType } from "./type";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "./Rect";
import { TimeXAxis } from "./TimeXAxis";
import { truncate } from "./number";
import { dateMaxValue, dateMinValue } from "./date";
export class OrdinalTimeXAxis extends CategoryXAxis {
    constructor() {
        super();
        this.k1 = dateMaxValue();
        this.k0 = dateMinValue();
        this.k3 = dateMaxValue();
        this.k2 = dateMinValue();
        this.k8 = null;
        this.ky = null;
        this.kw = null;
        this.actualRangeChanged = null;
        FastItemDateTimeColumn.m();
        this.kw = new TimeAxisLabelFormatCollection();
        let a = this.kx;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.le));
    }
    f7(a, b, c, d) {
        super.f7(a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                let e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.kz);
                    this.kz = null;
                }
                if (this.ir != null) {
                    this.kz = TimeAxisBase.kc(this.la, this);
                }
                break;
            case "DateTimeMemberPath":
                if (this.ir != null) {
                    this.ir.deregisterColumn(this.kz);
                    this.kz = TimeAxisBase.kc(this.la, this);
                }
                break;
            case "DateTimeColumn":
                this.lf();
                break;
        }
    }
    get actualMinimumValue() {
        return this.k1;
    }
    set actualMinimumValue(a) {
        this.k1 = a;
    }
    get actualMaximumValue() {
        return this.k0;
    }
    set actualMaximumValue(a) {
        this.k0 = a;
    }
    get visibleMinimum() {
        return this.k3;
    }
    set visibleMinimum(a) {
        this.k3 = a;
    }
    get visibleMaximum() {
        return this.k2;
    }
    set visibleMaximum(a) {
        this.k2 = a;
    }
    jw(a) {
        super.jw(a);
        this.lf();
    }
    lf() {
        if (this.kz == null || this.kz.count == 0) {
            this.actualMinimumValue = dateMinValue();
            this.actualMaximumValue = dateMaxValue();
            return;
        }
        let a = +(this.actualMinimumValue) != +(this.kz.item(0)) && +(this.actualMaximumValue) != +(this.kz.item(this.kz.count - 1));
        if (a) {
            let b = this.actualMinimumValue;
            let c = this.actualMaximumValue;
            this.actualMinimumValue = this.kz.item(0);
            this.actualMaximumValue = this.kz.item(this.kz.count - 1);
            this.lg();
            if (this.actualRangeChanged != null) {
                this.actualRangeChanged(this, new AxisRangeChangedEventArgs(b.getTime(), this.actualMinimumValue.getTime(), c.getTime(), this.actualMaximumValue.getTime()));
            }
        }
    }
    lg() {
        if (this.kz == null || this.kz.count == 0 || this.a9 == null) {
            this.visibleMinimum = this.actualMinimumValue;
            this.visibleMaximum = this.actualMaximumValue;
            return;
        }
        let a = new ScalerParams(1, this.a9.my, this.ib, this.bz);
        let b = truncate(Math.ceil(this.dm(this.ib.left, a)));
        let c = truncate(Math.ceil(this.dm(this.ib.right, a)));
        this.visibleMinimum = b >= 0 && b < this.kz.count ? this.kz.item(b) : this.actualMinimumValue;
        this.visibleMaximum = c >= 0 && c < this.kz.count ? this.kz.item(c) : this.actualMaximumValue;
    }
    get la() {
        return this.k8;
    }
    set la(a) {
        let b = this.la;
        if (a != b) {
            this.k8 = a;
            this.gd("DateTimeMemberPath", b, this.la);
        }
    }
    get kz() {
        return this.ky;
    }
    set kz(a) {
        if (this.ky != a) {
            let b = this.ky;
            this.ky = a;
            this.gd("DateTimeColumn", b, this.ky);
        }
    }
    gv(a, b) {
        super.gv(a, b);
        this.lg();
    }
    getWindowRectForSelection(a, b) {
        if (this.kz == null) {
            return Rect.empty;
        }
        let c = a > b;
        let d = c ? b : a;
        let e = c ? a : b;
        let f = -1;
        while (++f < this.kz.count && this.kz.item(f) < d) {
            ;
        }
        let g = this.kz.count;
        while (--g >= 0 && this.kz.item(g) > e) {
            ;
        }
        let h = new ScalerParams(0, new Rect(0, 0, 0, 1, 1), new Rect(0, 0, 0, 1, 1), this.bz, this.a9.mo);
        let i = this.dj(f, h);
        let j = this.dj(g + 1, h);
        return new Rect(0, i, NaN, Math.max(0, j - i), NaN);
    }
    get kx() {
        return this.kw;
    }
    le(a, b) {
        this.gj(false);
    }
    f9(a) {
        super.f9(a);
        this.la = a;
    }
    eq(a) {
        if (!(typeCast(Date_$type, a) !== null)) {
            return super.eq(a);
        }
        let b = TimeXAxis.lu(a, this.ld, this.kx);
        return b == null ? super.eq(a) : b;
    }
    get ld() {
        return +(this.visibleMaximum) - +(this.visibleMinimum);
    }
    ka() {
        return this.kz;
    }
    gu(a, b) {
        super.gu(a, b);
        this.lg();
    }
    kg(a, b) {
        return super.kg(a + 0.5, b);
    }
    kf(a, b, c, d) {
        return b;
    }
    get isVertical() {
        return this.b5;
    }
    j$c(a, b) {
        return this.dm.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dj.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.fz.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.f0.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.f1.apply(this, arguments);
    }
    get j$a() {
        return this.bz;
    }
}
OrdinalTimeXAxis.$t = markType(OrdinalTimeXAxis, 'OrdinalTimeXAxis', CategoryXAxis.$, [ITimeRangeSelectorAxis_$type]);
//# sourceMappingURL=OrdinalTimeXAxis.js.map