/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DomainChart } from "./DomainChart";
import { HorizontalAlignment_$type } from "./HorizontalAlignment";
import { VerticalAlignment_$type } from "./VerticalAlignment";
import { Visibility_$type } from "./Visibility";
import { AxisLabelsLocation_$type } from "./AxisLabelsLocation";
import { fromEnum, enumGetBox, markType } from "./type";
import { TitleSettings } from "./TitleSettings";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { ScalerParams } from "./ScalerParams";
export class XYChart extends DomainChart {
    constructor() {
        super();
        this.gl = null;
        this.gm = null;
        this.gy = 0;
        this.g0 = 5;
        this.gz = 0;
        this.gx = 5;
        this.hf = 5;
        this.hh = 0;
        this.hg = 5;
        this.he = 0;
        this.lu = null;
        this.l1 = null;
        this.g9 = 0;
        this.hq = 0;
        this.g8 = NaN;
        this.hp = NaN;
        this.hb = NaN;
        this.hs = NaN;
        this.ha = NaN;
        this.hr = NaN;
        this.g7 = NaN;
        this.ho = NaN;
        this.l0 = null;
        this.l7 = null;
        this.i1 = null;
        this.i4 = null;
        this.i3 = null;
        this.i6 = null;
        this.ix = null;
        this.iy = null;
        this.lv = null;
        this.l2 = null;
        this.g1 = 1;
        this.hi = 1;
        this.g2 = 1;
        this.hj = 0;
        this.lx = null;
        this.l4 = null;
        this.ly = null;
        this.l5 = null;
        this.g3 = 1;
        this.hk = 1;
        this.g4 = 5;
        this.hl = 0;
        this.lz = null;
        this.l6 = null;
        this.g5 = 2;
        this.hm = 2;
        this.i2 = null;
        this.i5 = null;
        this.lw = null;
        this.l3 = null;
        this.gw = 0;
        this.hd = 0;
        this.gv = NaN;
        this.hc = NaN;
        this.g6 = 0;
        this.hn = -90;
        this.gr = false;
        this.gs = false;
        this.lp = 1;
        this.mo = 1;
        this.lo = 1;
        this.lq = 2;
        this.mm = 0;
        this.mn = 1;
        this.ms = 0;
        this.mt = 0;
        this.gp = 2;
    }
    fj(a, b, c) {
        super.fj(a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.li((d) => d.leftMargin = this.h0);
                break;
            case "XAxisLabelTopMargin":
                this.li((d) => d.topMargin = this.h2);
                break;
            case "XAxisLabelRightMargin":
                this.li((d) => d.rightMargin = this.h1);
                break;
            case "XAxisLabelBottomMargin":
                this.li((d) => d.bottomMargin = this.hz);
                break;
            case "YAxisLabelLeftMargin":
                this.lm((d) => d.leftMargin = this.ii);
                break;
            case "YAxisLabelTopMargin":
                this.lm((d) => d.topMargin = this.ik);
                break;
            case "YAxisLabelRightMargin":
                this.lm((d) => d.rightMargin = this.ij);
                break;
            case "YAxisLabelBottomMargin":
                this.lm((d) => d.bottomMargin = this.ih);
                break;
            case "XAxisLabelTextColor":
                this.li((d) => d.textColor = this.l8);
                break;
            case "YAxisLabelTextColor":
                this.lm((d) => d.textColor = this.mf);
                break;
            case "XAxisTitleMargin":
                this.lj((d) => d.margin = this.ib);
                break;
            case "YAxisTitleMargin":
                this.ln((d) => d.margin = this.iu);
                break;
            case "XAxisTitleLeftMargin":
                this.lj((d) => d.leftMargin = this.ia);
                break;
            case "YAxisTitleLeftMargin":
                this.ln((d) => d.leftMargin = this.it);
                break;
            case "XAxisTitleTopMargin":
                this.lj((d) => d.topMargin = this.id);
                break;
            case "YAxisTitleTopMargin":
                this.ln((d) => d.topMargin = this.iw);
                break;
            case "XAxisTitleRightMargin":
                this.lj((d) => d.rightMargin = this.ic);
                break;
            case "YAxisTitleRightMargin":
                this.ln((d) => d.rightMargin = this.iv);
                break;
            case "XAxisTitleBottomMargin":
                this.lj((d) => d.bottomMargin = this.h9);
                break;
            case "YAxisTitleBottomMargin":
                this.ln((d) => d.bottomMargin = this.is);
                break;
            case "XAxisTitleTextColor":
                this.lj((d) => d.textColor = this.me);
                break;
            case "YAxisTitleTextColor":
                this.ln((d) => d.textColor = this.ml);
                break;
            case "XAxisFormatLabel":
                this.lh((d) => d.an = this.gn);
                break;
            case "YAxisFormatLabel":
                this.lk((d) => d.an = this.go);
                break;
        }
    }
    get gn() {
        return this.gl;
    }
    set gn(a) {
        let b = this.gn;
        if (a != b) {
            this.gl = a;
            this.fi("XAxisFormatLabel", b, this.gn);
        }
    }
    get go() {
        return this.gm;
    }
    set go(a) {
        let b = this.go;
        if (a != b) {
            this.gm = a;
            this.fi("YAxisFormatLabel", b, this.go);
        }
    }
    get h0() {
        return this.gy;
    }
    set h0(a) {
        let b = this.h0;
        if (a != b) {
            this.gy = a;
            this.fi("XAxisLabelLeftMargin", b, this.h0);
        }
    }
    get h2() {
        return this.g0;
    }
    set h2(a) {
        let b = this.h2;
        if (a != b) {
            this.g0 = a;
            this.fi("XAxisLabelTopMargin", b, this.h2);
        }
    }
    get h1() {
        return this.gz;
    }
    set h1(a) {
        let b = this.h1;
        if (a != b) {
            this.gz = a;
            this.fi("XAxisLabelRightMargin", b, this.h1);
        }
    }
    get hz() {
        return this.gx;
    }
    set hz(a) {
        let b = this.hz;
        if (a != b) {
            this.gx = a;
            this.fi("XAxisLabelBottomMargin", b, this.hz);
        }
    }
    get ii() {
        return this.hf;
    }
    set ii(a) {
        let b = this.ii;
        if (a != b) {
            this.hf = a;
            this.fi("YAxisLabelLeftMargin", b, this.ii);
        }
    }
    get ik() {
        return this.hh;
    }
    set ik(a) {
        let b = this.ik;
        if (a != b) {
            this.hh = a;
            this.fi("YAxisLabelTopMargin", b, this.ik);
        }
    }
    get ij() {
        return this.hg;
    }
    set ij(a) {
        let b = this.ij;
        if (a != b) {
            this.hg = a;
            this.fi("YAxisLabelRightMargin", b, this.ij);
        }
    }
    get ih() {
        return this.he;
    }
    set ih(a) {
        let b = this.ih;
        if (a != b) {
            this.he = a;
            this.fi("YAxisLabelBottomMargin", b, this.ih);
        }
    }
    get l8() {
        return this.lu;
    }
    set l8(a) {
        let b = this.l8;
        if (a != b) {
            this.lu = a;
            this.fi("XAxisLabelTextColor", b, this.l8);
        }
    }
    get mf() {
        return this.l1;
    }
    set mf(a) {
        let b = this.mf;
        if (a != b) {
            this.l1 = a;
            this.fi("YAxisLabelTextColor", b, this.mf);
        }
    }
    get ib() {
        return this.g9;
    }
    set ib(a) {
        let b = this.ib;
        if (a != b) {
            this.g9 = a;
            this.fi("XAxisTitleMargin", b, this.ib);
        }
    }
    get iu() {
        return this.hq;
    }
    set iu(a) {
        let b = this.iu;
        if (a != b) {
            this.hq = a;
            this.fi("YAxisTitleMargin", b, this.iu);
        }
    }
    get ia() {
        return this.g8;
    }
    set ia(a) {
        let b = this.ia;
        if (a != b) {
            this.g8 = a;
            this.fi("XAxisTitleLeftMargin", b, this.ia);
        }
    }
    get it() {
        return this.hp;
    }
    set it(a) {
        let b = this.it;
        if (a != b) {
            this.hp = a;
            this.fi("YAxisTitleLeftMargin", b, this.it);
        }
    }
    get id() {
        return this.hb;
    }
    set id(a) {
        let b = this.id;
        if (a != b) {
            this.hb = a;
            this.fi("XAxisTitleTopMargin", b, this.id);
        }
    }
    get iw() {
        return this.hs;
    }
    set iw(a) {
        let b = this.iw;
        if (a != b) {
            this.hs = a;
            this.fi("YAxisTitleTopMargin", b, this.iw);
        }
    }
    get ic() {
        return this.ha;
    }
    set ic(a) {
        let b = this.ic;
        if (a != b) {
            this.ha = a;
            this.fi("XAxisTitleRightMargin", b, this.ic);
        }
    }
    get iv() {
        return this.hr;
    }
    set iv(a) {
        let b = this.iv;
        if (a != b) {
            this.hr = a;
            this.fi("YAxisTitleRightMargin", b, this.iv);
        }
    }
    get h9() {
        return this.g7;
    }
    set h9(a) {
        let b = this.h9;
        if (a != b) {
            this.g7 = a;
            this.fi("XAxisTitleBottomMargin", b, this.h9);
        }
    }
    get is() {
        return this.ho;
    }
    set is(a) {
        let b = this.is;
        if (a != b) {
            this.ho = a;
            this.fi("YAxisTitleBottomMargin", b, this.is);
        }
    }
    get me() {
        return this.l0;
    }
    set me(a) {
        let b = this.me;
        if (a != b) {
            this.l0 = a;
            this.fi("XAxisTitleTextColor", b, this.me);
        }
    }
    get ml() {
        return this.l7;
    }
    set ml(a) {
        let b = this.ml;
        if (a != b) {
            this.l7 = a;
            this.fi("YAxisTitleTextColor", b, this.ml);
        }
    }
    fk(a, b, c) {
        super.fk(a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.li((d) => d.textStyle = this.ji);
                break;
            case "YAxisLabelTextStyle":
                this.lm((d) => d.textStyle = this.kk);
                break;
            case "XAxisTitleTextStyle":
                this.lj((d) => d.textStyle = this.j6);
                break;
            case "YAxisTitleTextStyle":
                this.ln((d) => d.textStyle = this.k8);
                break;
        }
    }
    get ji() {
        return this.i1;
    }
    set ji(a) {
        let b = this.ji;
        if (a != b) {
            this.i1 = a;
            this.fi("XAxisLabelTextStyle", b, this.ji);
        }
    }
    get kk() {
        return this.i4;
    }
    set kk(a) {
        let b = this.kk;
        if (a != b) {
            this.i4 = a;
            this.fi("YAxisLabelTextStyle", b, this.kk);
        }
    }
    get j6() {
        return this.i3;
    }
    set j6(a) {
        let b = this.j6;
        if (a != b) {
            this.i3 = a;
            this.fi("XAxisTitleTextStyle", b, this.j6);
        }
    }
    get k8() {
        return this.i6;
    }
    set k8(a) {
        let b = this.k8;
        if (a != b) {
            this.i6 = a;
            this.fi("YAxisTitleTextStyle", b, this.k8);
        }
    }
    le(a) {
        this.lb(a, (b) => b.leftMargin = this.h0);
        this.lb(a, (b) => b.topMargin = this.h2);
        this.lb(a, (b) => b.rightMargin = this.h1);
        this.lb(a, (b) => b.bottomMargin = this.hz);
        this.lb(a, (b) => b.textColor = this.l8);
        this.lb(a, (b) => b.textStyle = this.ji);
        this.lc(a, (b) => b.textColor = this.me);
        this.lc(a, (b) => b.textStyle = this.j6);
        this.lc(a, (b) => b.leftMargin = this.ia);
        this.lc(a, (b) => b.topMargin = this.id);
        this.lc(a, (b) => b.rightMargin = this.ic);
        this.lc(a, (b) => b.bottomMargin = this.h9);
    }
    lg(a) {
        this.lb(a, (b) => b.leftMargin = this.ii);
        this.lb(a, (b) => b.topMargin = this.ik);
        this.lb(a, (b) => b.rightMargin = this.ij);
        this.lb(a, (b) => b.bottomMargin = this.ih);
        this.lb(a, (b) => b.textColor = this.mf);
        this.lb(a, (b) => b.textStyle = this.kk);
        this.lc(a, (b) => b.textColor = this.ml);
        this.lc(a, (b) => b.textStyle = this.k8);
        this.lc(a, (b) => b.leftMargin = this.it);
        this.lc(a, (b) => b.topMargin = this.iw);
        this.lc(a, (b) => b.rightMargin = this.iv);
        this.lc(a, (b) => b.bottomMargin = this.is);
    }
    fx(a) {
        let b = this.r(a);
        let c = this.ag(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = a.data;
        c.name = this.c5(a);
        c.fj = this.c6(a, b);
        this.dataChart.series.add(c);
    }
    lh(a) {
        a(this.gj());
    }
    ll(a, b) {
        a(this.gk());
    }
    lk(a) {
        this.ll(a, true);
    }
    lj(a) {
        this.lc(this.gj(), a);
    }
    ln(a) {
        this.lc(this.gk(), a);
    }
    lm(a) {
        this.lb(this.gk(), a);
    }
    li(a) {
        this.lb(this.gj(), a);
    }
    ht(a) {
        return this.gj().dj(a, new ScalerParams(1, this.gi, this.gh, this.gj().bz));
    }
    hv(a) {
        return this.gj().dm(a, new ScalerParams(1, this.gi, this.gh, this.gj().bz));
    }
    hu(a) {
        return this.gk().dj(a, new ScalerParams(1, this.gi, this.gh, this.gk().bz));
    }
    hw(a) {
        return this.gk().dm(a, new ScalerParams(1, this.gi, this.gh, this.gk().bz));
    }
    fv(a) {
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            let b = this.gj();
            let c = this.gk();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    }
    static i7(a, b) {
        for (let c of fromEnum(b)) {
            let d = c.findMatchingHint(16);
            if (d != null) {
                let e = d.path;
                return e;
            }
        }
        return null;
    }
    ew(a) {
        super.ew(a);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.gj());
            this.dataChart.axes.add(this.gk());
        }
    }
    e2(a, b) {
        super.e2(a, b);
    }
    ld(a) {
        if (a != null && this.cm != null && a.ee == null) {
            a.provideRenderer(this.cm);
        }
        a.hv = this.l9;
        a.dr = this.h3;
        a.hw = this.ma;
        a.du = this.h4;
        a.hy = this.mc;
        a.ea = this.h5;
        a.hx = this.mb;
        a.eb = this.h6;
        a.hz = this.md;
        a.ec = this.h7;
        let b = a == this.gj();
        if (b) {
            a.fp = this.jx;
        }
        this.lb(a, (c) => c.angle = this.hy);
        this.lb(a, (c) => {
            if (c.extent != this.hx) {
                c.extent = this.hx;
            }
        });
        this.lb(a, (c) => c.horizontalAlignment = this.lr);
        this.lb(a, (c) => c.verticalAlignment = this.mp);
        this.lb(a, (c) => c.visibility = this.mu);
        this.lc(a, (c) => c.horizontalAlignment = this.ls);
        this.lc(a, (c) => c.angle = this.h8);
        this.le(a);
    }
    lf(a) {
        if (a == null) {
            return;
        }
        if (this.cm != null && a.ee == null) {
            a.provideRenderer(this.cm);
        }
        this.lb(a, (b) => b.angle = this.ig);
        this.lb(a, (b) => {
            if (b.extent != this.ie) {
                b.extent = this.ie;
            }
        });
        this.lb(a, (b) => b.horizontalAlignment = this.lt);
        this.lb(a, (b) => b.verticalAlignment = this.mq);
        this.lb(a, (b) => b.visibility = this.mv);
        this.lb(a, (b) => b.location = this.gq);
        this.lc(a, (b) => b.verticalAlignment = this.mr);
        this.lc(a, (b) => b.angle = this.ir);
        a.hv = this.mg;
        a.dr = this.il;
        a.hw = this.mh;
        a.du = this.im;
        a.hy = this.mj;
        a.ea = this.io;
        a.hx = this.mi;
        a.eb = this.ip;
        a.hz = this.mk;
        a.ec = this.iq;
        let b = a == this.gk();
        if (b) {
            a.fp = this.kz;
        }
        this.lg(a);
    }
    et() {
        super.et();
        this.ld(this.gj());
        this.lf(this.gk());
    }
    lb(a, b) {
        if (a == null) {
            return;
        }
        if (a.as == null) {
            a.as = new AxisLabelSettings();
            a.as.angle = a.c8();
            a.as.bottomMargin = a.c9();
            a.as.leftMargin = a.da();
            a.as.rightMargin = a.db();
            a.as.topMargin = a.dc();
            a.as.horizontalAlignment = a.hq();
            a.as.location = a.at();
            a.as.verticalAlignment = a.ij();
        }
        b(a.as);
    }
    lc(a, b) {
        if (a == null) {
            return;
        }
        if (a.a6 == null) {
            a.a6 = new TitleSettings();
            a.a6.bottomMargin = a.de();
            a.a6.leftMargin = a.df();
            a.a6.rightMargin = a.dg();
            a.a6.topMargin = a.dh();
            a.a6.location = a.au();
            a.a6.angle = a.dd();
            a.a6.horizontalAlignment = a.hr();
            a.a6.verticalAlignment = a.ik();
        }
        b(a.a6);
    }
    fi(a, b, c) {
        super.fi(a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.li((d) => d.angle = this.hy);
                break;
            case "YAxisLabelAngle":
                this.lm((d) => d.angle = this.ig);
                break;
            case "XAxisLabelHorizontalAlignment":
                this.li((d) => d.horizontalAlignment = this.lr);
                break;
            case "YAxisLabelHorizontalAlignment":
                this.lm((d) => d.horizontalAlignment = this.lt);
                break;
            case "XAxisLabelVerticalAlignment":
                this.li((d) => d.verticalAlignment = this.mp);
                break;
            case "YAxisLabelVerticalAlignment":
                this.lm((d) => d.verticalAlignment = this.mq);
                break;
            case "XAxisLabelVisibility":
                this.li((d) => d.visibility = this.mu);
                break;
            case "YAxisLabelVisibility":
                this.lm((d) => d.visibility = this.mv);
                break;
            case "XAxisLabel":
                this.lh((d) => d.er = this.iz);
                break;
            case "YAxisLabel":
                this.lk((d) => d.er = this.i0);
                break;
            case "XAxisTitleAngle":
                this.lj((d) => d.angle = this.h8);
                break;
            case "YAxisTitleAngle":
                this.ln((d) => d.angle = this.ir);
                break;
            case "XAxisTitleAlignment":
                this.lj((d) => d.horizontalAlignment = this.ls);
                break;
            case "YAxisTitleAlignment":
                this.ln((d) => d.verticalAlignment = this.mr);
                break;
            case "XAxisTitle":
                this.lh((d) => d.fp = this.jx);
                break;
            case "YAxisTitle":
                this.ll((d) => d.fp = this.kz, false);
                break;
            case "XAxisMajorStroke":
                this.lh((d) => d.hv = this.l9);
                break;
            case "YAxisMajorStroke":
                this.lk((d) => d.hv = this.mg);
                break;
            case "XAxisMajorStrokeThickness":
                this.lh((d) => d.dr = this.h3);
                break;
            case "YAxisMajorStrokeThickness":
                this.lk((d) => d.dr = this.il);
                break;
            case "XAxisMinorStroke":
                this.lh((d) => d.hw = this.ma);
                break;
            case "YAxisMinorStroke":
                this.lk((d) => d.hw = this.mh);
                break;
            case "XAxisMinorStrokeThickness":
                this.lh((d) => d.du = this.h4);
                break;
            case "YAxisMinorStrokeThickness":
                this.lk((d) => d.du = this.im);
                break;
            case "XAxisTickLength":
                this.lh((d) => d.eb = this.h6);
                break;
            case "YAxisTickLength":
                this.lk((d) => d.eb = this.ip);
                break;
            case "XAxisTickStroke":
                this.lh((d) => d.hz = this.md);
                break;
            case "YAxisTickStroke":
                this.lk((d) => d.hz = this.mk);
                break;
            case "XAxisTickStrokeThickness":
                this.lh((d) => d.ec = this.h7);
                break;
            case "YAxisTickStrokeThickness":
                this.lk((d) => d.ec = this.iq);
                break;
            case "XAxisStroke":
                this.lh((d) => d.hy = this.mc);
                break;
            case "YAxisStroke":
                this.lk((d) => d.hy = this.mj);
                break;
            case "XAxisStrokeThickness":
                this.lh((d) => d.ea = this.h5);
                break;
            case "YAxisStrokeThickness":
                this.lk((d) => d.ea = this.io);
                break;
            case "XAxisExtent":
                this.li((d) => d.extent = this.hx);
                break;
            case "YAxisExtent":
                this.lm((d) => d.extent = this.ie);
                break;
            case "XAxisStrip":
                this.lh((d) => d.hx = this.mb);
                break;
            case "YAxisStrip":
                this.lk((d) => d.hx = this.mi);
                break;
            case "XAxisInverted":
                this.lh((d) => d.bz = this.gt);
                break;
            case "YAxisInverted":
                this.lk((d) => d.bz = this.gu);
                break;
            case "YAxisLabelLocation":
                this.lm((d) => d.location = this.gq);
                break;
        }
    }
    get iz() {
        return this.ix;
    }
    set iz(a) {
        let b = this.iz;
        if (a != b) {
            this.ix = a;
            this.fi("XAxisLabel", b, this.iz);
        }
    }
    get i0() {
        return this.iy;
    }
    set i0(a) {
        let b = this.i0;
        if (a != b) {
            this.iy = a;
            this.fi("YAxisLabel", b, this.i0);
        }
    }
    get l9() {
        return this.lv;
    }
    set l9(a) {
        let b = this.l9;
        if (a != b) {
            this.lv = a;
            this.fi("XAxisMajorStroke", b, this.l9);
        }
    }
    get mg() {
        return this.l2;
    }
    set mg(a) {
        let b = this.mg;
        if (a != b) {
            this.l2 = a;
            this.fi("YAxisMajorStroke", b, this.mg);
        }
    }
    get h3() {
        return this.g1;
    }
    set h3(a) {
        let b = this.h3;
        if (a != b) {
            this.g1 = a;
            this.fi("XAxisMajorStrokeThickness", b, this.h3);
        }
    }
    get il() {
        return this.hi;
    }
    set il(a) {
        let b = this.il;
        if (a != b) {
            this.hi = a;
            this.fi("YAxisMajorStrokeThickness", b, this.il);
        }
    }
    get h4() {
        return this.g2;
    }
    set h4(a) {
        let b = this.h4;
        if (a != b) {
            this.g2 = a;
            this.fi("XAxisMinorStrokeThickness", b, this.h4);
        }
    }
    get im() {
        return this.hj;
    }
    set im(a) {
        let b = this.im;
        if (a != b) {
            this.hj = a;
            this.fi("YAxisMinorStrokeThickness", b, this.im);
        }
    }
    get mb() {
        return this.lx;
    }
    set mb(a) {
        let b = this.mb;
        if (a != b) {
            this.lx = a;
            this.fi("XAxisStrip", b, this.mb);
        }
    }
    get mi() {
        return this.l4;
    }
    set mi(a) {
        let b = this.mi;
        if (a != b) {
            this.l4 = a;
            this.fi("YAxisStrip", b, this.mi);
        }
    }
    get mc() {
        return this.ly;
    }
    set mc(a) {
        let b = this.mc;
        if (a != b) {
            this.ly = a;
            this.fi("XAxisStroke", b, this.mc);
        }
    }
    get mj() {
        return this.l5;
    }
    set mj(a) {
        let b = this.mj;
        if (a != b) {
            this.l5 = a;
            this.fi("YAxisStroke", b, this.mj);
        }
    }
    get h5() {
        return this.g3;
    }
    set h5(a) {
        let b = this.h5;
        if (a != b) {
            this.g3 = a;
            this.fi("XAxisStrokeThickness", b, this.h5);
        }
    }
    get io() {
        return this.hk;
    }
    set io(a) {
        let b = this.io;
        if (a != b) {
            this.hk = a;
            this.fi("YAxisStrokeThickness", b, this.io);
        }
    }
    get h6() {
        return this.g4;
    }
    set h6(a) {
        let b = this.h6;
        if (a != b) {
            this.g4 = a;
            this.fi("XAxisTickLength", b, this.h6);
        }
    }
    get ip() {
        return this.hl;
    }
    set ip(a) {
        let b = this.ip;
        if (a != b) {
            this.hl = a;
            this.fi("YAxisTickLength", b, this.ip);
        }
    }
    get md() {
        return this.lz;
    }
    set md(a) {
        let b = this.md;
        if (a != b) {
            this.lz = a;
            this.fi("XAxisTickStroke", b, this.md);
        }
    }
    get mk() {
        return this.l6;
    }
    set mk(a) {
        let b = this.mk;
        if (a != b) {
            this.l6 = a;
            this.fi("YAxisTickStroke", b, this.mk);
        }
    }
    get h7() {
        return this.g5;
    }
    set h7(a) {
        let b = this.h7;
        if (a != b) {
            this.g5 = a;
            this.fi("XAxisTickStrokeThickness", b, this.h7);
        }
    }
    get iq() {
        return this.hm;
    }
    set iq(a) {
        let b = this.iq;
        if (a != b) {
            this.hm = a;
            this.fi("YAxisTickStrokeThickness", b, this.iq);
        }
    }
    get jx() {
        return this.i2;
    }
    set jx(a) {
        let b = this.jx;
        if (a != b) {
            this.i2 = a;
            this.fi("XAxisTitle", b, this.jx);
        }
    }
    get kz() {
        return this.i5;
    }
    set kz(a) {
        let b = this.kz;
        if (a != b) {
            this.i5 = a;
            this.fi("YAxisTitle", b, this.kz);
        }
    }
    get ma() {
        return this.lw;
    }
    set ma(a) {
        let b = this.ma;
        if (a != b) {
            this.lw = a;
            this.fi("XAxisMinorStroke", b, this.ma);
        }
    }
    get mh() {
        return this.l3;
    }
    set mh(a) {
        let b = this.mh;
        if (a != b) {
            this.l3 = a;
            this.fi("YAxisMinorStroke", b, this.mh);
        }
    }
    get hy() {
        return this.gw;
    }
    set hy(a) {
        let b = this.hy;
        if (a != b) {
            this.gw = a;
            this.fi("XAxisLabelAngle", b, this.hy);
        }
    }
    get ig() {
        return this.hd;
    }
    set ig(a) {
        let b = this.ig;
        if (a != b) {
            this.hd = a;
            this.fi("YAxisLabelAngle", b, this.ig);
        }
    }
    get hx() {
        return this.gv;
    }
    set hx(a) {
        let b = this.hx;
        if (a != b) {
            this.gv = a;
            this.fi("XAxisExtent", b, this.hx);
        }
    }
    get ie() {
        return this.hc;
    }
    set ie(a) {
        let b = this.ie;
        if (a != b) {
            this.hc = a;
            this.fi("YAxisExtent", b, this.ie);
        }
    }
    get h8() {
        return this.g6;
    }
    set h8(a) {
        let b = this.h8;
        if (a != b) {
            this.g6 = a;
            this.fi("XAxisTitleAngle", b, this.h8);
        }
    }
    get ir() {
        return this.hn;
    }
    set ir(a) {
        let b = this.ir;
        if (a != b) {
            this.hn = a;
            this.fi("YAxisTitleAngle", b, this.ir);
        }
    }
    get gt() {
        return this.gr;
    }
    set gt(a) {
        let b = this.gt;
        if (a != b) {
            this.gr = a;
            this.fi("XAxisInverted", b, this.gt);
        }
    }
    get gu() {
        return this.gs;
    }
    set gu(a) {
        let b = this.gu;
        if (a != b) {
            this.gs = a;
            this.fi("YAxisInverted", b, this.gu);
        }
    }
    get ls() {
        return this.lp;
    }
    set ls(a) {
        let b = this.ls;
        if (a != b) {
            this.lp = a;
            this.fi("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ls));
        }
    }
    get mr() {
        return this.mo;
    }
    set mr(a) {
        let b = this.mr;
        if (a != b) {
            this.mo = a;
            this.fi("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.mr));
        }
    }
    get lr() {
        return this.lo;
    }
    set lr(a) {
        let b = this.lr;
        if (a != b) {
            this.lo = a;
            this.fi("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.lr));
        }
    }
    get_lt() {
        return this.lq;
    }
    set_lt(a) {
        let b = this.lt;
        if (a != b) {
            this.lq = a;
            this.fi("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.lt));
        }
    }
    get lt() {
        return this.get_lt();
    }
    set lt(a) {
        this.set_lt(a);
    }
    get mp() {
        return this.mm;
    }
    set mp(a) {
        let b = this.mp;
        if (a != b) {
            this.mm = a;
            this.fi("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.mp));
        }
    }
    get mq() {
        return this.mn;
    }
    set mq(a) {
        let b = this.mq;
        if (a != b) {
            this.mn = a;
            this.fi("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.mq));
        }
    }
    get mu() {
        return this.ms;
    }
    set mu(a) {
        let b = this.mu;
        if (a != b) {
            this.ms = a;
            this.fi("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.mu));
        }
    }
    get mv() {
        return this.mt;
    }
    set mv(a) {
        let b = this.mv;
        if (a != b) {
            this.mt = a;
            this.fi("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.mv));
        }
    }
    get_gq() {
        return this.gp;
    }
    set_gq(a) {
        let b = this.gq;
        if (a != b) {
            this.gp = a;
            this.fi("YAxisLabelLocation", enumGetBox(AxisLabelsLocation_$type, b), enumGetBox(AxisLabelsLocation_$type, this.gq));
        }
    }
    get gq() {
        return this.get_gq();
    }
    set gq(a) {
        this.set_gq(a);
    }
}
XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
//# sourceMappingURL=XYChart.js.map