import { Brush } from './Brush';
import { Color } from './Color';
import { Size } from './Size';
import { IgxSize } from './IgxSize';
import { Rect } from './Rect';
import { IgxRect } from './IgxRect';
import { BrushCollection } from './BrushCollection';
import { Point } from './type';
import { IList$1 } from './type';
import { Type } from './type';
import { QueryList } from '@angular/core';
export declare function brushToString(v: Brush): string;
export declare function stringToBrush(v: string): Brush;
export declare function ensureEnum<T>($t: Type, v: any): T;
export declare function ensureBool(v: any): boolean;
export declare function colorToString(v: Color): string;
export declare function stringToColor(v: string): Color;
export declare function fromSize(v: Size): IgxSize;
export declare function toSize(v: IgxSize | string): Size;
export declare function fromPoint(v: Point): Point;
export declare function toPoint(v: Point | string): Point;
export declare function fromRect(v: Rect): IgxRect;
export declare function toRect(v: IgxRect | string): Rect;
export declare function toBrushCollection(v: string[] | string): BrushCollection;
export declare function fromBrushCollection(v: BrushCollection): string[];
export declare class CollectionAdapter<T, J> {
    private _queryItems;
    private _manualItems;
    private _allList;
    private _target;
    private _query;
    private _toTarget;
    private _onItemAdded;
    private _onItemRemoved;
    constructor(query: QueryList<T>, target: IList$1<J>, allList: T[], toTarget: (item: T) => J, onItemAdded: (item: T) => void, onItemRemoved: (item: T) => void);
    syncItems(): void;
    onQueryChanged(currentItems: T[]): void;
    addManualItem(item: T): void;
    removeManualItem(item: T): boolean;
    removeManualItemAt(index: number): void;
    clearManualItems(): void;
    insertManualItem(index: number, item: T): void;
}
export declare function addPaletteThemeEntry(theme: any, clss: string, background: string, border?: string, foreground?: string): void;
export declare function addTextThemeEntry(theme: any, clss: string, fontFamily: string, fontSize: string, textColor: string, leftMargin?: string, topMargin?: string, rightMargin?: string, bottomMargin?: string, horizontalAlignment?: string, verticalAlignment?: string): void;
export declare function addBrushPaletteThemeEntry(theme: any, clss: string, backgrounds: string[], outlines: string[]): void;
