import { IgxCollection } from './IgxCollection';
import { markType } from './type';
import { SyncableObservableCollection$2 } from './SyncableObservableCollection$2';
import { Axis as Axis_internal } from './Axis';
import { IgxAxisComponent as IgxAxisComponent } from './igx-axis-component';
export class AxisCollection extends IgxCollection {
    constructor(list) {
        super();
        if (!IgxAxisComponent.$type) {
            IgxAxisComponent.$type = markType(IgxAxisComponent, "IgxAxisComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxAxisComponent.$type) {
            IgxAxisComponent.$type = markType(IgxAxisComponent, "IgxAxisComponent");
        }
        let coll = new SyncableObservableCollection$2(IgxAxisComponent.$type, Axis_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgxAxisComponent._createFromInternal(int);
                ext._implementation = int;
            }
            return ext;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-axis-collection.js.map