/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Output, EventEmitter, Input } from '@angular/core';
import { Visibility, Visibility_$type } from './Visibility';
import { HorizontalAlignment, HorizontalAlignment_$type } from './HorizontalAlignment';
import { VerticalAlignment, VerticalAlignment_$type } from './VerticalAlignment';
import { AxisLabelsLocation, AxisLabelsLocation_$type } from './AxisLabelsLocation';
import { AxisLabelSettings } from './AxisLabelSettings';
import { TitleSettings } from './TitleSettings';
import { AxisTitlePosition, AxisTitlePosition_$type } from './AxisTitlePosition';
import { ensureEnum, brushToString, stringToBrush, ensureBool } from './componentUtil';
import { delegateCombine } from './type';
import { RenderRequestedEventArgs } from './RenderRequestedEventArgs';
import { TypeRegistrar } from './type';
export const IgxAxisComponent_PROVIDERS = [];
/**
 * Represents the base class from which all axis types are derived.
*/
export class IgxAxisComponent {
    constructor() {
        this._renderer = null;
        this._renderRequested = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    get axisInternal() {
        return this.i;
    }
    createImplementation() {
        return null;
    }
    ngOnInit() {
    }
    set name(value) {
        console.log("setting axis name: " + value);
        this.i.name = value;
        console.log("checking axis anme: " + this.i.name);
    }
    get name() {
        console.log("getting axis anme: " + this.i.name);
        return this.i.name;
    }
    provideData(data) {
    }
    _provideRenderer(renderer) {
        this._renderer = renderer;
        this._zoneRunner = (act) => renderer._ngZone.run(act);
    }
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    /**
         * Gets or sets if the current axis is of category axis type
        */
    get isCategory() {
        return this.i.bt;
    }
    /**
         * Gets or sets if the current axis is of numeric axis type
        */
    get isNumeric() {
        return this.i.b1;
    }
    /**
         * Gets if the current axis is of angular axis type
        */
    get isAngular() {
        return this.i.bs;
    }
    /**
         * Gets or sets if the current axis is of radial axis type
        */
    get isRadial() {
        return this.i.b2;
    }
    /**
         * Gets if the current axis is a vertical axis.
        */
    get isVertical() {
        return this.i.b5;
    }
    /**
         * Gets or sets if the current axis is sorting data items
        */
    get isSorting() {
        return this.i.b3;
    }
    /**
         * Gets or sets if the current axis is of date time axis type
        */
    get isDateTime() {
        return this.i.bw;
    }
    /**
         * Gets or sets if the current axis is of category date time axis type
        */
    get isCategoryDateTime() {
        return this.i.bu;
    }
    /**
         * Gets if the current axis is a continuous rather than a discrete scale
        */
    get isContinuous() {
        return this.i.bv;
    }
    /**
         * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
        */
    get formatLabel() {
        return this.i.an;
    }
    set formatLabel(v) {
        this.i.an = v;
    }
    /**
         * Gets or sets the Title property.
        */
    get title() {
        return this.i.fp;
    }
    set title(v) {
        this.i.fp = v;
    }
    /**
         * Gets or sets the Stroke property.
         * Null is treated as auto. The axis stroke will be displayed or not based on the axis type and series used with it.
        */
    get stroke() {
        return brushToString(this.i.hy);
    }
    set stroke(v) {
        this.i.hy = stringToBrush(v);
    }
    /**
         * Gets or sets the effective stroke used for the axis.
        */
    get actualStroke() {
        return brushToString(this.i.hu);
    }
    /**
         * Gets or sets the StrokeThickness property.
        */
    get strokeThickness() {
        return this.i.ea;
    }
    set strokeThickness(v) {
        this.i.ea = +v;
    }
    /**
         * Gets or sets the Strip property.
        */
    get strip() {
        return brushToString(this.i.hx);
    }
    set strip(v) {
        this.i.hx = stringToBrush(v);
    }
    /**
         * Gets or sets the MajorStroke property.
         * Null is treated as auto. Major lines will be displayed or not based on the axis type and series used with it.
        */
    get majorStroke() {
        return brushToString(this.i.hv);
    }
    set majorStroke(v) {
        this.i.hv = stringToBrush(v);
    }
    /**
         * Gets or sets the ActualMajorStroke property.
        */
    get actualMajorStroke() {
        return brushToString(this.i.hs);
    }
    /**
         * Gets or sets the MajorStrokeThickness property.
        */
    get majorStrokeThickness() {
        return this.i.dr;
    }
    set majorStrokeThickness(v) {
        this.i.dr = +v;
    }
    /**
         * Gets or sets the MinorStroke property.
        */
    get minorStroke() {
        return brushToString(this.i.hw);
    }
    set minorStroke(v) {
        this.i.hw = stringToBrush(v);
    }
    /**
         * Gets or sets the ActualMinorStroke property.
        */
    get actualMinorStroke() {
        return brushToString(this.i.ht);
    }
    /**
         * Gets or sets the MinorStrokeThickness property.
        */
    get minorStrokeThickness() {
        return this.i.du;
    }
    set minorStrokeThickness(v) {
        this.i.du = +v;
    }
    /**
         * Gets or sets the TickStroke property.
        */
    get tickStroke() {
        return brushToString(this.i.hz);
    }
    set tickStroke(v) {
        this.i.hz = stringToBrush(v);
    }
    /**
         * Gets or sets the TickStrokeThickness property.
        */
    get tickStrokeThickness() {
        return this.i.ec;
    }
    set tickStrokeThickness(v) {
        this.i.ec = +v;
    }
    /**
         * Gets or sets the TickLength property.
        */
    get tickLength() {
        return this.i.eb;
    }
    set tickLength(v) {
        this.i.eb = +v;
    }
    /**
         * Gets or sets the IsDisabled property. If true, the axis will not be rendered.
        */
    get isDisabled() {
        return this.i.bx;
    }
    set isDisabled(v) {
        this.i.bx = ensureBool(v);
    }
    /**
         * Gets or sets the IsInverted property.
        */
    get isInverted() {
        return this.i.bz;
    }
    set isInverted(v) {
        this.i.bz = ensureBool(v);
    }
    /**
         * Gets or sets whether to use more advanced heuristics when determining the initial number of labels to render, before resolving collisions, etc.
        */
    get useEnhancedIntervalManagement() {
        return this.i.ce;
    }
    set useEnhancedIntervalManagement(v) {
        this.i.ce = ensureBool(v);
    }
    /**
         * Gets or sets the mininum desired characters to be displayed for horizontal axes when using advanced label heuristics. -1 will attempt to adjust the interval to precisely fit the horizontal labels.
        */
    get enhancedIntervalMinimumCharacters() {
        return this.i.ej;
    }
    set enhancedIntervalMinimumCharacters(v) {
        this.i.ej = +v;
    }
    /**
         * Gets or sets the text style to use for axis labels.
        */
    get labelTextStyle() {
        return this.i.as ? this.i.as.textStyle : null;
    }
    set labelTextStyle(v) {
        this.ensureLabelSettings();
        this.i.as.textStyle = v;
    }
    /**
         * The color of the {0}.
        */
    get labelTextColor() {
        return brushToString(this.i.as ? this.i.as.textColor : null);
    }
    set labelTextColor(v) {
        this.ensureLabelSettings();
        this.i.as.textColor = stringToBrush(v);
    }
    /**
         * Gets or sets the location of the {0}.
        */
    get labelLocation() {
        return this.i.as ? this.i.as.location : 0;
    }
    set labelLocation(v) {
        this.ensureLabelSettings();
        this.i.as.location = ensureEnum(AxisLabelsLocation_$type, v);
    }
    /**
         * Gets or sets the visibility of the {0}.
        */
    get labelVisibility() {
        return this.i.as ? this.i.as.visibility : 0;
    }
    set labelVisibility(v) {
        this.ensureLabelSettings();
        this.i.as.visibility = ensureEnum(Visibility_$type, v);
    }
    /**
         * Gets or sets whether the first label is displayed when the zoom level is set to 1.
        */
    get labelShowFirstLabel() {
        return this.i.as ? this.i.as.showFirstLabel : false;
    }
    set labelShowFirstLabel(v) {
        this.ensureLabelSettings();
        this.i.as.showFirstLabel = ensureBool(v);
    }
    /**
         * Gets or sets the angle of the {0}.
        */
    get labelAngle() {
        return this.i.as ? this.i.as.angle : NaN;
    }
    set labelAngle(v) {
        this.ensureLabelSettings();
        this.i.as.angle = +v;
    }
    /**
         * Distance between the axis and the edge of the control.
        */
    get labelExtent() {
        return this.i.as ? this.i.as.extent : NaN;
    }
    set labelExtent(v) {
        this.ensureLabelSettings();
        this.i.as.extent = +v;
    }
    /**
         * Margin applied to the left of the {0}.
        */
    get labelLeftMargin() {
        return this.i.as ? this.i.as.leftMargin : NaN;
    }
    set labelLeftMargin(v) {
        this.ensureLabelSettings();
        this.i.as.leftMargin = +v;
    }
    /**
         * Margin applied to the right of the {0}.
        */
    get labelRightMargin() {
        return this.i.as ? this.i.as.rightMargin : NaN;
    }
    set labelRightMargin(v) {
        this.ensureLabelSettings();
        this.i.as.rightMargin = +v;
    }
    /**
         * Margin applied above the {0}.
        */
    get labelTopMargin() {
        return this.i.as ? this.i.as.topMargin : NaN;
    }
    set labelTopMargin(v) {
        this.ensureLabelSettings();
        this.i.as.topMargin = +v;
    }
    /**
         * Margin applied below the {0}.
        */
    get labelBottomMargin() {
        return this.i.as ? this.i.as.bottomMargin : NaN;
    }
    set labelBottomMargin(v) {
        this.ensureLabelSettings();
        this.i.as.bottomMargin = +v;
    }
    /**
         * Gets or sets the horizontal alignment of the {0}.
        */
    get labelHorizontalAlignment() {
        return this.i.as ? this.i.as.horizontalAlignment : 0;
    }
    set labelHorizontalAlignment(v) {
        this.ensureLabelSettings();
        this.i.as.horizontalAlignment = ensureEnum(HorizontalAlignment_$type, v);
    }
    /**
         * Gets or sets the vertical alignment of the {0}.
        */
    get labelVerticalAlignment() {
        return this.i.as ? this.i.as.verticalAlignment : 0;
    }
    set labelVerticalAlignment(v) {
        this.ensureLabelSettings();
        this.i.as.verticalAlignment = ensureEnum(VerticalAlignment_$type, v);
    }
    ensureLabelSettings() {
        if (this.i.as) {
            return;
        }
        this.i.as = new AxisLabelSettings();
        this.i.as.location = this.i.at();
        this.i.as.angle = this.i.c8();
        this.i.as.leftMargin = this.i.da();
        this.i.as.rightMargin = this.i.db();
        this.i.as.topMargin = this.i.dc();
        this.i.as.bottomMargin = this.i.c9();
        this.i.as.horizontalAlignment = this.i.hq();
        this.i.as.verticalAlignment = this.i.ij();
    }
    /**
         * Gets or sets the CrossingAxis property.
        */
    get crossingAxis() {
        if (this.i.ag == null) {
            return null;
        }
        return this.i.ag.externalObject;
    }
    set crossingAxis(v) {
        v == null ? this.i.ag = null : this.i.ag = v.i;
    }
    /**
         * Gets or sets the CrossingValue property.
        */
    get crossingValue() {
        return this.i.eo;
    }
    set crossingValue(v) {
        this.i.eo = v;
    }
    /**
         * Gets or sets the title position relative to the axis labels.
        */
    get titlePosition() {
        return this.i.a6 ? this.i.a6.position : 0;
    }
    set titlePosition(v) {
        this.ensureTitleSettings();
        this.i.a6.position = ensureEnum(AxisTitlePosition_$type, v);
    }
    /**
         * Gets or sets the text style to use for axis labels.
        */
    get titleTextStyle() {
        return this.i.a6 ? this.i.a6.textStyle : null;
    }
    set titleTextStyle(v) {
        this.ensureTitleSettings();
        this.i.a6.textStyle = v;
    }
    /**
         * The color of the {0}.
        */
    get titleTextColor() {
        return brushToString(this.i.a6 ? this.i.a6.textColor : null);
    }
    set titleTextColor(v) {
        this.ensureTitleSettings();
        this.i.a6.textColor = stringToBrush(v);
    }
    /**
         * Gets or sets the location of the {0}.
        */
    get titleLocation() {
        return this.i.a6 ? this.i.a6.location : 0;
    }
    set titleLocation(v) {
        this.ensureTitleSettings();
        this.i.a6.location = ensureEnum(AxisLabelsLocation_$type, v);
    }
    /**
         * Gets or sets the visibility of the {0}.
        */
    get titleVisibility() {
        return this.i.a6 ? this.i.a6.visibility : 0;
    }
    set titleVisibility(v) {
        this.ensureTitleSettings();
        this.i.a6.visibility = ensureEnum(Visibility_$type, v);
    }
    /**
         * Gets or sets whether the first label is displayed when the zoom level is set to 1.
        */
    get titleShowFirstLabel() {
        return this.i.a6 ? this.i.a6.showFirstLabel : false;
    }
    set titleShowFirstLabel(v) {
        this.ensureTitleSettings();
        this.i.a6.showFirstLabel = ensureBool(v);
    }
    /**
         * Gets or sets the angle of the {0}.
        */
    get titleAngle() {
        return this.i.a6 ? this.i.a6.angle : NaN;
    }
    set titleAngle(v) {
        this.ensureTitleSettings();
        this.i.a6.angle = +v;
    }
    /**
         * Distance between the axis and the edge of the control.
        */
    get titleExtent() {
        return this.i.a6 ? this.i.a6.extent : NaN;
    }
    set titleExtent(v) {
        this.ensureTitleSettings();
        this.i.a6.extent = +v;
    }
    /**
         * Margin applied to the left of the {0}.
        */
    get titleLeftMargin() {
        return this.i.a6 ? this.i.a6.leftMargin : NaN;
    }
    set titleLeftMargin(v) {
        this.ensureTitleSettings();
        this.i.a6.leftMargin = +v;
    }
    /**
         * Margin applied to the right of the {0}.
        */
    get titleRightMargin() {
        return this.i.a6 ? this.i.a6.rightMargin : NaN;
    }
    set titleRightMargin(v) {
        this.ensureTitleSettings();
        this.i.a6.rightMargin = +v;
    }
    /**
         * Margin applied above the {0}.
        */
    get titleTopMargin() {
        return this.i.a6 ? this.i.a6.topMargin : NaN;
    }
    set titleTopMargin(v) {
        this.ensureTitleSettings();
        this.i.a6.topMargin = +v;
    }
    /**
         * Margin applied below the {0}.
        */
    get titleBottomMargin() {
        return this.i.a6 ? this.i.a6.bottomMargin : NaN;
    }
    set titleBottomMargin(v) {
        this.ensureTitleSettings();
        this.i.a6.bottomMargin = +v;
    }
    /**
         * Gets or sets the horizontal alignment of the {0}.
        */
    get titleHorizontalAlignment() {
        return this.i.a6 ? this.i.a6.horizontalAlignment : 0;
    }
    set titleHorizontalAlignment(v) {
        this.ensureTitleSettings();
        this.i.a6.horizontalAlignment = ensureEnum(HorizontalAlignment_$type, v);
    }
    /**
         * Gets or sets the vertical alignment of the {0}.
        */
    get titleVerticalAlignment() {
        return this.i.a6 ? this.i.a6.verticalAlignment : 0;
    }
    set titleVerticalAlignment(v) {
        this.ensureTitleSettings();
        this.i.a6.verticalAlignment = ensureEnum(VerticalAlignment_$type, v);
    }
    ensureTitleSettings() {
        if (this.i.a6) {
            return;
        }
        this.i.a6 = new TitleSettings();
        this.i.a6.location = this.i.au();
        this.i.a6.angle = this.i.dd();
        this.i.a6.leftMargin = this.i.df();
        this.i.a6.rightMargin = this.i.dg();
        this.i.a6.topMargin = this.i.dh();
        this.i.a6.bottomMargin = this.i.de();
        this.i.a6.horizontalAlignment = this.i.hr();
        this.i.a6.verticalAlignment = this.i.ik();
    }
    /**
         * Gets or sets the coercion methods to use when loading data from data sources.
         * Should be specified before setting any member paths, if being used. Setting it later
         * will not cause data to be re-imported into the chart.
        */
    get coercionMethods() {
        return this.i.coercionMethods;
    }
    set coercionMethods(v) {
        this.i.coercionMethods = v;
    }
    /**
         * Gets or sets whether the series should expect that properties in its items source may be functions that need to be
         * evaluated to yield their value. This defaults to false, as there will be a subtle performance impact to using this feature.
         * This value must be set before assigning an item's source to take effect.
        */
    get expectFunctions() {
        return this.i.expectFunctions;
    }
    set expectFunctions(v) {
        this.i.expectFunctions = ensureBool(v);
    }
    /**
         * Gets or sets the axis label format string.
        */
    get label() {
        return this.i.er;
    }
    set label(v) {
        this.i.er = v;
    }
    /**
         * Renders the axis with no animation.
        
        */
    renderAxis() {
        this.i.gi();
    }
    /**
         * If using enhanced interval management and precise interval fitting, this will reset the cached maximum label width, and recalculate using the current labels.
        
        */
    resetCachedEnhancedInterval() {
        this.i.gl();
    }
    /**
         * Scales a value from axis space into screen space.
        
        * @param unscaledValue  * The unscaled axis value to scale.
        */
    scaleValue(unscaledValue) {
        let iv = this.i.dy(unscaledValue);
        return (iv);
    }
    /**
         * This event is raised every time a render has been requested from a series.
        */
    get renderRequested() {
        if (this._renderRequested == null) {
            this._renderRequested = new EventEmitter();
            this.i.renderRequested = delegateCombine(this.i.renderRequested, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new RenderRequestedEventArgs();
                    outerArgs._provideImplementation(e);
                    this._renderRequested.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._renderRequested;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}
IgxAxisComponent.propDecorators = {
    "name": [{ type: Input },],
    "formatLabel": [{ type: Input },],
    "title": [{ type: Input },],
    "stroke": [{ type: Input },],
    "strokeThickness": [{ type: Input },],
    "strip": [{ type: Input },],
    "majorStroke": [{ type: Input },],
    "majorStrokeThickness": [{ type: Input },],
    "minorStroke": [{ type: Input },],
    "minorStrokeThickness": [{ type: Input },],
    "tickStroke": [{ type: Input },],
    "tickStrokeThickness": [{ type: Input },],
    "tickLength": [{ type: Input },],
    "isDisabled": [{ type: Input },],
    "isInverted": [{ type: Input },],
    "useEnhancedIntervalManagement": [{ type: Input },],
    "enhancedIntervalMinimumCharacters": [{ type: Input },],
    "labelTextStyle": [{ type: Input },],
    "labelTextColor": [{ type: Input },],
    "labelLocation": [{ type: Input },],
    "labelVisibility": [{ type: Input },],
    "labelShowFirstLabel": [{ type: Input },],
    "labelAngle": [{ type: Input },],
    "labelExtent": [{ type: Input },],
    "labelLeftMargin": [{ type: Input },],
    "labelRightMargin": [{ type: Input },],
    "labelTopMargin": [{ type: Input },],
    "labelBottomMargin": [{ type: Input },],
    "labelHorizontalAlignment": [{ type: Input },],
    "labelVerticalAlignment": [{ type: Input },],
    "crossingAxis": [{ type: Input },],
    "crossingValue": [{ type: Input },],
    "titlePosition": [{ type: Input },],
    "titleTextStyle": [{ type: Input },],
    "titleTextColor": [{ type: Input },],
    "titleLocation": [{ type: Input },],
    "titleVisibility": [{ type: Input },],
    "titleShowFirstLabel": [{ type: Input },],
    "titleAngle": [{ type: Input },],
    "titleExtent": [{ type: Input },],
    "titleLeftMargin": [{ type: Input },],
    "titleRightMargin": [{ type: Input },],
    "titleTopMargin": [{ type: Input },],
    "titleBottomMargin": [{ type: Input },],
    "titleHorizontalAlignment": [{ type: Input },],
    "titleVerticalAlignment": [{ type: Input },],
    "coercionMethods": [{ type: Input },],
    "expectFunctions": [{ type: Input },],
    "label": [{ type: Input },],
    "renderRequested": [{ type: Output },],
};
//# sourceMappingURL=igx-axis-component.js.map