import { FinancialCalculationDataSource } from './igx-financial-calculation-data-source';
import { FinancialCalculationSupportingCalculations } from './igx-financial-calculation-supporting-calculations';
import { List$1 } from './List$1';
import { String_$type } from './type';
/**
 * Parameterizes a financial calculation event.
*/
export class FinancialEventArgs {
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get basedOn() {
        let ret = null;
        if (this.i.basedOn) {
            ret = [];
            for (let i = 0; i < this.i.basedOn.count; i++) {
                ret.push(this.i.basedOn[i]);
            }
        }
        return ret;
    }
    set basedOn(v) {
        if (!v) {
            this.i.basedOn = null;
            return;
        }
        let list = new List$1(String_$type, 0);
        for (let i = 0; i < v.length; i++) {
            list.add(v[i]);
        }
        this.i.basedOn = list;
    }
    /**
         * The beginning position that should be calculated from.
        */
    get position() {
        return this.i.position;
    }
    /**
         * The number of positions that should be calculated from the start.
        */
    get count() {
        return this.i.count;
    }
    /**
         * The data to use for the calculation.
        */
    get dataSource() {
        if (this.i.dataSource == null) {
            return null;
        }
        if (!this.i.dataSource.externalObject) {
            let e = new FinancialCalculationDataSource();
            e._implementation = this.i.dataSource;
            this.i.dataSource.externalObject = e;
        }
        return this.i.dataSource.externalObject;
    }
    /**
         * The supporting calculations to use in the calculation.
        */
    get supportingCalculations() {
        if (this.i.supportingCalculations == null) {
            return null;
        }
        if (!this.i.supportingCalculations.externalObject) {
            let e = new FinancialCalculationSupportingCalculations();
            e._implementation = this.i.supportingCalculations;
            this.i.supportingCalculations.externalObject = e;
        }
        return this.i.supportingCalculations.externalObject;
    }
}
//# sourceMappingURL=igx-financial-event-args.js.map