import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxHorizontalAnchoredCategorySeriesComponent } from './igx-horizontal-anchored-category-series-component';
import { IgxAnchoredCategorySeriesComponent } from './igx-anchored-category-series-component';
import { IgxCategorySeriesComponent } from './igx-category-series-component';
import { IgxMarkerSeriesComponent } from './igx-marker-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { PointSeries } from "./PointSeries";
/**
 * Represents a IgxDataChartComponent point series.
*/
export const IgxPointSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }];
export class IgxPointSeriesComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PointSeries();
    }
    get i() {
        return this._implementation;
    }
    get isMarkerlessDisplayPreferred() {
        return this.i.cw;
    }
}
IgxPointSeriesComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-point-series',
                template: ``,
                providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxPointSeriesComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-point-series-component.js.map