import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxLegendBaseComponent } from './igx-legend-base-component';
import { ScaleLegend } from "./ScaleLegend";
/**
 * Represents a legend that indicates the size and the color scale for a collection of series.
*/
export const IgxScaleLegendComponent_PROVIDERS = [{ provide: IgxLegendBaseComponent, useExisting: forwardRef(() => IgxScaleLegendComponent) }];
export class IgxScaleLegendComponent extends IgxLegendBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ScaleLegend();
    }
    get i() {
        return this._implementation;
    }
}
IgxScaleLegendComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-scale-legend',
                template: ``,
                providers: [{ provide: IgxLegendBaseComponent, useExisting: forwardRef(() => IgxScaleLegendComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxScaleLegendComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-scale-legend-component.js.map