import { forwardRef, Input } from '@angular/core';
import { NumericScaleMode, NumericScaleMode_$type } from './NumericScaleMode';
import { IgxNumericAxisBaseComponent } from './igx-numeric-axis-base-component';
import { IgxAxisComponent } from './igx-axis-component';
import { ensureEnum } from "./componentUtil";
/**
 * Defines a set of basic methods and properties used to create a StraightNumeric axis.
*/
export const IgxStraightNumericAxisBaseComponent_PROVIDERS = [{ provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxStraightNumericAxisBaseComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxStraightNumericAxisBaseComponent) }];
export class IgxStraightNumericAxisBaseComponent extends IgxNumericAxisBaseComponent {
    constructor() {
        super();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Gets or sets the axis scale mode.
        */
    get scaleMode() {
        return this.i.ko;
    }
    set scaleMode(v) {
        this.i.ko = ensureEnum(NumericScaleMode_$type, v);
    }
}
IgxStraightNumericAxisBaseComponent.propDecorators = {
    "scaleMode": [{ type: Input },],
};
//# sourceMappingURL=igx-straight-numeric-axis-base-component.js.map