import { IgxCollection } from './IgxCollection';
import { markType } from './type';
import { SyncableObservableCollection$2 } from './SyncableObservableCollection$2';
import { TimeAxisBreak as TimeAxisBreak_internal } from './TimeAxisBreak';
import { TimeAxisBreak as TimeAxisBreak } from './igx-time-axis-break';
export class TimeAxisBreakCollection extends IgxCollection {
    constructor(list) {
        super();
        if (!TimeAxisBreak.$type) {
            TimeAxisBreak.$type = markType(TimeAxisBreak, "TimeAxisBreak");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!TimeAxisBreak.$type) {
            TimeAxisBreak.$type = markType(TimeAxisBreak, "TimeAxisBreak");
        }
        let coll = new SyncableObservableCollection$2(TimeAxisBreak.$type, TimeAxisBreak_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new TimeAxisBreak();
                ext._implementation = int;
            }
            return ext;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-time-axis-break-collection.js.map