import { Type } from '@angular/core';
import { IgxRect } from './IgxRect';
import { IgxPoint } from './IgxPoint';
import { IgxHorizontalAnchoredCategorySeriesComponent } from './igx-horizontal-anchored-category-series-component';
import { IgxMarkerSeriesComponent } from './igx-marker-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { WaterfallSeries } from "./WaterfallSeries";
/**
 * Represents a IgxDataChartComponent waterfall column series.
*/
export declare const IgxWaterfallSeriesComponent_PROVIDERS: ({
    provide: typeof IgxMarkerSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxWaterfallSeriesComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    protected createImplementation(): WaterfallSeries;
    readonly i: WaterfallSeries;
    constructor();
    readonly isNegativeColorSupported: boolean;
    /**
     * Gets or sets the brush to use for negative portions of the series.
    */
    negativeBrush: string;
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    */
    radiusX: number;
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    */
    radiusY: number;
    /**
     * Brush to use for outlining negative elements in the waterfall series.
    */
    negativeOutline: string;
    setNegativeColors(negativeBrush: string, negativeOutline: string): void;
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    */
    getSeriesValueBoundingBox(world: IgxPoint): IgxRect;
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    getItemSpan(): number;
}
