/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { IAxisVisualDataManager_$type } from "./IAxisVisualDataManager";
import { TextBlock } from "./TextBlock";
import { VisualExportHelper } from "./VisualExportHelper";
import { ChartTitleVisualData } from "./ChartTitleVisualData";
import { HorizontalAlignment_$type } from "./HorizontalAlignment";
import { VerticalAlignment_$type } from "./VerticalAlignment";
import { AxisTitlePosition_$type } from "./AxisTitlePosition";
import { RectData } from "./RectData";
import { AppearanceHelper } from "./AppearanceHelper";
import { AxisVisualData } from "./AxisVisualData";
import { PathVisualData } from "./PathVisualData";
import { List$1 } from "./List$1";
import { Base, EnumUtil, fromEnum, markType, getInstanceType } from "./type";
import { AxisLabelVisualData } from "./AxisLabelVisualData";
import { PointData } from "./PointData";
import { Size } from "./Size";
import { SizeData } from "./SizeData";
import { FontUtil } from "./FontUtil";
var AxisVisualDataManager = /** @class */ (function (_super) {
    tslib_1.__extends(AxisVisualDataManager, _super);
    function AxisVisualDataManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AxisVisualDataManager.prototype.c = function (a) {
        return a;
    };
    AxisVisualDataManager.prototype.d = function (a, b) {
        var c = VisualExportHelper.a(b);
        return c;
    };
    AxisVisualDataManager.prototype.a = function (a, b, c, d) {
        var e = new ChartTitleVisualData();
        var f = a.ay;
        var g = f.a1();
        e.viewport = RectData.b(g);
        var h = this.d(a, d);
        e.textPlotArea = RectData.b(h);
        var i = d._visibility == 0 && d.x != null;
        var j = a.ap.ae.d();
        var k = f.a7(d);
        var l = this.b(a, d, j);
        var m = AppearanceHelper.c(d, l);
        m.marginLeft = k.c;
        m.marginRight = k.d;
        m.marginTop = k.e;
        m.marginBottom = k.b;
        m.fontStretch = "Normal";
        m.textWrapping = "Wrap";
        m.visibility = i;
        if (a.a6 != null) {
            m.horizontalAlignment = EnumUtil.getName(HorizontalAlignment_$type, a.a6.horizontalAlignment);
            m.verticalAlignment = EnumUtil.getName(VerticalAlignment_$type, a.a6.verticalAlignment);
            m.textPosition = EnumUtil.getName(AxisTitlePosition_$type, a.a6.position);
        }
        else {
            m.horizontalAlignment = EnumUtil.getName(HorizontalAlignment_$type, (0));
            m.verticalAlignment = EnumUtil.getName(VerticalAlignment_$type, (1));
            m.textPosition = EnumUtil.getName(AxisTitlePosition_$type, (0));
        }
        e.appearance = m;
        return e;
    };
    AxisVisualDataManager.prototype.exportVisualData = function (a) {
        var b = new AxisVisualData();
        b.viewport = RectData.b(a.ib);
        b.labelsViewport = RectData.b(a.ay.a1());
        b.type = this.c(getInstanceType(a).typeName);
        b.name = a.name;
        var c = new PathVisualData(1, "axisLine", a.ay.a2);
        b.axisLine = c;
        b.tickMarks = new PathVisualData(1, "tickMarks", a.ap.ae.at);
        if (!a.ap.ab.contains(a.ap.ae.at)) {
            b.tickMarks.data.clear();
        }
        b.minorLines = new PathVisualData(1, "minorLines", a.ay.a4);
        b.majorLines = new PathVisualData(1, "majorLines", a.ay.a3);
        b.strips = new PathVisualData(1, "strips", a.ay.a5);
        if (a.fp != null) {
            var d = this.a(a, a.a9, b.type, a.gx);
            b.title = d;
        }
        else {
            b.title = null;
        }
        var e = a.a9.getFontInfo();
        if (a.as != null && a.as.textStyle != null) {
            e = a.as.f(a.a9.bk.i.af);
        }
        var f, g, h, i;
        var j = a.ap.ae.at.aj.c;
        for (var k = 1; k < j.count; k++) {
            var l = j._inner[k];
            var m = j._inner[k - 1];
            f = l.c.x - l.b.x;
            g = l.c.y - l.b.y;
            h = m.c.x - m.b.x;
            i = m.c.y - m.b.y;
            if (1 == k) {
                b.tickMarksLength = Math.sqrt(Math.pow(f, 2) + Math.pow(g, 2));
            }
        }
        var n = a.ap.a2;
        var o = a.ap.ae.g();
        var _loop_1 = function (p) {
            var q = a.ap.a2._inner[p];
            var r = a.ap.a1._inner[p];
            var s = ((function () {
                var $ret = new AxisLabelVisualData();
                $ret.labelPosition = q.a;
                $ret.labelValue = r;
                $ret.panelPosition = PointData.b(a.ay.ay());
                return $ret;
            })());
            var t = new List$1(TextBlock.$, 0);
            try {
                for (var _a = tslib_1.__values(fromEnum(o)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var u = _b.value;
                    t.add(u);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_1) throw e_1.error; }
            }
            if (p < t.count) {
                var v = this_1.b(a, t._inner[p], e);
                s.appearance = AppearanceHelper.c(t._inner[p], v);
                var w = a.bg.a._inner[p];
                s.position = PointData.b(a.ay.ax(w));
                s.size = SizeData.b(new Size(1, w.m, w.l));
            }
            b.labels.add(s);
            var e_1, _c;
        };
        var this_1 = this;
        for (var p = 0; p < n.count; p++) {
            _loop_1(p);
        }
        return b;
    };
    AxisVisualDataManager.prototype.b = function (a, b, c) {
        return FontUtil.getFontInfo(a.a9.bk.i.af, b, c);
    };
    AxisVisualDataManager.$t = markType(AxisVisualDataManager, 'AxisVisualDataManager', Base.$, [IAxisVisualDataManager_$type]);
    return AxisVisualDataManager;
}(Base));
export { AxisVisualDataManager };
//# sourceMappingURL=AxisVisualDataManager.js.map