/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "./ArgumentNullException";
import { Rect } from "./Rect";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { ScalerParams } from "./ScalerParams";
import { Series } from "./Series";
import { Base, typeCast, Type, markType, Array_$type, Number_$type, Point_$type, enumGetBox, runOn, fromEnum } from "./type";
import { truncate, intDivide, isNaN_, isInfinity } from "./number";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { List$1 } from "./List$1";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { IProvidesViewport_$type } from "./IProvidesViewport";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { PreparationParams } from "./PreparationParams";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { DefaultCategoryTrendlineHost } from "./DefaultCategoryTrendlineHost";
import { DefaultSingleValueProvider } from "./DefaultSingleValueProvider";
import { SingleValuesHolder } from "./SingleValuesHolder";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager_$type } from "./ICategorySeriesInteractionManager";
import { DVContainer } from "./DVContainer";
import { DependencyProperty } from "./DependencyProperty";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { Marker } from "./Marker";
import { Pool$1 } from "./Pool$1";
import { Clipper } from "./Clipper";
import { PropertyMetadata } from "./PropertyMetadata";
import { MarkerSeriesView } from "./MarkerSeriesView";
var CategoryBucketCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(CategoryBucketCalculator, _super);
    function CategoryBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.e = 0;
        _this.f = 0;
        _this.d = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        _this.c = a;
        _this.e = -1;
        _this.d = 0;
        return _this;
    }
    CategoryBucketCalculator.prototype.getBucket = function (a) {
        return null;
    };
    CategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    CategoryBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    CategoryBucketCalculator.prototype.g = function (a) {
        var b = this.c.bq;
        var c = this.c.bp;
        var d = this.c.cn;
        var e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
        var f = d.by;
        if (b.isEmpty || c.isEmpty || e == null || f == null || f.count == 0) {
            this.d = 0;
            return;
        }
        var g = d.getEffectiveViewport1(this.c);
        var h = d.k5(this.c);
        var i = typeCast(ISortingAxis_$type, e);
        if (i == null || i.i$b == null) {
            var j = new ScalerParams(0, b, c, e.bz, g);
            var k = Math.floor(e.dn(h.left, j, 0));
            var l = Math.ceil(e.dn(h.right, j, 0));
            if (e.bz) {
                l = Math.ceil(e.dn(h.left, j, 0));
                k = Math.floor(e.dn(h.right, j, 0));
            }
            var m = Math.floor((l - k + 1) * a / h.width);
            this.d = truncate(Math.max(1, m));
            this.e = truncate(Math.max(0, Math.floor(k / this.d) - 1));
            this.f = truncate(Math.ceil(l / this.d));
        }
        else {
            this.e = i.i$e(b, c, g, h);
            this.f = i.i$g(b, c, g, h);
            this.d = 1;
        }
    };
    CategoryBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.e;
        b = this.f;
        c = this.d;
        d = this.c.cn.ej;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    CategoryBucketCalculator.prototype.cacheValues = function () {
    };
    CategoryBucketCalculator.prototype.unCacheValues = function () {
    };
    CategoryBucketCalculator.$t = markType(CategoryBucketCalculator, 'CategoryBucketCalculator', Base.$, [IBucketizer_$type]);
    return CategoryBucketCalculator;
}(Base));
export { CategoryBucketCalculator };
var CategoryFramePreparerBase = /** @class */ (function (_super) {
    tslib_1.__extends(CategoryFramePreparerBase, _super);
    function CategoryFramePreparerBase(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        var f = d[0];
                        var g = d[1];
                        var h = d[2];
                        var i = d[3];
                        var j = d[4];
                        _this = _super.call(this, 1, g, h, i) || this;
                        _this.g = null;
                        _this.h = null;
                        _this.m = false;
                        _this.o = new List$1(Array_$type, 0);
                        _this.p = new List$1(Number_$type, 0);
                        _this.n = new List$1(Number_$type, 0);
                        _this.h = f;
                        _this.g = j;
                    }
                    _this.g = null;
                    _this.h = null;
                    _this.m = false;
                    _this.o = new List$1(Array_$type, 0);
                    _this.p = new List$1(Number_$type, 0);
                    _this.n = new List$1(Number_$type, 0);
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    _this = _super.call(this, 1, d, e, f) || this;
                    _this.g = null;
                    _this.h = null;
                    _this.m = false;
                    _this.o = new List$1(Array_$type, 0);
                    _this.p = new List$1(Number_$type, 0);
                    _this.n = new List$1(Number_$type, 0);
                    _this.h = c;
                    _this.g = g;
                }
                break;
        }
        return _this;
    }
    CategoryFramePreparerBase.prototype.i = function (a) {
        var b = new PreparationParams();
        b.f = this.h.useHighMarkerFidelity;
        b.b = this.h.scaler;
        b.c = this.h.yScaler;
        b.d = typeCast(ISortingAxis_$type, b.b);
        b.a = typeCast(CategoryFrame.$, a);
        if (b.a == null || b.b == null || b.c == null) {
            return null;
        }
        var c;
        var d;
        var e;
        var f;
        var g = this.g.getBucketInfo(c, d, e, f);
        c = g.p0;
        d = g.p1;
        e = g.p2;
        f = g.p3;
        b.i = c;
        b.j = d;
        b.h = e;
        b.g = f;
        if (b.j < b.i) {
            return null;
        }
        var h;
        var i;
        var j;
        var k = this.a.getViewInfo(i, h);
        i = k.p0;
        h = k.p1;
        j = this.a.getEffectiveViewport();
        b.m = h;
        b.l = i;
        b.k = j;
        if (Rect.l_op_Equality(b.m, Rect.empty) || Rect.l_op_Equality(b.l, Rect.empty)) {
            return null;
        }
        if (this.h != null && (typeCast(Series.$, this.h) !== null && this.h.cq) && this.g != null) {
            b.e = true;
        }
        return b;
    };
    CategoryFramePreparerBase.prototype.r = function (a, b, c, d) {
        return a.getOffset(b, c, d, this.h.currentMode2Index, this.h.currentCategoryMode);
    };
    CategoryFramePreparerBase.prototype.s = function (a) {
        return this.r(a.b, a.m, a.l, a.k);
    };
    CategoryFramePreparerBase.prototype.d = function (a, b) {
        var c = this.i(a);
        if (c == null || this.g == null) {
            return;
        }
        c.a.f.clear();
        c.a.k.clear();
        c.a.m.clear();
        c.a.p.clear();
        c.a.i.clear();
        c.a.h.clear();
        c.a.g.clear();
        var d = this.c.shouldDisplayMarkers;
        var e = false;
        var f = this.s(c);
        var g = this.j(c);
        if (c.d != null && c.d.i$b != null && c.d.i$b.count != g.e) {
            return;
        }
        if (c.d != null && c.d.i$a) {
            c.d.i$h();
        }
        this.g.cacheValues();
        if (this.m && c.d != null && c.d.i$b.count > 0) {
            var h = c.d.i$b._inner[c.i];
            this.z(g, h, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.i > 0) {
                c.i = c.i - 1;
                h = c.d.i$b._inner[c.i];
                this.z(g, h, true, c.e);
            }
            var i = c.d.i$b._inner[c.j];
            this.z(g, i, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.j < g.e - 1) {
                c.j = c.j + 1;
                i = c.d.i$b._inner[c.j];
                this.z(g, i, true, c.e);
            }
        }
        if (this.m && c.d == null) {
            var j = c.i;
            var k = this.g.getBucket(j);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.i > 0) {
                c.i = c.i - 1;
                j = c.i;
                k = this.g.getBucket(j);
            }
            var l = c.j;
            k = this.g.getBucket(l);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.j < (intDivide(g.e, c.h))) {
                c.j = c.j + 1;
                l = c.j;
                k = this.g.getBucket(l);
            }
        }
        this.w(c, g, f);
        var m = this.t(c, g, f, d, e);
        this.c.updateMarkerCount(m);
        this.v(typeCast(CategoryFrame.$, a), b);
        this.g.unCacheValues();
        return;
    };
    CategoryFramePreparerBase.prototype.v = function (a, b) {
    };
    Object.defineProperty(CategoryFramePreparerBase.prototype, "q", {
        get: function () {
            return this.o;
        },
        enumerable: true,
        configurable: true
    });
    CategoryFramePreparerBase.prototype.t = function (a, b, c, d, e) {
        var _this = this;
        var f = 0;
        var g = false;
        var h = null;
        var i = false;
        var j = a.d != null;
        var k = a.m;
        var l = a.l;
        var m = typeCast(NumericAxisBase.$, a.c) !== null && a.c.i6;
        var n = a.f;
        var o = this.h.mayContainUnknowns;
        var p = this.o;
        var q = this.n;
        var r = this.p;
        p.clear();
        q.clear();
        r.clear();
        var s = this.g;
        var t = this.h.provideCollisionDetector();
        var u = 0;
        var v = a.k;
        var w = new ScalerParams(0, k, l, a.b.j$a, v);
        var x = ((function () {
            var $ret = new ScalerParams(0, k, l, a.c.j$a, v);
            $ret.b = typeCast(Series.$, _this.h) !== null ? _this.h.d8() : NaN;
            return $ret;
        })());
        if (j) {
            u = a.b.j$c(2, w) - a.b.j$c(1, w);
            i = this.k();
        }
        var y = a.i;
        var z = a.j;
        var aa = a.a.f;
        var ab = typeCast(IDateTimeAxis_$type, a.b);
        if (ab != null) {
            ab.StartTimeCursor();
        }
        var _loop_1 = function (ac) {
            var ad = void 0;
            if (!j) {
                if (!o) {
                    ad = s.getBucketWithoutUnknowns(ac);
                }
                else {
                    ad = s.getBucket(ac);
                }
            }
            else {
                ad = ((function () { var ae = _this.f(a, ac, b, u, g, h, c); ac = ae.p1; g = ae.p4; h = ae.p5; return ae.ret; })());
            }
            var ae = !m || (m && ad[1] > 0);
            var af = ad[0];
            if (!j || !isNaN_(ad[0])) {
                aa.add(ad);
                if (g && i) {
                    if (h != null) {
                        aa.add(h);
                    }
                }
                if (d && ae) {
                    var ag = ac * a.h;
                    var ah = ag;
                    if (j && a.d.i$b != null && ag >= 0 && ag < a.d.i$b.count) {
                        ag = a.d.i$b._inner[ag];
                    }
                    var ai = new Array(ad.length);
                    ai[0] = ad[0];
                    ai[1] = ad[1];
                    ai[2] = ad[2];
                    if (n && ag < b.e) {
                        ai = new Array(ad.length);
                        ai[0] = af;
                        this_1.z(b, ag, true, a.e);
                        ai[1] = b.c;
                        ai[2] = b.d;
                    }
                    p.add(ai);
                    q.add(a.a.f.count - 1);
                    r.add(ag);
                }
            }
            out_ac_1 = ac;
        };
        var this_1 = this, out_ac_1;
        for (var ac = y; ac <= z; ++ac) {
            _loop_1(ac);
            ac = out_ac_1;
        }
        if (ab != null) {
            ab.ResetTimeCursor();
        }
        this.y(a, c, j, w, x, e, d);
        if (d) {
            var aj = p.count;
            var ak = void 0;
            for (var al = 0; al < aj; al++) {
                ak = p._inner[al];
                if (this.l(a.a, ak, t, Math.min(r._inner[al], b.e - 1), f, q._inner[al])) {
                    ++f;
                }
            }
        }
        return f;
    };
    CategoryFramePreparerBase.prototype.k = function () {
        if (typeCast(Series.$, this.h) !== null) {
            return this.h.ci;
        }
        return false;
    };
    CategoryFramePreparerBase.prototype.f = function (a, b, c, d, e, f, g) {
        var h;
        f = null;
        e = false;
        var i = typeCast(CategorySeries.$, this.h);
        var j = a.l;
        var k = a.m;
        var l = a.k;
        var m = new ScalerParams(0, k, j, a.b.j$a, l);
        var n = new ScalerParams(0, k, j, a.c.j$a, l);
        var o = a.e;
        if (a.d == null || a.d.i$b == null || a.d.i$b.count == 0) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        if (i != null && i.by != null && i.by.count < a.d.i$b.count) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        var p = a.d.i$b._inner[b];
        var q = a.d.i$d(p);
        var r = q;
        this.z(c, p, false, o);
        while (b < a.j) {
            p = a.d.i$b._inner[b + 1];
            r = a.d.i$d(p);
            this.z(c, p, true, o);
            if (r - q >= d || isNaN_(c.c) || isNaN_(c.d)) {
                if (e) {
                    var s = a.d.i$b._inner[b];
                    this.z(c, s, true, o);
                    f = [a.b.j$b(q, m), c.c, c.d];
                }
                break;
            }
            if (!e && this.k()) {
                var t = a.d.i$b._inner[b];
                this.z(c, t, true, o);
                var u = [a.b.j$b(q, m), c.c, c.d];
                if (!isNaN_(u[0])) {
                    if (!isNaN_(u[1]) && !isNaN_(u[2])) {
                        if (a.d != null) {
                            u[0] = u[0] + g;
                        }
                        a.a.f.add(u);
                        e = true;
                    }
                    else {
                        break;
                    }
                }
            }
            b++;
            this.u(c, p, o);
        }
        var v = NaN;
        if (!isNaN_(q)) {
            v = a.b.j$b(q, m);
        }
        h = this.e(v, c);
        return {
            ret: h,
            p1: b,
            p4: e,
            p5: f
        };
    };
    CategoryFramePreparerBase.prototype.y = function (a, b, c, d, e, f, g) {
        var h = a.h;
        var i = a.a.f.count;
        var j = a.a.f;
        var k = this.o;
        var l = k.count;
        if (f) {
            var m = a.c.j$b(a.c.jq, e);
            a.c.j$e(a.a.k, 0, a.a.k.count, e);
            var n = a.a.k;
            var o = n.count;
            for (var p = 0; p < n.count; p++) {
                n._inner[p] = Math.abs(n._inner[p] - m);
            }
        }
    };
    CategoryFramePreparerBase.prototype.w = function (a, b, c) {
    };
    CategoryFramePreparerBase.$t = markType(CategoryFramePreparerBase, 'CategoryFramePreparerBase', FramePreparer.$);
    return CategoryFramePreparerBase;
}(FramePreparer));
export { CategoryFramePreparerBase };
var CategoryFramePreparer = /** @class */ (function (_super) {
    tslib_1.__extends(CategoryFramePreparer, _super);
    function CategoryFramePreparer(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        var f = d[0];
                        var g = d[1];
                        var h = d[2];
                        var i = d[3];
                        var j = d[4];
                        _this = _super.call(this, 1, f, g, h, i, j) || this;
                        _this.aa = null;
                        _this.ab = null;
                        _this.aa = new DefaultCategoryTrendlineHost();
                        if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                            _this.aa = typeCast(IHasCategoryTrendline_$type, f);
                        }
                        _this.ab = new DefaultSingleValueProvider();
                        if (typeCast(IHasSingleValueCategory_$type, f) !== null) {
                            _this.ab = typeCast(IHasSingleValueCategory_$type, f);
                        }
                    }
                    _this.aa = null;
                    _this.ab = null;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    _this = _super.call(this, 1, c, d, e, f, g) || this;
                    _this.aa = null;
                    _this.ab = null;
                    _this.aa = new DefaultCategoryTrendlineHost();
                    if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                        _this.aa = typeCast(IHasCategoryTrendline_$type, c);
                    }
                    _this.ab = new DefaultSingleValueProvider();
                    if (typeCast(IHasSingleValueCategory_$type, c) !== null) {
                        _this.ab = typeCast(IHasSingleValueCategory_$type, c);
                    }
                }
                break;
        }
        return _this;
    }
    CategoryFramePreparer.prototype.l = function (a, b, c, d, e, f) {
        var g = b[0];
        var h = b[1];
        var i = new Rect(0, g - 5, h - 5, 11, 11);
        if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
            a.m.add({ $type: Point_$type, x: g, y: h });
            this.c.updateMarkerTemplate(e, d, f);
            return true;
        }
        return false;
    };
    CategoryFramePreparer.prototype.j = function (a) {
        var b = new SingleValuesHolder();
        var c = this.ab.valueColumn;
        b.f = c;
        return b;
    };
    CategoryFramePreparer.prototype.x = function (a, b, c, d, e, f) {
        if (d) {
            b[0] = b[0] + c;
        }
        else {
            b[0] = a.b.j$b(b[0], e) + c;
        }
        b[1] = a.c.j$b(b[1], f);
        if (a.h > 1 || d) {
            b[2] = a.c.j$b(b[2], f);
        }
        else {
            b[2] = b[1];
        }
    };
    CategoryFramePreparer.prototype.y = function (a, b, c, d, e, f, g) {
        _super.prototype.y.call(this, a, b, c, d, e, f, g);
        var h = a.h;
        var i = a.a.f.count;
        var j = a.a.f;
        var k = this.q;
        var l = k.count;
        var m = new List$1(Number_$type, 0);
        if (!c) {
            m.add(0);
        }
        var n = new List$1(Number_$type, 0);
        n.add(1);
        if (c || h > 1) {
            n.add(2);
        }
        a.b.j$d(j, m, 0, i, d);
        a.c.j$d(j, n, 0, i, e);
        for (var o = 0; o < i; o++) {
            j._inner[o][0] = j._inner[o][0] + b;
        }
        if (h == 1 && !c) {
            for (var p = 0; p < i; p++) {
                j._inner[p][2] = j._inner[p][1];
            }
        }
        if (g) {
            a.b.j$d(k, m, 0, l, d);
            a.c.j$d(k, n, 0, l, e);
            for (var q = 0; q < l; q++) {
                k._inner[q][0] = k._inner[q][0] + b;
            }
            if (h == 1 && !c) {
                for (var r = 0; r < l; r++) {
                    k._inner[r][2] = k._inner[r][1];
                }
            }
        }
    };
    CategoryFramePreparer.prototype.w = function (a, b, c) {
        if (this.aa.trendLineType == 0 || this.aa.trendlinePreparer == null || this.aa.trendLinePeriod < 1) {
            return;
        }
        this.aa.trendlinePreparer.prepareLine(this.aa, a, b, c);
    };
    CategoryFramePreparer.prototype.z = function (a, b, c, d) {
        var e = a;
        var f = e.f;
        var g = f.item(b);
        var h = g;
        if (d) {
            var i = this.g.getBucket(b);
            g = i[1];
            h = i[1];
        }
        if (c) {
            e.c = g;
            e.d = h;
        }
        else {
            e.a = g;
            e.b = h;
        }
    };
    CategoryFramePreparer.prototype.u = function (a, b, c) {
        var d = a;
        var e = d.f;
        if (b < e.count) {
            var f = void 0;
            if (c) {
                var g = this.g.getBucket(b);
                f = g[1];
            }
            else {
                f = e.item(b);
            }
            d.a = Math.min(d.a, f);
            d.b = Math.max(d.b, f);
        }
    };
    CategoryFramePreparer.prototype.e = function (a, b) {
        var c = b;
        return [a, c.a, c.b];
    };
    CategoryFramePreparer.$t = markType(CategoryFramePreparer, 'CategoryFramePreparer', CategoryFramePreparerBase.$);
    return CategoryFramePreparer;
}(CategoryFramePreparerBase));
export { CategoryFramePreparer };
var CategorySeries = /** @class */ (function (_super) {
    tslib_1.__extends(CategorySeries, _super);
    function CategorySeries() {
        var _this = _super.call(this) || this;
        _this.mq = null;
        _this.m3 = null;
        _this.m7 = false;
        _this.m6 = false;
        _this.assigningCategoryStyle = null;
        _this.assigningCategoryMarkerStyle = null;
        _this.m1 = null;
        _this.m2 = null;
        _this.mn = new CategoryFrame(3);
        _this.mp = new CategoryFrame(3);
        _this.mm = new CategoryFrame(3);
        _this.mo = new CategoryFrame(3);
        _this.mt = null;
        _this.mx = null;
        _this.n9 = null;
        _this.mt = new CategorySeriesRenderManager();
        _this.mx = new CategoryTransitionSourceFramePreparer();
        _this.n9 = new Rect(0, 0, 0, 1, 1);
        _this.m7 = false;
        _this.m6 = false;
        _this.ab = CategorySeries.$;
        return _this;
    }
    CategorySeries.prototype.be = function () {
        var a = new CategorySeriesView(this);
        return a;
    };
    Object.defineProperty(CategorySeries.prototype, "m4", {
        get: function () {
            var _this = this;
            if (this.m3 == null) {
                this.m3 = DVContainer.instance.createInstance(ICategorySeriesInteractionManager_$type, function () { return _this.b1.n; });
            }
            return this.m3;
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.h9 = function (a) {
        _super.prototype.h9.call(this, a);
        this.mu = a;
    };
    CategorySeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    Object.defineProperty(CategorySeries.prototype, "categoryAxis", {
        get: function () {
            return this.ml();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.ml = function () {
        return this.fetchXAxis();
    };
    CategorySeries.prototype.m5 = function () {
        return this.fetchYAxis();
    };
    CategorySeries.prototype.get_cj = function () {
        return true;
    };
    Object.defineProperty(CategorySeries.prototype, "cj", {
        get: function () {
            return this.get_cj();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.mu.cl.g(this.ej);
    };
    CategorySeries.prototype.ne = function () {
        return (this.assigningCategoryStyle != null && this.m7) || this.cs;
    };
    CategorySeries.prototype.nf = function () {
        return (this.assigningCategoryMarkerStyle != null && this.m6) || this.cs;
    };
    CategorySeries.prototype.n1 = function (a) {
        if (this.assigningCategoryStyle != null && this.m7) {
            this.assigningCategoryStyle(this, a);
        }
    };
    CategorySeries.prototype.n0 = function (a) {
        if (this.assigningCategoryMarkerStyle != null && this.m6) {
            this.assigningCategoryMarkerStyle(this, a);
        }
    };
    CategorySeries.prototype.mf = function (a, b) {
        return null;
    };
    CategorySeries.prototype.he = function (a, b) {
        _super.prototype.he.call(this, a, b);
        if (a) {
            this.nv(b);
        }
    };
    CategorySeries.prototype.a7 = function () {
        var a = _super.prototype.a7.call(this);
        return a;
    };
    CategorySeries.prototype.ht = function () {
        _super.prototype.ht.call(this);
        var a = this.fetchXAxis();
        if (a != null) {
            a.gj(false);
        }
        var b = this.fetchYAxis();
        if (b != null) {
            b.gj(false);
        }
    };
    CategorySeries.prototype.i8 = function (a, b) {
        _super.prototype.i8.call(this, a, b);
        this.mu.cl.g(this.ej);
        this.it(false);
    };
    CategorySeries.prototype.i7 = function (a, b) {
        if (this.di && this.eo < 0.05 && (this.br == null || !this.br.c2())) {
            this.dj = true;
        }
        _super.prototype.i7.call(this, a, b);
        this.mu.cl.g(this.ej);
        this.it(false);
    };
    CategorySeries.prototype.ie = function (a, b, c, d) {
        _super.prototype.ie.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                var e = this.fetchYAxis();
                var f = this.fetchXAxis();
                if (c != null && d == null) {
                    this.hi(f);
                    this.hi(e);
                }
                if (c == null && d != null) {
                    this.ik(f);
                    this.ik(e);
                }
                this.mu.cl.g(this.ej);
                this.it(false);
                break;
            case "SyncLink":
                if (this.bm != null && this.br != null) {
                    this.mu.cl.g(this.ej);
                }
                this.it(false);
                break;
            case "TransitionProgress":
                this.mp.c(this.eo, this.mn, this.mm);
                if (this.cb(this.bh)) {
                    return;
                }
                if (this.eo == 1) {
                    this.mm.v();
                    this.n2(this.mm, this.mu);
                    if (this.di) {
                        this.di = false;
                        this.hf();
                        this.bs.r = truncate(this.eg());
                        this.bs.b = this.bt;
                    }
                }
                else {
                    this.n2(this.mp, this.mu);
                }
                break;
            case "ErrorBarSettings":
                this.h1();
                break;
            case CategorySeries.$$p[4]:
                this.it(false);
                break;
            case CategorySeries.$$p[1]:
                this.m7 = this.m9();
                this.it(false);
                break;
            case CategorySeries.$$p[0]:
                this.m6 = this.m8();
                this.it(false);
                break;
        }
    };
    CategorySeries.prototype.m9 = function () {
        return this.nc;
    };
    CategorySeries.prototype.m8 = function () {
        return this.nb;
    };
    CategorySeries.prototype.nk = function (a) {
        return this.d4(a, this.fetchXAxis());
    };
    CategorySeries.prototype.get_cz = function () {
        return typeCast(ISortingAxis_$type, this.ml()) !== null;
    };
    Object.defineProperty(CategorySeries.prototype, "cz", {
        get: function () {
            return this.get_cz();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.ao = function () {
        return this.ml();
    };
    CategorySeries.prototype.ez = function (a) {
        return this.m4.b$d(this, a);
    };
    CategorySeries.prototype.fe = function (a) {
        return this.m4.b$f(this, a);
    };
    CategorySeries.prototype.ex = function (a) {
        var b = truncate(Math.round(this.d2(a)));
        return b;
    };
    CategorySeries.prototype.d2 = function (a) {
        return this.m4.b$c(this, a);
    };
    CategorySeries.prototype.get_na = function () {
        return false;
    };
    Object.defineProperty(CategorySeries.prototype, "na", {
        get: function () {
            return this.get_na();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.at = function (a, b) {
        var c = this.m0(a, b, this.m2);
        this.m2 = c;
        return c;
    };
    CategorySeries.prototype.get_ct = function () {
        return true;
    };
    Object.defineProperty(CategorySeries.prototype, "ct", {
        get: function () {
            return this.get_ct();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.as = function (a, b) {
        if (this.na) {
            var c = this.mz(a, b, this.m1);
            this.m1 = c;
            return c;
        }
        else {
            var d = this.my(a, b, this.m1);
            this.m1 = d;
            return d;
        }
    };
    CategorySeries.prototype.nj = function () {
        return this.mu.co.a;
    };
    CategorySeries.prototype.m0 = function (a, b, c) {
        if (!this.li()) {
            return null;
        }
        var d = this.mm;
        if (this.b9()) {
            d = this.mp;
        }
        var e = this.nj();
        return this.m4.b$b(this, e, d.f, a, b, c);
    };
    CategorySeries.prototype.mz = function (a, b, c) {
        var d = this.mu.cl.e;
        var e = this.mu.cl.f;
        var f = this.mu.cl.d;
        var g = this.mm;
        if (this.b9()) {
            g = this.mp;
        }
        return this.m4.b$a(this, g.f, d, e, f, a, b, c);
    };
    CategorySeries.prototype.my = function (a, b, c) {
        var d = new HighlightingInfo();
        d.b = this;
        d.f = 0;
        d.e = this.by.count - 1;
        if (c != null && c.f == d.f && c.e == d.e) {
            return c;
        }
        return d;
    };
    CategorySeries.prototype.nx = function (a, b, c, d, e, f) {
        var g = this.b8;
        this.mt.ab(a, b, c, d, e, f, g);
        var h = this.mt.b;
        var i = null;
        var j = this.by;
        if (g && this.br != null) {
            i = this.br.az.getHighlightingInfo(this, j, d, h.m, h.l, true);
            h.b = i;
        }
        h.f = f;
        this.n0(h);
        this.mt.z(i, f, g);
    };
    CategorySeries.prototype.ny = function (a, b, c, d, e, f) {
        var g = this.b8;
        this.mt.ac(a, b, c, d, e, f, g);
        var h = this.mt.c;
        var i = null;
        var j = this.by;
        if (g && this.br != null) {
            i = this.br.az.getHighlightingInfo(this, j, d, h.m, h.l, false);
            h.b = i;
        }
        h.f = f;
        this.n1(h);
        this.mt.aa(i, f, g);
    };
    CategorySeries.prototype.ds = function (a, b, c) {
        var d = _super.prototype.ds.call(this, a, b, c);
        d = d && this.ni(this.fetchXAxis());
        d = d && this.ni(this.fetchYAxis());
        var e = c;
        if (!c.l() || b.isEmpty || a.isEmpty || this.by == null) {
            d = false;
        }
        if (!d) {
            e.cl.d = 0;
        }
        return d;
    };
    CategorySeries.prototype.ni = function (a) {
        if (a == null || a.a9 == null) {
            return false;
        }
        var b = typeCast(CategoryAxisBase.$, a);
        if (b != null) {
            if (b.itemsSource == null) {
                return false;
            }
            if (b.ja < 1) {
                return false;
            }
        }
        else {
            var c = typeCast(NumericAxisBase.$, a);
            if (c != null) {
                return c.jg != c.jf;
            }
        }
        return true;
    };
    CategorySeries.prototype.c8 = function () {
        return this.nd;
    };
    CategorySeries.prototype.mv = function () {
        return 12;
    };
    CategorySeries.prototype.hf = function () {
        _super.prototype.hf.call(this);
        this.mn.v();
        this.mm.v();
        this.mp.v();
    };
    CategorySeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.mu.cl.g(this.ej);
        if (this.cb(this.bh)) {
            this.mm.y();
            this.mp.y();
            this.mn.y();
            return;
        }
        if (this.da) {
            if (this.b9()) {
                if (this.bs.g) {
                    this.bs.t();
                }
                this.n2(this.mp, this.mu);
            }
            else {
                this.n2(this.mm, this.mu);
            }
            return;
        }
        if (this.c6(a)) {
            var b = this.mn;
            if (this.b9()) {
                if (this.bs.g) {
                    this.bs.t();
                }
                this.mn = this.mp;
                this.mp = b;
            }
            else {
                this.mn = this.mm;
                this.mm = b;
            }
            this.nz(this.mm, this.mu);
            if (this.dk) {
                this.bs.w();
                this.bs.r = truncate(this.eh());
                this.bs.b = this.bu != null ? this.bu : this.bt;
                this.mx.p(this.mn, this.mm, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.mw, this.mv(), this.bo, this.bn(), runOn(this, this.nl), this.mu.bp);
            }
            this.hb();
            this.i1();
            if (this.dk) {
                this.dj = false;
                this.di = true;
            }
        }
        else {
            this.nz(this.mm, this.mu);
            this.n2(this.mm, this.mu);
        }
    };
    CategorySeries.prototype.bn = function () {
        return 3;
    };
    CategorySeries.prototype.nl = function () {
        if (this.isVertical) {
            return this.ld.left;
        }
        return this.ld.bottom;
    };
    CategorySeries.prototype.no = function () {
        var a = 0;
        var b = this.fetchXAxis();
        try {
            for (var _a = tslib_1.__values(fromEnum(this.br.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var c = _b.value;
                if (c == this) {
                    return a;
                }
                var d = typeCast(CategorySeries.$, c);
                if (d != null) {
                    var e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
                    if (e == b && d.preferredCategoryMode(e) == 2) {
                        a++;
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return -1;
        var e_1, _c;
    };
    Object.defineProperty(CategorySeries.prototype, "GetErrorBarsXAxis", {
        get: function () {
            return this.fetchXAxis();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategorySeries.prototype, "GetErrorBarsYAxis", {
        get: function () {
            return this.fetchYAxis();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.nw = function (a, b) {
        this.mt.w(this, this.nf(), runOn(this, this.mf), this.nm(a), this.nn(a));
        var c = this.mt.b;
        var d = c != null;
        var e = this.ml();
        if (e == null) {
            return;
        }
        var f = this.getEffectiveViewport1(a);
        var g = new ScalerParams(0, a.bq, a.bp, e.bz, f);
        var h = this.by == null ? 0 : this.by.count;
        var i = a;
        var j = b.f;
        var k = i.cl.e;
        var l = i.cl.f;
        var m = i.cl.d;
        var n = k * m;
        for (var o = 0; o < a.co.count; o++) {
            var p = a.co.item(o);
            var q = p.content;
            if (d) {
                var r = p.al;
                this.nx(j, r, h, e, g, a.n);
            }
            this.mt.ad(p, q);
        }
    };
    CategorySeries.prototype.n2 = function (a, b) {
        this.k4 = a.aa;
        b.ar();
    };
    Object.defineProperty(CategorySeries.prototype, "oa", {
        get: function () {
            return this.n9;
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.nz = function (a, b) {
        a.u();
    };
    CategorySeries.prototype.nm = function (a) {
        return a.cl.d;
    };
    CategorySeries.prototype.nn = function (a) {
        return a.cl.e;
    };
    CategorySeries.prototype.nv = function (a) {
        var b = a;
        b.co.count = 0;
    };
    CategorySeries.prototype.iv = function (a, b) {
        _super.prototype.iv.call(this, a, b);
        if (!this.dh) {
            this.bh.az(b);
            return;
        }
        var c = typeCast(CategorySeriesView.$, this.bg);
        c.cl.g(this.ej);
        this.bh.az(b);
        if (this.cb(this.bg)) {
            return;
        }
        this.n3();
        this.dh = false;
    };
    CategorySeries.prototype.n3 = function () {
        var a = typeCast(CategorySeriesView.$, this.bg);
        if (!this.db) {
            this.nz(this.mo, a);
        }
        this.db = false;
        this.n2(this.mo, a);
    };
    CategorySeries.prototype.mr = function (a) {
        var b = typeCast(CategorySeriesView.$, a);
        if (b != null && b.n) {
            if (b.m) {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), b, this, b.cl);
            }
            else {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), this.br.bk.m, this, b.cl);
            }
        }
        else {
            return this.mq;
        }
    };
    CategorySeries.prototype.al = function (a) {
        if (this.fetchXAxis() == a) {
            return this.fetchYAxis();
        }
        if (this.fetchYAxis() == a) {
            return this.fetchXAxis();
        }
        return null;
    };
    CategorySeries.mg = function (a, b, c, d, e) {
        var f = null;
        if (b > -1 && !d.isEmpty && !c.isEmpty) {
            var g = a._inner[0][0] < c.left - 2000 ? c.left - 10 : NaN;
            var h = c.bottom + 10;
            var i = a._inner[b][0] > c.right + 2000 ? c.right + 10 : NaN;
            var j = c.top - 10;
            f = new Clipper(1, g, h, i, j, e);
        }
        return f;
    };
    CategorySeries.$t = markType(CategorySeries, 'CategorySeries', MarkerSeries.$, [IHasCategoryModePreference_$type, ISupportsErrorBars_$type]);
    return CategorySeries;
}(MarkerSeries));
export { CategorySeries };
Type.dep(DependencyProperty, PropertyMetadata, CategorySeries, 'raisePropertyChanged', ['IsCustomCategoryMarkerStyleAllowed:nb:n4', [0, false], 'IsCustomCategoryStyleAllowed:nc:n5', [0, false], 'IsTransitionInEnabled:nd:n6', [0, false], 'TransitionInMode:mw:n7', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'UseHighMarkerFidelity:nh:n8', [0, false]]);
var CategorySeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(CategorySeriesView, _super);
    function CategorySeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cn = null;
        _this.cq = 0;
        _this.cl = null;
        _this.co = null;
        _this.cq = -1;
        _this.cn = a;
        _this.cl = _this.cm();
        _this.co = ((function () {
            var $ret = new Pool$1(Marker.$);
            $ret.create = runOn(_this, _this.bv);
            $ret.activate = runOn(_this, _this.ce);
            $ret.disactivate = runOn(_this, _this.cg);
            $ret.destroy = runOn(_this, _this.cf);
            return $ret;
        })());
        return _this;
    }
    CategorySeriesView.prototype.cp = function (a) {
        if (this.cq != a.t) {
            return true;
        }
        return false;
    };
    CategorySeriesView.prototype.cs = function (a) {
        this.cq = a.t;
    };
    CategorySeriesView.prototype.updateMarkerTemplate = function (a, b, c) {
        if (!this.bw.lk) {
            var d = this.co.item(a);
            var e = d.content;
            e.item = this.e.by.item(b);
            d.ak = b;
            d.al = c;
        }
    };
    CategorySeriesView.prototype.cm = function () {
        return new CategoryBucketCalculator(this);
    };
    Object.defineProperty(CategorySeriesView.prototype, "shouldDisplayMarkers", {
        get: function () {
            return this.cn.li();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeriesView.prototype.updateMarkerCount = function (a) {
        this.co.count = a;
    };
    CategorySeriesView.prototype.ca = function (a) {
        this.co.c(a);
    };
    CategorySeriesView.prototype.cr = function () {
    };
    CategorySeriesView.$t = markType(CategorySeriesView, 'CategorySeriesView', MarkerSeriesView.$, [ISupportsMarkers_$type]);
    return CategorySeriesView;
}(MarkerSeriesView));
export { CategorySeriesView };
/*<BeginStatics Name="Infragistics.Controls.Charts.CategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.CategorySeries" />*/
//# sourceMappingURL=CategoryBucketCalculator_combined.js.map