/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "./DependencyProperty";
import { List$1 } from "./List$1";
import { Base, Number_$type, typeCast, Array_$type, markType, TypeRegistrar } from "./type";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { Rect } from "./Rect";
import { MathUtil } from "./MathUtil";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { LinearCategorySnapper } from "./LinearCategorySnapper";
import { NumericYAxis } from "./NumericYAxis";
import { LabelPosition } from "./LabelPosition";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { PropertyMetadata } from "./PropertyMetadata";
import { truncate, isNaN_, isInfinity } from "./number";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
var CategoryXAxis = /** @class */ (function (_super) {
    tslib_1.__extends(CategoryXAxis, _super);
    function CategoryXAxis() {
        var _this = _super.call(this) || this;
        _this.kl = 1;
        _this.kk = 1;
        _this.kb = 0;
        _this.kc = 0;
        _this.iy = new List$1(Number_$type, 0);
        _this.ab = CategoryXAxis.$;
        return _this;
    }
    CategoryXAxis.prototype.ax = function () {
        return new CategoryXAxisView(this);
    };
    CategoryXAxis.prototype.f5 = function (a) {
        _super.prototype.f5.call(this, a);
        this.j9 = a;
    };
    Object.defineProperty(CategoryXAxis.prototype, "kn", {
        get: function () {
            return this.kl;
        },
        set: function (a) {
            this.kl = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryXAxis.prototype, "km", {
        get: function () {
            return this.kk;
        },
        set: function (a) {
            this.kk = a;
        },
        enumerable: true,
        configurable: true
    });
    CategoryXAxis.prototype.ao = function () {
        if (this.cf) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    };
    CategoryXAxis.prototype.getCategorySize = function (a, b, c) {
        var d = this.h9(b, c);
        return d.width / (this.ja * a.width);
    };
    CategoryXAxis.prototype.i3 = function (a, b, c) {
        var d = !isNaN_(this.i0) ? MathUtil.b(this.i0, 0, 1) : 0;
        var e = 0;
        if (!isNaN_(this.i7)) {
            e = Math.min(this.i7, 1);
        }
        else {
            e = 0;
        }
        ;
        var f = 1 - 0.5 * d;
        var g = this.jd == 0 ? 1 : this.jd;
        var h = this.getCategorySize(a, b, c) * f / (g - (g - 1) * e);
        return h;
    };
    CategoryXAxis.prototype.getGroupCenter = function (a, b, c, d) {
        var e = 0.5;
        if (this.jd > 1) {
            var f = !isNaN_(this.i0) ? MathUtil.b(this.i0, 0, 1) : 0;
            var g = 0;
            if (!isNaN_(this.i7)) {
                g = Math.min(this.i7, 1);
            }
            var h = 1 - 0.5 * f;
            var i = h / (this.jd - (this.jd - 1) * g);
            var j = (h - i) / (this.jd - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    };
    CategoryXAxis.prototype.c7 = function () {
        return this.ki;
    };
    CategoryXAxis.prototype.ks = function (a) {
        var b = this.a9 != null ? this.a9.mk : Rect.empty;
        b = b.copy();
        var c = this.ib;
        var d = this.h8();
        var e = new Rect(0, 0, 0, 1, 1);
        var f = new ScalerParams(0, e, e, this.bz, d);
        var g = !b.isEmpty && !c.isEmpty && this.ir != null ? this.ir.indexOf(a) : -1;
        var h = g > -1 ? this.dj(g, f) : NaN;
        if (!isNaN_(h) && this.a9.cx) {
            if (!isNaN_(h)) {
                if (h < b.left + 0.1 * b.width) {
                    h = h + 0.4 * b.width;
                    b.x = h - 0.5 * b.width;
                }
                if (h > b.right - 0.1 * b.width) {
                    h = h - 0.4 * b.width;
                    b.x = h - 0.5 * b.width;
                }
            }
            this.a9.kh(b, false, true);
        }
    };
    CategoryXAxis.prototype.dj = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.kh(a, NumericScaler.ac, b.c, this.categoryMode);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.kh(a, b.e, b.d, this.categoryMode);
    };
    CategoryXAxis.prototype.j8 = function (a) {
        if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
            return a.asArray();
        }
        return null;
    };
    CategoryXAxis.prototype.fz = function (a, b, c, d, e) {
        var f;
        var g = e.e;
        var h = e.d;
        var i = e.c;
        var j = e.a;
        var k = !i.isEmpty;
        var l = this.categoryMode == 0 ? this.ja - 1 : this.ja;
        if (l < 0) {
            l = 0;
        }
        var m = i.left;
        var n = i.width;
        var o = g.left;
        var p = g.width;
        var q = h.left;
        var r = h.width;
        var s = 0;
        var t = 1;
        var u = this.j8(a);
        var v = false;
        if (u != null) {
            v = true;
        }
        var w;
        for (var x = 0; x < b.count; x++) {
            w = b.item(x);
            for (var y = c; y < d; y++) {
                if (v) {
                    f = u[y];
                }
                else {
                    f = a.item(y);
                }
                if (k) {
                    var z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (j) {
                        z = 1 - z;
                    }
                    z = m + n * (z - s) / t;
                    var aa = (z - (o * r)) / p;
                    f[w] = aa;
                }
                else {
                    var ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (j) {
                        ab = 1 - ab;
                    }
                    ab = q + r * (ab - o) / p;
                    f[w] = ab;
                }
            }
        }
    };
    CategoryXAxis.prototype.dk = function (a, b, c) {
        if (!b.c.isEmpty) {
            var d = this.kh(a, NumericScaler.ac, b.c, c);
            d = (d - b.d.left) / b.d.width;
            d = b.d.left + b.d.width * (d - b.e.left) / b.e.width;
            return d;
        }
        return this.kh(a, b.e, b.d, c);
    };
    CategoryXAxis.prototype.kh = function (a, b, c, d) {
        var e = d == 0 ? this.ja - 1 : this.ja;
        if (e < 0) {
            e = 0;
        }
        var f = e >= 1 ? (a) / (e) : e == 0 ? 0.5 : NaN;
        if (this.b0) {
            f = 1 - f;
        }
        return c.left + c.width * (f - b.left) / b.width;
    };
    CategoryXAxis.prototype.dm = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            c = (c * b.d.width) + b.d.left;
            c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
            return c;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    };
    CategoryXAxis.prototype.dn = function (a, b, c) {
        if (!b.c.isEmpty) {
            var d = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            d = (d * b.d.width) + b.d.left;
            d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
            return d;
        }
        return this.getUnscaledValue3(a, b.e, b.d, c);
    };
    CategoryXAxis.prototype.getUnscaledValue3 = function (a, b, c, d) {
        var e = b.left + (a - c.left) * b.width / c.width;
        if (this.b0) {
            e = 1 - e;
        }
        var f = d == 0 ? this.ja - 1 : this.ja;
        if (f < 0) {
            f = 0;
        }
        return e * f;
    };
    CategoryXAxis.prototype.kt = function (a, b) {
        if (a == NaN || b == NaN || this.ir == null || this.ir.count == 0) {
            return;
        }
        var c = a / this.ir.count;
        var d = (b + 1) / this.ir.count;
        this.a9.my = new Rect(0, c, this.a9.my.y, d - c, this.a9.my.height);
    };
    CategoryXAxis.prototype.gk = function (a) {
        _super.prototype.gk.call(this, a);
        var b = this.a9 != null ? this.a9.mk : Rect.empty;
        var c = this.ib;
        var d = this.h6();
        var e = this.h5();
        var f = new ScalerParams(0, b, c, this.bz, d);
        var g = this.ay.at();
        var h = this.ay.aw();
        var i = this.ay.au();
        var j = this.ay.av();
        var k = this.ay.e();
        var l = this.ay.f();
        var m = this.ay.g();
        var n = this.ir;
        var o = this.ka();
        this.gr();
        this.fv(g);
        this.fv(h);
        this.fv(i);
        this.fv(j);
        this.cj.clear();
        this.ck.clear();
        this.iy.clear();
        this.ay.ao(this, b, c);
        if (b.isEmpty || c.isEmpty) {
            this.bg.count = 0;
        }
        if (this.bg.count == 0) {
            this.ay.t();
        }
        if (this.as != null) {
            this.as.registerAxis(this);
        }
        if (this.itemsSource == null || o == null || n.count == 0) {
            this.bg.count = 0;
            this.ay.t();
            return;
        }
        if (!b.isEmpty && !c.isEmpty) {
            var p = this.dm(e.left, f);
            var q = this.dm(e.right, f);
            if (this.bz) {
                p = Math.ceil(p);
                q = Math.floor(q);
            }
            else {
                p = Math.floor(p);
                q = Math.ceil(q);
            }
            var r = c.bottom;
            var s = r - c.top;
            if (this.ag != null) {
                var t = typeCast(NumericYAxis.$, this.ag);
                if (t != null) {
                    var u = this.gn(r, s, b, c, d, c.top, c.bottom);
                    r = u.p0;
                    s = u.p1;
                }
            }
            this.f3(g, r, c, k, true);
            this.ay.aj(s);
            var v = Math.min(p, q);
            var w = Math.max(p, q);
            var x = new LinearCategorySnapper(1, v, w, e.width, this.ki, this.categoryMode, this.dw());
            var y = Math.floor((v - 0) / x.g);
            var z = Math.ceil((w - 0) / x.g);
            this.kd = x.g;
            if (!isNaN_(y) && !isNaN_(z)) {
                var aa = truncate(y);
                var ab = truncate(z);
                var ac = this.kg(0 + aa * x.g, f);
                var ad = this.dj(x.g, f);
                var ae = Math.abs(ad - this.dj(0, f));
                this.ay.ak(ad);
                var af = truncate(Math.ceil(e.right));
                var ag = truncate(Math.floor(e.left));
                var ah = this.kj;
                var ai = ah > 0 && ah < x.g;
                var aj = c.right;
                var ak = this.iy;
                var al = x.g;
                var am = truncate(al);
                var an = this.jd;
                var ao = this.bz;
                var ap = this.categoryMode;
                for (var aq = aa; aq <= ab; ++aq) {
                    var ar = this.kg(0 + (aq + 1) * x.g, f);
                    if (ac <= aj) {
                        if (aq % 2 == 0) {
                            this.gt(h, ac, ar, c);
                        }
                        this.gs(i, ac, c, l, false);
                        ak.add(ac);
                    }
                    if (this.categoryMode != 0 && this.jd != 0 && this.b9) {
                        if (ai) {
                            var as = ae * this.kj;
                            if (this.bz) {
                                var at = ac;
                                while (at - as > ar) {
                                    at -= as;
                                    if (Math.abs(at - ar) < 0.0001) {
                                        break;
                                    }
                                    this.gs(j, at, c, m, false);
                                }
                            }
                            else {
                                var au = ac;
                                while (au + as < ar) {
                                    au += as;
                                    if (Math.abs(au - ar) < 0.0001) {
                                        break;
                                    }
                                    this.gs(j, au, c, m, false);
                                }
                            }
                            this.ke = this.kj;
                        }
                        else {
                            for (var av = 0; av < truncate(x.g); av++) {
                                for (var aw = 0; aw < this.jd; aw++) {
                                    var ax = this.getGroupCenter(aw, b, c, d);
                                    if (this.bz) {
                                        ax = -ax;
                                    }
                                    var ay = this.dj(av + aq * x.g, f) + ax;
                                    this.gs(j, ay, c, m, false);
                                }
                            }
                            this.ke = 0.5;
                        }
                    }
                    var az = this.kf(aq * al, ac, ap == 0, f);
                    var a0 = truncate(Math.round(az));
                    if (a0 >= ag && a0 <= af) {
                        var a1 = 0;
                        if (al >= 1) {
                            a1 = aq * truncate(Math.floor(al));
                        }
                        else {
                            if ((aq * al) * 2 % 2 == 0) {
                                a1 = truncate(Math.floor(aq * al));
                            }
                            else {
                                a1 = -1;
                            }
                        }
                        if (o != null && a1 < n.count && a1 >= 0) {
                            var a2 = o.getItem(a1);
                            var a3 = this.eq(a2);
                            if (!isNaN_(az) && !isInfinity(az) && a3 != null) {
                                if ((typeof a3 === 'string') && Base.equalsStatic(a3, "")) {
                                }
                                else {
                                    this.cj.add1(a3);
                                    this.ck.add(new LabelPosition(az));
                                }
                            }
                        }
                    }
                    ac = ar;
                }
            }
            if ((this.as == null || this.as.visibility == 0) && this.ag != null) {
                if (this.as != null && (this.as.location == 4 || this.as.location == 5)) {
                    this.a9.hp();
                }
            }
            this.ay.ap(this.cj, this.ck);
            this.jy();
        }
    };
    CategoryXAxis.prototype.cd = function () {
        if (this.b6 && this.ce) {
            this.a3 = this.a2();
        }
        if (this.ir == null) {
            return false;
        }
        var a = this.ir.count;
        if (a != this.km) {
            var b = new AxisRangeChangedEventArgs(1, 1, this.km, a);
            this.km = a;
            this.ge(b);
            return true;
        }
        return false;
    };
    Object.defineProperty(CategoryXAxis.prototype, "ki", {
        get: function () {
            return this.c(CategoryXAxis.ku);
        },
        set: function (a) {
            this.h(CategoryXAxis.ku, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryXAxis.prototype, "kd", {
        get: function () {
            return this.kb;
        },
        set: function (a) {
            if (this.kd != a) {
                var b = this.kb;
                this.kb = a;
                this.gd("ActualInterval", b, this.kd);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryXAxis.prototype, "kj", {
        get: function () {
            return this.c(CategoryXAxis.kv);
        },
        set: function (a) {
            this.h(CategoryXAxis.kv, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryXAxis.prototype, "ke", {
        get: function () {
            return this.kc;
        },
        set: function (a) {
            if (this.ke != a) {
                var b = this.kc;
                this.kc = a;
                this.gd("ActualMinorInterval", b, this.ke);
            }
        },
        enumerable: true,
        configurable: true
    });
    CategoryXAxis.prototype.iu = function (a) {
        if (a == null) {
            return false;
        }
        var b = this.a5();
        if (b == null) {
            return false;
        }
        return b.ac;
    };
    CategoryXAxis.prototype.get_av = function () {
        return 0;
    };
    Object.defineProperty(CategoryXAxis.prototype, "av", {
        get: function () {
            return this.get_av();
        },
        enumerable: true,
        configurable: true
    });
    CategoryXAxis.prototype.ka = function () {
        return this.ir;
    };
    CategoryXAxis.prototype.kg = function (a, b) {
        return this.dj(a, b);
    };
    CategoryXAxis.prototype.kf = function (a, b, c, d) {
        if (!c) {
            var e = this.kg(a + 1, d);
            return (b + e) / 2;
        }
        return b;
    };
    Object.defineProperty(CategoryXAxis.prototype, "isVertical", {
        get: function () {
            return this.b5;
        },
        enumerable: true,
        configurable: true
    });
    CategoryXAxis.prototype.j$c = function (a, b) {
        return this.dm.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$b = function (a, b) {
        return this.dj.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$d = function (a, b, c, d, e) {
        this.fz.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$e = function (a, b, c, d) {
        this.f0.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$f = function (a, b, c, d) {
        this.f1.apply(this, arguments);
    };
    Object.defineProperty(CategoryXAxis.prototype, "j$a", {
        get: function () {
            return this.bz;
        },
        enumerable: true,
        configurable: true
    });
    CategoryXAxis.ku = DependencyProperty.i("Interval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        a.gd("Interval", b.oldValue, b.newValue);
        a.gj(false);
    }));
    CategoryXAxis.kv = DependencyProperty.i("MinorInterval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        (typeCast(CategoryXAxis.$, a)).gd("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryXAxis.$, a)).gj(false);
    }));
    CategoryXAxis.$t = markType(CategoryXAxis, 'CategoryXAxis', CategoryAxisBase.$);
    return CategoryXAxis;
}(CategoryAxisBase));
export { CategoryXAxis };
var CategoryXAxisView = /** @class */ (function (_super) {
    tslib_1.__extends(CategoryXAxisView, _super);
    function CategoryXAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.ba = null;
        _this.ba = a;
        return _this;
    }
    CategoryXAxisView.$t = markType(CategoryXAxisView, 'CategoryXAxisView', CategoryAxisBaseView.$);
    return CategoryXAxisView;
}(CategoryAxisBaseView));
export { CategoryXAxisView };
/*<BeginStatics Name="Infragistics.Controls.Charts.CategoryXAxis" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.CategoryXAxis" />*/
//# sourceMappingURL=CategoryXAxis_combined.js.map