import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IndicatorDisplayType } from "./IndicatorDisplayType";
import { DependencyProperty } from "./DependencyProperty";
import { TrendLineType } from "./TrendLineType";
import { Brush } from "./Brush";
import { PenLineCap } from "./PenLineCap";
import { DoubleCollection } from "./DoubleCollection";
import { List$1 } from "./List$1";
import { AxisRange } from "./AxisRange";
import { SeriesView } from "./SeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { Axis } from "./Axis";
import { Point, IList$1, Type } from "./type";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "./Rect";
import { FastItemsSourceEventAction } from "./FastItemsSourceEventAction";
import { ITrendLineManager } from "./ITrendLineManager";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Clipper } from "./Clipper";
import { Path } from "./Path";
import { RenderingContext } from "./RenderingContext";
export declare abstract class FinancialIndicator extends FinancialSeries implements ITrendLineSeries {
    protected be(): SeriesView;
    h9(a: SeriesView): void;
    ow: FinancialIndicatorView;
    constructor();
    o8(a: boolean): void;
    protected o0(a: Point, b: Point, c: boolean): boolean;
    protected bc(): SeriesHitTestMode;
    k9(a: Point): Rect;
    dd(a: Point, b: boolean): boolean;
    protected hh(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    ox: IndicatorDisplayType;
    o3: number;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    pl: Brush;
    static readonly pb: DependencyProperty;
    trendLineThickness: number;
    pn: PenLineCap;
    pm: DoubleCollection;
    trendLinePeriod: number;
    protected o5(): number;
    o4: number;
    private _indicatorColumn;
    indicatorColumn: List$1<number>;
    protected ov: AxisRange;
    protected abstract oy(a: number, b: number): boolean;
    protected abstract o1(a: number, b: number): IList$1<string>;
    protected ie(a: any, b: string, c: any, d: any): void;
    ed(a: Point, b: boolean, c: boolean): number;
    e3(a: Point, b: boolean): number;
    e1(a: Point, b: boolean): number;
    protected get_dr(): boolean;
    readonly dr: boolean;
    private oz(a, b, c);
    private pa(a, b, c);
    am(a: Axis): AxisRange;
    c5(a: any): boolean;
    ds(a: Rect, b: Rect, c: SeriesView): boolean;
    ob(a: CategoryFrame, b: FinancialSeriesView): void;
    he(a: boolean, b: SeriesView): void;
    protected lw(): CategoryTransitionInMode;
    od(a: CategoryFrame, b: FinancialSeriesView): void;
    protected i4(): void;
    protected o9(): void;
    protected hn(a: any): void;
    static $$p: string[];
    static $t: Type;
}
export declare class FinancialIndicatorBucketCalculator extends FinancialBucketCalculator {
    constructor(a: FinancialSeriesView);
    protected f: FinancialIndicatorView;
    getBucket(a: number): number[];
    static $t: Type;
}
export declare class FinancialIndicatorView extends FinancialSeriesView {
    by: FinancialIndicator;
    constructor(a: FinancialIndicator);
    protected bt(): FinancialBucketCalculator;
    ap(): void;
    private readonly b1;
    private cb();
    private b4(a);
    cp: Path;
    cl: Path;
    cq: Path;
    cm: Path;
    cr: Path;
    cn: Path;
    co: Path;
    ck: Path;
    private bz;
    b0: ITrendLineManager;
    readonly b2: boolean;
    b3(a: boolean): void;
    b9(): void;
    b7(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: Clipper): void;
    b5(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: number, f: Clipper): void;
    b6(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: number): void;
    ca(): void;
    private ch;
    private cj;
    private ci;
    private cg;
    private cd;
    private cf;
    private ce;
    private cc;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    protected a2(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    b8(): void;
    static $t: Type;
}
