import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { TrendLineType } from "./TrendLineType";
import { DependencyProperty } from "./DependencyProperty";
import { Brush } from "./Brush";
import { PenLineCap } from "./PenLineCap";
import { DoubleCollection } from "./DoubleCollection";
import { PriceDisplayType } from "./PriceDisplayType";
import { SeriesView } from "./SeriesView";
import { Type, Point } from "./type";
import { CategoryFrame } from "./CategoryFrame";
import { FastItemsSourceEventAction } from "./FastItemsSourceEventAction";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { ITrendLineManager } from "./ITrendLineManager";
import { Axis } from "./Axis";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "./Rect";
import { List$1 } from "./List$1";
import { AxisRange } from "./AxisRange";
import { Pool$1 } from "./Pool$1";
import { Path } from "./Path";
import { GeometryGroup } from "./GeometryGroup";
import { RenderingContext } from "./RenderingContext";
export declare class FinancialPriceSeries extends FinancialSeries implements ITrendLineSeries {
    protected be(): SeriesView;
    h9(a: SeriesView): void;
    ow: FinancialPriceSeriesView;
    constructor();
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    pg: Brush;
    static readonly o6: DependencyProperty;
    trendLineThickness: number;
    pj: PenLineCap;
    pi: DoubleCollection;
    trendLinePeriod: number;
    o0: number;
    protected hh(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    ox: PriceDisplayType;
    protected bc(): SeriesHitTestMode;
    k9(a: Point): Rect;
    private ov(a, b);
    aj(a: Point): Rect[];
    dd(a: Point, b: boolean): boolean;
    protected dg(a: Point, b: boolean): boolean;
    protected ie(a: any, b: string, c: any, d: any): void;
    private o5();
    am(a: Axis): AxisRange;
    an(): AxisRange;
    d8(): number;
    c5(a: any): boolean;
    ds(a: Rect, b: Rect, c: SeriesView): boolean;
    ob(a: CategoryFrame, b: FinancialSeriesView): void;
    he(a: boolean, b: SeriesView): void;
    protected get_mp(): boolean;
    protected readonly mp: boolean;
    od(a: CategoryFrame, b: FinancialSeriesView): void;
    d7(): number;
    private o4(a, b, c);
    private oy(a, b);
    private o3(a, b);
    fh(a: any, b: Point): any;
    protected i4(): void;
    protected hn(a: any): void;
    ph: Brush;
    iy(a: Brush, b: Brush): void;
    static $$p: string[];
    static $t: Type;
}
export declare class FinancialPriceSeriesView extends FinancialSeriesView {
    protected by: FinancialPriceSeries;
    constructor(a: FinancialPriceSeries);
    b1: Pool$1<Path>;
    cj(): Path;
    protected b4: List$1<Path>;
    b9(a: Path): void;
    cb(a: Path): void;
    ca(a: Path): void;
    protected bt(): FinancialBucketCalculator;
    ap(): void;
    private ci;
    private ch;
    private bz;
    b0: ITrendLineManager;
    readonly b2: boolean;
    cc(): void;
    b6(): void;
    b5(): void;
    cf(): GeometryGroup;
    ce(): GeometryGroup;
    cd(): void;
    protected a8(): void;
    protected a9(): void;
    protected z(a: number): any;
    private cg;
    protected y(a: number): any;
    protected a3(a: RenderingContext, b: boolean): void;
    protected a2(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    b7(): void;
    b3: boolean;
    b8(): void;
    static $t: Type;
}
