/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler_$type } from "./IScaler";
import { markType } from "./type";
import { VerticalAxisLabelPanel } from "./VerticalAxisLabelPanel";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { RangeInfo } from "./RangeInfo";
import { VerticalLogarithmicScaler } from "./VerticalLogarithmicScaler";
import { FastVerticalLinearScaler } from "./FastVerticalLinearScaler";
import { isNaN_ } from "./number";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
var NumericYAxis = /** @class */ (function (_super) {
    tslib_1.__extends(NumericYAxis, _super);
    function NumericYAxis() {
        var _this = _super.call(this) || this;
        _this.ab = NumericYAxis.$;
        _this.ir = _this.ip();
        return _this;
    }
    NumericYAxis.prototype.ax = function () {
        return new NumericYAxisView(this);
    };
    NumericYAxis.prototype.ao = function () {
        return new VerticalAxisLabelPanel();
    };
    NumericYAxis.prototype.get_b5 = function () {
        return true;
    };
    Object.defineProperty(NumericYAxis.prototype, "b5", {
        get: function () {
            return this.get_b5();
        },
        enumerable: true,
        configurable: true
    });
    NumericYAxis.prototype.di = function () {
        return this.ib.height;
    };
    NumericYAxis.prototype.dj = function (a, b) {
        if (this.kq != null) {
            return this.kq.p(a, b);
        }
        return this.kp.p(a, b);
    };
    NumericYAxis.prototype.f0 = function (a, b, c, d) {
        if (this.kq != null) {
            this.kq.v(a, b, c, d);
            return;
        }
        this.kp.v(a, b, c, d);
    };
    NumericYAxis.prototype.fz = function (a, b, c, d, e) {
        if (this.kq != null) {
            this.kq.u(a, b, c, d, e);
            return;
        }
        this.kp.u(a, b, c, d, e);
    };
    NumericYAxis.prototype.dm = function (a, b) {
        if (this.kq != null) {
            return this.kq.q(a, b);
        }
        return this.kp.q(a, b);
    };
    NumericYAxis.prototype.f1 = function (a, b, c, d) {
        if (this.kq != null) {
            this.kq.j(a, b, c, d);
            return;
        }
        this.kp.j(a, b, c, d);
    };
    NumericYAxis.prototype.k7 = function (a, b) {
        if (this.a9 == null || a == NaN || b == NaN) {
            return;
        }
        var c = this.kv(a, this);
        var d = this.kv(b, this);
        if (c == NaN || d == NaN) {
            return;
        }
        this.a9.my = new Rect(0, this.a9.my.x, d, this.a9.my.width, c - d);
    };
    NumericYAxis.prototype.ip = function () {
        var _this = this;
        var a = _super.prototype.ip.call(this);
        a.b.c = function (b) {
            if (_this.as == null || _this.as.visibility == 0) {
                _this.ap.a6 = b;
                if (_this.as != null && (_this.as.location == 7 || _this.as.location == 6)) {
                    _this.a9.hp();
                }
            }
        };
        a.k = function (b, c, d) { return _this.f3(c, d, b.z, b.b, false); };
        a.l = function (b, c, d, e) { return _this.f4(c, d, e, b.z); };
        a.m = function (b, c) {
            var d = b.y;
            var e = new ScalerParams(0, b.aa, b.z, _this.b0, d);
            return _this.dj(c, e);
        };
        a.q = function (b, c) { return true; };
        a.j = function (b) { return _this.gs(b.t, b.n, b.z, b.a, true); };
        a.e = function (b) {
            b.n = b.z.left;
            var c = b.y;
            var d = new ScalerParams(0, b.aa, b.z, _this.b0, c);
            if (_this.ag != null && _this.ag.a9 != null) {
                var e = b.n;
                var f = b.r;
                var g = _this.gn(e, f, b.aa, b.z, b.y, b.z.left, b.z.right);
                e = g.p0;
                f = g.p1;
                b.n = e;
                b.r = f;
            }
        };
        a.p = function (b, c, d) {
            var e = Math.round(c);
            return e >= Math.floor(b.z.top) && e <= Math.ceil(b.z.bottom);
        };
        return a;
    };
    NumericYAxis.prototype.is = function (a, b, c, d) {
        var e = d;
        var f = _super.prototype.is.call(this, a, b, c, d);
        var g = new ScalerParams(0, b, a, this.bz, c);
        var h = NaN;
        var i = NaN;
        if (!this.bz && b.top == 0) {
            i = this.jf;
        }
        else if (this.bz && b.bottom == 1) {
            h = this.jf;
        }
        if (isNaN_(h)) {
            h = this.dm(e.bottom, g);
        }
        if (isNaN_(i)) {
            i = this.dm(e.top, g);
        }
        var j = Math.min(h, i);
        var k = Math.max(h, i);
        this.jj = j;
        this.ji = k;
        var l = ((function () {
            var $ret = new RangeInfo();
            $ret.d = j;
            $ret.c = k;
            $ret.b = e.height;
            return $ret;
        })());
        f.k.add(l);
        return f;
    };
    NumericYAxis.prototype.gk = function (a) {
        _super.prototype.gk.call(this, a);
        var b = this.a9 != null ? this.a9.mk : Rect.empty;
        var c = this.ib;
        var d = this.h6();
        var e = this.h5();
        var f = this.ir.c(a, c, b, d, e);
        if (f != null) {
            this.je = f.f.m;
            this.jh = f.f.l;
        }
    };
    NumericYAxis.prototype.gu = function (a, b) {
        _super.prototype.gu.call(this, a, b);
        if (b.height != a.height) {
            this.cb();
        }
    };
    NumericYAxis.prototype.get_av = function () {
        return 1;
    };
    Object.defineProperty(NumericYAxis.prototype, "av", {
        get: function () {
            return this.get_av();
        },
        enumerable: true,
        configurable: true
    });
    NumericYAxis.prototype.iu = function () {
        if (this.i5) {
            return new VerticalLogarithmicScaler();
        }
        switch (this.ko) {
            case 0: return new FastVerticalLinearScaler();
            case 1: return new VerticalLogarithmicScaler();
        }
        return null;
    };
    NumericYAxis.prototype.j$c = function (a, b) {
        return this.dm.apply(this, arguments);
    };
    NumericYAxis.prototype.j$b = function (a, b) {
        return this.dj.apply(this, arguments);
    };
    NumericYAxis.prototype.j$d = function (a, b, c, d, e) {
        this.fz.apply(this, arguments);
    };
    NumericYAxis.prototype.j$e = function (a, b, c, d) {
        this.f0.apply(this, arguments);
    };
    NumericYAxis.prototype.j$f = function (a, b, c, d) {
        this.f1.apply(this, arguments);
    };
    Object.defineProperty(NumericYAxis.prototype, "j$a", {
        get: function () {
            return this.bz;
        },
        enumerable: true,
        configurable: true
    });
    NumericYAxis.$t = markType(NumericYAxis, 'NumericYAxis', StraightNumericAxisBase.$, [IScaler_$type]);
    return NumericYAxis;
}(StraightNumericAxisBase));
export { NumericYAxis };
var NumericYAxisView = /** @class */ (function (_super) {
    tslib_1.__extends(NumericYAxisView, _super);
    function NumericYAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bc = null;
        _this.bc = a;
        return _this;
    }
    NumericYAxisView.$t = markType(NumericYAxisView, 'NumericYAxisView', StraightNumericAxisBaseView.$);
    return NumericYAxisView;
}(StraightNumericAxisBaseView));
export { NumericYAxisView };
//# sourceMappingURL=NumericYAxis_combined.js.map