/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { fromEnum, markType } from "./type";
import { NumericYAxis } from "./NumericYAxis";
import { NumericScaler } from "./NumericScaler";
import { AxisRange } from "./AxisRange";
import { PercentChangeAxisRenderer } from "./PercentChangeAxisRenderer";
import { isNaN_ } from "./number";
import { AutoRangeCalculator } from "./AutoRangeCalculator";
var PercentChangeYAxis = /** @class */ (function (_super) {
    tslib_1.__extends(PercentChangeYAxis, _super);
    function PercentChangeYAxis() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PercentChangeYAxis.prototype.iu = function () {
        return new VerticalPercentChangeScaler(this);
    };
    PercentChangeYAxis.prototype.im = function () {
        var a = 1.7976931348623157E+308;
        var b = -1.7976931348623157E+308;
        try {
            for (var _a = tslib_1.__values(fromEnum(this.ci())), _b = _a.next(); !_b.done; _b = _a.next()) {
                var c = _b.value;
                var d = c.am(this);
                if (d == null) {
                    continue;
                }
                var e = c.d8();
                if (isNaN_(e)) {
                    continue;
                }
                var f = d.b - e;
                var g = e - d.c;
                var h = Math.abs(f / e * 100);
                var i = Math.abs(g / e * 100);
                a = Math.min(a, -i);
                b = Math.max(b, h);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return new AxisRange(a, b);
        var e_1, _c;
    };
    PercentChangeYAxis.prototype.iq = function (a) {
        return new PercentChangeAxisRenderer(a);
    };
    PercentChangeYAxis.prototype.j$c = function (a, b) {
        return this.dm.apply(this, arguments);
    };
    PercentChangeYAxis.prototype.j$b = function (a, b) {
        return this.dj.apply(this, arguments);
    };
    PercentChangeYAxis.prototype.j$d = function (a, b, c, d, e) {
        this.fz.apply(this, arguments);
    };
    PercentChangeYAxis.prototype.j$e = function (a, b, c, d) {
        this.f0.apply(this, arguments);
    };
    PercentChangeYAxis.prototype.j$f = function (a, b, c, d) {
        this.f1.apply(this, arguments);
    };
    Object.defineProperty(PercentChangeYAxis.prototype, "j$a", {
        get: function () {
            return this.bz;
        },
        enumerable: true,
        configurable: true
    });
    PercentChangeYAxis.$t = markType(PercentChangeYAxis, 'PercentChangeYAxis', NumericYAxis.$);
    return PercentChangeYAxis;
}(NumericYAxis));
export { PercentChangeYAxis };
var VerticalPercentChangeScaler = /** @class */ (function (_super) {
    tslib_1.__extends(VerticalPercentChangeScaler, _super);
    function VerticalPercentChangeScaler(a) {
        var _this = _super.call(this) || this;
        _this.ad = null;
        _this.ad = a;
        return _this;
    }
    VerticalPercentChangeScaler.prototype.t = function (a, b, c, d, e) {
        var f = AutoRangeCalculator.a(this.ad, b, c, false, -1, d, e);
        d = f.p5;
        e = f.p6;
        return {
            p3: d,
            p4: e
        };
    };
    VerticalPercentChangeScaler.prototype.p = function (a, b) {
        var c;
        if (isNaN_(b.b)) {
            c = a;
        }
        else {
            var d = (a - b.b) / Math.abs(b.b) * 100;
            c = d;
        }
        var e = (c - this.o) / this.m;
        if (!b.a) {
            e = 1 - e;
        }
        return b.d.top + b.d.height * (e - b.e.top) / b.e.height;
    };
    VerticalPercentChangeScaler.prototype.q = function (a, b) {
        var c = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
        if (!b.a) {
            c = 1 - c;
        }
        return this.o + c * (this.m);
    };
    VerticalPercentChangeScaler.$t = markType(VerticalPercentChangeScaler, 'VerticalPercentChangeScaler', NumericScaler.$);
    return VerticalPercentChangeScaler;
}(NumericScaler));
export { VerticalPercentChangeScaler };
//# sourceMappingURL=PercentChangeYAxis_combined.js.map