/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { FastItemDateTimeColumn } from "./FastItemDateTimeColumn";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { DependencyProperty } from "./DependencyProperty";
import { List$1 } from "./List$1";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "./Rect";
import { NumericScaler } from "./NumericScaler";
import { SeriesViewer } from "./SeriesViewer";
import { Type, typeCast, Number_$type, Date_$type, fromEnum, runOn, delegateRemove, delegateCombine, markType, TypeRegistrar } from "./type";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { SortedListView$1 } from "./SortedListView$1";
import { ArrayExtension } from "./ArrayExtension";
import { IFastItemsSource_$type } from "./IFastItemsSource";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { MathUtil } from "./MathUtil";
import { PropertyMetadata } from "./PropertyMetadata";
import { truncate, isNaN_ } from "./number";
import { dateMinValue, dateSubtract, dateAdd, dateMaxValue } from "./date";
var TimeAxisBase = /** @class */ (function (_super) {
    tslib_1.__extends(TimeAxisBase, _super);
    function TimeAxisBase() {
        var _this = _super.call(this) || this;
        _this.j9 = null;
        _this.ki = null;
        _this.kd = false;
        _this.kl = dateMaxValue();
        _this.kk = dateMinValue();
        _this.actualRangeChanged = null;
        FastItemDateTimeColumn.m();
        return _this;
    }
    TimeAxisBase.prototype.dj = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.kq(a, NumericScaler.ac, b.c, Rect.empty);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.kq(a, b.e, b.d, b.c);
    };
    TimeAxisBase.prototype.kq = function (a, b, c, d) {
        var e;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            e = -1;
        }
        else {
            e = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        var f = 0;
        if (this.categoryMode == 2) {
            f = this.getGroupCenter(0, b, c, d);
        }
        if (this.bz) {
            e = 1 - e;
            f = -f;
        }
        return c.left + c.width * (e - b.left) / b.width - f;
    };
    TimeAxisBase.prototype.kr = function (a, b, c) {
        var d;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            d = -1;
        }
        else {
            d = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        var e = 0;
        if (this.bz) {
            d = 1 - d;
            e = -e;
        }
        return c.left + c.width * (d - b.left) / b.width - e;
    };
    TimeAxisBase.prototype.dm = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.d.left;
            var d = b.d.width;
            if (this.categoryMode != 0) {
                var e = this.getCategorySize(b.e, b.d, b.c);
                c += e / 2;
                d -= e;
            }
            var f = b.e.left + b.e.width * (a - c) / this.width;
            f = (f * b.d.width) + b.d.left;
            f = this.getUnscaledValue3(f, NumericScaler.ac, b.c, this.categoryMode);
            return f;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    };
    TimeAxisBase.prototype.getUnscaledValue3 = function (a, b, c, d) {
        var e = b.left + b.width * (a - c.left) / c.width;
        if (this.bz) {
            e = 1 - e;
        }
        return truncate(Math.floor(this.actualMinimumValue.getTime() + e * (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime())));
    };
    TimeAxisBase.prototype.i$h = function () {
        this.k2();
    };
    TimeAxisBase.prototype.k2 = function () {
        var a = this.a9 != null ? this.a9.mk : Rect.empty;
        var b = !a.isEmpty ? this.ib : Rect.empty;
        var c = (new Date());
        var d = (new Date());
        var e = false;
        if (!a.isEmpty && !b.isEmpty && this.ka != null) {
            var f = typeCast(FastItemDateTimeColumn.$, this.ka);
            if (f != null) {
                if (this.kj == null) {
                    this.k3();
                }
            }
            else {
                this.kj = null;
            }
            if (this.ka.count > 0) {
                e = true;
                var g = this.kj == null ? 0 : this.kj._inner[0];
                var h = this.kj == null ? this.ka.count - 1 : this.kj._inner[this.ka.count - 1];
                c = this.ka.item(g);
                d = this.ka.item(h);
                this.ke = false;
                if (this.categoryMode == 2) {
                    var i = this.k0(c, d);
                    if (+c != +(dateMinValue())) {
                        c = dateSubtract(+c, +i);
                    }
                    d = dateAdd(+d, +i);
                }
            }
        }
        if (this.kh()) {
            e = true;
            c = this.minimumValue;
        }
        if (this.kg()) {
            e = true;
            d = this.maximumValue;
        }
        var j = +(this.actualMinimumValue) != +c || +(this.actualMaximumValue) != +d;
        if (e && j) {
            var k = this.actualMinimumValue;
            var l = this.actualMaximumValue;
            this.actualMinimumValue = c;
            this.actualMaximumValue = d;
            this.k7();
            if (this.actualRangeChanged != null) {
                this.actualRangeChanged(this, new AxisRangeChangedEventArgs(k.getTime(), this.actualMinimumValue.getTime(), l.getTime(), this.actualMaximumValue.getTime()));
            }
        }
    };
    TimeAxisBase.prototype.k7 = function () {
    };
    Object.defineProperty(TimeAxisBase.prototype, "ka", {
        get: function () {
            return this.j9;
        },
        set: function (a) {
            if (this.j9 != a) {
                var b = this.j9;
                this.j9 = a;
                this.gd("DateTimeColumn", b, this.j9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "kj", {
        get: function () {
            return this.ki;
        },
        set: function (a) {
            this.ki = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "i$b", {
        get: function () {
            if (this.kj == null) {
                var a = typeCast(FastItemDateTimeColumn.$, this.ka);
                if (a != null) {
                    this.k3();
                }
                else {
                    this.kj = null;
                }
            }
            return this.kj;
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.k3 = function () {
        if (this.kf) {
            this.kj = new List$1(Number_$type, 0);
            var a = this.kj;
            var b = this.ka.count;
            for (var c = 0; c < b; c++) {
                a.add(c);
            }
        }
        else {
            var d = typeCast(FastItemDateTimeColumn.$, this.ka);
            this.kj = d.f();
        }
    };
    TimeAxisBase.prototype.i$e = function (a, b, c, d) {
        var e = d;
        var f = new ScalerParams(0, a, b, this.bz, c);
        var g, h;
        if (this.bz) {
            h = this.dm(e.left, f);
            g = this.dm(e.right, f);
        }
        else {
            g = this.dm(e.left, f);
            h = this.dm(e.right, f);
        }
        var i = 0;
        for (var j = 0; j < this.kj.count; j++) {
            if (this.ka == null) {
                break;
            }
            var k = this.ka.item(this.kj._inner[j]);
            if (k.getTime() >= g) {
                break;
            }
            i = j;
        }
        return i;
    };
    TimeAxisBase.prototype.i$g = function (a, b, c, d) {
        var e = d;
        var f = new ScalerParams(0, a, b, this.bz, c);
        var g, h;
        if (this.bz) {
            h = this.dm(e.left, f);
            g = this.dm(e.right, f);
        }
        else {
            g = this.dm(e.left, f);
            h = this.dm(e.right, f);
        }
        var i = this.kj.count - 1;
        var j = i;
        for (var k = i; k >= 0; k--) {
            if (this.ka == null || this.kj.count <= k) {
                break;
            }
            var l = this.kj._inner[k];
            if (l >= this.ka.count) {
                break;
            }
            var m = this.ka.item(l);
            if (m.getTime() < h) {
                break;
            }
            j = Math.min(k + 1, this.kj.count - 1);
        }
        return j;
    };
    TimeAxisBase.prototype.i$d = function (a) {
        if (this.ka == null) {
            return NaN;
        }
        var b = this.j9.item(a);
        var c = b.getTime();
        var d = c;
        return d;
    };
    TimeAxisBase.prototype.i$c = function (a) {
        var b = this;
        if (b.i$b == null) {
            return -1;
        }
        var c = new SortedListView$1(Date_$type, this.ka, b.i$b);
        var ticks_ = a;
        var d = (new Date(ticks_));
        var e = this.ks(d, c);
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            var diff1_ = d.getTime() - c.item(e - 1).getTime();
            var diff2_ = c.item(e).getTime() - d.getTime();
            var f = e - 1;
            var g = e;
            if (f < 0 && g >= 0) {
                return g;
            }
            if (g > b.i$b.count - 1 && f < b.i$b.count) {
                return f;
            }
            if (f < 0 && g < 0) {
                return -1;
            }
            if (f > b.i$b.count - 1 && g > b.i$b.count - 1) {
                return -1;
            }
            var h = diff1_ / (diff1_ + diff2_);
            if (isNaN_(h)) {
                h = 0;
            }
            return f + h;
        }
        if (e >= 0 && e < b.i$b.count) {
            return e;
        }
        var i = this.h6();
        if (e == b.i$b.count && this.a9 != null && this.dj(a, new ScalerParams(0, this.a9.mk, this.ib, this.bz, i)) < (this.ib.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.a9 != null && Math.abs(this.dj(a, new ScalerParams(0, this.a9.mk, this.ib, this.bz, i)) - this.ib.left) < 2) {
            return 0;
        }
        return -1;
    };
    TimeAxisBase.prototype.ks = function (a, b) {
        var c = this;
        if (this.ka == null || c.i$b == null) {
            return -1;
        }
        var d = -1;
        var e = ArrayExtension.binarySearch$11(Date_$type, b, function (f) {
            if (a < f) {
                return -1;
            }
            if (a > f) {
                return 1;
            }
            return 0;
        });
        if (e >= 0) {
            d = e;
        }
        else {
            d = ~e;
        }
        while (d >= 0 && d < b.count && d - 1 >= 0 && +(b.item(d)) == +(b.item(d - 1))) {
            d--;
        }
        return d;
    };
    TimeAxisBase.prototype.i$f = function (a) {
        var b = this;
        if (b.i$b == null || this.ka == null || b.i$b.count != this.ka.count) {
            return -1;
        }
        var c = new SortedListView$1(Date_$type, this.ka, b.i$b);
        var ticks_ = a;
        var d = (new Date(ticks_));
        var e = this.ks(d, c);
        var f = this.h6();
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            var g = +d - +(c.item(e - 1));
            var h = +(c.item(e)) - +d;
            if (g < h) {
                e = e - 1;
            }
        }
        if (e >= 0 && e < b.i$b.count) {
            return b.i$b._inner[e];
        }
        if (e == b.i$b.count && this.a9 != null && this.dj(a, new ScalerParams(0, this.a9.mk, this.ib, this.bz, f)) < (this.ib.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.a9 != null && Math.abs(this.dj(a, new ScalerParams(0, this.a9.mk, this.ib, this.bz, f)) - this.ib.left) < 2) {
            return 0;
        }
        return -1;
    };
    TimeAxisBase.prototype.i$i = function () {
        this.kj = null;
        this.gi();
    };
    TimeAxisBase.prototype.get_ke = function () {
        return this.kd;
    };
    TimeAxisBase.prototype.set_ke = function (a) {
        this.kd = a;
    };
    Object.defineProperty(TimeAxisBase.prototype, "ke", {
        get: function () {
            return this.get_ke();
        },
        set: function (a) {
            this.set_ke(a);
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.f9 = function (a) {
        _super.prototype.f9.call(this, a);
        this.dateTimeMemberPath = a;
    };
    TimeAxisBase.prototype.gc = function (a) {
        _super.prototype.gc.call(this, a);
        this.minimumValue = a;
    };
    TimeAxisBase.prototype.gb = function (a) {
        _super.prototype.gc.call(this, a);
        this.maximumValue = a;
    };
    TimeAxisBase.prototype.cd = function () {
        if (this.b6 && this.ce) {
            this.a3 = this.a2();
        }
        var a = this.actualMinimumValue.getTime();
        var b = this.actualMaximumValue.getTime();
        this.k2();
        var c = !this.kh() ? this.actualMinimumValue.getTime() : this.minimumValue.getTime();
        var d = !this.kg() ? this.actualMaximumValue.getTime() : this.maximumValue.getTime();
        var e = new AxisRangeChangedEventArgs(a, c, b, d);
        this.ge(e);
        return true;
    };
    TimeAxisBase.prototype.kh = function () {
        return (this.minimumValue != null);
    };
    TimeAxisBase.prototype.kg = function () {
        return (this.maximumValue != null);
    };
    Object.defineProperty(TimeAxisBase.prototype, "actualMinimumValue", {
        get: function () {
            return this.kl;
        },
        set: function (a) {
            var b = +(this.kl) != +a;
            if (b) {
                var c = this.kl;
                this.kl = a;
                this.gd("ActualMinimumValue", c, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.et = function () {
        return this.actualMinimumValue;
    };
    Object.defineProperty(TimeAxisBase.prototype, "actualMaximumValue", {
        get: function () {
            return this.kk;
        },
        set: function (a) {
            var b = +(this.kk) != +a;
            if (b) {
                var c = this.kk;
                this.kk = a;
                this.gd("ActualMaximumValue", c, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.es = function () {
        return this.maximumValue;
    };
    TimeAxisBase.prototype.k4 = function (a) {
        this.gk(a);
        if (this.ir == null) {
            return;
        }
        try {
            for (var _a = tslib_1.__values(fromEnum(this.ci())), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                b.it(a);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var e_1, _c;
    };
    TimeAxisBase.prototype.f7 = function (a, b, c, d) {
        _super.prototype.f7.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                var e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.ka);
                    this.ka = null;
                    e.event = delegateRemove(e.event, runOn(this, this.k1));
                }
                var f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.kj = null;
                    this.ka = this.kb(this.dateTimeMemberPath);
                    f.event = delegateCombine(f.event, runOn(this, this.k1));
                }
                this.k4(false);
                break;
            case TimeAxisBase.$$p[0]:
                if (this.ir != null) {
                    this.ir.deregisterColumn(this.ka);
                    this.ka = this.kb(this.dateTimeMemberPath);
                    this.kj = null;
                }
                break;
            case TimeAxisBase.$$p[3]:
                this.cb();
                this.k4(false);
                break;
            case TimeAxisBase.$$p[2]:
                this.cb();
                this.k4(false);
                break;
            case "DateTimeColumn":
                this.k2();
                break;
        }
    };
    TimeAxisBase.prototype.k1 = function (a, b) {
        this.kj = null;
    };
    TimeAxisBase.prototype.kb = function (a) {
        return TimeAxisBase.kc(a, this);
    };
    TimeAxisBase.kc = function (a, b) {
        if (a == null) {
            return b.ir.registerColumnDateTime(null, null, false);
        }
        var c = null;
        var d = SeriesViewer.bb(a, b.coercionMethods);
        c = d.a;
        return b.ir.registerColumnDateTime(a, c, b.expectFunctions);
    };
    TimeAxisBase.prototype.ao = function () {
        if (this.cf) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    };
    TimeAxisBase.prototype.get_av = function () {
        return 0;
    };
    Object.defineProperty(TimeAxisBase.prototype, "av", {
        get: function () {
            return this.get_av();
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.gk = function (a) {
        _super.prototype.gk.call(this, a);
        var b = this.ay.at();
        var c = this.ay.aw();
        var d = this.ay.au();
        var e = this.ay.av();
        var f = this.ay.e();
        var g = this.ay.f();
        var h = this.ay.g();
        this.gr();
        this.fv(b);
        this.fv(c);
        this.fv(d);
        this.fv(e);
        this.cj.clear();
        this.ck.clear();
        this.iy.clear();
        this.ap.ac = this;
        var i = this.a9 != null ? this.a9.mk : Rect.empty;
        var j = !i.isEmpty ? this.ib : Rect.empty;
        this.ap.cn = i;
        this.ap.cm = j;
        if (i.isEmpty || j.isEmpty) {
            this.bg.count = 0;
        }
        if (this.bg.count == 0) {
            this.ap.ab.clear();
        }
        if (this.as != null) {
            this.as.registerAxis(this);
        }
        this.k2();
    };
    TimeAxisBase.prototype.get_bw = function () {
        return true;
    };
    Object.defineProperty(TimeAxisBase.prototype, "bw", {
        get: function () {
            return this.get_bw();
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.startCursor = function () {
    };
    TimeAxisBase.prototype.resetCursor = function () {
    };
    TimeAxisBase.prototype.StartTimeCursor = function () {
        this.startCursor();
    };
    TimeAxisBase.prototype.ResetTimeCursor = function () {
        this.resetCursor();
    };
    TimeAxisBase.prototype.getCategorySize = function (a, b, c) {
        if (this.ja == 0) {
            return 0;
        }
        var d = this.h9(b, c);
        return d.width / (this.ja * a.width);
    };
    TimeAxisBase.prototype.getGroupCenter = function (a, b, c, d) {
        return this.getCategorySize(b, c, d) * 0.5;
    };
    TimeAxisBase.prototype.i3 = function (a, b, c) {
        var d = !isNaN_(this.i0) ? MathUtil.b(this.i0, 0, 1) : 0;
        var e = 1 - 0.5 * d;
        var f = this.getCategorySize(a, b, c) * e;
        return f;
    };
    TimeAxisBase.prototype.get_b3 = function () {
        return true;
    };
    Object.defineProperty(TimeAxisBase.prototype, "b3", {
        get: function () {
            return this.get_b3();
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.k0 = function (a, b) {
        return (0);
    };
    TimeAxisBase.prototype.preferredCategoryMode = function (a) {
        return this.bu ? 0 : 1;
    };
    Object.defineProperty(TimeAxisBase.prototype, "isVertical", {
        get: function () {
            return this.b5;
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.j$c = function (a, b) {
        return this.dm.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$b = function (a, b) {
        return this.dj.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$d = function (a, b, c, d, e) {
        this.fz.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$e = function (a, b, c, d) {
        this.f0.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$f = function (a, b, c, d) {
        this.f1.apply(this, arguments);
    };
    Object.defineProperty(TimeAxisBase.prototype, "j$a", {
        get: function () {
            return this.bz;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "i$a", {
        get: function () {
            return this.bw;
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.$t = markType(TimeAxisBase, 'TimeAxisBase', CategoryAxisBase.$, [ISortingAxis_$type, IDateTimeAxis_$type]);
    return TimeAxisBase;
}(CategoryAxisBase));
export { TimeAxisBase };
Type.dep(DependencyProperty, PropertyMetadata, TimeAxisBase, 'gd', ['DateTimeMemberPath::k8', [2, null], 'IsDataPreSorted:kf:k9', [0, false], 'MaximumValue::la', [3, null], 'MinimumValue::lb', [3, null]]);
/*<BeginStatics Name="Infragistics.Controls.Charts.TimeAxisBase" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.TimeAxisBase" />*/
//# sourceMappingURL=TimeAxisBase.js.map