/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { TimeAxisBase } from "./TimeAxisBase";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { TimeAxisBreakCollection } from "./TimeAxisBreakCollection";
import { TimeAxisLabelFormatCollection } from "./TimeAxisLabelFormatCollection";
import { OrderedDictionary$2 } from "./OrderedDictionary$2";
import { TimeAxisBreak } from "./TimeAxisBreak";
import { List$1 } from "./List$1";
import { TimeAxisIntervalCollection } from "./TimeAxisIntervalCollection";
import { runOn, delegateCombine, Number_$type, fromEnum, fromEn, typeCast, Date_$type, markType } from "./type";
import { ScalerParams } from "./ScalerParams";
import { KeyValuePair$2 } from "./KeyValuePair$2";
import { Rect } from "./Rect";
import { TimeAxisInterval } from "./TimeAxisInterval";
import { NumericYAxis } from "./NumericYAxis";
import { LabelPosition } from "./LabelPosition";
import { Extensions } from "./Extensions";
import { SortedListView$1 } from "./SortedListView$1";
import { Dictionary$2 } from "./Dictionary$2";
import { truncate, isNaN_ } from "./number";
import { dateFromTicks, dateMaxValue, dateAdd, dateSubtract, dateAddMonths, dateFromValues, dateGetMonth, dateGetTimeOfDay, dateAddDays, dateAddHours, dateMinValue } from "./date";
import { timeSpanTicks, timeSpanInit3, timeSpanInit1, timeSpanFromDays, timeSpanFromHours, timeSpanFromMinutes, timeSpanTotalMilliseconds, timeSpanFromTicks } from "./timespan";
import { dateToStringFormat } from "./dateExtended";
var TimeXAxis = /** @class */ (function (_super) {
    tslib_1.__extends(TimeXAxis, _super);
    function TimeXAxis() {
        var _this = _super.call(this) || this;
        _this.lt = 0;
        _this.ld = null;
        _this.lj = null;
        _this._omission = 0;
        _this.lc = null;
        _this.lh = null;
        _this.l3 = 0;
        _this.lp = dateMaxValue();
        _this.lo = dateMinValue();
        _this.l1 = 0;
        _this.ab = TimeXAxis.$;
        _this.omission = (0);
        _this.lt = -2147483648;
        _this.ld = new TimeAxisBreakCollection();
        var a = _this.le;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.l6));
        _this.lh = new TimeAxisIntervalCollection();
        var b = _this.li;
        b.collectionChanged = delegateCombine(b.collectionChanged, runOn(_this, _this.l7));
        _this.lj = new TimeAxisLabelFormatCollection();
        var c = _this.lk;
        c.collectionChanged = delegateCombine(c.collectionChanged, runOn(_this, _this.l8));
        _this.l3 = (0);
        return _this;
    }
    TimeXAxis.prototype.dj = function (a, b) {
        var c = new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
        var d = this.lt != -2147483648 ? this.lt : 0;
        var e = this.lc != null ? this.lc.count : 0;
        while (d < e) {
            var f = this.lc.item1(d);
            if (f.d.getTime() <= a && f.c.getTime() >= a) {
                return NaN;
            }
            if (f.c.getTime() <= a) {
                c = new KeyValuePair$2(TimeAxisBreak.$, Number_$type, 1, f, this.lc.item(f));
                d++;
            }
            else {
                break;
            }
        }
        if (d > 0) {
            d -= 1;
        }
        if (this.lt != -2147483648) {
            this.lt = d;
        }
        var g;
        var h;
        if (c.key != null) {
            g = c.value;
            h = c.key.c;
        }
        else {
            g = 0;
            h = this.actualMinimumValue;
        }
        var fromPrecedingBreak_ = +(dateFromTicks(truncate(a))) - +h;
        var i = (fromPrecedingBreak_ / ((this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime()) - this.omission));
        var j = g + i;
        j -= b.e.left;
        j /= b.e.width;
        var k = b.d.left;
        var l = b.d.right;
        var m = b.d.width;
        if (this.categoryMode != 0) {
            var n = this.getCategorySize(b.e, b.d, b.c);
            k += n / 2;
            l -= n / 2;
            m -= n;
        }
        if (this.bz) {
            return l - m * j;
        }
        return k + m * j;
    };
    TimeXAxis.prototype.f0 = function (a, b, c, d) {
        this.lt = 0;
        for (var e = b; e < c; e++) {
            a.item(e, this.dj(a.item(e), d));
        }
        this.lt = -2147483648;
    };
    TimeXAxis.prototype.startCursor = function () {
        this.lt = 0;
    };
    TimeXAxis.prototype.resetCursor = function () {
        this.lt = -2147483648;
    };
    TimeXAxis.prototype.dm = function (a, b) {
        var c = b.d.left;
        var d = b.d.width;
        if (this.categoryMode != 0) {
            var e = this.getCategorySize(b.e, b.d, b.c);
            c += e / 2;
            d -= e;
        }
        var f = b.e.left + b.e.width * (a - c) / d;
        if (this.bz) {
            f = 1 - f;
        }
        var g = new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
        if (this.lc != null) {
            try {
                for (var _a = tslib_1.__values(fromEnum(this.lc)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var h = _b.value;
                    if (h.value >= f && h.value <= f) {
                        return h.key.d.getTime();
                    }
                    if (h.value < f && h.value > g.value) {
                        g = h;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        var precedingBreakEnd_;
        var i;
        if (g.key != null) {
            i = g.value;
            precedingBreakEnd_ = g.key.c;
        }
        else {
            i = 0;
            precedingBreakEnd_ = this.actualMinimumValue;
        }
        var portionFromPrecedingBreak_ = f - i;
        var actualRange_ = +(this.actualMaximumValue) - +(this.actualMinimumValue) - this.omission;
        return (precedingBreakEnd_.getTime() + portionFromPrecedingBreak_ * actualRange_);
        var e_1, _c;
    };
    Object.defineProperty(TimeXAxis.prototype, "le", {
        get: function () {
            return this.ld;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeXAxis.prototype, "lk", {
        get: function () {
            return this.lj;
        },
        enumerable: true,
        configurable: true
    });
    TimeXAxis.prototype.f7 = function (a, b, c, d) {
        _super.prototype.f7.call(this, a, b, c, d);
        switch (b) {
            case "ActualMaximumValue":
                this.l5();
                break;
            case "DateTimeColumn":
                this.l1 = this.l0();
                break;
        }
    };
    TimeXAxis.prototype.gv = function (a, b) {
        _super.prototype.gv.call(this, a, b);
        this.l4();
        this.k7();
    };
    TimeXAxis.prototype.gu = function (a, b) {
        _super.prototype.gu.call(this, a, b);
        this.l4();
        this.k7();
    };
    TimeXAxis.prototype.cd = function () {
        var a = _super.prototype.cd.call(this);
        this.l4();
        return a;
    };
    Object.defineProperty(TimeXAxis.prototype, "omission", {
        get: function () {
            return this._omission;
        },
        set: function (a) {
            this._omission = a;
        },
        enumerable: true,
        configurable: true
    });
    TimeXAxis.prototype.l5 = function () {
        var a = this.lm(this.le);
        var b = (0);
        try {
            for (var _a = tslib_1.__values(fromEnum(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var c = _b.value;
                b += (+(c.c) - +(c.d));
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_2) throw e_2.error; }
        }
        this.omission = b;
        var e_2, _c;
    };
    TimeXAxis.prototype.lm = function (a) {
        var b = new List$1(TimeAxisBreak.$, 0);
        if (a == null || +(this.actualMaximumValue) == +(dateMaxValue())) {
            return b;
        }
        var _loop_1 = function (c) {
            if (c.c >= this_1.actualMinimumValue && c.d <= this_1.actualMaximumValue) {
                b.add(c);
            }
            if (c.i != (0)) {
                var d = +(c.c) - +(c.d);
                var e_3 = dateAdd(+(c.d), +(c.i));
                var _loop_2 = function () {
                    var f = this_1.lq(e_3, d);
                    var g = ((function () {
                        var $ret = new TimeAxisBreak();
                        $ret.d = e_3;
                        $ret.c = f;
                        return $ret;
                    })());
                    if (g.c >= this_1.actualMinimumValue && g.d <= this_1.actualMaximumValue) {
                        b.add(g);
                    }
                    if (dateSubtract(+(dateMaxValue()), +(c.i)) < g.d) {
                        return "break";
                    }
                    e_3 = this_1.lq(g.d, c.i);
                };
                while (e_3 <= this_1.actualMaximumValue) {
                    var state_1 = _loop_2();
                    if (state_1 === "break")
                        break;
                }
            }
        };
        var this_1 = this;
        try {
            for (var _a = tslib_1.__values(fromEn(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var c = _b.value;
                _loop_1(c);
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_4) throw e_4.error; }
        }
        return b;
        var e_4, _c;
    };
    TimeXAxis.prototype.lq = function (a, b) {
        var c = dateFromTicks(a.getTime());
        c.setMilliseconds(c.getMilliseconds() + b);
        return c;
    };
    TimeXAxis.prototype.l4 = function () {
        this.lc = new OrderedDictionary$2(TimeAxisBreak.$, Number_$type);
        if (+(this.actualMaximumValue) == +(dateMaxValue()) || this.le == null || this.le.count == 0 || this.a9 == null) {
            return;
        }
        var a = new List$1(TimeAxisBreak.$, 1, this.lm(this.le));
        a.aa(function (b, c) { return b.d < c.d ? -1 : b.d > c.d ? 1 : 0; });
        var b = this.a9.mk;
        var c = new ScalerParams(0, this.a9.mk, this.a9.mx, this.bz, this.a9.mo);
        var d = +(this.actualMaximumValue) - +(this.actualMinimumValue) - this.omission;
        var e = 0;
        try {
            for (var _a = tslib_1.__values(fromEnum(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var f = _b.value;
                var g = timeSpanTicks((+(f.d) - +(this.actualMinimumValue))) / timeSpanTicks(d);
                var h = timeSpanTicks((+(f.c) - +(this.actualMinimumValue))) / timeSpanTicks(d);
                if (h < 0 || g - e > 1) {
                    continue;
                }
                this.lc.addItem(f, g - e);
                e += (h - g);
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_5) throw e_5.error; }
        }
        var e_5, _c;
    };
    TimeXAxis.prototype.eq = function (a) {
        if (!(typeCast(Date_$type, a) !== null)) {
            return _super.prototype.eq.call(this, a);
        }
        var b = TimeXAxis.lu(a, this.l3, this.lk);
        return b == null ? _super.prototype.eq.call(this, a) : b;
    };
    TimeXAxis.lu = function (a, b, c) {
        var d = null;
        if (b == (0)) {
            return null;
        }
        var e;
        if (c == null || c.count == 0) {
            e = TimeXAxis.lx(b);
        }
        else {
            try {
                for (var _a = tslib_1.__values(fromEnum(c)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var f = _b.value;
                    if (f.b > b) {
                        continue;
                    }
                    if (d == null || f.b > d.b) {
                        d = f;
                    }
                }
            }
            catch (e_6_1) { e_6 = { error: e_6_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_6) throw e_6.error; }
            }
            if (d == null) {
                return null;
            }
            e = d.a;
        }
        return dateToStringFormat(a, e);
        var e_6, _c;
    };
    TimeXAxis.prototype.get_ke = function () {
        return _super.prototype.get_ke.call(this) || (this.li != null && this.li.count > 0);
    };
    TimeXAxis.prototype.set_ke = function (a) {
        _super.prototype.set_ke.call(this, a);
    };
    Object.defineProperty(TimeXAxis.prototype, "ke", {
        get: function () {
            return this.get_ke();
        },
        set: function (a) {
            this.set_ke(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeXAxis.prototype, "li", {
        get: function () {
            return this.lh;
        },
        enumerable: true,
        configurable: true
    });
    TimeXAxis.prototype.lw = function () {
        return TimeXAxis.lx(this.l3);
    };
    TimeXAxis.lx = function (a) {
        a = Math.abs(a);
        if (a > timeSpanInit3(1825, 0, 0, 0)) {
            return "yyyy";
        }
        if (a > timeSpanInit3(365, 0, 0, 0)) {
            return "MMM yyyy";
        }
        if (a > timeSpanInit3(4, 0, 0, 0)) {
            return "MMM dd";
        }
        if (a > timeSpanInit3(1, 0, 0, 0)) {
            return "MMM dd hh:mmtt";
        }
        if (a > timeSpanInit1(0, 10, 0)) {
            return "hh:mm";
        }
        return "hh:mm:ss";
    };
    TimeXAxis.prototype.lf = function () {
        var a = this.l3;
        if (a == (0)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.a = 8;
                $ret.d = 1;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(365 * 100)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.a = 8;
                $ret.d = 10;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(365 * 5)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.a = 8;
                $ret.d = 1;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(365 * 2)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.a = 7;
                $ret.d = 3;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(150)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.a = 7;
                $ret.d = 1;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(60)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.a = 5;
                $ret.d = 10;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(30)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.a = 5;
                $ret.d = 5;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(20)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.a = 5;
                $ret.d = 2;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(4)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.a = 5;
                $ret.d = 1;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(1)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.a = 4;
                $ret.d = 12;
                return $ret;
            })());
        }
        if (a >= timeSpanFromHours(6)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.a = 4;
                $ret.d = 1;
                return $ret;
            })());
        }
        if (a >= timeSpanFromMinutes(30)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.a = 3;
                $ret.d = 5;
                return $ret;
            })());
        }
        if (a >= timeSpanFromMinutes(10)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.a = 3;
                $ret.d = 2;
                return $ret;
            })());
        }
        return ((function () {
            var $ret = new TimeAxisInterval();
            $ret.a = 2;
            $ret.d = 30;
            return $ret;
        })());
    };
    TimeXAxis.prototype.lg = function () {
        if (this.li == null || this.li.count == 0) {
            return this.lf();
        }
        if (this.l3 == (0)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.a = 8;
                $ret.d = 1;
                return $ret;
            })());
        }
        var a = null;
        try {
            for (var _a = tslib_1.__values(fromEnum(this.li)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                if (b.e > this.l3) {
                    continue;
                }
                if (a == null || b.e > a.e) {
                    a = b;
                }
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_7) throw e_7.error; }
        }
        return a == null ? this.lf() : a;
        var e_7, _c;
    };
    TimeXAxis.prototype.gk = function (a) {
        _super.prototype.gk.call(this, a);
        var b = this.a9 != null ? this.a9.mk : Rect.empty;
        var c = !b.isEmpty ? this.ib : Rect.empty;
        var d = this.h6();
        var e = this.h5();
        var f = new ScalerParams(0, b, c, this.bz, d);
        if (this.ka == null && !this.kg() && !this.kh()) {
            return;
        }
        if (!b.isEmpty && !c.isEmpty) {
            var g = c.bottom;
            var h = g - c.top;
            if (this.ag != null) {
                var i = typeCast(NumericYAxis.$, this.ag);
                if (i != null) {
                    var j = this.gn(g, h, b, c, d, c.top, c.bottom);
                    g = j.p0;
                    h = j.p1;
                }
            }
            if (isNaN_(g)) {
                g = 0;
            }
            this.f3(this.ay.at(), g, c, this.ay.e(), true);
            this.ap.a6 = h;
            var k = truncate(Math.ceil(e.right));
            var l = truncate(Math.floor(e.left));
            var m = this.ay.aw();
            var n = this.ay.f();
            var o = this.ay.au();
            this.k7();
            var p = new List$1(Date_$type, 1, this.ll());
            var q = new List$1(Number_$type, 0);
            for (var r = 0; r < p.count; r++) {
                q.add(p._inner[r].getTime());
            }
            this.f0(q, 0, q.count, f);
            for (var s = 0; s < p.count; s++) {
                var t = p._inner[s];
                var u = q._inner[s];
                var v = truncate(Math.round(u));
                if (v <= k) {
                    if (s % 2 == 0) {
                        var w = s < q.count - 1 ? q._inner[s + 1] : e.right;
                        this.gt(m, u, w, c);
                    }
                    this.gs(o, u, c, n, false);
                    this.iy.add(u);
                }
                if (v >= l && v <= k) {
                    var x = this.eq(t);
                    if (x != null) {
                        this.cj.add1(x);
                        this.ck.add(new LabelPosition(u));
                    }
                }
            }
        }
        if ((this.as == null || this.as.visibility == 0) && this.ag != null) {
            if (this.as != null && (this.as.location == 4 || this.as.location == 5)) {
                this.a9.hp();
            }
        }
        this.ap.a1 = this.cj;
        this.ap.a2 = this.ck;
        this.jy();
    };
    TimeXAxis.prototype.ll = function () {
        var a = this.a9 != null ? this.a9.mk : Rect.empty;
        var b = !a.isEmpty ? this.ib : Rect.empty;
        var c = this.h6();
        var d = this.h5();
        var e = new ScalerParams(0, a, b, this.bz, c);
        var f = this.lg();
        var g = this.visibleMinimum;
        if (!this.kh() && f != null) {
            if (f.a == 7 && g.getDate() != 1) {
                g = dateAddMonths(g, 1);
                g = dateFromValues(g.getFullYear(), dateGetMonth(g), 1, 0, 0, 0, 0);
            }
            else if (f.a == 5 && dateGetTimeOfDay(g) != (0)) {
                g = dateAddDays(g, 1);
                g = dateFromValues(g.getFullYear(), dateGetMonth(g), g.getDate(), 0, 0, 0, 0);
            }
            else if (f.a == 4 && g.getMinutes() != 0) {
                g = dateAddHours(g, 1);
                g = dateFromValues(g.getFullYear(), dateGetMonth(g), g.getDate(), g.getHours(), 0, 0, 0);
            }
        }
        var h = new List$1(Date_$type, 0);
        var i = 0;
        var j = 10000;
        if (f.d == 0) {
            return h;
        }
        while (g <= this.visibleMaximum && i++ < j) {
            var k = this.ln(g);
            var l = g;
            if (k.key != null) {
                l = f.c(k.key.c);
            }
            h.add(l);
            while (g <= l) {
                g = f.b(g);
            }
        }
        return h;
    };
    TimeXAxis.prototype.ln = function (a) {
        if (this.lc == null) {
            return new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
        }
        try {
            for (var _a = tslib_1.__values(fromEnum(this.lc)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                if (b.key.d <= a && b.key.c >= a) {
                    return b;
                }
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_8) throw e_8.error; }
        }
        return new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
        var e_8, _c;
    };
    Object.defineProperty(TimeXAxis.prototype, "visibleMinimum", {
        get: function () {
            return this.lp;
        },
        set: function (a) {
            this.lp = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeXAxis.prototype, "visibleMaximum", {
        get: function () {
            return this.lo;
        },
        set: function (a) {
            this.lo = a;
        },
        enumerable: true,
        configurable: true
    });
    TimeXAxis.prototype.k7 = function () {
        _super.prototype.k7.call(this);
        if (this.a9 == null || !Extensions.b(this.a9.mx)) {
            return;
        }
        var a = new ScalerParams(0, this.a9.mk, this.a9.mx, this.bz, this.a9.mo);
        var b = this.a9.mx.left;
        var c = this.a9.mx.right;
        if (this.categoryMode != 0) {
            var d = this.getCategorySize(a.e, a.d, a.c);
            b += d / 2;
            c -= d / 2;
        }
        var e = truncate(this.dm(b, a));
        var f = truncate(this.dm(c, a));
        if (e < 0 || f < 0) {
            this.l3 = (0);
            return;
        }
        e = Math.min(dateMaxValue().getTime(), e);
        f = Math.min(dateMaxValue().getTime(), f);
        this.visibleMinimum = dateFromTicks(Math.min(e, f));
        this.visibleMaximum = dateFromTicks(Math.max(e, f));
        this.l3 = +(this.visibleMaximum) - +(this.visibleMinimum);
    };
    TimeXAxis.prototype.getOffset1 = function (a, b, c, d, e) {
        return 0;
    };
    TimeXAxis.prototype.i$f = function (a) {
        if (this.le == null || this.le.count == 0) {
            return _super.prototype.i$f.call(this, a);
        }
        var b = this;
        if (b.i$b == null) {
            return -1;
        }
        var c = new SortedListView$1(Date_$type, this.ka, b.i$b);
        var ticks_ = a;
        var d = (new Date(ticks_));
        var e = this.ks(d, c);
        e = Math.max(0, Math.min(b.i$b.count - 1, e));
        var f = c.item(e);
        var g;
        var h;
        if (f < d) {
            g = e;
            h = g + 1;
        }
        else {
            h = e;
            g = e - 1;
        }
        if (g < 0) {
            return h;
        }
        if (h >= b.i$b.count) {
            return g;
        }
        var i = c.item(g);
        var j = c.item(h);
        var k = new ScalerParams(0, this.a9.my, this.ib, this.bz, this.a9.mo);
        this.startCursor();
        var l = this.dj(i.getTime(), k);
        var m = this.dj(a, k);
        var n = this.dj(j.getTime(), k);
        this.resetCursor();
        if (Math.abs(l - m) < Math.abs(n - m)) {
            return this.kj._inner[g];
        }
        else {
            return this.kj._inner[h];
        }
    };
    TimeXAxis.prototype.l6 = function (a, b) {
        this.l5();
        this.l4();
        if (this.ap != null) {
            this.ap.ak = this.le.count > 0;
        }
        this.gj(false);
        try {
            for (var _a = tslib_1.__values(fromEnum(this.ci())), _b = _a.next(); !_b.done; _b = _a.next()) {
                var c = _b.value;
                c.it(false);
            }
        }
        catch (e_9_1) { e_9 = { error: e_9_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_9) throw e_9.error; }
        }
        var e_9, _c;
    };
    TimeXAxis.prototype.l8 = function (a, b) {
        this.gj(false);
    };
    TimeXAxis.prototype.l7 = function (a, b) {
        this.gj(false);
    };
    TimeXAxis.prototype.get_bu = function () {
        return false;
    };
    Object.defineProperty(TimeXAxis.prototype, "bu", {
        get: function () {
            return this.get_bu();
        },
        enumerable: true,
        configurable: true
    });
    TimeXAxis.prototype.getWindowRectForSelection = function (a, b) {
        var c = +(this.actualMaximumValue) - +(this.actualMinimumValue);
        var d = timeSpanTotalMilliseconds((+a - +(this.actualMinimumValue))) / timeSpanTotalMilliseconds(c);
        var e = 1 - (timeSpanTotalMilliseconds((+(this.actualMaximumValue) - +b)) / timeSpanTotalMilliseconds(c));
        e = Math.min(1, e);
        return new Rect(0, d, NaN, Math.max(0, e - d), NaN);
    };
    TimeXAxis.prototype.getCategorySize = function (a, b, c) {
        if (this.l3 != (0)) {
            var d = timeSpanFromTicks(truncate((timeSpanTicks(this.l3) * (a.width / (this.a9 != null ? this.a9.mk.width : 1)))));
            var e = timeSpanTicks(d) / timeSpanTicks(this.l1);
            var f = b.width / 4;
            return Math.min(f, b.width / (e + 1));
        }
        return _super.prototype.getCategorySize.call(this, a, b, c);
    };
    TimeXAxis.prototype.l0 = function () {
        if (this.ka == null || this.ka.count < 2 || this.kj == null) {
            return (0);
        }
        var a = Math.min(5, this.ka.count);
        var b = this.ka.item(this.kj._inner[0]);
        var c = new Dictionary$2(Number_$type, Number_$type, 0);
        var d = 0;
        var e = (0);
        for (var f = 0; f < a; f++) {
            var g = this.ka.item(this.kj._inner[f]);
            var h = +g - +b;
            if (!c.containsKey(h)) {
                c.addItem(h, 0);
            }
            c.item(h, c.item(h) + 1);
            if (c.item(h) > d) {
                d = c.item(h);
                e = h;
            }
            b = g;
        }
        return e;
    };
    TimeXAxis.prototype.k3 = function () {
        _super.prototype.k3.call(this);
        this.l1 = this.l0();
    };
    Object.defineProperty(TimeXAxis.prototype, "isVertical", {
        get: function () {
            return this.b5;
        },
        enumerable: true,
        configurable: true
    });
    TimeXAxis.prototype.j$c = function (a, b) {
        return this.dm.apply(this, arguments);
    };
    TimeXAxis.prototype.j$b = function (a, b) {
        return this.dj.apply(this, arguments);
    };
    TimeXAxis.prototype.j$d = function (a, b, c, d, e) {
        this.fz.apply(this, arguments);
    };
    TimeXAxis.prototype.j$e = function (a, b, c, d) {
        this.f0.apply(this, arguments);
    };
    TimeXAxis.prototype.j$f = function (a, b, c, d) {
        this.f1.apply(this, arguments);
    };
    Object.defineProperty(TimeXAxis.prototype, "j$a", {
        get: function () {
            return this.bz;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeXAxis.prototype, "i$a", {
        get: function () {
            return this.bw;
        },
        enumerable: true,
        configurable: true
    });
    TimeXAxis.$t = markType(TimeXAxis, 'TimeXAxis', TimeAxisBase.$, [ITimeRangeSelectorAxis_$type]);
    return TimeXAxis;
}(TimeAxisBase));
export { TimeXAxis };
//# sourceMappingURL=TimeXAxis.js.map