import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from './igx-strategy-based-indicator-component';
import { IgxFinancialIndicatorComponent } from './igx-financial-indicator-component';
import { IgxFinancialSeriesComponent } from './igx-financial-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { AverageDirectionalIndexIndicator } from "./AverageDirectionalIndexIndicator";
/**
 * Represents a IgxDataChartComponent Average Directional indicator series.
 * Default required members: High, Low, Close
*/
export var IgxAverageDirectionalIndexIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }];
var IgxAverageDirectionalIndexIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxAverageDirectionalIndexIndicatorComponent, _super);
    function IgxAverageDirectionalIndexIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxAverageDirectionalIndexIndicatorComponent.prototype.createImplementation = function () {
        return new AverageDirectionalIndexIndicator();
    };
    Object.defineProperty(IgxAverageDirectionalIndexIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAverageDirectionalIndexIndicatorComponent.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current AverageDirectionalIndexIndicator object.
         * The typical, and initial, value for AverageDirectionalIndexIndicator periods is 14.
        */
        get: /**
             * Gets or sets the moving average period for the current AverageDirectionalIndexIndicator object.
             * The typical, and initial, value for AverageDirectionalIndexIndicator periods is 14.
            */
        function () {
            return this.i.qa;
        },
        set: function (v) {
            this.i.qa = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxAverageDirectionalIndexIndicatorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-average-directional-index-indicator',
                    template: "",
                    providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxAverageDirectionalIndexIndicatorComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxAverageDirectionalIndexIndicatorComponent.ctorParameters = function () { return []; };
    IgxAverageDirectionalIndexIndicatorComponent.propDecorators = {
        "period": [{ type: Input },],
    };
    return IgxAverageDirectionalIndexIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxAverageDirectionalIndexIndicatorComponent };
//# sourceMappingURL=igx-average-directional-index-indicator-component.js.map