import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxCategoryAxisBaseComponent } from './igx-category-axis-base-component';
import { IgxAxisComponent } from './igx-axis-component';
import { CategoryAngleAxis } from "./CategoryAngleAxis";
/**
 * Represents a IgxDataChartComponent category angle axis. Useful for displaying radial categories.
*/
export var IgxCategoryAngleAxisComponent_PROVIDERS = [{ provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(function () { return IgxCategoryAngleAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: forwardRef(function () { return IgxCategoryAngleAxisComponent; }) }];
var IgxCategoryAngleAxisComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxCategoryAngleAxisComponent, _super);
    function IgxCategoryAngleAxisComponent() {
        return _super.call(this) || this;
    }
    IgxCategoryAngleAxisComponent.prototype.createImplementation = function () {
        return new CategoryAngleAxis();
    };
    Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "isAngular", {
        /**
         * Checks if the axis is of angular type
        */
        get: /**
             * Checks if the axis is of angular type
            */
        function () {
            return this.i.bs;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "startAngleOffset", {
        /**
         * Indicates the angle in degress that the chart's 0th angle should be offset.
        */
        get: /**
             * Indicates the angle in degress that the chart's 0th angle should be offset.
            */
        function () {
            return this.i.ku;
        },
        set: function (v) {
            this.i.ku = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "interval", {
        /**
         * Gets or sets the frequency of displayed labels.
         * The set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
        */
        get: /**
             * Gets or sets the frequency of displayed labels.
             * The set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
            */
        function () {
            return this.i.kr;
        },
        set: function (v) {
            this.i.kr = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "actualInterval", {
        /**
         * Gets the effective value for the current Interval.
        */
        get: /**
             * Gets the effective value for the current Interval.
            */
        function () {
            return this.i.kl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "minorInterval", {
        /**
         * Gets or sets the frequency of displayed minor lines.
         * The set value is a factor that determines how the minor lines will be displayed.
        */
        get: /**
             * Gets or sets the frequency of displayed minor lines.
             * The set value is a factor that determines how the minor lines will be displayed.
            */
        function () {
            return this.i.ks;
        },
        set: function (v) {
            this.i.ks = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxCategoryAngleAxisComponent.prototype, "actualMinorInterval", {
        /**
         * Gets the effective value for the current MinorInterval.
        */
        get: /**
             * Gets the effective value for the current MinorInterval.
            */
        function () {
            return this.i.km;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Gets the scaled angle in radians from the raw axis value.
    
    * @param unscaledAngle  * The raw axis value.
    */
    /**
         * Gets the scaled angle in radians from the raw axis value.
        
        * @param unscaledAngle  * The raw axis value.
        */
    IgxCategoryAngleAxisComponent.prototype.getScaledAngle = /**
         * Gets the scaled angle in radians from the raw axis value.
        
        * @param unscaledAngle  * The raw axis value.
        */
    function (unscaledAngle) {
        var iv = this.i.getScaledAngle(unscaledAngle);
        return (iv);
    };
    /**
     * Gets the raw axis value from the scaled angle in radians.
    
    */
    /**
         * Gets the raw axis value from the scaled angle in radians.
        
        */
    IgxCategoryAngleAxisComponent.prototype.getUnscaledAngle = /**
         * Gets the raw axis value from the scaled angle in radians.
        
        */
    function (scaledAngle) {
        var iv = this.i.getUnscaledAngle(scaledAngle);
        return (iv);
    };
    IgxCategoryAngleAxisComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-category-angle-axis',
                    template: "",
                    providers: [{ provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(function () { return IgxCategoryAngleAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: forwardRef(function () { return IgxCategoryAngleAxisComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxCategoryAngleAxisComponent.ctorParameters = function () { return []; };
    IgxCategoryAngleAxisComponent.propDecorators = {
        "startAngleOffset": [{ type: Input },],
        "interval": [{ type: Input },],
        "minorInterval": [{ type: Input },],
    };
    return IgxCategoryAngleAxisComponent;
}(IgxCategoryAxisBaseComponent));
export { IgxCategoryAngleAxisComponent };
//# sourceMappingURL=igx-category-angle-axis-component.js.map