import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from './igx-strategy-based-indicator-component';
import { IgxFinancialIndicatorComponent } from './igx-financial-indicator-component';
import { IgxFinancialSeriesComponent } from './igx-financial-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { ChaikinOscillatorIndicator } from "./ChaikinOscillatorIndicator";
/**
 * Represents the IgxDataChartComponent Chaikin Oscillator indicator series.
 * Default required members: Close, Low, High, Volume
*/
export var IgxChaikinOscillatorIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }];
var IgxChaikinOscillatorIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxChaikinOscillatorIndicatorComponent, _super);
    function IgxChaikinOscillatorIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxChaikinOscillatorIndicatorComponent.prototype.createImplementation = function () {
        return new ChaikinOscillatorIndicator();
    };
    Object.defineProperty(IgxChaikinOscillatorIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxChaikinOscillatorIndicatorComponent.prototype, "shortPeriod", {
        /**
         * Gets or sets the short moving average period for the current ChaikinOscillatorIndicator object.
         * The typical, and initial, value for short CHO periods is 3.
        */
        get: /**
             * Gets or sets the short moving average period for the current ChaikinOscillatorIndicator object.
             * The typical, and initial, value for short CHO periods is 3.
            */
        function () {
            return this.i.shortPeriod;
        },
        set: function (v) {
            this.i.shortPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxChaikinOscillatorIndicatorComponent.prototype, "longPeriod", {
        /**
         * Gets or sets the long moving average period for the current ChaikinOscillatorIndicator object.
         * The typical, and initial, value for long CHO periods is 10.
        */
        get: /**
             * Gets or sets the long moving average period for the current ChaikinOscillatorIndicator object.
             * The typical, and initial, value for long CHO periods is 10.
            */
        function () {
            return this.i.longPeriod;
        },
        set: function (v) {
            this.i.longPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxChaikinOscillatorIndicatorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-chaikin-oscillator-indicator',
                    template: "",
                    providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxChaikinOscillatorIndicatorComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxChaikinOscillatorIndicatorComponent.ctorParameters = function () { return []; };
    IgxChaikinOscillatorIndicatorComponent.propDecorators = {
        "shortPeriod": [{ type: Input },],
        "longPeriod": [{ type: Input },],
    };
    return IgxChaikinOscillatorIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxChaikinOscillatorIndicatorComponent };
//# sourceMappingURL=igx-chaikin-oscillator-indicator-component.js.map