import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from './igx-strategy-based-indicator-component';
import { IgxFinancialIndicatorComponent } from './igx-financial-indicator-component';
import { IgxFinancialSeriesComponent } from './igx-financial-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { DetrendedPriceOscillatorIndicator } from "./DetrendedPriceOscillatorIndicator";
/**
 * Represents a IgxDataChartComponent Detrended Price Oscillator indicator series.
 * Default required members: Close
*/
export var IgxDetrendedPriceOscillatorIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }];
var IgxDetrendedPriceOscillatorIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxDetrendedPriceOscillatorIndicatorComponent, _super);
    function IgxDetrendedPriceOscillatorIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxDetrendedPriceOscillatorIndicatorComponent.prototype.createImplementation = function () {
        return new DetrendedPriceOscillatorIndicator();
    };
    Object.defineProperty(IgxDetrendedPriceOscillatorIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDetrendedPriceOscillatorIndicatorComponent.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current DetrendedPriceOscillatorIndicator object.
         * The typical, and initial, value for DPO periods is 20.
        */
        get: /**
             * Gets or sets the moving average period for the current DetrendedPriceOscillatorIndicator object.
             * The typical, and initial, value for DPO periods is 20.
            */
        function () {
            return this.i.qa;
        },
        set: function (v) {
            this.i.qa = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxDetrendedPriceOscillatorIndicatorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-detrended-price-oscillator-indicator',
                    template: "",
                    providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxDetrendedPriceOscillatorIndicatorComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxDetrendedPriceOscillatorIndicatorComponent.ctorParameters = function () { return []; };
    IgxDetrendedPriceOscillatorIndicatorComponent.propDecorators = {
        "period": [{ type: Input },],
    };
    return IgxDetrendedPriceOscillatorIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxDetrendedPriceOscillatorIndicatorComponent };
//# sourceMappingURL=igx-detrended-price-oscillator-indicator-component.js.map