import { HighlightingState } from './HighlightingState';
import { IgxSeriesComponent } from './igx-series-component';
import { HighlightingInfo as HighlightingInfo_internal } from "./HighlightingInfo";
/**
 * Contains contextual information about a highlighting.
*/
export declare class HighlightingInfo {
    protected createImplementation(): HighlightingInfo_internal;
    protected _implementation: any;
    readonly i: HighlightingInfo_internal;
    private onImplementationCreated();
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The index of the first highlighted item.
    */
    startIndex: number;
    /**
     * The index of the last highlighted item.
    */
    endIndex: number;
    /**
     * The state of the highlighting.
    */
    state: HighlightingState;
    /**
     * A number between 0 and 1 representing the progress of the highlighting.
    */
    progress: number;
    /**
     * True if this HighlightingInfo represents a marker highlighting.
    */
    isMarker: boolean;
    /**
     * The series in context.
    */
    readonly series: IgxSeriesComponent;
}
