import { EventEmitter, OnInit } from '@angular/core';
import { LegendMouseButtonEventArgs } from './igx-legend-mouse-button-event-args';
import { LegendMouseEventArgs } from './igx-legend-mouse-event-args';
import { LegendBase } from "./LegendBase";
/**
 * Represents the base class for a legend in IgxDataChartComponent.
*/
export declare const IgxLegendBaseComponent_PROVIDERS: any[];
export declare abstract class IgxLegendBaseComponent implements OnInit {
    protected createImplementation(): LegendBase;
    ngOnInit(): void;
    protected _implementation: any;
    readonly i: LegendBase;
    private onImplementationCreated();
    constructor();
    private _legendItemMouseLeftButtonDown;
    /**
     * Event raised when the left mouse button is pressed while the mouse pointer is over a legend item
     * in this Legend.
    */
    readonly legendItemMouseLeftButtonDown: EventEmitter<{
        sender: any;
        args: LegendMouseButtonEventArgs;
    }>;
    private _legendItemMouseLeftButtonUp;
    /**
     * Event raised when the left mouse button is released while the mouse pointer is over a legend item
     * in this Legend.
    */
    readonly legendItemMouseLeftButtonUp: EventEmitter<{
        sender: any;
        args: LegendMouseButtonEventArgs;
    }>;
    private _legendItemMouseEnter;
    /**
     * Event raised when the mouse pointer enters a legend item of this legend.
    */
    readonly legendItemMouseEnter: EventEmitter<{
        sender: any;
        args: LegendMouseEventArgs;
    }>;
    private _legendItemMouseLeave;
    /**
     * Event raised when the mouse pointer leaves a legend item of this legend.
    */
    readonly legendItemMouseLeave: EventEmitter<{
        sender: any;
        args: LegendMouseEventArgs;
    }>;
    private _legendItemMouseMove;
    /**
     * Event raised when the mouse pointer moves over a legend item of this legend.
    */
    readonly legendItemMouseMove: EventEmitter<{
        sender: any;
        args: LegendMouseEventArgs;
    }>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
}
