import * as tslib_1 from "tslib";
import { IgxCollection } from './IgxCollection';
import { SyncableObservableCollection$2 } from './SyncableObservableCollection$2';
import { MarkerType_$type } from './MarkerType';
import { ensureEnum } from './componentUtil';
var MarkerTypeCollection = /** @class */ (function (_super) {
    tslib_1.__extends(MarkerTypeCollection, _super);
    function MarkerTypeCollection(list) {
        var _this = _super.call(this) || this;
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    MarkerTypeCollection.prototype._ensureOuter = function (item) {
        return ensureEnum(MarkerType_$type, item);
    };
    MarkerTypeCollection.prototype._createInnerColl = function () {
        var coll = new SyncableObservableCollection$2(MarkerType_$type, MarkerType_$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext;
        };
        coll.createFrom = function (int) {
            return int;
        };
        return coll;
    };
    return MarkerTypeCollection;
}(IgxCollection));
export { MarkerTypeCollection };
//# sourceMappingURL=igx-marker-type-collection.js.map