import * as tslib_1 from "tslib";
import { forwardRef, Input } from '@angular/core';
import { IgxAxisComponent } from './igx-axis-component';
import { ensureBool } from "./componentUtil";
/**
 * Represents the base class for all IgxDataChartComponent numeric axes.
*/
export var IgxNumericAxisBaseComponent_PROVIDERS = [{ provide: IgxAxisComponent, useExisting: forwardRef(function () { return IgxNumericAxisBaseComponent; }) }];
var IgxNumericAxisBaseComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxNumericAxisBaseComponent, _super);
    function IgxNumericAxisBaseComponent() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "isNumeric", {
        /**
         * Gets or sets if the current axis is of numeric axis type
        */
        get: /**
             * Gets or sets if the current axis is of numeric axis type
            */
        function () {
            return this.i.b1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "minimumValue", {
        /**
         * Gets or sets the MinimumValue property.
        */
        get: /**
             * Gets or sets the MinimumValue property.
            */
        function () {
            return this.i.jo;
        },
        set: function (v) {
            this.i.jo = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualMinimumValue", {
        /**
         * Gets the effective minimum value for the current numeric axis object.
        */
        get: /**
             * Gets the effective minimum value for the current numeric axis object.
            */
        function () {
            return this.i.jg;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualVisibleMinimumValue", {
        /**
         * Gets the effective minimum value for the current numeric axis object.
        */
        get: /**
             * Gets the effective minimum value for the current numeric axis object.
            */
        function () {
            return this.i.jj;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "maximumValue", {
        /**
         * Gets or sets the MaximumValue property.
        */
        get: /**
             * Gets or sets the MaximumValue property.
            */
        function () {
            return this.i.jn;
        },
        set: function (v) {
            this.i.jn = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualMaximumValue", {
        /**
         * Gets the effective maximum value for the current numeric axis object.
        */
        get: /**
             * Gets the effective maximum value for the current numeric axis object.
            */
        function () {
            return this.i.jf;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualVisibleMaximumValue", {
        /**
         * Gets the effective visible maximum value for the current numeric axis object.
        */
        get: /**
             * Gets the effective visible maximum value for the current numeric axis object.
            */
        function () {
            return this.i.ji;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "interval", {
        /**
         * Gets or sets the Interval property.
        */
        get: /**
             * Gets or sets the Interval property.
            */
        function () {
            return this.i.jk;
        },
        set: function (v) {
            this.i.jk = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualInterval", {
        /**
         * Gets the effective value for the current Interval.
        */
        get: /**
             * Gets the effective value for the current Interval.
            */
        function () {
            return this.i.je;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "minorInterval", {
        /**
         * Gets or sets the MinorInterval property.
        */
        get: /**
             * Gets or sets the MinorInterval property.
            */
        function () {
            return this.i.jp;
        },
        set: function (v) {
            this.i.jp = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualMinorInterval", {
        /**
         * Gets the effective value for the current MinorInterval.
        */
        get: /**
             * Gets the effective value for the current MinorInterval.
            */
        function () {
            return this.i.jh;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "referenceValue", {
        /**
         * Gets or sets the ReferenceValue property.
        */
        get: /**
             * Gets or sets the ReferenceValue property.
            */
        function () {
            return this.i.jq;
        },
        set: function (v) {
            this.i.jq = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "isLogarithmic", {
        /**
         * Gets or sets the IsLogarithmic property.
        */
        get: /**
             * Gets or sets the IsLogarithmic property.
            */
        function () {
            return this.i.i5;
        },
        set: function (v) {
            this.i.i5 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "actualIsLogarithmic", {
        /**
         * Determines if the axis has a valid logarithmic scale.
        */
        get: /**
             * Determines if the axis has a valid logarithmic scale.
            */
        function () {
            return this.i.i1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "logarithmBase", {
        /**
         * Gets or sets the LogarithmBase property.
        */
        get: /**
             * Gets or sets the LogarithmBase property.
            */
        function () {
            return this.i.js;
        },
        set: function (v) {
            this.i.js = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "hasUserMinimum", {
        /**
         * Determines if the axis has a user-defined minimum.
        */
        get: /**
             * Determines if the axis has a user-defined minimum.
            */
        function () {
            return this.i.i4;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "hasUserMaximum", {
        /**
         * Determines if the axis has a user-defined maximum.
        */
        get: /**
             * Determines if the axis has a user-defined maximum.
            */
        function () {
            return this.i.i3;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAxisBaseComponent.prototype, "abbreviateLargeNumbers", {
        get: function () {
            return this.i.i0;
        },
        set: function (v) {
            this.i.i0 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Unscales a value from screen space into axis space.
    
    * @param unscaledValue  * The scaled value in screen coordinates to unscale into axis space.
    */
    /**
         * Unscales a value from screen space into axis space.
        
        * @param unscaledValue  * The scaled value in screen coordinates to unscale into axis space.
        */
    IgxNumericAxisBaseComponent.prototype.unscaleValue = /**
         * Unscales a value from screen space into axis space.
        
        * @param unscaledValue  * The scaled value in screen coordinates to unscale into axis space.
        */
    function (unscaledValue) {
        var iv = this.i.jr(unscaledValue);
        return (iv);
    };
    IgxNumericAxisBaseComponent.propDecorators = {
        "minimumValue": [{ type: Input },],
        "maximumValue": [{ type: Input },],
        "interval": [{ type: Input },],
        "minorInterval": [{ type: Input },],
        "referenceValue": [{ type: Input },],
        "isLogarithmic": [{ type: Input },],
        "logarithmBase": [{ type: Input },],
        "abbreviateLargeNumbers": [{ type: Input },],
    };
    return IgxNumericAxisBaseComponent;
}(IgxAxisComponent));
export { IgxNumericAxisBaseComponent };
//# sourceMappingURL=igx-numeric-axis-base-component.js.map