import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from './igx-strategy-based-indicator-component';
import { IgxFinancialIndicatorComponent } from './igx-financial-indicator-component';
import { IgxFinancialSeriesComponent } from './igx-financial-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { RelativeStrengthIndexIndicator } from "./RelativeStrengthIndexIndicator";
/**
 * Represents a IgxDataChartComponent Relative Strength Index indicator series.
 * Default required members: Close
*/
export var IgxRelativeStrengthIndexIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }];
var IgxRelativeStrengthIndexIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxRelativeStrengthIndexIndicatorComponent, _super);
    function IgxRelativeStrengthIndexIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxRelativeStrengthIndexIndicatorComponent.prototype.createImplementation = function () {
        return new RelativeStrengthIndexIndicator();
    };
    Object.defineProperty(IgxRelativeStrengthIndexIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxRelativeStrengthIndexIndicatorComponent.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current RelativeStrengthIndexIndicator object.
         * The typical, and initial, value for RSI periods is 14.
        */
        get: /**
             * Gets or sets the moving average period for the current RelativeStrengthIndexIndicator object.
             * The typical, and initial, value for RSI periods is 14.
            */
        function () {
            return this.i.qa;
        },
        set: function (v) {
            this.i.qa = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxRelativeStrengthIndexIndicatorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-relative-strength-index-indicator',
                    template: "",
                    providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxRelativeStrengthIndexIndicatorComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxRelativeStrengthIndexIndicatorComponent.ctorParameters = function () { return []; };
    IgxRelativeStrengthIndexIndicatorComponent.propDecorators = {
        "period": [{ type: Input },],
    };
    return IgxRelativeStrengthIndexIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxRelativeStrengthIndexIndicatorComponent };
//# sourceMappingURL=igx-relative-strength-index-indicator-component.js.map