/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventEmitter, Output, TemplateRef, Input } from '@angular/core';
import { Visibility, Visibility_$type } from './Visibility';
import { TransitionInSpeedType, TransitionInSpeedType_$type } from './TransitionInSpeedType';
import { SeriesHitTestMode, SeriesHitTestMode_$type } from './SeriesHitTestMode';
import { brushToString, stringToBrush, toPoint, fromPoint, fromRect, stringToColor, colorToString, ensureEnum, ensureBool } from './componentUtil';
import { RenderRequestedEventArgs } from './RenderRequestedEventArgs';
import { delegateCombine, TypeRegistrar } from './type';
export var IgxSeriesComponent_PROVIDERS = [];
/**
 * Represents the base class for all IgxDataChartComponent series.
*/
var IgxSeriesComponent = /** @class */ (function () {
    function IgxSeriesComponent() {
        this._chartLevelData = null;
        this._dataSource = null;
        this._tooltipTemplate = null;
        this._tooltipContent = null;
        this._tooltipContainerTemplate = null;
        this._renderer = null;
        this._renderRequested = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    Object.defineProperty(IgxSeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesComponent.prototype.onImplementationCreated = function () {
    };
    IgxSeriesComponent.prototype.createImplementation = function () {
        return null;
    };
    Object.defineProperty(IgxSeriesComponent.prototype, "seriesInternal", {
        get: function () {
            return this.i;
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesComponent.prototype.ngOnInit = function () {
    };
    Object.defineProperty(IgxSeriesComponent.prototype, "name", {
        get: function () {
            return this.i.name;
        },
        set: function (value) {
            this.i.name = value;
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesComponent.prototype.provideData = function (data) {
        this._chartLevelData = data;
        this.updateDataSource();
    };
    IgxSeriesComponent.prototype.updateDataSource = function () {
        if (this._dataSource == null) {
            this.i.itemsSource = this._chartLevelData;
        }
        else {
            this.i.itemsSource = this._dataSource;
        }
    };
    Object.defineProperty(IgxSeriesComponent.prototype, "dataSource", {
        get: function () {
            if (this._dataSource != null) {
                return this._dataSource;
            }
            return this.i.itemsSource;
        },
        set: function (value) {
            this._dataSource = value;
            this.updateDataSource();
            //console.log("setting axis data source: " + value)
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesComponent.prototype.bindAxes = function (axes) {
    };
    Object.defineProperty(IgxSeriesComponent.prototype, "tooltipTemplate", {
        get: function () {
            return this._tooltipTemplate;
        },
        set: function (value) {
            this._tooltipTemplate = value;
            if (value == null) {
                if (this._tooltipContent !== null) {
                    this._tooltipContent.destroy();
                    this._tooltipContent = null;
                }
            }
            if (this._tooltipContent != null) {
                this._tooltipContent.instance.template = this._tooltipTemplate;
            }
            else {
                if (this.owner != null) {
                    this.owner._ensureTooltipCreated(this);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "tooltipContainerTemplate", {
        get: function () {
            return this._tooltipContainerTemplate;
        },
        set: function (value) {
            this._tooltipContainerTemplate = value;
            if (this._tooltipContent != null) {
                this._tooltipContent.instance.containerTemplate = this._tooltipContainerTemplate;
            }
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesComponent.prototype._ensureTooltipCreated = function (createTooltip, createWrapper) {
        if (this._tooltipTemplate == null) {
            this.i.toolTip = null;
        }
        if (this._tooltipContent == null && this._tooltipTemplate != null) {
            var tooltip = createTooltip();
            if (tooltip == null) {
                return;
            }
            this._tooltipContent = tooltip;
            tooltip.instance.template = this._tooltipTemplate;
            this.i.toolTip = createWrapper(tooltip.location.nativeElement);
        }
    };
    IgxSeriesComponent.prototype._ensureTooltipDestroyed = function () {
        if (this._tooltipContent !== null) {
            this._tooltipContent.destroy();
            this._tooltipContent = null;
        }
    };
    IgxSeriesComponent.prototype._provideRenderer = function (renderer) {
        this._renderer = renderer;
        this._zoneRunner = function (act) { return renderer._ngZone.run(act); };
    };
    IgxSeriesComponent._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    Object.defineProperty(IgxSeriesComponent.prototype, "isAnnotationLayer", {
        /**
     * Gets whether the series is an annotation layer.
    */
        get: /**
             * Gets whether the series is an annotation layer.
            */
        function () {
            return this.i.ch;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isVertical", {
        /**
         * Gets whether the current series is oriented vertically.
        */
        get: /**
             * Gets whether the current series is oriented vertically.
            */
        function () {
            return this.i.isVertical;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isFragment", {
        /**
         * Gets whether the current series is a stack fragment.
        */
        get: /**
             * Gets whether the current series is a stack fragment.
            */
        function () {
            return this.i.cq;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        */
        get: /**
             * Gets whether the current series shows an area or line shape.
            */
        function () {
            return this.i.ci;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isPolar", {
        /**
         * Gets whether the current series is a polar type series.
        */
        get: /**
             * Gets whether the current series is a polar type series.
            */
        function () {
            return this.i.cy;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isScatter", {
        /**
         * Gets whether the current series is a scatter type series.
        */
        get: /**
             * Gets whether the current series is a scatter type series.
            */
        function () {
            return this.i.c2;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isRadial", {
        /**
         * Gets whether the current series is a radial type series.
        */
        get: /**
             * Gets whether the current series is a radial type series.
            */
        function () {
            return this.i.c0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isStacked", {
        /**
         * Gets whether the current series is a stacked type series.
        */
        get: /**
             * Gets whether the current series is a stacked type series.
            */
        function () {
            return this.i.isStacked;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isFinancial", {
        /**
         * Gets whether the current series is a financial type series.
        */
        get: /**
             * Gets whether the current series is a financial type series.
            */
        function () {
            return this.i.cp;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isRange", {
        /**
         * Gets whether the current series is a range type series.
        */
        get: /**
             * Gets whether the current series is a range type series.
            */
        function () {
            return this.i.c1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isCategory", {
        /**
         * Gets whether the current series is a category type series.
        */
        get: /**
             * Gets whether the current series is a category type series.
            */
        function () {
            return this.i.cj;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isGeographic", {
        /**
         * Gets whether the current seires is a geogrpahic series.
        */
        get: /**
             * Gets whether the current seires is a geogrpahic series.
            */
        function () {
            return this.i.cr;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isDefaultCrosshairBehaviorDisabled", {
        /**
         * Gets whether the default crosshair behavior should be disabled if this series is present.
        */
        get: /**
             * Gets whether the default crosshair behavior should be disabled if this series is present.
            */
        function () {
            return this.i.ck;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isDefaultTooltipBehaviorDisabled", {
        /**
         * Gets whether the default tooltip behavior should be disabled if this series is present.
        */
        get: /**
             * Gets whether the default tooltip behavior should be disabled if this series is present.
            */
        function () {
            return this.i.cl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "hasMarkers", {
        /**
         * Returns whether the current series supports visual markers.
        */
        get: /**
             * Returns whether the current series supports visual markers.
            */
        function () {
            return this.i.hasMarkers;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isIndexed", {
        /**
         * Gets if the series uses an index, which can be used to auto-assign it a color.
        */
        get: /**
             * Gets if the series uses an index, which can be used to auto-assign it a color.
            */
        function () {
            return this.i.cu;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isUsableInLegend", {
        /**
         * Gets if the series should appear in any legends.
        */
        get: /**
             * Gets if the series should appear in any legends.
            */
        function () {
            return this.i.isUsableInLegend;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "legendItemVisibility", {
        /**
         * Gets or sets the legend item visibility for the current series object.
        */
        get: /**
             * Gets or sets the legend item visibility for the current series object.
            */
        function () {
            return this.i.le;
        },
        set: function (v) {
            this.i.le = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "legendItemBadgeTemplate", {
        /**
         * Gets or sets the LegendItemBadgeTemplate property.
         * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
         * the series object itself.
        */
        get: /**
             * Gets or sets the LegendItemBadgeTemplate property.
             * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
             * the series object itself.
            */
        function () {
            return this.i.legendItemBadgeTemplate;
        },
        set: function (v) {
            this.i.legendItemBadgeTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "legendItemTemplate", {
        /**
         * Gets or sets the LegendItemTemplate property.
         * The legend item control content is created according to the LegendItemTemplate on-demand by
         * the series object itself.
        */
        get: /**
             * Gets or sets the LegendItemTemplate property.
             * The legend item control content is created according to the LegendItemTemplate on-demand by
             * the series object itself.
            */
        function () {
            return this.i.legendItemTemplate;
        },
        set: function (v) {
            this.i.legendItemTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "discreteLegendItemTemplate", {
        /**
         * Gets or sets the DiscreteLegendItemTemplate property.
         * The legend item control content is created according to the DiscreteLegendItemTemplate on-demand by
         * the series object itself.
        */
        get: /**
             * Gets or sets the DiscreteLegendItemTemplate property.
             * The legend item control content is created according to the DiscreteLegendItemTemplate on-demand by
             * the series object itself.
            */
        function () {
            return this.i.jd;
        },
        set: function (v) {
            this.i.jd = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "transitionEasingFunction", {
        /**
         * Gets or sets the easing function used to morph the current series.
        */
        get: /**
             * Gets or sets the easing function used to morph the current series.
            */
        function () {
            return this.i.bt;
        },
        set: function (v) {
            this.i.bt = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "transitionInEasingFunction", {
        /**
         * Gets or sets the EasingFunction used to morph the current series during the initial transition.
        */
        get: /**
             * Gets or sets the EasingFunction used to morph the current series during the initial transition.
            */
        function () {
            return this.i.bu;
        },
        set: function (v) {
            this.i.bu = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "transitionDuration", {
        /**
         * Gets or sets the duration of the current series's morph.
        */
        get: /**
             * Gets or sets the duration of the current series's morph.
            */
        function () {
            return this.i.e7;
        },
        set: function (v) {
            this.i.e7 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "resolution", {
        /**
         * Gets or sets the current series object's rendering resolution.
        */
        get: /**
             * Gets or sets the current series object's rendering resolution.
            */
        function () {
            return this.i.ej;
        },
        set: function (v) {
            this.i.ej = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "title", {
        /**
         * Gets or sets the Title property.
         * The legend item control is created according to the Title on-demand by
         * the series object itself.
        */
        get: /**
             * Gets or sets the Title property.
             * The legend item control is created according to the Title on-demand by
             * the series object itself.
            */
        function () {
            return this.i.fj;
        },
        set: function (v) {
            this.i.fj = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "brush", {
        /**
         * Gets or sets the brush to use for the series.
        */
        get: /**
             * Gets or sets the brush to use for the series.
            */
        function () {
            return brushToString(this.i.kk);
        },
        set: function (v) {
            this.i.kk = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "actualBrush", {
        /**
         * Gets the effective brush for the current series object.
        */
        get: /**
             * Gets the effective brush for the current series object.
            */
        function () {
            return brushToString(this.i.ki);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "outline", {
        /**
         * Gets or sets the brush to use for the outline of the series.
         * Some series types, such as LineSeries, do not display outlines.  Therefore, this property does not affect some charts.
        */
        get: /**
             * Gets or sets the brush to use for the outline of the series.
             * Some series types, such as LineSeries, do not display outlines.  Therefore, this property does not affect some charts.
            */
        function () {
            return brushToString(this.i.kn);
        },
        set: function (v) {
            this.i.kn = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "actualOutline", {
        /**
         * Gets the effective outline for the current series object.
        */
        get: /**
             * Gets the effective outline for the current series object.
            */
        function () {
            return brushToString(this.i.kj);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "thickness", {
        /**
         * Gets or sets the width of the current series object's line thickness.
        */
        get: /**
             * Gets or sets the width of the current series object's line thickness.
            */
        function () {
            return this.i.en;
        },
        set: function (v) {
            this.i.en = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isHighlightingEnabled", {
        /**
         * Gets or sets whether highlighting should be enabled for this series, if this type of series supports highlighting.
        */
        get: /**
             * Gets or sets whether highlighting should be enabled for this series, if this type of series supports highlighting.
            */
        function () {
            return this.i.cs;
        },
        set: function (v) {
            this.i.cs = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isDropShadowEnabled", {
        /**
         * Gets or sets whether drop shadow should be enabled for this series.
        */
        get: /**
             * Gets or sets whether drop shadow should be enabled for this series.
            */
        function () {
            return this.i.cn;
        },
        set: function (v) {
            this.i.cn = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "shadowBlur", {
        /**
         * Gets or sets the shadow blur.
         * This property is ignored when Series.UseSingleShadow is set to true.
        */
        get: /**
             * Gets or sets the shadow blur.
             * This property is ignored when Series.UseSingleShadow is set to true.
            */
        function () {
            return this.i.ek;
        },
        set: function (v) {
            this.i.ek = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "shadowColor", {
        /**
         * Gets or sets the drop shadow color.
        */
        get: /**
             * Gets or sets the drop shadow color.
            */
        function () {
            return colorToString(this.i.kp);
        },
        set: function (v) {
            this.i.kp = stringToColor(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "useSingleShadow", {
        /**
         * Gets or sets whether drop shadow is applied to the whole series visual or to each of the individual shapes forming the series.
         * When this property is set to true, no Series.ShadowBlur is applied.
        */
        get: /**
             * Gets or sets whether drop shadow is applied to the whole series visual or to each of the individual shapes forming the series.
             * When this property is set to true, no Series.ShadowBlur is applied.
            */
        function () {
            return this.i.dq;
        },
        set: function (v) {
            this.i.dq = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "shadowOffsetX", {
        /**
         * Gets or sets the drop shadow x-offset.
        */
        get: /**
             * Gets or sets the drop shadow x-offset.
            */
        function () {
            return this.i.el;
        },
        set: function (v) {
            this.i.el = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "shadowOffsetY", {
        /**
         * Gets or sets the drop shadow y-offset.
        */
        get: /**
             * Gets or sets the drop shadow y-offset.
            */
        function () {
            return this.i.em;
        },
        set: function (v) {
            this.i.em = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "areaFillOpacity", {
        /**
         * Gets or sets the opacity applied to the area fill visual.
         * This property only applies to series that have area visual.
        */
        get: /**
             * Gets or sets the opacity applied to the area fill visual.
             * This property only applies to series that have area visual.
            */
        function () {
            return this.i.dz;
        },
        set: function (v) {
            this.i.dz = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "actualAreaFillOpacity", {
        /**
         * Gets the actual opacity applied to the area fill visual.
        */
        get: /**
             * Gets the actual opacity applied to the area fill visual.
            */
        function () {
            return this.i.dy;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isDefaultToolTipSelected", {
        /**
         * Gets if the default tooltip has been selected for display.
        */
        get: /**
             * Gets if the default tooltip has been selected for display.
            */
        function () {
            return this.i.cm;
        },
        set: function (v) {
            this.i.cm = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "showDefaultTooltip", {
        /**
         * Gets or sets whether default tooltip will be shown.
        */
        get: /**
             * Gets or sets whether default tooltip will be shown.
            */
        function () {
            return this.i.c9;
        },
        set: function (v) {
            this.i.c9 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "transitionInDuration", {
        /**
         * Gets or sets the duration of the current series's transition in morph.
        */
        get: /**
             * Gets or sets the duration of the current series's transition in morph.
            */
        function () {
            return this.i.e8;
        },
        set: function (v) {
            this.i.e8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "transitionInSpeedType", {
        /**
         * Gets or sets the duration of the current series's transition in morph.
        */
        get: /**
             * Gets or sets the duration of the current series's transition in morph.
            */
        function () {
            return this.i.bo;
        },
        set: function (v) {
            this.i.bo = ensureEnum(TransitionInSpeedType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "mouseOverEnabled", {
        /**
         * Gets or sets the whether the chart reacts to mouse move events.
        */
        get: /**
             * Gets or sets the whether the chart reacts to mouse move events.
            */
        function () {
            return this.i.c3;
        },
        set: function (v) {
            this.i.c3 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "coercionMethods", {
        /**
         * Gets or gets the coercion methods to use when loading data from data sources.
         * Should be specified before setting any member paths, if being used. Setting it later
         * will not cause data to be reimported into the chart.
        */
        get: /**
             * Gets or gets the coercion methods to use when loading data from data sources.
             * Should be specified before setting any member paths, if being used. Setting it later
             * will not cause data to be reimported into the chart.
            */
        function () {
            return this.i.coercionMethods;
        },
        set: function (v) {
            this.i.coercionMethods = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "expectFunctions", {
        /**
         * Gets or sets whether the series should expect that properties in its items source may be functions that need to be
         * evaluated to yield their value. This defaults to false, as there will be a subtle performance impact to using this feature.
         * This value must be set before assigning an item's source to take effect.
        */
        get: /**
             * Gets or sets whether the series should expect that properties in its items source may be functions that need to be
             * evaluated to yield their value. This defaults to false, as there will be a subtle performance impact to using this feature.
             * This value must be set before assigning an item's source to take effect.
            */
        function () {
            return this.i.expectFunctions;
        },
        set: function (v) {
            this.i.expectFunctions = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "hitTestMode", {
        /**
         * Method of hit testing to use when pointing to items in this series.
        */
        get: /**
             * Method of hit testing to use when pointing to items in this series.
            */
        function () {
            return this.i.bd;
        },
        set: function (v) {
            this.i.bd = ensureEnum(SeriesHitTestMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "actualHitTestMode", {
        /**
         * Resolved method of hit testing to use when pointing to items in the chart.
        */
        get: /**
             * Resolved method of hit testing to use when pointing to items in the chart.
            */
        function () {
            return this.i.bb;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isNegativeColorSupported", {
        get: function () {
            return this.i.cx;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
        get: function () {
            return this.i.cw;
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesComponent.prototype.resolveTooltipBrush = function () {
        var iv = this.i.ge();
        return (iv);
    };
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    */
    /**
         * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
        
        * @param world  * The world position for which to return the index.
        */
    IgxSeriesComponent.prototype.getExactItemIndex = /**
         * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
        
        * @param world  * The world position for which to return the index.
        */
    function (world) {
        var iv = this.i.d2(toPoint(world));
        return (iv);
    };
    /**
     * Gets the item item index associated with the specified world position
    
    */
    /**
         * Gets the item item index associated with the specified world position
        
        */
    IgxSeriesComponent.prototype.getItemIndex = /**
         * Gets the item item index associated with the specified world position
        
        */
    function (world) {
        var iv = this.i.ex(toPoint(world));
        return (iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
    IgxSeriesComponent.prototype.getItem = /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
    function (world) {
        var iv = this.i.fe(toPoint(world));
        return (iv);
    };
    IgxSeriesComponent.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.e3(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgxSeriesComponent.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.e1(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgxSeriesComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ed(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgxSeriesComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.k0(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    */
    /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        */
    IgxSeriesComponent.prototype.getSeriesValueBoundingBox = /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        */
    function (world) {
        var iv = this.i.k9(toPoint(world));
        return fromRect(iv);
    };
    /**
     * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinates for which to get a value marker bounding box for
    */
    /**
         * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinates for which to get a value marker bounding box for
        */
    IgxSeriesComponent.prototype.getSeriesValueMarkerBoundingBox = /**
         * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinates for which to get a value marker bounding box for
        */
    function (world) {
        var iv = this.i.lb(toPoint(world));
        return fromRect(iv);
    };
    IgxSeriesComponent.prototype.getSeriesHighValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.d9(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgxSeriesComponent.prototype.getSeriesHighValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.kw(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgxSeriesComponent.prototype.getSeriesLowValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.eb(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgxSeriesComponent.prototype.getSeriesLowValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ky(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgxSeriesComponent.prototype.getSeriesValuePositionFromSeriesPixel = function (mouse, useInterpolation, skipUnknowns) {
        var iv = this.i.k1(toPoint(mouse), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgxSeriesComponent.prototype.getSeriesValueFromSeriesPixel = function (mouse, useInterpolation, skipUnknowns) {
        var iv = this.i.ee(toPoint(mouse), useInterpolation, skipUnknowns);
        return (iv);
    };
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        */
    IgxSeriesComponent.prototype.getItemSpan = /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        */
    function () {
        var iv = this.i.d7();
        return (iv);
    };
    /**
     * Converts a point from coordinates within the series plot area to a world position within axis space.
    
    * @param seriesPoint  * The pixel location within the plot area of the series.
    */
    /**
         * Converts a point from coordinates within the series plot area to a world position within axis space.
        
        * @param seriesPoint  * The pixel location within the plot area of the series.
        */
    IgxSeriesComponent.prototype.toWorldPosition = /**
         * Converts a point from coordinates within the series plot area to a world position within axis space.
        
        * @param seriesPoint  * The pixel location within the plot area of the series.
        */
    function (seriesPoint) {
        var iv = this.i.k3(toPoint(seriesPoint));
        return fromPoint(iv);
    };
    /**
     * Converts a point from world coordinates to coordinates within the viewport of the series.
    
    * @param world  * The world position from which to convert.
    */
    /**
         * Converts a point from world coordinates to coordinates within the viewport of the series.
        
        * @param world  * The world position from which to convert.
        */
    IgxSeriesComponent.prototype.fromWorldPosition = /**
         * Converts a point from world coordinates to coordinates within the viewport of the series.
        
        * @param world  * The world position from which to convert.
        */
    function (world) {
        var iv = this.i.kv(toPoint(world));
        return fromPoint(iv);
    };
    /**
     * Requests that the provided item should be brought into view if possible.
    
    * @param item  * The item to attempt to bring into view.
    */
    /**
         * Requests that the provided item should be brought into view if possible.
        
        * @param item  * The item to attempt to bring into view.
        */
    IgxSeriesComponent.prototype.scrollIntoView = /**
         * Requests that the provided item should be brought into view if possible.
        
        * @param item  * The item to attempt to bring into view.
        */
    function (item) {
        var iv = this.i.c5(item);
        return (iv);
    };
    /**
     * Renders the series.
    
    * @param animate  * True if the change should be animated.
    */
    /**
         * Renders the series.
        
        * @param animate  * True if the change should be animated.
        */
    IgxSeriesComponent.prototype.renderSeries = /**
         * Renders the series.
        
        * @param animate  * True if the change should be animated.
        */
    function (animate) {
        this.i.it(animate);
    };
    /**
     * Gets the effective viewport, adjusted to account for margins and other factors.
    
    */
    /**
         * Gets the effective viewport, adjusted to account for margins and other factors.
        
        */
    IgxSeriesComponent.prototype.getEffectiveViewport = /**
         * Gets the effective viewport, adjusted to account for margins and other factors.
        
        */
    function () {
        var iv = this.i.getEffectiveViewport();
        return fromRect(iv);
    };
    IgxSeriesComponent.prototype.removeAllAlternateViews = function () {
        this.i.io();
    };
    IgxSeriesComponent.prototype.removeAlternateView = function (viewIdentifier) {
        this.i.iq(viewIdentifier);
    };
    /**
     * Replays the assigned transition in animation, if any.
    
    */
    /**
         * Replays the assigned transition in animation, if any.
        
        */
    IgxSeriesComponent.prototype.replayTransitionIn = /**
         * Replays the assigned transition in animation, if any.
        
        */
    function () {
        this.i.iw();
    };
    /**
     * Simulates a pointer hover over the series surface.
    
    * @param point  * The pointer position relative to the series viewport over which to hover.
    */
    /**
         * Simulates a pointer hover over the series surface.
        
        * @param point  * The pointer position relative to the series viewport over which to hover.
        */
    IgxSeriesComponent.prototype.simulateHover = /**
         * Simulates a pointer hover over the series surface.
        
        * @param point  * The pointer position relative to the series viewport over which to hover.
        */
    function (point) {
        this.i.i0(toPoint(point));
    };
    IgxSeriesComponent.prototype.styleUpdated = function () {
        this.i.i2();
    };
    IgxSeriesComponent.prototype.setNegativeColors = function (negativeBrush, negativeOutline) {
        this.i.iy(stringToBrush(negativeBrush), stringToBrush(negativeOutline));
    };
    /**
     * Moves the cursor point to the provided world position. Some series may react to the current cursor position.
    
    * @param point  * The cursor point, in world coordinates.
    */
    /**
         * Moves the cursor point to the provided world position. Some series may react to the current cursor position.
        
        * @param point  * The cursor point, in world coordinates.
        */
    IgxSeriesComponent.prototype.moveCursorPoint = /**
         * Moves the cursor point to the provided world position. Some series may react to the current cursor position.
        
        * @param point  * The cursor point, in world coordinates.
        */
    function (point) {
        this.i.hu(toPoint(point));
    };
    Object.defineProperty(IgxSeriesComponent.prototype, "renderRequested", {
        get: /**
             * This event is raised every time a render has been requested from a series.
            */
        function () {
            var _this = this;
            if (this._renderRequested == null) {
                this._renderRequested = new EventEmitter();
                this.i.renderRequested = delegateCombine(this.i.renderRequested, function (o, e) {
                    var outerArgs = new RenderRequestedEventArgs();
                    outerArgs._provideImplementation(e);
                    _this._renderRequested.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._renderRequested;
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    IgxSeriesComponent.propDecorators = {
        "name": [{ type: Input },],
        "dataSource": [{ type: Input },],
        "tooltipTemplate": [{ type: Input },],
        "tooltipContainerTemplate": [{ type: Input },],
        "legendItemVisibility": [{ type: Input },],
        "legendItemBadgeTemplate": [{ type: Input },],
        "legendItemTemplate": [{ type: Input },],
        "discreteLegendItemTemplate": [{ type: Input },],
        "transitionEasingFunction": [{ type: Input },],
        "transitionInEasingFunction": [{ type: Input },],
        "transitionDuration": [{ type: Input },],
        "resolution": [{ type: Input },],
        "title": [{ type: Input },],
        "brush": [{ type: Input },],
        "outline": [{ type: Input },],
        "thickness": [{ type: Input },],
        "isHighlightingEnabled": [{ type: Input },],
        "isDropShadowEnabled": [{ type: Input },],
        "shadowBlur": [{ type: Input },],
        "shadowColor": [{ type: Input },],
        "useSingleShadow": [{ type: Input },],
        "shadowOffsetX": [{ type: Input },],
        "shadowOffsetY": [{ type: Input },],
        "areaFillOpacity": [{ type: Input },],
        "isDefaultToolTipSelected": [{ type: Input },],
        "showDefaultTooltip": [{ type: Input },],
        "transitionInDuration": [{ type: Input },],
        "transitionInSpeedType": [{ type: Input },],
        "mouseOverEnabled": [{ type: Input },],
        "coercionMethods": [{ type: Input },],
        "expectFunctions": [{ type: Input },],
        "hitTestMode": [{ type: Input },],
        "renderRequested": [{ type: Output },],
    };
    return IgxSeriesComponent;
}());
export { IgxSeriesComponent };
//# sourceMappingURL=igx-series-component.js.map