import * as tslib_1 from "tslib";
import { forwardRef, Input } from '@angular/core';
import { SplineType, SplineType_$type } from './SplineType';
import { IgxHorizontalAnchoredCategorySeriesComponent } from './igx-horizontal-anchored-category-series-component';
import { IgxAnchoredCategorySeriesComponent } from './igx-anchored-category-series-component';
import { IgxCategorySeriesComponent } from './igx-category-series-component';
import { IgxMarkerSeriesComponent } from './igx-marker-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { ensureEnum } from "./componentUtil";
/**
 * Represents the base class for all IgxDataChartComponent spline series.
*/
export var IgxSplineSeriesBaseComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxSplineSeriesBaseComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxSplineSeriesBaseComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(function () { return IgxSplineSeriesBaseComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxSplineSeriesBaseComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxSplineSeriesBaseComponent; }) }];
var IgxSplineSeriesBaseComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxSplineSeriesBaseComponent, _super);
    function IgxSplineSeriesBaseComponent() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxSplineSeriesBaseComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSplineSeriesBaseComponent.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        */
        get: /**
             * Gets whether the current series shows an area or line shape.
            */
        function () {
            return this.i.ci;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSplineSeriesBaseComponent.prototype, "splineType", {
        /**
         * Gets or sets the type of spline to be rendered.
        */
        get: /**
             * Gets or sets the type of spline to be rendered.
            */
        function () {
            return this.i.py;
        },
        set: function (v) {
            this.i.py = ensureEnum(SplineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    IgxSplineSeriesBaseComponent.propDecorators = {
        "splineType": [{ type: Input },],
    };
    return IgxSplineSeriesBaseComponent;
}(IgxHorizontalAnchoredCategorySeriesComponent));
export { IgxSplineSeriesBaseComponent };
//# sourceMappingURL=igx-spline-series-base-component.js.map